unit oDBController;

interface

uses
  Classes,
  SysUtils,
  oDBConnection;

type
  TDBController = class(TObject)
  private
    fDBConnection: TDBConnection;
  public
    constructor Create(aDBConnection: TDBConnection);
    destructor Destroy; override;

    property DBConnection: TDBConnection
      read fDBConnection;
  end;

const
  XML_DATE = 'YYYY-MM-DD';
  XML_DATETIME = 'YYYY-MM-DD hh:mm:ss';
  XML_VERSION = '<?xml version="1.0"?>';
  XML_STATUS_OK = '<RESULT><STATUS>OK</STATUS></RESULT>';
  XML_STATUS_ERROR =
    '<RESULT><STATUS>ERROR</STATUS><DB_ENGINE_ERROR_MESSAGE>%s</DB_ENGINE_ERROR_MESSAGE></RESULT>';

implementation

{ TDBController }

constructor TDBController.Create(aDBConnection: TDBConnection);
begin
  inherited Create;
  fDBConnection := aDBConnection;
end;

destructor TDBController.Destroy;
begin
  FreeAndNil(fDBConnection);
  inherited;
end;

end.
