unit oInterfaces;
{
================================================================================
*
*       Application:  CliO
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
*       Developer:    petit               
*       Site:         Hines OIFO
*
*       Description:
*
*
*       Notes:
*
*
================================================================================
*       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/CLIO/oInterfaces.pas $
*
* $History: oInterfaces.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/13/09    Time: 1:15p
 * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/CLIO
 * Patch 19 source code
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/24/08    Time: 4:23p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/CLIO
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/02/08    Time: 9:24a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/CLIO
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/22/07    Time: 9:16a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/CLIO
 * 
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 3/27/07    Time: 1:31p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/CLIO
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:37p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/CLIO
 *
*
================================================================================
}
interface

uses
  Classes;

type
  {Ordinal data types needed by the interfaces}
  TDBConnectionType = (dbVistABroker, dbCacheSQL, dbMSAccess, dbOracle
    {,dbVistALink});
  TDBCmdType = (ctQuery, ctInsert, ctUpdate);
  TDBCmdStatus = (csActive, csExecuting, csError, csComplete);
  TDBQueryComparison = (coLessThan, coLessThanOrEqualTo, coEqualTo,
    coEqualToOrGreaterThan, coGreaterThan);
  TDBValueType = (vtString, vtInteger, vtDouble, vtDate, vtDateTime,
    vtDateTimeSeconds, vtClob);

  {Forward Declarations}
  I_DBInsert = interface;
  I_DBQuery = interface;
  I_DBUpdate = interface;
  I_DBExecutorQuery = interface;
  I_DBExecutorInsert = interface;
  I_DBExecutorUpdate = interface;

  I_DBConnection = interface
    ['{9DB93BD9-FFD8-4756-A05C-AB24E5E1364C}']
    procedure SetName(aName: string); stdcall;
    function GetName: string; stdcall;
    function GetDBType: TDBConnectionType; stdcall;

    function Initialize(aP1, aP2, aP3, aP4, aP5: string): boolean; stdcall;
    function PostInit(aObject: TObject): boolean; stdcall;
    function IsInitialized: boolean; stdcall;

    function Open: boolean; stdcall;
    function IsOpen: boolean; stdcall;

    procedure SetSequenceTableName(aName: string); stdcall;
    function GetSequenceTableName: string; stdcall;

    function BeginTransaction: Boolean; stdcall;
    function CommitTransaction: Boolean; stdcall;
    function RollBackTransaction: Boolean; stdcall;

    function ExecRemoteProc(aName: string; aParams: array of string; aOptions:
      array of Integer; aMultList: TStringList; var aRetList: TStringList):
      Boolean; stdcall;

    function ExecuteQuery(aQuery: I_DBExecutorQuery): boolean; stdcall;
    function ExecuteInsert(aInsert: I_DBExecutorInsert): boolean; stdcall;
    function ExecuteUpdate(aUpdate: I_DBExecutorUpdate): boolean; stdcall;

    function Close: boolean; stdcall;
    function Description: string; stdcall;
    function Properties: string; stdcall;

    function GetInsertValue(aValue: string; aValueType: TDBValueType): string;
      stdcall;
    function GetNextID(aViewName: string): integer; stdcall;

    {Manages Dates in and out of the DB - Default methods available in TDBConnection}
    procedure SetDateSeparator(aDateSeparator: Char); stdcall;
    procedure SetTimeSeparator(aTimeSeparator: Char); stdcall;
    procedure SetDateTimeSeparator(aDateTimeSeparator: Char); stdcall;

    procedure SetDateFormat(aDateFormat: string); stdcall;
    procedure SetTimeFormat(aTimeFormat: string); stdcall;
    procedure SetTimeSecondsFormat(aTimeSecondsFormat: string); stdcall;

    function GetDateSeparator: string; stdcall;
    function GetTimeSeparator: string; stdcall;
    function GetDateTimeSeparator: string; stdcall;

    function GetDateFormat: string; stdcall;
    function GetDateTimeFormat: string; stdcall;
    function GetDateTimeSecondsFormat: string; stdcall;
    function GetTimeFormat: string; stdcall;
    function GetTimeSecondsFormat: string; stdcall;
  end;

  I_DBCommand = interface
    ['{A43771E8-4B5B-4446-B9B9-AC1D6D4450DA}']
    function View: string; stdcall;
    function Status: TDBCmdStatus; stdcall;
    function Execute(aDBConnection: I_DBConnection): boolean; stdcall;
    procedure Close; stdcall;
  end;

  I_DBInsert = interface(I_DBCommand)
    ['{3A3CB7DC-61AB-4798-92EA-A1F7B9042D1F}']
    procedure AddValueString(aColumn: string; aValue: string); overload;
      stdcall;
    procedure AddValueInteger(aColumn: string; aValue: integer); overload;
      stdcall;
    procedure AddValueDouble(aColumn: string; aValue: Double); overload;
      stdcall;
    procedure AddValueDate(aColumn: string; aValue: TDateTime); overload;
      stdcall;
    procedure AddValueDateTime(aColumn: string; aValue: TDateTime); overload;
      stdcall;
    procedure AddValueDateTimeSeconds(aColumn: string; aValue: TDateTime);
      overload; stdcall;
    procedure AddValueClob(aColumn: string; aValue: string); stdcall;
  end;

  I_DBQuery = interface(I_DBCommand)
    ['{3EE97E5E-031C-49B7-A156-C38A1797BFB3}']
    procedure AddFilter(aColumn: string; aComparison: TDBQueryComparison;
      aValue: string); overload; stdcall;
    procedure AddFilter(aColumn: string; aComparison: TDBQueryComparison;
      aValue: integer); overload; stdcall;
    procedure AddFilter(aColumn: string; aComparison: TDBQueryComparison;
      aValue: Double); overload; stdcall;

    procedure UsePrimaryKey(aColumn: string; aValue: string); overload; stdcall;
    procedure UsePrimaryKey(aColumn: string; aValue: integer); overload;
      stdcall;

    function QueryResults: string; stdcall;
  end;

  I_DBUpdate = interface(I_DBCommand)
    ['{ED1375D6-7990-4D54-8C3D-4BA0D87D3CE7}']
    procedure AddValueString(aColumn: string; aValue: string); overload;
      stdcall;
    procedure AddValueInteger(aColumn: string; aValue: integer); overload;
      stdcall;
    procedure AddValueDouble(aColumn: string; aValue: Double); overload;
      stdcall;
    procedure AddValueDate(aColumn: string; aValue: TDateTime); overload;
      stdcall;
    procedure AddValueDateTime(aColumn: string; aValue: TDateTime); overload;
      stdcall;
    procedure AddValueDateTimeSeconds(aColumn: string; aValue: TDateTime);
      overload; stdcall;
    procedure AddValueClob(aColumn: string; aValue: string); stdcall;

    procedure UsePrimaryKey(aColumn: string; aValue: string); overload; stdcall;
    procedure UsePrimaryKey(aColumn: string; aValue: integer); overload;
      stdcall;

    procedure AddFilter(aColumn: string; aComparison: TDBQueryComparison;
      aValue: string); overload; stdcall;
    procedure AddFilter(aColumn: string; aComparison: TDBQueryComparison;
      aValue: integer); overload; stdcall;
    procedure AddFilter(aColumn: string; aComparison: TDBQueryComparison;
      aValue: Double); overload; stdcall;
  end;

  I_DBExecutorInsert = interface(I_DBInsert)
    ['{0A4DE8B8-27EE-4B59-8305-09C28CBCE494}']
    function ValueCount: integer; stdcall;
    function Value(index: integer): string; stdcall;
    function ValueIsClobType(index: integer): boolean; stdcall;
    function SQLValueStmt: string; stdcall;

    function ColumnCount: integer; stdcall;
    function Column(index: integer): string; stdcall;
    function SQLColumnStmt: string; stdcall;

    function FilterCount: integer; stdcall;
    function Filter(index: integer): string; stdcall;
    function SQLFilterStmt: string; stdcall;
  end;

  I_DBExecutorQuery = interface(I_DBQuery)
    ['{FE214D7B-4ED8-47F6-B44A-D110E7C38803}']
    procedure SetResults(aString: string); stdcall;

    function PrimaryKey: boolean;
    function PrimaryKeyColumn: string;
    function PrimaryKeyValue: string;
    function PrimaryKeyValueType: TDBValueType;

    function FilterCount: integer; stdcall;
    function Filter(index: integer): string; stdcall;
    function SQLFilterStmt: string; stdcall;
  end;

  I_DBExecutorUpdate = interface(I_DBUpdate)
    ['{A968B677-5FBC-4415-AF65-086B74F30F75}']
    function ValueCount: integer; stdcall;
    function Value(index: integer): string; stdcall;
    function ValueIsClobType(index: integer): boolean; stdcall;
    function SQLValueStmt: string; stdcall;

    function ColumnCount: integer; stdcall;
    function Column(index: integer): string; stdcall;
    function SQLColumnStmt: string; stdcall;

    function PrimaryKey: boolean;
    function PrimaryKeyColumn: string;
    function PrimaryKeyValue: string;
    function PrimaryKeyValueType: TDBValueType;

    function SQLUpdateStmt: string; stdcall;

    function FilterCount: integer; stdcall;
    function Filter(index: integer): string; stdcall;
    function SQLFilterStmt: string; stdcall;
  end;

type
  TCustomInterfacedObject = class(TInterfacedObject)
  protected
    function _AddRef: integer; stdcall;
    function _Release: integer; stdcall;
  end;

type
  TBaseInterfacedObject = class(TCustomInterfacedObject)
  public
    function _AddRef: integer; stdcall;
    function _Release: integer; stdcall;
  end;

implementation

{ TCustomInterfacedObject }

function TCustomInterfacedObject._AddRef: integer;
begin
  Result := -1;
end;

function TCustomInterfacedObject._Release: integer;
begin
  Result := -1;
end;

{ TBaseInterfacedObject }

function TBaseInterfacedObject._AddRef: integer;
begin
  Result := -1;
end;

function TBaseInterfacedObject._Release: integer;
begin
  Result := -1;
end;

end.
