unit fGMV_AboutDlg;
{
================================================================================
*
*        Application:  Vitals
*        Revision:     $Revision: 1 $  $Modtime: 4/23/08 6:59a $
*        Developer:    petit               
*                     modified from BCMA Application by BKurtze@Dallas CIOFO
*        Site:         Hines OIFO
*
*         Description:  This is an About Dialog which displays data from the project
*                     VersionInfo block for the application.
*
*        Notes:        Delphi developer must add Keys VAReleaseDate and VANamespace
*                     Under Project|Options on the Version Info tab for the version,
*                     patch, and release date information to show up on the form.
*
*
================================================================================
*        $ Archive: /CP Version 1.0 $
*        $ History: fGMV_AboutDlg.pas $
*
================================================================================
*       2007-06-20 vhaishandria         Execute method updated b. 312 (#13)
}

interface

uses Windows,
  SysUtils,
  Classes,
  Graphics,
  Forms,
  Controls,
  StdCtrls,
  Buttons,
  ExtCtrls
  , jpeg
  ;

type
  TfrmGMV_AboutDlg = class(TForm)
    (*
      An About dialog which displays the Version Info data for the current
      application.
    *)
    Panel1: TPanel;
    lblProductNameInset: TLabel;
    lblClientVersion: TLabel;
    lblCopyright: TLabel;
    lblReleaseDate: TLabel;
    Label2: TLabel;
    lblReleaseDateLabel: TLabel;
    Label4: TLabel;
    lblPatchLabel: TLabel;
    lblPatch: TLabel;
    lblProductNameShadow: TLabel;
    pnlImage: TPanel;
    ApplicationImage: TImage;
    btnOK: TButton;
    Label1: TLabel;
    lblHelpFile: TLabel;
    Panel3: TPanel;
    pnlComments: TPanel;
    lblSecurity: TLabel;
    Label3: TLabel;
    lblServerVersion: TLabel;
    lblCompileDate: TLabel;
    lblCRCValue: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    lblSourceInfo: TLabel;
    Image: TImage;
    procedure FormCreate(Sender: TObject);
    procedure lblCommentsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    (*
      Uses TVersionInfo to read the Version Info for application.ExeName into
      the form's display fields.
    *)
  private
    fClose: Boolean;
    fComments: TStringList;
    procedure ShowInfo;
    procedure HideInfo;
    procedure Splash;
  public
    procedure Execute;
  end;

var
  GMVAboutDlg: TfrmGMV_AboutDlg;
  GMVAboutSplash: TfrmGMV_AboutDlg;

procedure SplashOn;
procedure SplashOff;

implementation

{$R *.DFM}
uses
  Dialogs
  , Math
  , uGMV_CRC32
  , uGMV_VersionInfo
  , uMDK_Utils
  , fMDK_Main
  ;
procedure SplashOn;
begin
  GMVAboutSplash := TfrmGMV_AboutDlg.Create(Application);
//  GMVAboutSplash.bv.Visible := True;
//  frmMain.pnlToolbar.Visible := False;

  GMVAboutSplash.Splash;
end;

procedure SplashOff;
begin
  GMVAboutSplash.Free;
//  frmMain.Show;
end;

function getResourceString(aName: string): string;
var
  tmpStream: TResourceStream;
  SL: TStringList;
begin
  Result := '';
  if aName = '' then
    Exit;
  SL := TStringList.Create;
  tmpStream := nil;
  try
    tmpStream := TResourceStream.Create(HInstance, aName, 'TXT');
    SL.LoadFromStream(tmpStream);
  finally
    tmpStream.Free;
  end;
  Result := SL.Text;
  SL.Free;
end;

(*=== AboutDlg Methods ======================================================*)

procedure TfrmGMV_AboutDlg.Splash;
begin
  HideInfo;
  pnlComments.Align := alClient;
  Image.Align := alClient;
  btnOK.Visible := False;
  Height := 260;
  BorderStyle := bsNone;
  Panel1.BevelWidth := 3;
  Panel1.BevelOuter := bvRaised;
  Show;
  Update;
end;

procedure TfrmGMV_AboutDlg.Execute;
begin
  HideInfo;
  pnlComments.Align := alClient;
  Image.Align := alClient;
  ShowModal;
end;

//Copy from FileCtrl

procedure CutFirstDirectory(var S: TFileName);
var
  Root: Boolean;
  P: Integer;
begin
  if S = '\' then
    S := ''
  else
    begin
      if S[1] = '\' then
        begin
          Root := True;
          Delete(S, 1, 1);
        end
      else
        Root := False;
      if S[1] = '.' then
        Delete(S, 1, 4);
      P := AnsiPos('\', S);
      if P <> 0 then
        begin
          Delete(S, 1, P);
          S := '...\' + S;
        end
      else
        S := '';
      if Root then
        S := '\' + S;
    end;
end;

function MinimizeName(const Filename: TFileName; Canvas: TCanvas;
  MaxLen: Integer): TFileName;
var
  Drive: TFileName;
  Dir: TFileName;
  Name: TFileName;
begin
  Result := FileName;
  Dir := ExtractFilePath(Result);
  Name := ExtractFileName(Result);

  if (Length(Dir) >= 2) and (Dir[2] = ':') then
    begin
      Drive := Copy(Dir, 1, 2);
      Delete(Dir, 1, 2);
    end
  else
    Drive := '';
  while ((Dir <> '') or (Drive <> '')) and (Canvas.TextWidth(Result) > MaxLen)
    do
    begin
      if Dir = '\...\' then
        begin
          Drive := '';
          Dir := '...\';
        end
      else if Dir = '' then
        Drive := ''
      else
        CutFirstDirectory(Dir);
      Result := Drive + Dir + Name;
    end;
end;

procedure TfrmGMV_AboutDlg.FormCreate(Sender: TObject);
begin
  fClose := False;
  fComments := TStringList.Create;

  fComments.Text := getResourceString('TEAM');

  lblProductNameInset.Font.Color := clWindowText; //clActiveCaption;
  lblProductNameShadow.Font.Color := clBtnHighlight;

  lblProductNameShadow.Top := lblProductNameInset.Top + 1;
  lblProductNameShadow.Left := lblProductNameInset.Left + 1;

  lblHelpFile.Caption := MinimizeName(Application.HelpFile, lblHelpFile.Canvas,
    lblHelpFile.Width);

  lblHelpFile.Hint := 'Help file name: ' + Application.HelpFile;
  lblHelpFile.ShowHint := (Pos('...', lblHelpFile.Caption) > 0);

  lblCRCValue.Caption := GetFileCRC32(Application.Exename);

  with TVersionInfo.Create(self) do
    try
      lblProductNameInset.Caption := 'CP '+ProductName;
      lblProductNameShadow.Caption := 'CP '+ProductName;

      Self.Caption := 'About ' + 'CP '+ProductName;

      lblSourceInfo.Caption := VASourceInformation;
//      lblClientVersion.Caption := piece(FileVersion,'.',1,2);
      lblClientVersion.Caption := FileVersion;
      lblServerVersion.Caption := VAServerVersion;
      lblPatch.Caption := VAPatchNumber;
      lblPatchLabel.Visible := (VAPatchNumber <> '');
      lblCompileDate.Caption := FormatDateTime('mm/dd/yy hh:mm:ss',
        CompileDateTime);
      lblReleaseDate.Caption := VAReleaseDate;
      lblCopyright.Caption := LegalCopyRight;
    finally
      free;
    end;
end;

procedure TfrmGMV_AboutDlg.lblCommentsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if (Button = mbRight) and (ssShift in Shift) and (ssCtrl in Shift)
    and (ssAlt in Shift) and (ssDouble in Shift) then
    ShowInfo;
end;

procedure TfrmGMV_AboutDlg.HideInfo;
begin
  pnlComments.Visible := False;
end;

procedure TfrmGMV_AboutDlg.ShowInfo;
var
  iStep, iMargin,
    j, i: Integer;
  sLeft, sCenter, sRight: string;
const
  clText = clNavy;

  procedure GrowRightCentered(aCanvas: TCanvas; aWait: Integer;
    aXMargin, Y, aWidth: Integer; aFColor: TColor; aText: string);
  var
    ii, i: integer;
  begin
    if fClose then
      Exit;
    with aCanvas do
      begin
        Font.Style := [fsBold];
        ii := TextWidth(aText);
        ii := (aWidth - ii) div 2;
        aXMargin := ii;
        ii := TextHeight(aText);
        Font.Color := aFColor;
        for i := aXMargin to aWidth - aXMargin do
          begin
            FillRect(Rect(aXMargin, y, i, y + ii));
            TextRect(Rect(aXMargin, y, i, y + ii), aXMargin, y, aText);
            Application.ProcessMessages;
            if fClose then
              Exit;
            sleep(aWait);
          end;
      end;
  end;

  procedure GrowRight(aCanvas: TCanvas; aWait: Integer;
    aXMargin, Y, aWidth: Integer; aFColor: TColor; aText: string);
  var
    iLen, iWidth, iHeight,
      i: integer;
  begin
    if fClose then
      Exit;
    with aCanvas do
      begin
        Font.Style := [fsBold];
        iWidth := TextWidth(aText);
        iHeight := TextHeight(aText);
        Font.Color := aFColor;
        iLen := Min(iWidth, aWidth - aXMargin);
        for i := aXMargin to iLen do
          begin
            FillRect(Rect(aXMargin, y, i, y + iHeight));
            TextRect(Rect(aXMargin, y, i, y + iHeight), aXMargin, y, aText);
            Application.ProcessMessages;
            if fClose then
              Exit;
            sleep(aWait);
          end;
      end;
  end;

  procedure SlideRight(aCanvas: TCanvas; aWait: Integer;
    aXMargin, Y, AwIDTH: Integer; aFColor: TColor; aText: string);
  var
    iWidth, iHeight,
      i: integer;
  begin
    if fClose then
      Exit;
    with aCanvas do
      begin
        Font.Style := [fsBold];
        iWidth := TextWidth(aText);
        iHeight := TextHeight(aText);
        Font.Color := aFColor;

        for i := aXMargin to aXMargin + iWidth do
          begin
            TextRect(Rect(aXMargin, y, i, y + iHeight), aXMargin, y, aText);
            Application.ProcessMessages;
            if fClose then
              Exit;
            sleep(aWait);
          end;
      end;
  end;

  procedure SlideLeft(aCanvas: TCanvas; aWait: Integer;
    aXMargin, Y, aWidth: Integer; aFColor: TColor; aText: string);
  var
    iX,
      iLen, iWidth, iHeight, iPos,
      i: integer;

  begin
    if fClose then
      Exit;
    with aCanvas do
      begin
        iPos := aWidth - aXMargin;
        iLen := 0;
        Font.Style := [];
        iWidth := TextWidth(aText);
        iHeight := TextHeight(aText);
        Font.Color := aFColor;
        iX := Max(aXMargin, aWidth - iWidth - aXMargin);
        for i := aWidth - aXMargin downto iX do
          begin
            iPos := i;
            if Font.Color > $0 then
              Font.Color := Font.Color - $00030303;
            iLen := Min(iWidth, aWidth - aXMargin - i);
            FillRect(Rect(iPos, y, iPos + iLen + 2, y + iHeight));
            TextRect(Rect(iPos, y, iPos + iLen, y + iHeight), i, y, aText);
            Application.ProcessMessages;
            if fClose then
              Exit;
            if (aWidth - aXMargin - i) > 0 then
              begin
                sleep(aWait);
                Application.ProcessMessages;
              end;
          end;
        FillRect(Rect(iPos, y, iPos + iLen + 2, y + iHeight));
        Font.Style := [];
        TextRect(Rect(iPos, y, iPos + iLen, y + iHeight), iPos, y, aText);
        Application.ProcessMessages;
      end;
  end;

begin
  fClose := False;
  pnlComments.Visible := True;
  Image.Canvas.Brush.Color := pnlComments.Color;
  Image.Canvas.FillRect(Rect(0, 0, Image.Width, Image.Height));

  i := 0;
  for j := 0 to fComments.Count - 1 do
    begin
      iStep := StrToIntDef(piece(fComments[j], '^', 1), 0);
      //          iWait := StrToIntDef(piece(fComments[j],'^',2),0);
      iMargin := StrToIntDef(piece(fComments[j], '^', 3), 30);
      sLeft := piece(fComments[j], '^', 4);
      sCenter := piece(fComments[j], '^', 5);
      sRight := piece(fComments[j], '^', 6);
      inc(i, iStep);
      if sCenter <> '' then
        GrowRightCentered(Image.Canvas, 0, iMargin, i, Image.Width, clBlack,
          sCenter);
      if sLeft <> '' then
        SlideRight(Image.Canvas, 10, iMargin, i, Image.Width, clText,
          sLeft);
      if sRight <> '' then
        SlideLeft(Image.Canvas, 30, iMargin, i, Image.Width, clBlack,
          sRight);
    end;

  if fClose then
    Exit;
  sleep(750);
  pnlComments.Visible := False;
end;

procedure TfrmGMV_AboutDlg.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    begin
      fClose := True;
      Close;
    end;
end;

procedure TfrmGMV_AboutDlg.FormDestroy(Sender: TObject);
begin
  fComments.Free;
  inherited;
end;

end.

