unit fMDK_AddOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, Buttons, CheckLst, ExtCtrls
  , fMDK_Options;

type
  TfrmAddOptions = class(TForm)
    Panel2: TPanel;
    ActionList1: TActionList;
    acAssign: TAction;
    pnlAssign: TPanel;
    bbGet: TBitBtn;
    acGetUserPreferences: TAction;
    Panel3: TPanel;
    acClearAll: TAction;
    acSelectAll: TAction;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    bbAssign: TBitBtn;
    GroupBox1: TGroupBox;
    clbOptions: TCheckListBox;
    pnlTopComment: TPanel;
    Memo1: TMemo;
    mmComments: TMemo;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    Bevel1: TBevel;
    procedure acAssignExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acGetUserPreferencesExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure acClearAllExecute(Sender: TObject);
    procedure acSelectAllExecute(Sender: TObject);
    procedure BitBtn8Click(Sender: TObject);
    procedure clbOptionsClick(Sender: TObject);
    procedure pnlAssignDblClick(Sender: TObject);
  private
    { Private declarations }
    procedure setValueList(aStringList: TStringList);
    procedure SaveOptions(aUserDUZ, aUserName: string);
  public
    { Public declarations }
  end;

var
  frmAddOptions: TfrmAddOptions;

procedure AddOptions(anAssign: Boolean = False; anOptionView: TfrmMDK_Options =
  nil);

implementation

uses uMDK_Options, fMDK_SelectProvider, uMDK_Engine, uROR_CommonUtils,
  uMDK_Common;

{$R *.dfm}

procedure AddOptions(anAssign: Boolean = False; anOptionView: TfrmMDK_Options =
  nil);
begin
  if not Assigned(frmAddOptions) then
    Application.CreateForm(TfrmAddOptions, frmAddOptions);

  with frmAddOptions do
    begin
      bbGet.Visible := anAssign;
      bbAssign.Visible := anAssign;

      pnlAssign.Visible := anAssign;

      setValueList(userOptions.ValueList);
      clbOptionsClick(nil);
      ShowModal;
    end;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmAddOptions.FormCreate(Sender: TObject);
begin
{$IFDEF AANTEST}
  bbAssign.Visible := True;
{$ELSE}
  bbAssign.Visible := False;
{$ENDIF}
end;

procedure TfrmAddOptions.setValueList(aStringList: TStringList);
var
  i: integer;
  s: string;
  uo: TUserOptions;
begin
  uo := TUserOptions.Create;
  uo.Values.Text := sysOptions.Values.Text;
  uo.Update(userOptions.Values.Text);
(*
  i := 0;
  if uo.Values.Count > 0 then
    while i < uo.Values.Count - 1 do
      begin
        s := uo.Values[i];
        if Trim(s)='' then
          uo.Values.Delete(i)
        else
          inc(i);
      end;
*)
//  clbOptions.Items.Assign(Preferences.ValueList);
//  clbOptions.Items.Assign(uo.ValueList);
  clbOptions.Items.Assign(uo.ValueList);
  uo.Free;
  i := 0;
  while i < clbOptions.Items.Count do
//  for i := 0 to clbOptions.Items.Count - 1 do
    begin
      s := clbOptions.Items.Names[i];
      if Trim(s) = '' then
        begin
          clbOptions.Items.Delete(i);
        end
      else
        begin
          if (aStringList <> nil) and (aStringList.IndexOfName(s) >= 0) then
            clbOptions.Checked[i] := True
          else
            clbOptions.Checked[i] := False;
          inc(i);
        end;

    end;

  if clbOptions.Items.Count > 0 then
    clbOptions.ItemIndex := 0;
end;

procedure TfrmAddOptions.acAssignExecute(Sender: TObject);
var
  s: string;
begin
  s := SelectProvider('', Engine.fRenalController, 3);
  if s <> '' then
    SaveOptions(piece(s, '^', 2), piece(s, '^', 1));
end;

procedure TfrmAddOptions.SaveOptions(aUserDUZ, aUserName: string);
var
  s: string;
  i: integer;
begin
  if aUserDUZ <> Engine.UserDUZ then
    begin
      if Dialogs.MessageDLG(
        'You are about to update the preference list' + #13#10 +
        'of the user <' + aUserName + '>' + #13#10#13#10 +
        'Do you want to continue?',
        mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
        Exit;
    end;

  s := '';
  for i := 0 to clbOptions.Items.Count - 1 do
    begin
      if clbOptions.Checked[i] then
        s := s + clbOptions.Items[i] + #13#10;
    end;

  if Engine.fRenalController.setUserOptionByDUZ(onUserOptions, aUserDUZ, s) and
    (aUserDUZ = Engine.UserDUZ) then
    userOptions.ValueList.Text := s;
end;

procedure TfrmAddOptions.acGetUserPreferencesExecute(Sender: TObject);
var
  _UserDUZ, _UserName,
    s: string;
  sl: TStringList;
begin
  s := SelectProvider('', Engine.fRenalController, 3);
  if s <> '' then
    begin
      _UserName := piece(s, '^', 1);
      _UserDUZ := piece(s, '^', 2);
      Engine.fRenalController.GetUserOptionByDUZ(onUserOptions, _UserDUZ, s);
      if s <> '' then
        begin
          if pos('-', s) = 1 then
            ShowMessage(piece(s, '^', 2))
          else
            begin
              clbOptions.Items.Clear;
              sl := TStringList.Create;
              sl.Text := s;
              if (trim(s) = '') or (pos('=', sl[0]) = 0) then
                sl.Delete(0);

              setValueList(sl);
              sl.Free;
            end;
        end
      else
        setValueList(nil);
    end;
end;

procedure TfrmAddOptions.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = char(VK_ESCAPE) then
    ModalResult := mrCancel;
end;

procedure TfrmAddOptions.acClearAllExecute(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to clbOptions.Items.Count - 1 do
    clbOptions.Checked[i] := False;
end;

procedure TfrmAddOptions.acSelectAllExecute(Sender: TObject);
var
  i: integer;
begin
  for i := 0 to clbOptions.Items.Count - 1 do
    clbOptions.Checked[i] := True;
end;

procedure TfrmAddOptions.BitBtn8Click(Sender: TObject);
begin
  SaveOptions(Engine.UserDUZ, Engine.CurrentOperatorID);
end;

procedure TfrmAddOptions.clbOptionsClick(Sender: TObject);
var
  s, sOutput,
    sName, sValue: string;
  i: integer;
begin
  i := clbOptions.ItemIndex;
  sName := Piece(clbOptions.Items[i], '=', 1);
  sValue := PreferenceComments.stringValue(sName);

  sOutput := '';
  for i := 1 to Length(sValue) do
    begin
      s := copy(sValue, i, 1);
      if s = '^' then
        sOutput := sOutput + #13#10
      else
        sOutput := sOutput + s;
    end;

  //  sOutput := piece(sOutput,'<MIN>',1);
  //  sOutput := piece(sOutput,'<MAX>',1);

  mmComments.Lines.Text := sOutput;

  if mmComments.Lines.Count < 3 then
    mmComments.Lines.Text := #13#10 + mmComments.Lines.Text;
end;

procedure TfrmAddOptions.pnlAssignDblClick(Sender: TObject);
begin
  pnlTopComment.Visible := not pnlTopComment.Visible;
  mmComments.Visible := not mmComments.Visible;
end;

end.
