unit fMDK_CDS;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 1/24/08 2:24p $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  The unit contains general client data set view/edit form
*                     and providers special actions to support the Hemodialysis
*                     application dictionary
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms/fMDK_CDS.pas $
*
*       $ History: fMDK_CDS.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, DBCtrls, ExtCtrls, Grids, ValEdit, Buttons, DBGrids, DB,
  ComCtrls, DBClient, ActnList, Menus, ImgList;

type
  TStringReplace = function(aString: string): string;

  TfrmMDK_CDS = class(TForm)
    pnlDetailsCDS: TPanel;
    pnlCDSTools: TPanel;
    ActionList1: TActionList;
    acSend: TAction;
    acSaveAs: TAction;
    acLoad: TAction;
    acDictionaryCreate: TAction;
    acDictionarySave: TAction;
    acDictionaryLoad: TAction;
    dlgSave: TSaveDialog;
    dlgOpen: TOpenDialog;
    acGUIUpdate: TAction;
    acUpdateField: TAction;
    acDeleteAll: TAction;
    acCopyRecord: TAction;
    acRecover: TAction;
    acSortAndFilter: TAction;
    splCDS: TSplitter;
    pnlCDSDetails: TPanel;
    pnlFieldName: TPanel;
    DBMemo1: TDBMemo;
    ImageList1: TImageList;
    Panel2: TPanel;
    pcMain: TPageControl;
    tsAccessSites: TTabSheet;
    Panel12: TPanel;
    dbG: TDBGrid;
    tsRecord: TTabSheet;
    vleRecord: TValueListEditor;
    pnlInfoPlus0: TPanel;
    acPatchDictionary: TAction;
    acViewXML: TAction;
    acSaveInstrumentData: TAction;
    pnlPos: TPanel;
    Bevel1: TBevel;
    pnlDBN: TPanel;
    dbN: TDBNavigator;
    sbSaveAs: TBitBtn;
    ckbConfirmDelete: TCheckBox;
    acSaveAsVistAOption: TAction;
    acReload: TAction;
    acResetID: TAction;
    pnlDictionaryPlus: TPanel;
    BitBtn9: TBitBtn;
    BitBtn12: TBitBtn;
    bbResetID: TBitBtn;
    pnlDictionaryActions1: TPanel;
    BitBtn11: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn8: TBitBtn;
    pnlInfoPlus: TPanel;
    BitBtn2: TBitBtn;
    sbRecover: TBitBtn;
    bbReload: TBitBtn;
    bbSaveAsVistAOption: TBitBtn;
    sbLoad: TBitBtn;
    acDictionaryVerify: TAction;
    BitBtn1: TBitBtn;
    acReloadDictionary: TAction;
    acSetLabels: TAction;
    bbDeleteAll: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn7: TBitBtn;
    acClearField: TAction;
    BitBtn4: TBitBtn;
    acDictionaryDefault: TAction;
    BitBtn5: TBitBtn;
    pnlDictionaryBackup: TPanel;
    acDictionaryBackup: TAction;
    acDictionaryRestore: TAction;
    BitBtn6: TBitBtn;
    BitBtn13: TBitBtn;
    procedure acSaveAsExecute(Sender: TObject);
    procedure acDictionaryCreateExecute(Sender: TObject);
    procedure acDictionarySaveExecute(Sender: TObject);
    procedure acDictionaryLoadExecute(Sender: TObject);
    procedure dbGKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dbGTitleClick(Column: TColumn);
    procedure dbGDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure dbGCellClick(Column: TColumn);
    procedure ckbConfirmDeleteClick(Sender: TObject);
    procedure acLoadExecute(Sender: TObject);
    procedure dbNClick(Sender: TObject; Button: TNavigateBtn);
    procedure pcMainChange(Sender: TObject);
    procedure acGUIUpdateExecute(Sender: TObject);
    procedure acDeleteAllExecute(Sender: TObject);
    procedure acCopyRecordExecute(Sender: TObject);
    procedure acRecoverExecute(Sender: TObject);
    procedure acSortAndFilterExecute(Sender: TObject);
    procedure acPatchDictionaryExecute(Sender: TObject);
    procedure acSaveInstrumentDataExecute(Sender: TObject);
    procedure acSaveAsVistAOptionExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acReloadExecute(Sender: TObject);
    procedure acResetIDExecute(Sender: TObject);
    procedure acDictionaryVerifyExecute(Sender: TObject);
    procedure acReloadDictionaryExecute(Sender: TObject);
    procedure acSetLabelsExecute(Sender: TObject);
    procedure acClearFieldExecute(Sender: TObject);
    procedure acDictionaryDefaultExecute(Sender: TObject);
    procedure dbGDblClick(Sender: TObject);
    procedure acDictionaryRestoreExecute(Sender: TObject);
    procedure acDictionaryBackupExecute(Sender: TObject);
  private
    { Private declarations }
    fCDSOptionName: string;
    procedure ShowPosition;
    function getXML: string;
    procedure ForAllRecords(aField: string; SR: TStringReplace);
  public
    { Public declarations }
    procedure ShowCDSRecord(aCDS: TClientDataSet);
    procedure SelectCDS(aName: string);
    procedure SetStatus(aStatus: string);
    procedure SetUpLayout(b: Boolean);
  end;

var
  frmMDK_CDS: TfrmMDK_CDS;

implementation

uses
//  fMDK_SendTo
  dMDK_Data
  , uMDK_Engine
  , uMDK_CDSCommon
  , uGMV_VersionInfo
  , uROR_CommonUtils
  , fMDK_SorAndFilter
  , uMDK_Options
//  , fMDK_XMLView
  , uXML, uMDK_Dictionary, uMDK_Common;

const
  msgSystemOptionLockFailed = 'System Option Lock Failed' + #13#10;

{$R *.dfm}

procedure TfrmMDK_CDS.ShowPosition;
begin
  try
    pnlPos.Caption := Format('%d/%d',
      [TClientDataSet(dbg.DataSource.DataSet).RecNo,
      TClientDataSet(dbg.DataSource.DataSet).RecordCount]);
  except
  end;
end;

procedure TfrmMDK_CDS.acSaveAsExecute(Sender: TObject);
var
  SL: TStringList;
begin
  SL := nil;
  if dlgSave.Execute then
    try
      TClientDataSet(dbg.DataSource.DataSet).MergeChangeLog;
      SL := TStringList.Create;
      SL.Text := TClientDataSet(dbg.DataSource.DataSet).XMLData;
      SL.SaveToFile(dlgSave.FileName);
    finally
      SL.Free;
    end;
  ShowPosition;
end;

procedure TfrmMDK_CDS.acLoadExecute(Sender: TObject);
var
  SL: TStringList;
begin
  if dlgOpen.Execute then
    begin
      SL := TStringList.Create;
      SL.LoadFromFile(dlgOpen.FileName);

      try
        if CDSGetData(dmData.cdsSource, SL.Text) then
          begin
            //            CDSMerge(dmData.cdsSource,TClientDataSet(dbg.DataSource.DataSet),'ID');
            CDSAppend(dmData.cdsSource, TClientDataSet(dbg.DataSource.DataSet));
          end;
      except
      end;

      SL.Free;
    end;
  ShowPosition;
end;

procedure TfrmMDK_CDS.acDictionaryCreateExecute(Sender: TObject);
begin
  uMDK_Dictionary.DictionaryID := 0;
  UpdateDictionary(dmData.cdsInfo);
  UpdateDictionary(dmData.cdsFlowSheet);
  UpdateDictionary(dmData.cdsAP);
  UpdateDictionary(dmData.cdsAPHistory);
  UpdateDictionary(dmData.cdsVAInfection);
  UpdateDictionary(dmData.cdsStudyHistory);
  UpdateDictionary(dmData.cdsMedList);
  UpdateDictionary(dmData.cdsSummary);
  UpdateDictionary(dmData.cdsNotes);
  ShowPosition;
end;

procedure TfrmMDK_CDS.acDictionarySaveExecute(Sender: TObject);
begin
  Engine.SaveDictionaryToDB;
end;

procedure TfrmMDK_CDS.acDictionaryLoadExecute(Sender: TObject);
begin
  Engine.LoadDictionaryFromDB;
end;

procedure TfrmMDK_CDS.dbGKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  ShowPosition;
end;

procedure TfrmMDK_CDS.dbGTitleClick(Column: TColumn);
begin
  try
    TClientDataSet(dbg.DataSource.DataSet).IndexFieldNames := Column.FieldName;
  except
  end;
end;

procedure TfrmMDK_CDS.dbGDrawColumnCell(Sender: TObject; const Rect: TRect;
  DataCol: Integer; Column: TColumn; State: TGridDrawState);
var
  field: TField;
  dataset: TDataSet;
  risk: string;
begin
  dataset := dbg.DataSource.DataSet;
  if (DataSet = dmData.dsEvents.DataSet)
    or (DataSet = dmData.dsStudyEvents.DataSet) then
    begin
      field := dataset.FieldByName(fnEvents_Type);
      risk := field.asString;
      if risk = etDebug then
        dbg.canvas.font.color := clBlack
      else if risk = etWarning then
        dbg.canvas.font.color := clBlue
      else if risk = etInfo then
        dbg.canvas.font.color := clGreen
      else
        dbg.canvas.font.color := clRed;

      if (gdFocused in State) {//  or (gdSelected in State)} then
        begin
          dbg.canvas.font.color := clWhite;
        end
      else
        begin
          if risk = etWarning then
            dbg.Canvas.Brush.color := $00FFFDE6
          else if risk = etError then
            dbg.Canvas.Brush.color := $00FFFDE6
          else if risk = etInfo then
            dbg.Canvas.Brush.color := $00C8ECFD
          else
            dbg.Canvas.Brush.color := clWindow;
        end;
      dbg.DefaultDrawColumnCell(Rect, DataCol, Column, State);
    end
  else
    dbg.DefaultDrawColumnCell(rect, DataCol, column, state);
end;

procedure TfrmMDK_CDS.dbGCellClick(Column: TColumn);
begin
  try
    dbMemo1.DataField := Column.FieldName;
    ShowPosition;
  except
  end;
end;

procedure TfrmMDK_CDS.ShowCDSRecord(aCDS: TClientDataSet);
var
  i: Integer;
  s: string;
  sl: TStringList;
begin
  if not Assigned(aCDS) then
    Exit;
  if not aCDS.Active then
    Exit;
  try
    if not aCDS.RecordCount > 0 then
      exit;
  except
    Exit;
  end;
  s := '';
  SL := TStringList.Create;
  for i := 0 to aCDS.FieldDefs.Count - 1 do
    begin
      try
        s := aCDS.FieldByName(aCDS.FieldDefs[i].Name).AsString;
      except
        s := '';
      end;
      SL.Add(aCDS.FieldDefs[i].Name + '=' + s);
    end;
  vleRecord.Strings.Assign(SL);
  for i := 0 to aCDS.FieldDefs.Count - 1 do
    vleRecord.ItemProps[i].ReadOnly := True;

  SL.Free;
  ShowPosition;
end;

procedure TfrmMDK_CDS.SelectCDS(aname: string);
(*
  procedure SetupEventsGrid;
  var
    iWidth,iIndex,i: Integer;

  begin
    iWidth := 0;
    iIndex := 0;
    for i := 0 to dbg.Columns.Count - 1 do
      if dbg.Columns[i].FieldName = 'Comments' then
        iIndex := i
      else
        iWidth := iWidth + dbg.Columns[i].Width;

    dbg.Columns[iIndex].Width := dbg.Width - iWidth - 35;
  end;
*)

begin
  fCDSOptionName := 'Unknown';

  acDictionaryCreate.Enabled := False;
  acDictionaryLoad.Enabled := False;
  acDictionarySave.Enabled := False;
  acGUIUpdate.Enabled := False;
  acCopyRecord.Enabled := False;

{$IFDEF AANTEST}
  dbg.ReadOnly := False;
  frmMDK_CDS.dbN.Enabled := True;
{$ENDIF}

  if aName = 'Summary' then
    begin
      dbG.DataSource := dmData.dsSummary;
      dbN.DataSource := dmData.dsSummary;
      fCDSOptionName := '';
    end
  else if aName = 'Study History' then
    begin
      dbG.DataSource := dmData.dsStudyHistory;
      dbN.DataSource := dmData.dsStudyHistory;
      fCDSOptionName := '';
    end
  else if (aName = 'Flow Sheet') or (aName = 'Flowsheet') then
    begin
      dbG.DataSource := dmData.dsFlowSheet;
      dbN.DataSource := dmData.dsFlowSheet;
      fCDSOptionName := '';
    end
      //  else if aName = 'Events' then
  else if aName = 'Application Events' then
    begin
      dbG.DataSource := dmData.dsEvents;
      dbN.DataSource := dmData.dsEvents;
      //      SetUpEventsGrid;
      fCDSOptionName := '';
    end
  else if aName = 'Info' then
    begin
      dbG.DataSource := dmData.dsInfo;
      dbN.DataSource := dmData.dsInfo;
      fCDSOptionName := '';
    end
  else if (aName = 'AP') or (aName = 'Access Points') then
    begin
      dbG.DataSource := dmData.dsAP;
      dbN.DataSource := dmData.dsAP;
      fCDSOptionName := '';
    end
  else if aName = 'AP History' then
    begin
      dbG.DataSource := dmData.dsAPHistory;
      dbN.DataSource := dmData.dsAPHistory;
      fCDSOptionName := '';
    end
  else if aName = 'AP Infection History' then
    begin
      dbG.DataSource := dmData.dsVAInfection;
      dbN.DataSource := dmData.dsVAInfection;
      fCDSOptionName := '';
    end
  else if aName = 'Medication' then
    begin
      dbG.DataSource := dmData.dsMedList;
      dbN.DataSource := dmData.dsMedList;
      fCDSOptionName := '';
    end
  else if aName = 'Timeline' then
    begin
      dbG.DataSource := dmData.dsTimeline;
      dbN.DataSource := dmData.dsTimeline;
      fCDSOptionName := '';
    end
  else if aName = 'Notes' then
    begin
      dbG.DataSource := dmData.dsNotes;
      dbN.DataSource := dmData.dsNotes;
      fCDSOptionName := '';
    end
  else if aName = 'Study Events' then
    begin
      dbG.DataSource := dmData.dsStudyEvents;
      dbN.DataSource := dmData.dsStudyEvents;
      fCDSOptionName := '';
    end
      //  else if aName = 'Study List' then
      //    begin
      //      dbG.DataSource := dmData.dsStudyList;
      //      dbN.DataSource := dmData.dsStudyList;
      //    end
  else if aName = 'Status' then
    begin
      dbG.DataSource := dmData.dsStatus;
      dbN.DataSource := dmData.dsStatus;
      fCDSOptionName := '';
    end
  else if aName = onSubmittedStudies then
    begin
      dbG.DataSource := dmData.dsSubmitHistory;
      dbN.DataSource := dmData.dsSubmitHistory;
      fCDSOptionName := onSubmittedStudies;
    end
  else if (aName = 'Dictionary') or (aName = 'Application Dictionary') then
    begin
      dbG.DataSource := dmData.dsDict;
      dbN.DataSource := dmData.dsDict;
      acDictionaryCreate.Enabled := True;
      acDictionaryLoad.Enabled := True;
      acDictionarySave.Enabled := True;
      acGUIUpdate.Enabled := True;
      acCopyRecord.Enabled := True;

      fCDSOptionName := onDictionary;
    end
      ;

  if fCDSOptionName <> 'Unknown' then
    begin
      ShowCDSRecord(TClientDataSet(dbg.DataSource.DataSet));
      dbMemo1.DataField := '';
      dbMemo1.DataSource := dbg.DataSource;
      dbMemo1.DataField := dbg.DataSource.DataSet.FieldDefs[0].Name;
    end;
end;

procedure TfrmMDK_CDS.ckbConfirmDeleteClick(Sender: TObject);
begin
  dbN.ConfirmDelete := ckbConfirmDelete.Checked;
end;

procedure TfrmMDK_CDS.dbNClick(Sender: TObject; Button: TNavigateBtn);
begin
  ShowCDSRecord(TClientDataSet(dbg.DataSource.DataSet));
  ShowPosition;
end;

procedure TfrmMDK_CDS.pcMainChange(Sender: TObject);
begin
  try
    ShowCDSRecord(TClientDataSet(dbg.DataSource.DataSet));
  except
  end;
end;

procedure TfrmMDK_CDS.acGUIUpdateExecute(Sender: TObject);
var
  aBM: TBookmark;
begin
  aBM := dmData.cdsDict.GetBookmark;
  Engine.setUpFields;
  dmData.cdsDict.GotoBookmark(aBM);
  dmData.cdsDict.FreeBookmark(aBM);
end;

procedure TfrmMDK_CDS.acDeleteAllExecute(Sender: TObject);
begin
  if not ckbConfirmDelete.Checked or
    (MessageDlg('Delete all records from the Table?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
    try
      dbN.DataSource.DataSet.First;
      while not dbN.DataSource.DataSet.EOF and
        (dbN.DataSource.DataSet.RecordCount > 0) do
        dbN.DataSource.DataSet.Delete;
      ShowPosition;
    except
    end;
end;

procedure TfrmMDK_CDS.acCopyRecordExecute(Sender: TObject);
var
  i, ii: Integer;
  s: string;
const
  cc = '00000000';
begin
  s := '';
  ii := dbN.DataSource.DataSet.Fields[0].AsInteger + 2;

  for i := 0 to dbN.DataSource.DataSet.FieldCount - 1 do
    s := s + dbN.DataSource.DataSet.Fields[i].AsString + '^';

  dbN.DataSource.DataSet.Insert;
  for i := 1 to dbN.DataSource.DataSet.FieldCount - 1 do
    dbN.DataSource.DataSet.Fields[i].AsString := Piece(s, '^', i + 1);

  s := IntToStr(ii);
  s := copy(cc, 1, Length(cc) - Length(s)) + s;
  dbN.DataSource.DataSet.Fields[0].AsString := s;
  dbN.DataSource.DataSet.Post;

end;

procedure TfrmMDK_CDS.acRecoverExecute(Sender: TObject);
var
  s: string;
  SL: TStringList;
  ds: TDataSet;
begin
  ds := dbg.DataSource.DataSet;

  s := ds.FieldByName(fnEvents_Comments).AsString;
  if pos(XML_VERSION, s) < 1 then
    begin
      ShowMessage('No Valid XML string found in the field <' + fnEvents_Comments
        + '>');
      Exit;
    end;

  ds.Next;
  while (ds.FieldByName(fnEvents_StudyID).AsString = cToBeContinued)
    and (not ds.EOF) do
    begin
      s := s + ds.FieldByName(fnEvents_Comments).AsString;
      ds.Next;
    end;
  if dlgSave.Execute then
    begin
      SL := TStringList.Create;
      SL.Text := s;
      SL.SaveToFile(dlgSave.FileName);
      SL.Free;
    end;
end;

procedure TfrmMDK_CDS.acSortAndFilterExecute(Sender: TObject);
var
  i: Integer;
  s: string;
  aCDS: TDataSet;
begin
  try
    aCDS := dbg.DataSource.DataSet;
    if not assigned(dlgSort) then
      begin
        Application.CreateForm(TdlgSort, dlgSort);
        s := '';
        for i := 0 to aCDS.FieldCount - 1 do
          if aCDS.Fields[i].Visible then
            s := s + aCDS.Fields[i].FieldName + #13#10;
        dlgSort.cmbField.Items.Text := s;
        dlgSort.lbFrom.Items.Text := s;
      end;
    if dlgSort.ShowModal = mrOK then
      begin
        try
          aCDS.Filter := dlgSort.mmFilter.Text;
          aCDS.Filtered := dlgSort.mmFilter.Text <> '';
        except
        end;

        if dlgSort.rbYes.Checked then
          TClientDataSet(aCDS).IndexFieldNames := dlgSort.edSort.Text
        else
          TClientDataSet(aCDS).IndexFieldNames := '';
      end;
  except
  end;
end;

procedure TfrmMDK_CDS.SetStatus(aStatus: string);
begin
{$IFDEF AANTEST}
  sbLoad.Visible := True;
  sbRecover.Visible := True;
  sbSaveAs.Visible := True;
  ckbConfirmDelete.Visible := True;
  pnlDBN.Visible := True;
  pnlInfoPlus.Visible := true;
  pnlDictionaryPlus.Visible := true;
{$ELSE}
  sbLoad.Visible := False;
  sbSaveAs.Visible := False;

  sbRecover.Visible := aStatus = rnAdmin;
  pnlDBN.Visible := aStatus = rnAdmin;

  ckbConfirmDelete.Visible := False;
  pnlInfoPlus.Visible := false;
  pnlDictionaryPlus.Visible := False;
  bbReload.Visible := false;
  bbSaveAsVistaOption.Visible := false;
{$ENDIF}
end;

procedure TfrmMDK_CDS.acPatchDictionaryExecute(Sender: TObject);
var
  SL: TStringList;
begin
  if
    (MessageDlg('Do you want to save the copy of current dictionary in a text file?', mtInformation,
    [mbOk, mbNo], 0) = mrOK) then
    acSaveAsExecute(nil);

  if dlgOpen.Execute then
    begin
      SL := TStringList.Create;
      SL.LoadFromFile(dlgOpen.FileName);

      dmData.PatchDictionary(SL.Text);

      SL.Free;
    end;
  ShowPosition;
end;

procedure TfrmMDK_CDS.acSaveInstrumentDataExecute(Sender: TObject);
var
  s, ss, sName, sExtension: string;
  i: Integer;
  ds: TDataSet;
  sl: TStringList;
begin

  if not dlgSave.Execute then
    Exit;

  s := dlgSave.FileName;

  sExtension := ExtractFileExt(s);
  sName := ExtractFileName(s);
  sName := ChangeFileExt(sName, '.');
  sName := copy(sName, 1, Length(sName) - 1);
  i := 0;

  SL := TStringList.Create;
  ds := dbg.DataSource.DataSet;

  repeat
    inc(i);
    sl.Clear;
    s := ds.FieldByName(fnEvents_Comments).AsString;
    ds.Next;
    while (ds.FieldByName(fnEvents_StudyID).AsString = cToBeContinued)
      and (not ds.EOF) do
      begin
        s := s + ds.FieldByName(fnEvents_Comments).AsString;
        ds.Next;
      end;
    try
      if pos('<?xml', s) > 0 then
        begin
          while (pos('<?xml', s) <> 1) and (Length(s) > 5) do
            s := copy(s, 2, Length(s));
        end
      else
        begin
        end;
    except
    end;
    sl.Text := s;
    ss := Format('%s-%-2.2d%s', [sName, i, sExtension]);
    if s <> '' then
      sl.SaveToFile(ss);
  until ds.EOF or (ds.FieldByName(fnEvents_Action).AsString <>
    'Get Instrument Results');
  SL.Free;

end;

procedure TfrmMDK_CDS.acSaveAsVistAOptionExecute(Sender: TObject);
var
  s: string;
begin
  try
    //    s := fCDSOptionName; -- it's too dengerous to overwrite dictionary.
    s := 'COPY_' + dbg.DataSource.DataSet.Name;
    if InputQuery('Input Box', 'Enter the name of the option to save table <' +
      dbg.DataSource.DataSet.Name + '>', s) and
      (s <> '') then
      try
        //        if Engine.LockSystemOption(s) then
        begin
          TClientDataSet(dbg.DataSource.DataSet).MergeChangeLog;
          Engine.setSystemOptionByName(s,
            TClientDataSet(dbg.DataSource.DataSet).XMLData);
          //            Engine.UnLockSystemOption(s);
        end
        //        else
        //          ShowMessage({msgSystemOptionLockFailed+}'CDS XML was not saved');
      except
        on E: Exception do
          ShowMessage({msgSystemOptionLockFailed+}'CDS XML was not saved');
      end;
  except
  end;
end;

procedure TfrmMDK_CDS.FormCreate(Sender: TObject);
begin
{$IFDEF AANTEST}
  bbSaveAsVistaOption.Visible := True;
  bbResetID.Visible := True;
  sbLoad.Visible := True;
{$ENDIF}
end;

procedure TfrmMDK_CDS.acReloadExecute(Sender: TObject);
var
  s: string;
begin
  s := getXML;
  if s = '' then
    ShowMessage('Incorrect Format. Try another record')
  else
    Engine.setInstrumentRecord(Engine.CurrentPatient.ID,
      Engine.CurrentPatient.SessionID, s,
      'Reload Log Record');
end;

function TfrmMDK_CDS.getXML: string;
var
  s: string;
  ds: TDataSet;
begin
  ds := dbg.DataSource.DataSet;
  ds.DisableControls; // vhaishandria 061011
  s := ds.FieldByName(fnEvents_Comments).AsString;

  ds.Next;
  while (ds.FieldByName(fnEvents_StudyID).AsString = cToBeContinued)
    and (not ds.EOF) do
    begin
      s := s + ds.FieldByName(fnEvents_Comments).AsString;
      ds.Next;
    end;
  ds.EnableControls; // vhaishandria 061011
  try
    if pos('<?xml', s) > 0 then
      begin
        while (pos('<?xml', s) <> 1) and (Length(s) > 5) do
          s := copy(s, 2, Length(s));
      end
    else
      s := '';
  except
  end;

  Result := s;
end;

procedure TfrmMDK_CDS.acResetIDExecute(Sender: TObject);
begin
  with dmData.cdsDict do
    begin
      Last;
      while not BOF do
        begin
          Edit;
          FieldByName(fnDict_ID).AsString := Format('%8.8d', [RecNo * 10]);
          Post;
          Prior;
        end;
    end;

end;

procedure TfrmMDK_CDS.acDictionaryVerifyExecute(Sender: TObject);
begin
  VerifyDictionary(dmData.cdsInfo);
  VerifyDictionary(dmData.cdsFlowSheet);
  VerifyDictionary(dmData.cdsAP);
  VerifyDictionary(dmData.cdsAPHistory);
  VerifyDictionary(dmData.cdsVAInfection);
  VerifyDictionary(dmData.cdsStudyHistory);
  VerifyDictionary(dmData.cdsMedList);
  VerifyDictionary(dmData.cdsSummary);
  VerifyDictionary(dmData.cdsNotes);
end;

procedure TfrmMDK_CDS.acReloadDictionaryExecute(Sender: TObject);
begin
  Engine.LoadDictionaryFromDB;
  Engine.setUpFields;
end;

procedure TfrmMDK_CDS.acSetLabelsExecute(Sender: TObject);
var
  s: string;
  aCDS: TClientDataSet;
  BM: TBookmark;
begin
  aCDS := TClientDataSet(dbN.DataSource.DataSet);
  BM := aCDS.GetBookmark;

  aCDS.First;
  while not aCDS.Eof do
    begin
      s := aCDS.FieldByName(fnDict_Label).AsString;
      if pos('<', s) = 1 then
        s := copy(s, 2, Length(s));
      if pos('>', s) = Length(s) then
        s := copy(s, 1, Length(s) - 1);
      aCDS.Edit;
      aCDS.FieldByName(fnDict_Label).AsString := s;
      aCDS.Post;

      aCDS.Next;
    end;

  aCDS.GotoBookmark(BM);
  aCDS.FreeBookmark(BM);

end;

procedure TfrmMDK_CDS.ForAllRecords(aField: string; SR: TStringReplace);
var
  s: string;
  aCDS: TClientDataSet;
  BM: TBookmark;
begin
  if not Assigned(SR) then
    Exit;

  aCDS := TClientDataSet(dbN.DataSource.DataSet);
  BM := aCDS.GetBookmark;

  aCDS.First;
  while not aCDS.Eof do
    begin
      try
        s := aCDS.FieldByName(aField).AsString;
      except
        Exit;
      end;
      aCDS.Edit;
      aCDS.FieldByName(aField).AsString := SR(s);
      aCDS.Post;

      aCDS.Next;
    end;

  aCDS.GotoBookmark(BM);
  aCDS.FreeBookmark(BM);

end;

function ReplacePounds(aString: string): string;
begin
  if pos('#', trim(aString)) = 1 then
    Result := ''
  else
    Result := aString;
end;

procedure TfrmMDK_CDS.acClearFieldExecute(Sender: TObject);
begin
  ForAllRecords(fnDict_Format, ReplacePounds);
end;

procedure TfrmMDK_CDS.acDictionaryDefaultExecute(Sender: TObject);
var
  s: string;
begin
  s := getDefaultResource(onDictionary);
  if s <> '' then
    begin
      Engine.LoadDictionaryFromString(s);
    end;
end;

procedure TfrmMDK_CDS.dbGDblClick(Sender: TObject);
var
  s: string;
  cdsDict,
    CDS: TClientDataSet;
  aF: TField;

begin
  if fCDSOptionName <> onDictionary then
    Exit;

  if Engine.CurrentOperatorMode <> rnADMIN then
    Exit;

  cdsDict := TClientDataSet(dbg.DataSource.DataSet);
  s := cdsDict.FieldByName(fnDict_Table).AsString;
  CDS := dmData.getCDSByName(s);
  if not assigned(CDS) then
    Exit;

  s := cdsDict.FieldByName(fnDict_Column).AsString;
  aF := CDS.FieldByName(s);

  s :=
    'FullName: ' + aF.FullName + #13#10 +
    'Display Name: ' + aF.DisplayName + #13#10 +
    'Data Type: ' + DataTypeComment(aF.DataType) + #13#10;
  if aF.DataType = ftInteger then
    s := s +
      'Min Value: ' + IntToStr(TIntegerField(aF).MinValue) + #13#10 +
      'Max Value: ' + IntToStr(TIntegerField(aF).MaxValue) + #13#10;
  if aF.DataType = ftFloat then
    s := s +
      'Min Value: ' + Format('%n', [TFloatField(aF).MinValue]) + #13#10 +
    'Max Value: ' + Format('%n', [TFloatField(aF).MaxValue]) + #13#10;

  s := s + #13#10;

  if MessageDlg(s + 'Reset GUI fields assosiated with this dictionary line?',
    mtConfirmation, [mbNo, mbOK], 0) <> mrOk then
    Exit;

  CDSSetUpField(aF,
    cdsDict.FieldByName(fnDict_Format).AsString,
    cdsDict.FieldByName(fnDict_EditMask).AsString,
    cdsDict.FieldByName(fnDict_Width).AsString,
    cdsDict.FieldByName(fnDict_Units).AsString,
    cdsDict.FieldByName(fnDict_Default).AsString,
    cdsDict.FieldByName(fnDict_Section).AsString,
    cdsDict.FieldByName(fnDict_Label).AsString,
    cdsDict.FieldByName(fnDict_MaxValue).AsString,
    cdsDict.FieldByName(fnDict_MinValue).AsString
    );

end;

procedure TfrmMDK_CDS.acDictionaryRestoreExecute(Sender: TObject);
begin
// restoration of the dictionary from backup  copy
{$IFDEF DICTIONARY_BACKUP}
  Engine.LoadDictionaryFromDB(donDictionaryBackup);
{$ENDIF}
end;

procedure TfrmMDK_CDS.acDictionaryBackupExecute(Sender: TObject);
begin
// backup copy of dictionary
{$IFDEF DICTIONARY_BACKUP}
  Engine.SaveDictionaryToDB(donDictionaryBackup);
{$ENDIF}
end;

(*
procedure TfrmMDK_CDS.acViewXMLExecute(Sender: TObject);
var
  s: string;
  form: TfrmXMLView;
begin
  try
    s := getXML;
    if s = '' then
      Exit;
    form := getXMLView(s);
    form.Show;
  except
  end;
end;

*)
procedure TfrmMDK_CDS.SetUpLayout(b: Boolean);
begin
  pnlCDSDetails.Visible := True;
  pnlFieldName.Visible := True;
  pnlDictionaryActions1.Visible := b;
  pnlDictionaryBackup.Visible := True;
  dbg.ReadOnly := False;
  dbN.Enabled := True;
  acDeleteAll.Enabled := True;
  acLoad.Enabled := True;
  dbN.VisibleButtons := [nbFirst, nbPrior, nbNext, nbLast,
      nbRefresh, nbEdit, nbPost, nbCancel];
end;
end.
