unit fMDK_DateRangeSelector;
{
================================================================================
*
*       Application:  Vitals
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
*       Developer:    andriyevskiy                  
*       Site:         Hines OIFO
*
*       Description:  Selects two date ranges.
*
*       Notes:        based on fGMV_DateRange.pas
*
================================================================================
*       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_DateRangeSelector.pas $
*
* $History: fMDK_DateRangeSelector.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/13/09    Time: 1:15p
 * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
 * Patch 19 source code
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/24/08    Time: 4:23p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/02/08    Time: 9:24a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 6/20/07    Time: 3:23p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 6/04/07    Time: 9:08a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/22/07    Time: 9:16a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 3/27/07    Time: 1:31p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:38p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:27p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/25/07    Time: 9:39a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:36p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Forms
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:28p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Forms
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/28/06    Time: 5:15p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
 *
*
================================================================================
}
interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ComCtrls,
  ExtCtrls;

type
  TfrmGMV_DateRange = class(TForm)
    Panel1: TPanel;
    Panel5: TPanel;
    GroupBox1: TGroupBox;
    lblFrom: TLabel;
    lblTo: TLabel;
    dtpFrom: TDateTimePicker;
    dtpTo: TDateTimePicker;
    Panel2: TPanel;
    btnOK: TButton;
    btnCancel: TButton;
    procedure btnOKClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dtpFromEnter(Sender: TObject);
    procedure dtpFromExit(Sender: TObject);
    procedure dtpToExit(Sender: TObject);
    procedure dtpToEnter(Sender: TObject);
  private
  public
    { Public declarations }
  end;

implementation

const
  clTabIn = clWindow;
  clTabOut = clInfoBk;
{$R *.DFM}

function GetDateRange(var FromDate, ToDate: TDateTime; AllowFutureDate: Boolean
  = True; AllowPastDate: Boolean = True): Boolean;
begin
  with TfrmGMV_DateRange.Create(Application) do
    try
      dtpFrom.DateTime := FromDate;
      dtpTo.DateTime := ToDate;
      dtpFrom.MaxDate := TRunc(Now);
      dtpTo.MaxDate := dtpFrom.MaxDate;
      activeControl := dtpFrom;
      ShowModal;
      if ModalResult = mrOK then
        begin
          FromDate := dtpFrom.Date;
          ToDate := dtpTo.Date;
          Result := True;
        end
      else
        Result := False;
    finally
      free;
    end;
end;

procedure TfrmGMV_DateRange.btnOKClick(Sender: TObject);
begin
  if trunc(dtpFrom.DateTime) <= trunc(dtpTo.DateTime) then
    ModalResult := mrOk
  else
    MessageDlg('The ''Start with Date'' must be less' + #13 +
      'than the ''Go to Date'' value.',
      mtInformation, [mbok], 0);
end;

procedure TfrmGMV_DateRange.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    ModalResult := mrCancel;
end;

procedure TfrmGMV_DateRange.dtpFromEnter(Sender: TObject);
begin
  dtpFrom.Color := clTabIn;
end;

procedure TfrmGMV_DateRange.dtpFromExit(Sender: TObject);
begin
  dtpFrom.Color := clTabOut;
end;

procedure TfrmGMV_DateRange.dtpToExit(Sender: TObject);
begin
  dtpTo.Color := clTabOut;
end;

procedure TfrmGMV_DateRange.dtpToEnter(Sender: TObject);
begin
  dtpTo.Color := clTabIn;
end;

end.
