unit fMDK_DateTimeSelector;

interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ComCtrls, ActnList, Mask;

type
  TdlgDateTime = class(TForm)
    Panel1: TPanel;
    CancelBtn: TBitBtn;
    OKbtn: TBitBtn;
    Panel2: TPanel;
    mcDate: TMonthCalendar;
    BitBtn1: TBitBtn;
    ActionList1: TActionList;
    acNow: TAction;
    Label2: TLabel;
    meDate: TMaskEdit;
    pnlTime: TPanel;
    Label1: TLabel;
    meTime: TMaskEdit;
    pnlDate: TPanel;
    acOK: TAction;
    procedure acNowExecute(Sender: TObject);
    procedure mcDateClick(Sender: TObject);
    procedure meDateChange(Sender: TObject);
  private
    { Private declarations }
    fIgnore: Boolean;
  public
    { Public declarations }
  end;

var
  dlgDateTime: TdlgDateTime;

function getDateTime(aTitle, aFormat: string; var aValue: string): Integer;

implementation

uses uMDK_Engine
  , Dialogs
  , uMDK_Utils;

{$R *.dfm}

function getDateTime(aTitle, aFormat: string; var aValue: string): Integer;
var
  dt: TDateTime;
begin
  Result := mrCancel;
  if not Assigned(dlgDateTime) then
    Application.CreateForm(TdlgDateTime, dlgDateTime);
  if not Assigned(dlgDateTime) then
    Exit;

  dlgDateTime.Height := 240;

  dlgDateTime.Caption := aTitle;
  try
    dt := StrToDate(aValue);
    dlgDateTime.mcDate.MaxDate := trunc(Engine.getCurrentServerDateTime);
    dlgDateTime.meTime.Text := FormatDateTime('hh:nn', dt);
    dlgDateTime.meDate.Text := FormatDateTime('mm/dd/yyyy', dt);
  except
    begin
      dt := Engine.getCurrentServerDateTime;
      dlgDateTime.mcDate.MaxDate := trunc(dt);
      dlgDateTime.meTime.Text := FormatDateTime('hh:nn', dt);
      dlgDateTime.meDate.Text := FormatDateTime('mm/dd/yyyy', dt);
    end;
  end;
//  dlgDateTime.mcDate.MaxDate := trunc(dt);
//  dlgDateTime.meTime.Text := FormatDateTime('hh:nn', dt);
//  dlgDateTime.meDate.Text := FormatDateTime('mm/dd/yyyy', dt);
  Result := dlgDateTime.ShowModal;
  if Result = mrOK then
    begin
      dt := StrToDateTime(dlgDateTime.meTime.Text);
      aValue := FormatDateTime(aFormat, trunc(dlgDateTime.mcDate.Date) + dt);
    end;
end;

procedure TdlgDateTime.acNowExecute(Sender: TObject);
var
  dt: TDateTime;
begin
  dt := Engine.getCurrentServerDateTime;
  mcDate.Date := dt;
  meDate.Text := FormatDateTime('mm/dd/yyyy', dt);
  meTime.Text := FormatDateTime('hh:nn', dt);
end;

procedure TdlgDateTime.mcDateClick(Sender: TObject);
var
  b: Boolean;
begin
  b := fIgnore;
  fIgnore := True;

  meDate.Text := FormatDateTime('mm/dd/yyyy', mcDate.Date);
  fIgnore := b;
end;

procedure TdlgDateTime.meDateChange(Sender: TObject);
var
  dt: TDateTime;
  y,m,d: Integer;
begin
  if fIgnore then
    Exit;
  fIgnore := True;
  try
    d := StrToInt(piece(meDate.Text,'/',2));
    m := StrToInt(piece(meDate.Text,'/',1));
    y := StrToInt(piece(meDate.Text,'/',3));
    dt := EncodeDate(y,m,d);
     if dt > mcDate.MaxDate then
      begin
        MessageDLG('Future dates are not available.', mtWarning, [mbOK], 0);
        mcDate.Date := mcDate.MaxDate;
        meDate.Text := FormatDateTime('mm/dd/yyyy', mcDate.Date);
      end
    else
    if dt<0 then
        MessageDLG('The selected date is too far in the past.', mtWarning, [mbOK], 0)
    else
      begin
//        showMessage('Assigned date:' +FormatDateTime('mm/dd/yyyy',dt));
        mcDate.Date := dt;
      end;
  except
  end;
  fIgnore := False;

end;

end.
