unit fMDK_FallAssessement;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 3/31/08 11:23a $
*       Site Name:    Hines OIFO
*       Date Created: 3/11/06
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Falls assessement dialog
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms/fMDK_FallAssessement.pas $
*
*       $ History: fMDK_FallAssessement.pas $
}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, Dialogs;

type
  TFallAssessment = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    GroupBox1: TGroupBox;
    Panel4: TPanel;
    lbAge: TLabel;
    Label4: TLabel;
    rb1: TRadioButton;
    rb2: TRadioButton;
    rb3: TRadioButton;
    rb4: TRadioButton;
    cbEvaluation: TCheckBox;
    cb2: TCheckBox;
    cb5: TCheckBox;
    cb6: TCheckBox;
    cb3: TCheckBox;
    cb4: TCheckBox;
    edOther2: TEdit;
    Panel6: TPanel;
    Label7: TLabel;
    cb21: TCheckBox;
    cbDevice: TCheckBox;
    cb24: TCheckBox;
    cb22: TCheckBox;
    cb25: TCheckBox;
    cb23: TCheckBox;
    cb26: TCheckBox;
    edOther1: TEdit;
    cbConsult: TCheckBox;
    cbHandout: TCheckBox;
    edAge: TEdit;
    procedure cbEvaluationClick(Sender: TObject);
    procedure cbDeviceClick(Sender: TObject);
    procedure rb4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Report: TStringList;
    procedure SetReport;
    procedure CleanUpForm;
  end;

var
  FallAssessment: TFallAssessment;

implementation

uses uMDK_Options, uMDK_Common;

{$R *.dfm}

procedure TFallAssessment.cbEvaluationClick(Sender: TObject);
begin
  rb1.Enabled := cbEvaluation.Checked;
  rb2.Enabled := cbEvaluation.Checked;
  rb3.Enabled := cbEvaluation.Checked;
  rb4.Enabled := cbEvaluation.Checked;

  cbDevice.Enabled := cbEvaluation.Checked;
  cbHandout.Enabled := cbEvaluation.Checked;
  cbConsult.Enabled := cbEvaluation.Checked;

  cb21.Enabled := cbEvaluation.Checked and cbDevice.Checked;
  cb22.Enabled := cbEvaluation.Checked and cbDevice.Checked;
  cb23.Enabled := cbEvaluation.Checked and cbDevice.Checked;
  cb24.Enabled := cbEvaluation.Checked and cbDevice.Checked;
  cb25.Enabled := cbEvaluation.Checked and cbDevice.Checked;
  cb26.Enabled := cbEvaluation.Checked and cbDevice.Checked;
  edOther1.Enabled := cbEvaluation.Checked and cbDevice.Checked;

  cb2.Enabled := cbEvaluation.Checked and rb4.Checked;
  cb3.Enabled := cbEvaluation.Checked and rb4.Checked;
  cb4.Enabled := cbEvaluation.Checked and rb4.Checked;
  cb5.Enabled := cbEvaluation.Checked and rb4.Checked;
  cb6.Enabled := cbEvaluation.Checked and rb4.Checked;
  edOther2.Enabled := cbEvaluation.Checked and rb4.Checked;

  if edOther2.Enabled then
    edOther2.Color := clWindow
  else
    edOther2.Color := clBtnFace;

  if edAge.Enabled then
    edAge.Color := clWindow
  else
    edAge.Color := clBtnFace;

  if edOther1.Enabled then
    edOther1.Color := clWindow
  else
    edOther1.Color := clBtnFace;
end;

procedure TFallAssessment.cbDeviceClick(Sender: TObject);
begin
  cb21.Enabled := cbDevice.Checked;
  cb22.Enabled := cbDevice.Checked;
  cb23.Enabled := cbDevice.Checked;
  cb24.Enabled := cbDevice.Checked;
  cb25.Enabled := cbDevice.Checked;
  cb26.Enabled := cbDevice.Checked;

  edOther1.Enabled := cbDevice.Checked;
  if edOther1.Enabled then
    edOther1.Color := clWindow
  else
    edOther1.Color := clBtnFace;
end;

procedure TFallAssessment.rb4Click(Sender: TObject);
begin
  cb2.Enabled := rb4.Checked;
  cb3.Enabled := rb4.Checked;
  cb4.Enabled := rb4.Checked;
  cb5.Enabled := rb4.Checked;
  cb6.Enabled := rb4.Checked;
  edOther2.Enabled := rb4.Checked;
  if edOther2.Enabled then
    edOther2.Color := clWindow
  else
    edOther2.Color := clBtnFace;
end;

procedure TFallAssessment.FormCreate(Sender: TObject);
begin
  Report := TStringList.Create;
  cbEvaluation.Checked := False;
  cbEvaluationClick(nil);
end;

procedure TFallAssessment.OKBtnClick(Sender: TObject);
begin
  SetReport;
end;

procedure TFallAssessment.SetReport;

  procedure _add(aString: string);
  begin
    Report.Add(aString);
  end;

const
//  _Tab = char(VK_TAB);
  _Tab = '      ';

begin
  Report.Clear;
  if not cbEvaluation.Checked then
    Exit;

  //  _add('');
  if Preferences.bValue(onFallsAssessmentAsTIU) then // vhaishandria 2008-03-31
    _add(cbEvaluation.Caption);

  _add(lbAge.Caption + ' ' + edAge.Text);
  if rb1.Checked then
    _add(rb1.Caption);
  if rb2.Checked then
    _add(rb2.Caption);
  if rb3.Checked then
    _add(rb3.Caption);
  if rb4.Checked then
    begin
      _add(rb4.Caption);
      if cb2.Checked then
        _add(_Tab + cb2.Caption);
      if cb3.Checked then
        _add(_Tab + cb3.Caption);
      if cb4.Checked then
        _add(_Tab + cb4.Caption);
      if cb5.Checked then
        _add(_Tab + cb5.Caption);
      if cb6.Checked then
        _add(_Tab + cb6.Caption);
      if edOther2.Text <> '' then
        _add(_Tab + 'Other: ' + edOther2.Text);
    end;

  if cbDevice.Checked then
    begin
      _add(cbDevice.Caption);
      if cb21.Checked then
        _add(_Tab + cb21.Caption);
      if cb22.Checked then
        _add(_Tab + cb22.Caption);
      if cb23.Checked then
        _add(_Tab + cb23.Caption);
      if cb24.Checked then
        _add(_Tab + cb24.Caption);
      if cb25.Checked then
        _add(_Tab + cb25.Caption);
      if cb26.Checked then
        _add(_Tab + cb26.Caption);
      if edOther1.Text <> '' then
        _add(_Tab + 'Other: ' + edOther1.Text);
    end;
  if cbConsult.Checked then
    _add(cbConsult.Caption);
  if cbHandout.Checked then
    _add(cbHandout.Caption);

end;

procedure TFallAssessment.FormDestroy(Sender: TObject);
begin
  Report.Free;
  inherited;
end;

procedure TFallAssessment.Button1Click(Sender: TObject);
begin
  SetReport;
  if Trim(Report.Text) = '' then
    MessageDlg('Report text is blank'#13 +
      'Check form options and try again.', mtWarning, [mbOK], 0)
  else
    ShowMessage(Report.Text);
end;

procedure TFallAssessment.CleanUpForm;
begin
  cbDevice.Checked := False;
  cbHandout.Checked := False;
  cbConsult.Checked := False;
  cb21.Checked := False;
  cb22.Checked := False;
  cb23.Checked := False;
  cb24.Checked := False;
  cb25.Checked := False;
  cb26.Checked := False;

  cb2.Checked := False;
  cb3.Checked := False;
  cb4.Checked := False;
  cb5.Checked := False;
  cb6.Checked := False;

  edAge.Text := '';
  edOther1.Text := '';
  edOther2.Text := '';

  cbEvaluation.Checked := False;

  rb1.Checked := True;
end;

end.
