unit fMDK_Info;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
*       Site Name:    Hines OIFO
*       Date Created: 3/11/06
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Info form
*       Notes:
*
================================================================================
*       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_Info.pas $
*
* $History: fMDK_Info.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/13/09    Time: 1:15p
 * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
 * Patch 19 source code
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/24/08    Time: 4:23p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/02/08    Time: 9:24a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 4  *****************
 * User: Vhaishandria Date: 6/20/07    Time: 3:23p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 6/07/07    Time: 4:12p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 6/04/07    Time: 9:08a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/22/07    Time: 9:16a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 3/27/07    Time: 1:31p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:38p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:27p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/25/07    Time: 9:39a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:36p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Forms
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:28p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Forms
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 12/13/06   Time: 2:00p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/28/06    Time: 5:15p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, Buttons;

type
  TfrmInfo = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    mmInfo: TMemo;
    BitBtn1: TBitBtn;
    cbWW: TCheckBox;
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure cbWWClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInfo: TfrmInfo;

function ShowInfo(anInfo: string): Integer;

implementation

{$R *.dfm}

function ShowInfo(anInfo: string): Integer;
begin
  if not Assigned(frmInfo) then
    Application.CreateForm(TfrmInfo, frmInfo);
  frmInfo.mmInfo.Text := anInfo;
  Result := frmInfo.ShowModal;
end;

procedure TfrmInfo.FormKeyPress(Sender: TObject; var Key: Char);
begin
  if Key = char(VK_ESCAPE) then
    Close;
end;

procedure TfrmInfo.cbWWClick(Sender: TObject);
begin
  mmInfo.WordWrap := cbWW.Checked;
  if cbWW.Checked then
    mmInfo.ScrollBars := ssVertical
  else
    mmInfo.ScrollBars := ssBoth;
end;

end.
