unit fMDK_ListEdit;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 12/03/07 1:15p $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the  Hemodialysis application
*                     PCE Editor form
*       Notes:
*
================================================================================
*       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_ListEdit.pas $
*
* $History: fMDK_ListEdit.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/13/09    Time: 1:15p
 * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
 * Patch 19 source code
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/24/08    Time: 4:23p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/02/08    Time: 9:24a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 4  *****************
 * User: Vhaishandria Date: 6/21/07    Time: 9:05a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 * Build 312 #14
 * 
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 6/20/07    Time: 3:23p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 6/04/07    Time: 9:08a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/22/07    Time: 9:16a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, ActnList, Buttons, CheckLst, DB,
  DBClient, Grids, DBGrids
  , uMDK_BillingInfo
  ;

type
  TfrmListEdit = class(TForm)
    Panel1: TPanel;
    pnlToolbar: TPanel;
    pnlData: TPanel;
    Panel4: TPanel;
    Panel5: TPanel;
    Panel8: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    edClinicID: TEdit;
    edPatientID: TEdit;
    al: TActionList;
    acSetData: TAction;
    PageControl1: TPageControl;
    tsDiagnosis: TTabSheet;
    tsProcedures: TTabSheet;
    Panel6: TPanel;
    Panel7: TPanel;
    tsProviders: TTabSheet;
    Panel11: TPanel;
    Panel12: TPanel;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    Panel13: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    tvDiagnoses: TTreeView;
    cbDiagnoses: TComboBox;
    Splitter1: TSplitter;
    Panel9: TPanel;
    Splitter2: TSplitter;
    Panel10: TPanel;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel18: TPanel;
    cbProcedure: TComboBox;
    tvProcedure: TTreeView;
    Panel19: TPanel;
    Splitter3: TSplitter;
    Panel20: TPanel;
    cbProvider: TComboBox;
    lbProviders: TListBox;
    Panel21: TPanel;
    Panel22: TPanel;
    clbProvider: TCheckListBox;
    acAddProvider: TAction;
    lblProvider: TLabel;
    acDeleteProvider: TAction;
    Label3: TLabel;
    sbDebug: TSpeedButton;
    acData: TAction;
    acAddDiagnosys: TAction;
    acDeleteDiagnosys: TAction;
    acAddProcedure: TAction;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    acGetProcedures: TAction;
    acGetDiagnoses: TAction;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label4: TLabel;
    edStudy: TEdit;
    SpeedButton4: TSpeedButton;
    acGetEncounterData: TAction;
    Panel3: TPanel;
    Panel23: TPanel;
    lblDiagnoses: TLabel;
    Label6: TLabel;
    ckbDiagnoses: TCheckListBox;
    pnlGrid: TPanel;
    dbgProcedures: TDBGrid;
    cdsProcedures: TClientDataSet;
    dsProcedures: TDataSource;
    acGetLegacy: TAction;
    tsService: TTabSheet;
    pnlService: TPanel;
    mm: TMemo;
    acClear: TAction;
    SpeedButton5: TSpeedButton;
    acSetPCE: TAction;
    SpeedButton6: TSpeedButton;
    acDeleteProcedure: TAction;
    SpeedButton2: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    Timer1: TTimer;
    cbReview: TCheckBox;
    acSave: TAction;
    Label5: TLabel;
    Label7: TLabel;
    SB: TStatusBar;
    mmService: TMemo;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    Splitter4: TSplitter;
    pnlSC: TPanel;
    cbxSC: TCheckBox;
    cbxCV: TCheckBox;
    cbxAOE: TCheckBox;
    cbxIRE: TCheckBox;
    cbxEC: TCheckBox;
    cbxMST: TCheckBox;
    cbxHNC: TCheckBox;
    pnl1: TPanel;
    rbSC1: TRadioButton;
    rbSC2: TRadioButton;
    Panel24: TPanel;
    rbCV1: TRadioButton;
    rbCV2: TRadioButton;
    Panel25: TPanel;
    rbAOE1: TRadioButton;
    rbAOE2: TRadioButton;
    Panel26: TPanel;
    rbIRE1: TRadioButton;
    rbIRE2: TRadioButton;
    Panel28: TPanel;
    rbHNC1: TRadioButton;
    rbHNC2: TRadioButton;
    Panel29: TPanel;
    rbMST1: TRadioButton;
    rbMST2: TRadioButton;
    Panel30: TPanel;
    rbEC1: TRadioButton;
    rbEC2: TRadioButton;
    Label8: TLabel;
    Label9: TLabel;
    Bevel2: TBevel;
    Label10: TLabel;
    Bevel3: TBevel;
    Button1: TButton;
    acReview: TAction;
    acSearchClinic: TAction;
    acSetClinic: TAction;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    acGetPCEInfo: TAction;
    BitBtn9: TBitBtn;
    procedure cbDiagnosesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cbProviderKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure acAddProviderExecute(Sender: TObject);
    procedure clbProviderClick(Sender: TObject);
    procedure acDeleteProviderExecute(Sender: TObject);
    procedure lbProvidersKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure acDataExecute(Sender: TObject);
    procedure acGetProceduresExecute(Sender: TObject);
    procedure acGetDiagnosesExecute(Sender: TObject);
    procedure acGetEncounterDataExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acAddProcedureExecute(Sender: TObject);
    procedure tvProcedureDblClick(Sender: TObject);
    procedure PageControl1Change(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure acGetLegacyExecute(Sender: TObject);
    procedure ckbDiagnosesClick(Sender: TObject);
    procedure acAddDiagnosysExecute(Sender: TObject);
    procedure acDeleteDiagnosysExecute(Sender: TObject);
    procedure pnlGridResize(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure tvDiagnosesKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tvProcedureKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure acSetDataExecute(Sender: TObject);
    procedure acClearExecute(Sender: TObject);
    procedure acSetPCEExecute(Sender: TObject);
    procedure acDeleteProcedureExecute(Sender: TObject);
    procedure dbgProceduresColEnter(Sender: TObject);
    procedure dbgProceduresDblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton7Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
    procedure cbReviewClick(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure SpeedButton10Click(Sender: TObject);
    procedure acReviewExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure acGetPCEInfoExecute(Sender: TObject);
  private
    { Private declarations }
    fLegacy: string;

    function getLegacy: string;
    procedure setLegacy(aValue: string);
    procedure ClearObjects;
    procedure DoProviderSearch(aTarget: string);
    procedure setConnectionData(aV: string);

    procedure SBShow(aString: string);
  protected
    fIgnore: Boolean;
  public
    { Public declarations }
    procedure SetUpClinicInfo;
    property Legacy: string read getLegacy write setLegacy;
    procedure ShowStatus;
    procedure setQuantityLimit(anInteger: Integer);
  end;

var
  frmListEdit: TfrmListEdit;

function UpdateList(aDFN, aClinic: string; aPage: Integer = 0): Integer;

implementation

uses uMDK_Engine, uROR_CommonUtils, uMDK_CDSCommon, uMDK_Options
  , uMDK_Info, uMDK_Common
  ;

{$R *.dfm}

const
  iStatus = 0;
  iLastUpdate = 1;

  fnPr_Quantity = 'Quantity';

function UpdateList(aDFN, aClinic: string; aPage: Integer = 0): Integer;
var
  s,
    sComment: string;
begin
  if not Assigned(frmListEdit) then
    Application.CreateForm(TfrmListEdit, frmListEdit);

  frmListEdit.Legacy := Engine.BillingInfo.Legacy;
  frmListEdit.PageControl1.ActivePageIndex := aPage;
  case aPage of
    0: frmListEdit.ActiveControl := frmListEdit.cbDiagnoses;
    1: frmListEdit.ActiveControl := frmListEdit.cbProcedure;
    2: frmListEdit.ActiveControl := frmListEdit.cbProvider;
  end;
  frmListEdit.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
  frmListEdit.edPatientID.Text := aDFN;
  frmListEdit.SetUpClinicInfo;
  frmListEdit.edStudy.Text := Engine.CurrentPatient.SessionID;
  frmListEdit.acGetEncounterData.Execute;

  frmListEdit.cbReview.Checked := true;
  frmListEdit.cbReviewClick(nil);
  frmListEdit.acReviewExecute(nil);

  Engine.getServiceConnections(Engine.CurrentPatient.ID,
    Engine.CurrentPatient.SessionID, s);
  frmListEdit.mmService.Lines.Text := s;
  frmListEdit.ShowStatus;

  Result := frmListEdit.ShowModal;
  if Result = mrOK then
    begin
      frmListEdit.acGetLegacyExecute(nil);
      Engine.BillingInfo.Legacy := frmListEdit.Legacy;
      Engine.Report(rtInfo, frmListEdit.Legacy, '', 0, ''
        {Engine.CurrentOperatorID}, 'getEncounterData');

      if not Engine.ValidBillingInfo(sComment) then
        begin
          MessageDlg('Billing Information is not correct.' + #13#10 + #13#10 +
            sComment + #13#10 + #13#10
            , mtInformation, [mbOK], 0);
          Result := -1;
        end;
    end;
end;

procedure ClearNode(aName: string; aTree: TTreeView);
var
  j, i: Integer;
  TheNode: TTreeNode;
begin
  TheNode := nil;
  for i := 0 to aTree.Items.Count - 1 do
    begin
      if aTree.Items[i].Text = aName then
        begin
          TheNode := aTree.Items[i];
          Break;
        end;
    end;
  j := 0;
  while J < aTree.Items.Count - 1 do
    begin
      if (TheNode <> nil) and (aTree.Items[j].Parent = TheNode) then
        aTree.Items.Delete(aTree.Items[j])
      else
        Inc(j);
    end;
  if TheNode <> nil then
    aTree.Items.Delete(TheNode);
end;

procedure setUpTab(aName, aValue: string; tv: TTreeView);
var
  SL: TStringList;
  sName, sCode: string;
  i: Integer;
  {tnParent,} tnRoot: TTreeNode;
begin
  ClearNode(aName, tv);
  tnRoot := nil;
  SL := TStringList.Create;
  SL.Text := aValue;
  for i := 1 to SL.Count - 1 do
    begin
      if tnRoot = nil then
        tnRoot := tv.Items.AddChild(nil, aName);
      sCode := Piece(SL[i], '^', 1);
      sName := Piece(SL[i], '^', 2);
      if sCode = '' then
//        tnParent := tv.Items.AddChild(tnRoot, sName)
        tv.Items.AddChild(tnRoot, sName)
      else
//        tv.Items.AddChild(tnParent, sCode + ' -- ' + sname);
        tv.Items.AddChild(tnRoot, sCode + ' -- ' + sname);
    end;
  SL.Free;
end;

procedure TfrmListEdit.cbDiagnosesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  ss: string;

  procedure setUpTab(aName, aValue: string; tv: TTreeView);
  var
    SL: TStringList;
    sName, sIEN, sCode: string;
    i, k: Integer;
    tnRoot: TTreeNode;
  begin
    ClearNode(aName, tv);
    tnRoot := nil;
    SL := TStringList.Create;
    SL.Text := aValue;
    if pos('^', SL[0]) > 0 then
      k := 0
    else
      k := 1;

    for i := k to SL.Count - 1 do
      begin
        if tnRoot = nil then
          tnRoot := tv.Items.AddChild(nil, aName);
        sCode := Piece(SL[i], '^', 1);
        sIEN := Piece(SL[i], '^', 2);
        sName := Piece(SL[i], '^', 3);
        tv.Items.AddChild(tnRoot, sCode + ' -- ' + sname + ' | ' + sIEN);
      end;
    i := SL.Count;
    if i > 0 then
      i := i - 1;

    if tv = frmListEdit.tvDiagnoses then
      begin
        SBShow(SB.Panels[iStatus].Text + '  ' + IntToStr(i) + ' items found');
        if i > 0 then
          ActiveControl := tvDiagnoses;
      end
    else
      begin
        SBShow(SB.Panels[iStatus].Text + '  ' + IntToStr(i) + ' items found');
        if i > 0 then
          ActiveControl := tvProcedure;
      end;

    if tnRoot <> nil then
      tnRoot.Expand(true);
    SL.Free;
  end;

begin
  if Key = vk_Return then
    begin
      if Sender = cbProcedure then
        begin
          if cbProcedure.Text = '' then
            begin
              Timer1.Enabled := True;
              SBShow('  Enter search target and press Enter');
              Exit;
            end;

          SBShow('  Looking for <' + cbProcedure.Text + '>');
          Application.ProcessMessages;
          Engine.getCPTByTarget(cbProcedure.Text, ss);
          if pos('-1', ss) = 1 then
            ShowMessage(piece(ss, '^', 2))
          else
            setUpTab('Lexicon Procedures', ss, tvProcedure);
        end;

      if Sender = cbDiagnoses then
        begin
          if cbDiagnoses.Text = '' then
            begin
              Timer1.Enabled := True;
              SBShow('  Enter search target and press Enter');
              Exit;
            end;
          SBShow('  Looking for <' + cbDiagnoses.Text + '>');
          Application.ProcessMessages;
          Engine.getICDByTarget(cbDiagnoses.Text, ss);
          if pos('-1', ss) = 1 then
            ShowMessage(piece(ss, '^', 2))
          else
            setUpTab('Lexicon Diagnoses', ss, tvDiagnoses);
        end;
      Timer1.Enabled := True;
    end;
end;

procedure TfrmListEdit.DoProviderSearch(aTarget: string);
var
  i: Integer;
  s, sName, sValue: string;
  SL: TStringList;
begin
  if aTarget = '' then
    begin
      Timer1.Enabled := True;
      SBShow('  Enter search target and press Enter');
      Exit;
    end;
  SBShow('  Looking for <' + aTarget + '>');
  SL := TStringList.Create;
  s := Engine.getProviderList(aTarget);
  SL.Text := s;

  if pos('-1', s) = 1 then
    ShowMessage(piece(s, '^', 2))
  else
    begin

      Timer1.Enabled := True;
      if SL.Count > 1 then
        begin
          lbProviders.Items.Clear;
          for i := 1 to SL.Count - 1 do
            begin
              sName := Piece(SL[i], '^', 2);
              sValue := Piece(SL[i], '^', 1);
              lbProviders.Items.AddObject(sName, Pointer(StrToInt(sValue)));
            end;
        end;
      i := SL.Count;
      if i > 0 then
        i := i - 1;
      SBShow('  Looking for <' + aTarget + '>: ' + IntToStr(i) +
        ' items found');
      if i > 0 then
        ActiveControl := lbProviders;

    end;
  SL.Free;
end;

procedure TfrmListEdit.cbProviderKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_Return) and (cbProvider.Text <> '') then
    DoProviderSearch(Uppercase(cbProvider.Text))
end;

procedure TfrmListEdit.acAddProviderExecute(Sender: TObject);
var
  s: string;
  aP: TMDK_Provider;
begin
  try
    s := lbProviders.Items[lbProviders.ItemIndex];
    aP := TMDK_Provider.Create;
    aP.ID :=
      IntToStr(Integer(Pointer(lbProviders.Items.Objects[lbProviders.ItemIndex])));
    aP.Name := s;
    aP.Primary := False;

    if pos(
      uppercase(lbProviders.Items[lbProviders.ItemIndex]),
      uppercase(clbProvider.Items.Text)) > 0 then
      begin
        ShowMessage('The provider "' +
          lbProviders.Items[lbProviders.ItemIndex] +
          '" has already been selected');
        exit;
      end;

    clbProvider.Items.AddObject(lbProviders.Items[lbProviders.ItemIndex], aP);
  except
  end;

end;

procedure OnlyYou(aClb: TCheckListBox);
var
  i: Integer;
begin
  for i := 0 to aCLB.Items.Count - 1 do
    aCLB.Checked[i] := i = aCLB.ItemIndex;
end;

procedure TfrmListEdit.clbProviderClick(Sender: TObject);

  procedure OnlyYou(aClb: TCheckListBox);
  var
    i: Integer;
  begin
    for i := 0 to aCLB.Items.Count - 1 do
      begin
        aCLB.Checked[i] := i = aCLB.ItemIndex;
        try
          TMDK_Provider(clbProvider.Items.Objects[i]).Primary :=
            i = aCLB.ItemIndex;
        except
        end;
      end;
  end;

begin
  if clbProvider.ItemIndex < 0 then
    clbProvider.ItemIndex := 0;
  try
    lblProvider.Caption :=
      clbProvider.Items[clbProvider.ItemIndex] + '  ' +
      TMDK_Provider(clbProvider.Items.Objects[clbProvider.ItemIndex]).ID;
  except
  end;
  OnlyYou(clbProvider);

end;

procedure TfrmListEdit.acDeleteProviderExecute(Sender: TObject);
var
  i: Integer;
  aP: TMDK_Provider;
begin
  if clbProvider.Items.Count < 1 then
    exit;
  try
    i := clbProvider.ItemIndex;
    aP := TMDK_Provider(clbProvider.Items.Objects[i]);
    try
      FreeAndNil(aP);
    except
    end;
    clbProvider.Items.Delete(i);
    if i < clbProvider.Items.Count then
      clbProvider.ItemIndex := i
    else if clbProvider.Items.Count > 0 then
      clbProvider.ItemIndex := clbProvider.Items.Count - 1;

  except
  end;
end;

procedure TfrmListEdit.lbProvidersKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = VK_Return) and (lbProviders.Items.Count <> 0) then
    acAddProvider.Execute;
end;

procedure TfrmListEdit.acDataExecute(Sender: TObject);
begin
  pnlData.Visible := not pnlData.Visible;
  lblProvider.Visible := not lblProvider.Visible;
end;

procedure TfrmListEdit.acGetProceduresExecute(Sender: TObject);
var
  ss: string;
begin
  Engine.getClinicProcedures(edPatientID.Text, edClinicID.Text, ss);
  mm.Lines.Text := mm.Lines.Text + ss + #13#10;

  setUpTab('Procedures by Clinic', ss, tvProcedure);
end;

procedure TfrmListEdit.acGetDiagnosesExecute(Sender: TObject);
var
  ss: string;
begin
  Engine.getClinicDiagnosis(edPatientID.Text, edClinicID.Text, ss);
  mm.Lines.Text := mm.Lines.Text + ss + #13#10;
  setUpTab('Diagnoses By Clinic', ss, tvDiagnoses);
end;

procedure TfrmListEdit.acGetEncounterDataExecute(Sender: TObject);
var
  s: string;
begin
  //  Engine.GetBillingData(edStudy.Text,s);
  Engine.GetEncounterData(edStudy.Text, s);
  mm.Lines.Text := s;
end;

procedure TfrmListEdit.FormCreate(Sender: TObject);
begin
  fIgnore := False;
  NewStringField(cdsProcedures, 'Code', 'Code', 8, 20);
  NewStringField(cdsProcedures, 'Title', 'Title', 200, 200);
  NewIntegerField(cdsProcedures, fnPr_Quantity, fnPr_Quantity, 8);
  try
    TIntegerField(cdsProcedures.Fields[cdsProcedures.FieldCount - 1]).MaxValue
      := devOptions.iValue(donMaxProcedureQuantity);
  except
    begin
      TIntegerField(cdsProcedures.Fields[cdsProcedures.FieldCount - 1]).MaxValue
        := 99;
    end;
  end;
  NewStringField(cdsProcedures, 'IEN', 'IEN', 8, 20);
{$IFNDEF AANTEST}
  cdsProcedures.Fields[cdsProcedures.FieldCount - 1].Visible := False;
{$ENDIF}
  cdsProcedures.CreateDataSet;
  cdsProcedures.Open;

{$IFDEF AANTEST}
  pnlData.Visible := True;
  sbDebug.Visible := True;
  lblProvider.Visible := True;
  lblDiagnoses.Visible := True;
{$ELSE}
  pnlData.Visible := False;
  sbDebug.Visible := False;
  lblProvider.Visible := False;
  lblDiagnoses.Visible := False;
{$ENDIF}
end;

procedure TfrmListEdit.acAddProcedureExecute(Sender: TObject);
var
  tn: TTreeNode;
  sCode, sTitle, sIEN: string;
begin
  tn := tvProcedure.Selected;
  if tn = nil then
    Exit;
  if tn.Level < 1 then
    Exit;
  if pos('--', tn.Text) = 0 then
    Exit;
  sCode := trim(Piece(tn.Text, '--', 1));
  sTitle := Piece(tn.Text, '--', 2);
  sIEN := Piece(sTitle, ' | ', 2);

  if cdsProcedures.Locate('Code', sCode, []) then
    begin
      ShowMessage('The Procedure "' + sTitle + '" has already been selected.');
      ActiveControl := dbgProcedures;

    end
  else
    try
      cdsProcedures.Insert;
      cdsProcedures.FieldByName('Code').AsString := sCode;
      cdsProcedures.FieldByName('Title').AsString := sTitle;
      cdsProcedures.FieldByName(fnPr_Quantity).AsInteger := 1;
      cdsProcedures.FieldByName('IEN').AsString := sIEN;
      cdsProcedures.Post;
    except
    end;

end;

procedure TfrmListEdit.tvProcedureDblClick(Sender: TObject);
begin
  acAddProcedure.Execute;
end;

procedure TfrmListEdit.PageControl1Change(Sender: TObject);
begin
  with PageControl1 do
    begin
      if ActivePage = tsDiagnosis then
        ActiveControl := cbDiagnoses;
      if ActivePage = tsProcedures then
        ActiveControl := cbProcedure;
      if ActivePage = tsProviders then
        ActiveControl := cbProvider;
    end;

end;

procedure TfrmListEdit.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    ModalResult := mrCancel;
end;

procedure TfrmListEdit.acGetLegacyExecute(Sender: TObject);
begin
  mm.Lines.Text := Legacy;
end;

procedure TfrmListEdit.ckbDiagnosesClick(Sender: TObject);

  procedure OnlyYou(aClb: TCheckListBox);
  var
    i: Integer;
  begin
    for i := 0 to aCLB.Items.Count - 1 do
      begin
        aCLB.Checked[i] := i = aCLB.ItemIndex;
        if Assigned(aCLB.Items.Objects[i]) then
          try
            TMDK_Provider(clbProvider.Items.Objects[i]).Primary :=
              aCLB.Checked[i];
          except
          end;
      end;
  end;

begin
  if ckbDiagnoses.ItemIndex < 0 then
    ckbDiagnoses.ItemIndex := 0;
  TMDK_Diagnosis(ckbDiagnoses.Items.Objects[ckbDiagnoses.ItemIndex]).Primary :=
    ckbDiagnoses.Checked[ckbDiagnoses.ItemIndex];
  OnlyYou(ckbDiagnoses);
end;

procedure TfrmListEdit.acAddDiagnosysExecute(Sender: TObject);
var
  s, ss, sIEN: string;
  aP: TMDK_Diagnosis;
begin
  try
    if tvDiagnoses.Selected = nil then
      Exit;
    s := tvDiagnoses.Selected.Text;
    if pos(' -- ', s) = 0 then
      Exit;

    ss := Piece(s, ' -- ', 1);
    s := Piece(s, ' -- ', 2);
    sIEN := Piece(s, ' | ', 2);

    if pos(s, ckbDiagnoses.Items.Text) > 0 then
      exit;

    aP := TMDK_Diagnosis.Create;
    aP.ID := ss;
    aP.Title := s;
    aP.IEN := sIEN;
    aP.Category := '';
    aP.Primary := False;

    ckbDiagnoses.Items.AddObject(s, aP);
  except
  end;

end;

procedure TfrmListEdit.acDeleteDiagnosysExecute(Sender: TObject);
var
  i: Integer;
  aP: TMDK_Diagnosis;
begin
  if ckbDiagnoses.Items.Count < 1 then
    exit;
  try
    i := ckbDiagnoses.ItemIndex;
    aP := TMDK_Diagnosis(ckbDiagnoses.Items.Objects[i]);
    try
      FreeAndNil(aP);
    except
    end;
    ckbDiagnoses.Items.Delete(i);
    if i < ckbDiagnoses.Items.Count then
      ckbDiagnoses.ItemIndex := i
    else if ckbDiagnoses.Items.Count > 0 then
      ckbDiagnoses.ItemIndex := ckbDiagnoses.Items.Count - 1;
  except
  end;
end;

procedure TfrmListEdit.pnlGridResize(Sender: TObject);
var
  i: integer;
begin
  i := dbgProcedures.Columns[0].Width
    + dbgProcedures.Columns[2].Width
{$IFDEF AANTEST}
  + dbgProcedures.Columns[3].Width
{$ENDIF}
  ;
  dbgProcedures.Columns[1].Width := dbgProcedures.Width - i - 40;
end;

procedure TfrmListEdit.FormResize(Sender: TObject);
begin
  pnlGrid.OnResize(Sender);
end;

procedure TfrmListEdit.tvDiagnosesKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_return then
    acAddDiagnosysExecute(nil);
end;

procedure TfrmListEdit.tvProcedureKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = vk_return then
    acAddProcedureExecute(nil);
end;

function TfrmListEdit.getLegacy: string;
var
  ss: string;
  i: Integer;
  aPro: TMDK_Provider;
  aDiag: TMDK_Diagnosis;

  function setCB(aName: string; ckb: TCheckBox): string;
  begin
    Result := '';
    if aName = '' then
      Exit;
    if ckb.Enabled then
      begin
        Result := aName + ';1^';
        if ckb.Checked then
          Result := Result + '1;'
        else
          Result := Result + '0;';

      end
    else
      Result := aName + ';0^;';
  end;

  function setRB(aName: string; ckb: TRadioButton): string;
  begin
    Result := '';
    if aName = '' then
      Exit;
    if ckb.Enabled then
      begin
        Result := aName + ';1^';
        if ckb.Checked then
          Result := Result + '1;'
        else
          Result := Result + '0;';

      end
    else
      Result := aName + ';0^;';
  end;

begin
  ss := '';
  try
    ss := ss + setRB('SC', rbSC1);
    ss := ss + setRB('AO', rbAOE1);
    ss := ss + setRB('IR', rbIRE1);
    ss := ss + setRB('EC', rbEC1);
    ss := ss + setRB('MST', rbMST1);
    ss := ss + setRB('HNC', rbHNC1);
    ss := ss + setRB('CV', rbCV1);
    {
        ss := ss + setCB('SC',cbxSC);
        ss := ss + setCB('AO',cbxAOE);
        ss := ss + setCB('IR',cbxIRE);
        ss := ss + setCB('EC',cbxEC);
        ss := ss + setCB('MST',cbxMST);
        ss := ss + setCB('HNC',cbxHNC);
        ss := ss + setCB('CV',cbxCV);
    }
    ss := ss + #13#10;

    for i := 0 to clbProvider.Items.Count - 1 do
      begin
        aPro := TMDK_Provider(clbProvider.Items.Objects[i]);
        ss := ss + 'PRV^' + aPro.ID + '^^' + aPro.Name + '^^';
        if clbProvider.Checked[i] then
          ss := ss + '1';
        ss := ss + #13#10;
      end;
    for i := 0 to ckbDiagnoses.Items.Count - 1 do
      begin
        aDiag := TMDK_Diagnosis(ckbDiagnoses.Items.Objects[i]);
        ss := ss + 'POV^' + aDiag.IEN + '^' + aDiag.ID + '^^' + aDiag.Title +
          '^';
        if ckbDiagnoses.Checked[i] then
          ss := ss + '1';
        ss := ss + #13#10;
      end;

    cdsProcedures.First;
    while not cdsProcedures.Eof do
      begin
        ss := ss + 'CPT^' + cdsProcedures.FieldByName('IEN').AsString +
          '^' + cdsProcedures.FieldByName('Code').AsString + '^^';
        ss := ss + Piece(cdsProcedures.FieldByName('Title').AsString, '|', 1) +
          '^^';
        ss := ss + cdsProcedures.FieldByName(fnPr_Quantity).AsString;

        cdsProcedures.Next;
        ss := ss + #13#10;
      end;

  except
  end;
  Result := ss;
end;

procedure TfrmListEdit.ClearObjects;
var
  i: Integer;
  aP: TMDK_Provider;
  aD: TMDK_Diagnosis;
begin
  for i := 0 to ckbDiagnoses.Count - 1 do
    begin
      aD := TMDK_Diagnosis(ckbDiagnoses.items.Objects[i]);
      try
        FreeAndNil(aD);
      except
      end;
    end;
  ckbDiagnoses.Items.Clear;

  for i := 0 to clbProvider.Count - 1 do
    begin
      aP := TMDK_Provider(clbProvider.items.Objects[i]);
      try
        FreeAndNil(aP);
      except
      end;
    end;
  clbProvider.Items.Clear;

  cdsProcedures.First;
  while not cdsProcedures.Eof do
    cdsProcedures.Delete;
end;

procedure TfrmListEdit.acSetDataExecute(Sender: TObject);
begin
  Legacy := mm.Lines.Text;
end;

procedure TfrmListEdit.setConnectionData(aV: string);

  procedure Connection(aSource: string; aCB: TCheckBox);
  var
    s1, s2: string;
  begin
    if aSource = '' then
      Exit;
    s1 := piece(aSource, '^', 1);
    s2 := piece(piece(aSource, '^', 2), ';', 1);
    if s1 = '0' then
      begin
        aCB.Enabled := False;
        aCB.Checked := False;
      end
    else
      begin
        aCB.Enabled := True;
        aCB.Checked := s2 = '1';
      end;
  end;

  procedure Connection1(aSource: string; aCB, aCB1: TRadioButton);
  var
    s1, s2: string;
  begin
    if aSource = '' then
      Exit;
    s1 := piece(aSource, '^', 1);
    s2 := piece(piece(aSource, '^', 2), ';', 1);
    if s1 = '0' then
      begin
        aCB.Enabled := False;
        aCB.Checked := False;
        aCB1.Enabled := False;
        aCB1.Checked := False;
      end
    else
      begin
        aCB.Enabled := True;
        aCB1.Enabled := True;
        aCB.Checked := s2 = '1';
      end;
  end;

var
  ss: string;
begin
  ss := Piece(aV, 'SC;', 2);
  Connection(ss, cbxSC);
  Connection1(ss, rbSC1, rbSC2);

  ss := Piece(aV, 'AO;', 2);
  Connection(ss, cbxAOE);
  Connection1(ss, rbAOE1, rbAOE2);

  ss := Piece(aV, 'IR;', 2);
  Connection(ss, cbxIRE);
  Connection1(ss, rbIRE1, rbIRE2);

  ss := Piece(aV, 'EC;', 2);
  Connection(ss, cbxEC);
  Connection1(ss, rbEC1, rbEC2);

  ss := Piece(aV, 'HNC;', 2);
  Connection(ss, cbxHNC);
  Connection1(ss, rbHNC1, rbHNC2);

  ss := Piece(aV, 'MST;', 2);
  Connection(ss, cbxMST);
  Connection1(ss, rbMST1, rbMST2);

  ss := Piece(aV, 'CV;', 2);
  Connection(ss, cbxCV);
  Connection1(ss, rbCV1, rbCV2);
end;

procedure TfrmListEdit.setLegacy(aValue: string);
var
  i: Integer;
  SL: TStringList;

  {
    iPRVKeyword = 1;
    iPRVCode = 2;
    iPRVName = 4;
    iPRVPrimary = 6;
  }
  procedure AddProvider(aSource: string);
  var
    aProvider: TMDK_Provider;
  begin
    aProvider := TMDK_Provider.Create;
    aProvider.ID := piece(aSource, '^', iPRVCode);
    aProvider.Name := piece(aSource, '^', iPRVName);
    aProvider.Primary := piece(aSource, '^', iPRVPrimary) = '1';
    clbProvider.Items.AddObject(aProvider.Name, aProvider);
    clbProvider.Checked[clbProvider.Items.Count - 1] := aProvider.Primary;
  end;
  {
    iCPTKeyword = 1;
    iCPTCode = 3;
    iCPTSHortDescription = 5;
    iCPTQuantity = 7;
  }
  procedure AddCPT(aSource: string);
  begin
    try
      cdsProcedures.Insert;
      cdsProcedures.FieldByName('Code').AsString := piece(aSource, '^',
        iCPTCode);
      cdsProcedures.FieldByName('Title').AsString := piece(aSource, '^',
        iCPTShortDescription);
      cdsProcedures.FieldByName(fnPr_Quantity).AsString := piece(aSource, '^',
        iCPTQuantity);
      cdsProcedures.Post;
    except
    end;
  end;

  {
    iICD9Keyword = 1;
    iICD9Code = 3;
    iICD9ShortDescription = 5;
    iICD9Primary = 6;
  }
  procedure AddICD(aSource: string);
  var
    aDiagnosis: TMDK_Diagnosis;
  begin
    aDiagnosis := TMDK_Diagnosis.Create;
    aDiagnosis.ID := piece(aSource, '^', iICD9Code);
    aDiagnosis.IEN := piece(aSource, '^', iICDIEN);
    aDiagnosis.Title := Piece(aSource, '^', iICD9ShortDescription);
    aDiagnosis.Primary := Piece(aSource, '^', iICD9Primary) = '1';
    ckbDiagnoses.Items.AddObject(aDiagnosis.Title, aDiagnosis);
    ckbDiagnoses.Checked[ckbDiagnoses.Items.Count - 1] := aDiagnosis.Primary;
  end;

begin
  ClearObjects;
  fLegacy := aValue;
  SL := TStringList.Create;
  SL.Text := aValue;
  if SL.Count < 1 then
    Exit;

  SetConnectionData(SL[0]);

  for i := 1 to SL.Count - 1 do
    begin
      if piece(SL[i], '^', 1) = 'PRV' then
        addProvider(SL[i]);
      if piece(SL[i], '^', 1) = 'POV' then
        addICD(SL[i]);
      if piece(SL[i], '^', 1) = 'CPT' then
        addCPT(SL[i]);
    end;
end;

procedure TfrmListEdit.acClearExecute(Sender: TObject);
begin
  CLearObjects;
end;

procedure TfrmListEdit.acSetPCEExecute(Sender: TObject);
var
  s: string;
  aSL: TStringList;
begin
  aSL := TStringList.Create;
  aSL.Text := mm.Lines.Text;
  Engine.setEncounterData(edStudy.Text, aSL, s);
  aSL.Free;
{$IFDEF AANTEST}
  ShowMessage(s);
{$ENDIF}
end;

procedure TfrmListEdit.acDeleteProcedureExecute(Sender: TObject);
begin
  if cdsProcedures.Eof then
    try
      cdsProcedures.Prior;
    except
      Exit;
    end;
  try
    cdsProcedures.Delete;
    cdsProcedures.Post;
  except
  end;
end;

procedure TfrmListEdit.dbgProceduresColEnter(Sender: TObject);
begin
  with dbgProcedures.SelectedField do
    begin
      if (FieldName = fnPr_Quantity) then
        dbgProcedures.ReadOnly := False
      else
        dbgProcedures.ReadOnly := True
    end;
end;

procedure TfrmListEdit.dbgProceduresDblClick(Sender: TObject);
begin
  acDeleteProcedure.Execute;
end;

procedure TfrmListEdit.setUpClinicInfo;
var
  ss: string;
begin
  Engine.getClinicProcedures(Engine.CurrentPatient.ID,
    Engine.CurrentPatient.SessionID, ss);
  setUpTab('Procedures by Clinic', ss, tvProcedure);
  Engine.getClinicDiagnosis(Engine.CurrentPatient.ID,
    Engine.CurrentPatient.SessionID, ss);
  setUpTab('Diagnoses By Clinic', ss, tvDiagnoses);
end;

procedure TfrmListEdit.Timer1Timer(Sender: TObject);
begin
  try
    SBShow('');
    Timer1.Enabled := False;
  except
  end
end;

procedure TfrmListEdit.SpeedButton2Click(Sender: TObject);
begin
  DoProviderSearch(Uppercase(cbProvider.Text));
end;

procedure TfrmListEdit.SpeedButton7Click(Sender: TObject);
var
  K: word;
begin
  k := vk_Return;
  cbDiagnosesKeyDown(cbProcedure, k, []);
end;

procedure TfrmListEdit.SpeedButton8Click(Sender: TObject);
var
  K: word;
begin
  k := vk_Return;
  cbDiagnosesKeyDown(cbDiagnoses, k, []);
end;

procedure TfrmListEdit.cbReviewClick(Sender: TObject);
begin
  if not cbReview.Checked then
    begin

      rbSC2.Enabled := cbReview.Checked;
      rbCV2.Enabled := cbReview.Checked;
      rbAOE2.Enabled := cbReview.Checked;
      rbEC2.Enabled := cbReview.Checked;
      rbMST2.Enabled := cbReview.Checked;
      rbHNC2.Enabled := cbReview.Checked;
      rbIRE2.Enabled := cbReview.Checked;

      rbSC1.Enabled := cbReview.Checked;
      rbCV1.Enabled := cbReview.Checked;
      rbAOE1.Enabled := cbReview.Checked;
      rbEC1.Enabled := cbReview.Checked;
      rbMST1.Enabled := cbReview.Checked;
      rbHNC1.Enabled := cbReview.Checked;
      rbIRE1.Enabled := cbReview.Checked;

      cbxSC.Enabled := cbReview.Checked;
      cbxCV.Enabled := cbReview.Checked;
      cbxAOE.Enabled := cbReview.Checked;
      cbxEC.Enabled := cbReview.Checked;
      cbxMST.Enabled := cbReview.Checked;
      cbxHNC.Enabled := cbReview.Checked;
      cbxIRE.Enabled := cbReview.Checked;
    end
  else
    begin
      SetConnectionData(fLegacy);
      if not fIgnore then
        Engine.PCESetReviewed;
    end;
  ShowStatus;
end;

procedure TfrmListEdit.acSaveExecute(Sender: TObject);
begin
  //  if cbReview.Checked then
  if Engine.PCEReadyToSubmit then
    ModalResult := mrOK
  else
    ShowMessage('Please, review the Service connection information before saving the data');
end;

procedure TfrmListEdit.SBShow(aString: string);
begin
  SB.Panels[iStatus].Text := aString;
end;

procedure TfrmListEdit.SpeedButton10Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmListEdit.ShowStatus;
var
  sl: TStringList;
begin
  //  SB.Panels[iLastUpdate].Text := Engine.PCEBillingStatusDescription;
  sl := TStringList.Create;
  sl.Text := Engine.PCEBillingStatusDescription;
  Caption := 'PCE Information. ' + sl[0];
  sl.Free;
end;

procedure TfrmListEdit.acReviewExecute(Sender: TObject);
begin
  SetConnectionData(fLegacy);
  if not fIgnore then
    Engine.PCESetReviewed;
  ShowStatus;
end;

procedure TfrmListEdit.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  cdsProcedures.First;
  while not cdsProcedures.Eof do
    begin
      if cdsProcedures.FieldByName(fnPr_Quantity).AsInteger >
        devOptions.iValue(donMaxProcedureQuantity) then
        break;
      cdsProcedures.Next;
    end;
  if cdsProcedures.Eof or
    (MessageDlg(
    'Procedure Quantity ' + #13#10 +
    cdsProcedures.FieldByName('Quantity').AsString + #13#10 +
    ' is greater then the limit value' + #13#10 +
    devOptions.sValue(donMaxProcedureQuantity) + #13#10 +
    'Close the dialog?',
    mtConfirmation,
    [mbYes, mbNo], 0) = mrYes) then
    CanClose := True;

end;

procedure TfrmListEdit.setQuantityLimit(anInteger: Integer);
begin
  TIntegerField(cdsProcedures.FieldByName(fnPr_Quantity)).MaxValue := anInteger;
end;

procedure TfrmListEdit.acGetPCEInfoExecute(Sender: TObject);
var
  s: string;
begin
  s := Engine.getPCEInfo;
  MessageDlg('PCE Info:' + #13#10#13#10 + s, mtInformation, [mbOK], 0);

end;

end.
