unit fMDK_Main;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 10/03/08 2:20p $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  Contains the Application Main form
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms/fMDK_Main.pas $
*
*       $ History: fMDK_Main.pas $
 *
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdActns, ActnList, Menus, ExtCtrls, StdCtrls,
  Buttons
  , CommCtrl, AppEvnts
  , uMDK_Patients, Grids, DBGrids
  , ShellAPI
  , MidasLib // To avoid the distribution of the MIDAS.DLL
  , ImgList
{$IFDEF XPTHEME}
  , XPMan
{$ENDIF}
  ;

type
  TShellMode = (smBlank, smLog, smPatient);

type
  TfrmMain = class(TForm)
    ActionList: TActionList;
    FileExit: TAction;
    HelpAbout: TAction;
    pnlToolBar: TPanel;
    pnlPtInfo: TPanel;
    lblPtDemographics: TLabel;
    lblPtName: TLabel;
    acShowLog: TAction;
    StatusBar: TStatusBar;
    aclMain: TActionList;
    acFileExit: TAction;
    acFileBreakLink: TAction;
    acFileRejoinApp: TAction;
    acFileRejoinGlobal: TAction;
    acPatientSelect: TAction;
    pgcMain: TPageControl;
    tsCover: TTabSheet;
    tsRxLab: TTabSheet;
    tsPreTreatment: TTabSheet;
    tsAccess: TTabSheet;
    tsFlowSheet: TTabSheet;
    tsPostTreatment: TTabSheet;
    tsSummary: TTabSheet;
    pnlTopSpace: TPanel;
    mmShell: TMainMenu;
    N1: TMenuItem;
    Exit1: TMenuItem;
    alEvents: TActionList;
    pnlLog: TPanel;
    pnlBlank: TPanel;
    acSave: TAction;
    acShowPatientInfo: TAction;
    acShowPatientPostings: TAction;
    PatientInfo1: TMenuItem;
    Postings1: TMenuItem;
    N3: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    CCOW1: TMenuItem;
    BreaktheClinicalLink1: TMenuItem;
    UseApplicationData1: TMenuItem;
    N2: TMenuItem;
    UseGlobalData1: TMenuItem;
    acFileDisplayStatus: TAction;
    N4: TMenuItem;
    DisplayStatus1: TMenuItem;
    acHelpIndex: TAction;
    Index1: TMenuItem;
    acWebPage: TAction;
    timer: TTimer;
    acBugsLog1: TMenuItem;
    SelectPatient1: TMenuItem;
    N5: TMenuItem;
    acOptionsShow: TAction;
    Print1: TMenuItem;
    Save1: TMenuItem;
    N7: TMenuItem;
    tsSubmit: TTabSheet;
    acReloadOptions: TAction;
    ReloadOptions1: TMenuItem;
    Web1: TMenuItem;
    N9: TMenuItem;
    Panel3: TPanel;
    Bevel1: TBevel;
    tmGateway: TTimer;
    acShowGatewayInfo: TAction;
    ShowGatewayInfo1: TMenuItem;
    mnuDEV: TMenuItem;
    acSaveVitals: TAction;
    acSaveFlowsheet: TAction;
    SaveVitals1: TMenuItem;
    SaveFlowsheetVitals1: TMenuItem;
    acReadMe: TAction;
    ReadMe1: TMenuItem;
    mnuOptions: TMenuItem;
    acUserManual: TAction;
    UserManual1: TMenuItem;
    N6: TMenuItem;
    ImageList1: TImageList;
    acShowStatusPanel: TAction;
    ShowHideStatusPanel1: TMenuItem;
    N8: TMenuItem;
    EditFlowsheetRecord1: TMenuItem;
    acShowGUI: TAction;
    ShowGUI1: TMenuItem;
    acSaveRPCResults: TAction;
    SaveRPCResults1: TMenuItem;
    acSetPending: TAction;
    N10: TMenuItem;
    SetPendingStatus1: TMenuItem;
    pnlStudyInfo: TPanel;
    lblStudyDate: TLabel;
    Label2: TLabel;
    lblStudyNum: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label1: TLabel;
    lblLocationID: TLabel;
    lblStudyStatus: TLabel;
    lblAppointmentInfo: TLabel;
    miComments: TMenuItem;
    pnlStatusseparator: TPanel;
    Bevel7: TBevel;
    pnlButtons3D: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    sbSelect: TSpeedButton;
    sbSave: TSpeedButton;
    N11: TMenuItem;
    ShowOldStyleComments1: TMenuItem;
    procedure FileExitExecute(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acFileExitExecute(Sender: TObject);
    procedure acPatientSelectExecute(Sender: TObject);
    procedure pnlPtInfoMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure pnlPtInfoMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure acShowLogExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acSaveExecute(Sender: TObject);
    procedure acShowPatientInfoExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure HelpAboutExecute(Sender: TObject);
    procedure acHelpIndexExecute(Sender: TObject);
    procedure acWebPageExecute(Sender: TObject);
    procedure pgcMainChange(Sender: TObject);
    procedure timerTimer(Sender: TObject);
    procedure StatusBarMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure StatusBarDblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure acOptionsShowExecute(Sender: TObject);
    procedure acReloadOptionsExecute(Sender: TObject);
    procedure pgcMainChanging(Sender: TObject; var AllowChange: Boolean);
    procedure tmGatewayTimer(Sender: TObject);
    procedure acShowGatewayInfoExecute(Sender: TObject);
    procedure acSaveVitalsExecute(Sender: TObject);
    procedure acSaveFlowsheetExecute(Sender: TObject);
    procedure acUserManualExecute(Sender: TObject);
    procedure acShowStatusPanelExecute(Sender: TObject);
    procedure pgcMainMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure acShowGUIExecute(Sender: TObject);
    procedure acSaveRPCResultsExecute(Sender: TObject);
    procedure acSetPendingExecute(Sender: TObject);
    procedure StatusBarDrawPanel(StatusBar: TStatusBar;
      Panel: TStatusPanel; const Rect: TRect);
    procedure ShowOldStyleComments1Click(Sender: TObject);
  private
    fMenu: TMainMenu;
    fCurrentForm: TForm;
    fMode: TShellMode;

    function VerifyStartUp: Boolean;
    procedure ShutDownKitchen(aMsg: string = '');

    procedure SetUpForm(aForm: TForm; aTab: TWinControl {TTabSheet});
    procedure SetMode(aMode: TShellMode);

    procedure AdjustInfoPanelPosition(aStep: Integer);
    procedure setBackGroundColor(aReadOnly: Boolean);

    procedure ShowStatusMessage(aString: string);
  public
    function Connect: Boolean;
    procedure Disconnect;
    procedure SelectPatient(aPatient: TMDKRegisteredPatient);
    property Mode: TShellMode read fMode write SetMode;

    procedure RefreshStudyStatus(acClear: Boolean = False);
    procedure RefreshSubmitStatusPanel;
    procedure ShutDown;

    procedure GoToPage(aPage: string);
    procedure ResetOptions;
    procedure UpdateSB;
    procedure RefreshCurrentWindow;
    procedure AppException(Sender: TObject; E: Exception);
  end;

var
  frmMain: TfrmMain;

implementation

uses
  dMDK_Data
  , DB
  , fMDK_Blank
  , fMDK_Log
  , fMDK_Access
  , fMDK_Cover
  , fMDK_RxLab
  , fMDK_Pre
  , fMDK_Post
  , fMDK_Flowsheet
  , fMDK_Summary
  , uMDK_Engine
  , uMDK_Summary
  , fMDK_Info
  , fGMV_AboutDlg
  , uMDK_Common
  , uGMV_VersionInfo
  , uROR_RPCBroker
  , fMDK_Wait
  , uMDK_Info
  , fMDK_Options
  , uMDK_Options
  , fMDK_Submit
  , uMDK_InstrumentRecord
  , fMDK_Medication
  , fMDK_ListEdit
  , uMDK_MedList
  , fGMV_TimeOutManager
  , uMDK_CDSCommon
  , uMDK_Utils
  , uMDK_Flowsheet
  , Printers
  , fMDK_FlowSheetEdit, fMDK_LocalLogin, fMDK_AddOptions,
  oDBController_Renal, uMDK_LocalDB, uMDK_Notes, iMDK_Presenter,
  fMDK_Studies;

{$R *.dfm}
{$R .\MDK_Dictionary.res} // default string lists

const
  sbIndex_StudyID = 2;
  sbIndex_Connection = 1;
  sbIndex_ReadOnly = 3;
  sbIndex_User = 4; //2;
  sbIndex_UserRole = 5; //3;//4
  sbIndex_GatewayStatus = 6; //4;//5

var
  ContextName: string = 'MD HEMODIALYSIS USER';

  ////////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.FormCreate(Sender: TObject);

  procedure SafeSetUpForm(aForm: TForm; aWinCOntrol: TWinCOntrol);
  begin
    try
      setupForm(aForm, aWinCOntrol);
    except
      on e: Exception do
        ShowMessage('Setup form failed:' + #13 +
          e.Message);
    end;
  end;

begin
  Left := 0;
  Top := 0;
  fCurrentForm := nil;

{$IFNDEF LOG_DIALOG}
  SafeSetUpForm(frmLog, pnlLog);
{$ENDIF}

  SafeSetUpForm(frmBlank, pnlBlank);
  SafeSetUpForm(frmCover, tsCover);
  SafeSetUpForm(frmRxLab, tsRxLab);

  SafeSetUpForm(frmPre, tsPreTreatment);
  SafeSetUpForm(frmAccess, tsAccess);
  SafeSetUpForm(frmPost, tsPostTreatment);

  SafeSetUpForm(frmFlow, tsFlowsheet);
  SafeSetUpForm(frmSummary, tsSummary);
  SafeSetUpForm(frmSubmit, tsSubmit);

  tsCover.Caption := pnCover;
  tsRxLab.Caption := pnRxLab;
  tsPreTreatment.Caption := pnPre;
  tsPostTreatment.Caption := pnPost;
  tsAccess.Caption := pnAccess;
  tsFlowSheet.Caption := pnFlow;
  tsSummary.Caption := pnSummary;

  Mode := smBlank;
  if Assigned(frmCover) then
    fMenu := frmCover.getMainMenu;

  HelpContext := 1001;
  pgcMain.HelpContext := 1001;
  Position := poScreenCenter; // vhaishandria 2008-03-12

{$IFDEF AANTEST}
  mnuDEV.Visible := True;
{$ELSE}
  mnuDEV.Visible := False;
{$ENDIF}

  StatusBar.Panels[sbIndex_GatewayStatus].Style := psOwnerDraw;

end;

procedure TfrmMain.UpdateSB;
var
  i, wd: Integer;

begin
  if Assigned(Engine) then
    begin
      StatusBar.Panels[sbIndex_UserRole].Text :=
        '  ' + Engine.CurrentOperatorMode + '   ';
      if Engine.CurrentPatient = nil then
        StatusBar.Panels[sbIndex_ReadOnly].Text := NotAplicable
      else if Engine.CurrentPatient.ID = '' then
        StatusBar.Panels[sbIndex_ReadOnly].Text := NotAplicable
      else if Engine.CurrentPatient.ReadOnly then
        StatusBar.Panels[sbIndex_ReadOnly].Text := '    R/O   '
      else
        StatusBar.Panels[sbIndex_ReadOnly].Text := ' Editable ';
    end
  else
    StatusBar.Panels[sbIndex_ReadOnly].Text := NotAplicable;

  wd := StatusBar.Width;
  for i := StatusBar.Panels.Count - 1 downto 1 do
    begin
      if StatusBar.Panels[i].Text <> '' then
        StatusBar.Panels[i].Width :=
          StatusBar.Canvas.TextWidth(StatusBar.Panels[i].Text) + 10;
      wd := wd - StatusBar.Panels[i].Width;
    end;
  StatusBar.Panels[0].Width := wd;

  StatusBar.Invalidate;
end;

procedure TfrmMain.FormResize(Sender: TObject);
begin
  UpdateSB;
end;

////////////////////////////////////////////////////////////////////////////////

function TfrmMain.VerifyStartUp: Boolean;
var
  sDictionary,
  s, ss: string;
  fNow: TDateTime;
  bLocalConnect: Boolean;

const
  msgDictionaryLoadFailed =
    'The application dictionary cannot loaded.'+#13#10+
    '(Possible reason: network traffic congestion)' +#13#10+
    'The application will close.' + #13#10#13#10 +
    'Please try again later.' + #13#10;
  msgDictionaryNotFound =
    'Appication Dictionary is not found.' + #13#10 +
    'Do you want to use the default dictionary?' + #13#10 + '' + #13#10 +
    'Select "No" to close the application without changes';
begin
  frmWait.WakeUp(pgcMain, 'Starting Application', aviCopyFiles);

  Caption := {$IFDEF AANTEST} ' ===DEV=== ' + {$ENDIF}CurrentTitle;

  Engine := TMDK_Engine.Create;
{$IFDEF DEMO}
  bLocalConnect := cmdLineSwitch(['/DEMO']);
{$ELSE}
  bLocalCOnnect := False;
{$ENDIF}
  Engine.StartUpRenalController(bLocalConnect); // creates Renal Controller

{$IFDEF DEMO}
  if cmdLineSwitch(['/DEMO']) then
    Engine.CurrentOperatorID := dlgLocalLogin.cbName.Text;
{$ENDIF}

  if not Engine.VersionIsCompatible then
    begin
      Result := False;
      Exit;
    end;

  frmWait.WakeUp(pgcMain, 'Starting Application', aviCopyFiles);

  // assuming Engine is Running:
  Engine.setServerDelay;
  frmWait.AddLogLine(char(VK_TAB) + 'Load Dictionary:');
  // vhaishandria 2008-02-19 --------------------------------------------- begin
  s := Engine.fRenalController.GetXPAR('');
  if piece(s,'^',3) <> 'YES' then
    begin
     Engine.fRenalController.GetSystemOption(onDictionary, sDictionary);
      if (sDictionary = '') or (Pos('-1', sDictionary) = 1) then
        s := Engine.RestoreDefaults;
      Engine.fRenalController.SetXPAR('',
        FloatToStr(WindowsDateTimeToFMDateTime(Now))+'^'+
        Engine.CurrentOperatorID + '^YES^'+
        getWorkstationName);
    end;
  // vhaishandria 2008-02-19 ----------------------------------------------- end

  // Check if the dictionary is available and restore it if needed
  Engine.fRenalController.GetSystemOption(onDictionary, sDictionary);
  if (sDictionary = '') or (Pos('-1', sDictionary) = 1) then
    begin
      frmWait.Hide;
      if devOptions.bValue(donSilentDefaultsRestore) or
        (MessageDlg(msgDictionaryNotFound, mtWarning, [mbYes, mbNo], 0) = mrYes) then
        begin
          s := Engine.RestoreOptionDefault(onDictionary); // vhaishandria 2008-02-14
          if s = '' then
            Engine.fRenalController.GetSystemOption(onDictionary, sDictionary)
          else
            begin
              MessageDlg(msgDictionaryLoadFailed , mtError, [mbOK], 0);
              ShutDownKitchen('No dictionary found');
              Result := False;
              Exit;
            end;
        end
      else
        begin
          ShutDownKitchen('No dictionary found');
          Result := False;
          Exit;
        end;
    end;

  frmWait.Show;
  fNow := Now;

// vhaishandria 2007-07-20 ----------------------------------------------- begin
  if not Engine.LoadDictionaryFromString(sDictionary) then
    begin
      Engine.Report(rtError,s,'',0,'','Load Dictionary','FAILED',TRUE);
      s := Engine.RestoreOptionDefault(onDictionary);
      if s <> '' then
        begin
          Engine.Report(rtError,'Failed to restore the default dictionary'+#13#10+s,
            '',0,'','Load Default Dictionary','FAILED',TRUE);
          Result := False;
          Exit;
        end
      else
        begin
          Engine.fRenalController.GetSystemOption(onDictionary, sDictionary);
          if not Engine.LoadDictionaryFromString(sDictionary) then
            begin
              Engine.Report(rtError,'Failed to install the default dictionary',
                '',0,'','Install the default dictionary','FAILED',TRUE);
            end
          else
            begin
              Engine.SaveDictionaryToDB;
              Engine.Report(rtWarning,sDictionary,
                '',0,'','Save default dictionary','OK',TRUE);
            end;
        end;
    end;

{$IFDEF SAVE_ERRORS_LOG}
  Engine.fRenalController.getSystemOption(onErrorLog,s);
  try
    CDSInitByString(dmData.cdsEvents,s,False);
  except
  end;
{$ENDIF}
// vhaishandria 2007-07-20 ------------------------------------------------- end

  frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now - fNow));

  if devOptions.bValue(donCleanOptions) then
    begin
      Engine.CleanUpOptions;

      fNow := Now;
      frmWait.AddLogLine(char(VK_TAB) + 'Update options:');
      // Clean preferences
      s := Engine.getSystemOptionByName(onSysOptions);
      sysOptions.CleanupString(s);
      sysOptions.Overwrite(s);

      if not sysOptions.checkValues(ss) then
        Engine.Report(rtWarning, ss, '', 0, '', 'Fix System Option values');

      Engine.setSystemOptionByName(onSysOptions, sysOptions.ValueList.Text);

      s := Engine.getUserOptionByName(onUserOptions);
      userOptions.Overwrite(s);

      if not userOptions.checkValues(ss) then
        Engine.Report(rtWarning, ss, '', 0, '', 'Fix User Option values');

      s := Engine.getSystemOptionByName(onSysOptions);
      userOptions.CleanupValues(s);

      Engine.setUserOptionByName(onUserOptions, userOptions.ValueList.Text);
      ResetPreferences(SysOptions.ValueList.Text,
        UserOptions.ValueList.Text);

      s := Engine.getUserOptionByName(onUserSettings);
//      UserSettings.ValueList.Text := s;
      UserSettings.CleanUpString(s);
      UserSettings.CleanUpBlankLines(s);
      Preferences.Overwrite(s);

      frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz',Now - fNow));
    end;

  CheckSummaryReport; // vhaishandria 2008-03-31 -------------------------------

  frmWait.AddLogLine(char(VK_TAB) + 'Set Up Fields:');
  fNow := Now;
  Engine.SetUpFields; // updates field formats;  vhaishandria  050322
  frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now - fNow));

  // With the Engine Running we can create Business Objects
  frmLog.setUpTreeView;
  frmLog.setRole(Engine.CurrentOperatorMode);

  // Link Vascular Access GUI elements with Datasets
  frmAccess.VAP := Engine.VAP_CDS;
  frmAccess.VAPH := Engine.VAPH_CDS;
  frmAccess.VAPIH := Engine.VAPIH_CDS;
  frmAccess.OperatorID := Engine.CurrentOperatorID;

  // Submit
  frmSubmit.lblOperator.Caption := Engine.CurrentOperatorID;
  Application.ProcessMessages;

  // frmFlow
  frmFlow.btnReload.Visible := Engine.CurrentOperatorMode = rnAdmin;

  InitStudyList;

  Mode := smBlank; // setMode will set the initial Layout
  acPatientSelect.Enabled := Engine <> nil;

  tmGateway.Enabled := true;
  tmGatewayTimer(nil);

  Result := True;
end;

procedure TfrmMain.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Engine);
end;

procedure TfrmMain.ShutDownKitchen(aMsg: string = '');
var
  ErrorMsg: string;
begin
  ErrorMsg := aMsg;
  if Assigned(frmStudies) and Assigned(Engine) then
    if not Engine.CurrentPatient.ReadOnly then
      frmStudies.ReleaseStudy(Engine.CurrentPatient.SessionID,ErrorMsg);
  try
    frmLog.SaveOptions;
{$IFNDEF LOG_DIALOG}
    frmLog.Close;
{$ENDIF}
    frmBlank.Close;
    frmCover.Close;
    frmAccess.Close;
    frmRxLab.Close;
    frmPre.Close;
    frmPost.Close;
    frmFlow.Close;
    frmSummary.Close;
    // vhaishandria 2007-07-20 ------------------------------------------- begin
{$IFDEF SAVE_ERRORS_LOG}
    if Preferences.bValue(onSaveErrorsLog) then
      dmData.SaveErrorsLog;
{$ENDIF}
    // vhaishandria 2007-07-20 --------------------------------------------- end
  except
  end;
  frmWait.LayDown;
end;

////////////////////////////////////////////////////////////////////////////////
// Connect is called from the project module to create the connection/broker
////////////////////////////////////////////////////////////////////////////////

function TFrmMain.Connect: Boolean;
begin
  Result := False;
// vhaishandria 20081003 ------------------------------------------------- begin
//                                                  comments removed on 20081002
// vhaishandria 20081003 --------------------------------------------------- end
  if VerifyStartUp then
    begin
      Result := True;
{$IFDEF XPTHEME}
      devOptions.setValue(donWindowsXPTheme,'TRUE');
{$ELSE}
      devOptions.setValue(donWindowsXPTheme,'FALSE');
{$ENDIF}
      if not Assigned(RPCBroker) then
        begin
          StatusBar.Panels[sbIndex_Connection].Text := '  ' + LOCAL_DIR;
          StatusBar.Panels[sbIndex_User].Text := '  ' +
            Engine.CurrentOperatorID;
// vhaishandria 20081003 ------------------------------------------------- begin
        end
      else
        begin
          StatusBar.Panels[sbIndex_Connection].Text := Format(' %s @ %d',
            [RPCBroker.Server, RPCBroker.ListenerPort]);
          StatusBar.Panels[sbIndex_User].Text := '  ' + RPCBroker.User.Name;
// vhaishandria 20081003 --------------------------------------------------- end
        end;
      UpdateSB;
      { Display the main application window }
      Show;
      Application.BringToFront;
    end;
end;

procedure TFrmMain.Disconnect;
begin
  if Assigned(RPCBroker) then
    begin
      Hide;
      { Disconnect and destroy the RPC Broker }
      RPCBroker.Connected := False;
      FreeAndNil(RPCBroker);
    end;
end;

procedure TfrmMain.acFileExitExecute(Sender: TObject);
begin
  if frmLog.fOptions.ValueUpdated then
    frmLog.fOptions.SaveOptionList;
  Close;
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TFrmMain.setBackGroundColor(aReadOnly: Boolean);
var
  _Enabled: Boolean;
  _color: TColor;
begin
  if aReadOnly then
    begin
      pnlToolBar.Color := Preferences.iValue(onColorReview);
      _Color := Preferences.iValue(onColorReview);
      _Enabled := False;
    end
  else
    begin
      pnlToolBar.Color := clSilver;
      _Color := Preferences.iValue(onColorBackground);
      _Enabled := True;
    end;

  try
    frmCover.pnlCover.Color := _Color;
    frmPre.pnlPreTreatment.Color := _Color;
    frmPost.pnlPostTreatment.Color := _Color;
    frmRxLab.pnlRXLabs.Color := _Color;
    frmFlow.pnlFlowSheet.Color := _Color;
    frmSummary.pnlSummary.Color := _Color;
    frmSubmit.pnlSubmit.Color := _Color;
    frmAccess.pnlAccess.Color := _Color;

    frmCover.setReadOnly(not _Enabled);
    frmPre.setReadOnly(not _Enabled);
    frmPost.setReadOnly(not _Enabled);
    frmRxLab.setReadOnly(not _Enabled);
    frmFlow.setReadOnly(not _Enabled);
    frmSummary.setReadOnly(not _Enabled);
    frmAccess.AccessReadOnly := not _Enabled;
  except
  end;
end;

procedure TfrmMain.SetMode(aMode: TShellMode);
begin
  fMode := aMode;
  case fMode of
    smBlank:
      begin
        pnlLog.Visible := False;
        pnlToolBar.Visible := true{False};

        pnlBlank.Visible := True;
        pgcMain.Visible := False;
        lblPtName.Caption := '';
        lblPtDemographics.Caption := '';
        acSave.Enabled := False;

        sbSelect.Caption := '&Select';
        sbSave.Caption := 'Sa&ve';
        mnuOptions.Caption := 'Options...';
        HelpContext := 1000;
        miComments.Visible := False;

        if Assigned(fMenu) then
          mmShell.Unmerge(fMenu);
//        ResetOptions;
      end;
    smLog:
      begin
        pnlLog.Visible := True;
        pnlToolBar.Visible := False;
        pnlBlank.Visible := False;
        pgcMain.Visible := False;
        frmLog.Refresh;
        frmLog.setRole(Engine.CurrentOperatorMode);

        sbSelect.Caption := 'Select';
        sbSave.Caption := 'Save';
        mnuOptions.Caption := 'Patient Data...';
        HelpContext := 1009;
        miComments.Visible := False;

        if Assigned(fMenu) then
          mmShell.Unmerge(fMenu);

      end;
    smPatient:
      begin
        pnlLog.Visible := False;
        pnlToolBar.Visible := True;
        pnlBlank.Visible := False;
        pgcMain.Visible := True;

        sbSelect.Caption := '&Select';
        sbSave.Caption := 'Sa&ve';
        mnuOptions.Caption := 'Options...';
        HelpContext := 1001 + pgcMain.ActivePageIndex;
        ResetOptions;
        miComments.Visible := True;

        if Assigned(fMenu) then
          mmShell.Merge(fMenu);
      end;
  end;
end;

// Performs actual selection of the patient
procedure TFrmMain.SelectPatient(aPatient: TMDKRegisteredPatient);
begin
  // switch to the Cover page. Could be user parameter
  pgcMain.ActivePageIndex := 0;

  // setUp the main form
  acShowPatientInfo.Enabled := aPatient <> nil;
  acShowPatientPostings.Enabled := aPatient <> nil;

  if aPatient = nil then
    begin
      Mode := smBlank;
      Engine.CurrentPatient := nil;
      frmFlow.tmrRefresh.Enabled := False;
      lblAppointmentInfo.Caption := '';
    end
  else
    begin
      frmWait.WakeUp(pgcMain, 'Loading Patient Data');
      Mode := smPatient;

      // Update Demographic info================================================
      frmWait.AddLogLine(aPatient.Name + #13#10);
      setBackgroundColor(aPatient.ReadOnly);
      // disable GUI updates
      frmRxLab.Ignore := True;
      frmPre.Ignore := True;
      frmPost.Ignore := True;
      frmSummary.Ignore := True;
      // Assigning new patient will force Engine to Save previous data
      // and SetUp CurrentSessionID
      Engine.CurrentPatient := aPatient;
      Engine.getLocation;
      // Main Form
      RefreshStudyStatus;
      // Update Forms===========================================================
      // frmAccess ===
      frmWait.AddLogLine(char(VK_TAB) + 'Patient Data:');
      frmAccess.PatientID := aPatient.ID;
      frmAccess.StudyID := aPatient.SessionID;
      frmAccess.LoadPatientData;
      frmAccess.FrameMDK_Comments.acRefreshExecute(nil);
      frmWait.AppendLogLine(gLoaded);

      // frmCover setup ===
      frmCover.ReloadData;
      frmCover.cbReadOnly.Checked := not Engine.IsItNewInfo;
      frmCover.ActivateTabForm;
      frmCover.RefreshGUI; // vhaishandria 20081002 patch 1.0.6.320
      // frmRXLab setup
      frmWait.AddLogLine(char(VK_TAB) + 'Rx and Lab Info:');
      frmRxLab.tvLabs.Items.Clear;
      frmRxLab.FrameMDK_Comments.acRefreshExecute(nil);
      frmWait.AppendLogLine(gLoaded);

      // frmPre
      frmPre.FrameMDK_Comments.acRefreshExecute(nil);

      // frmPost
      frmPost.FrameMDK_Comments.acRefreshExecute(nil);

      // frmFlow
      frmFlow.FrameMDK_Comments.acRefreshExecute(nil);
      frmFlow.setGridAlign(taCenter); // will aliggn fields and titles
      frmFlow.cmbAutoRefresh.Text := IntToStr(Preferences.iValue(onRefreshRate)
        * 60);
      if aPatient.ReadOnly then
        frmFlow.tmrRefresh.Enabled := False
      else
        begin
          frmFlow.tmrRefresh.Enabled := True;
          frmFlow.acRefreshExecute(nil);
        end;

      // frmSummary
      frmSummary.SetUp;
      frmSummary.FrameMDK_Comments.acRefreshExecute(nil);

      // frmSubmit
      frmSubmit.edSignature.Text := '';
      frmSubmit.CleanTV;
      frmSubmit.setupAdditionalReports;
      frmSubmit.acSubmit.Enabled := not aPatient.ReadOnly;

      // enable GUI
      frmRxLab.Ignore := False;
      frmPre.Ignore := False;
      frmPost.Ignore := False;
      frmSummary.Ignore := False;

      frmWait.LayDown;
      acSave.Enabled := not aPatient.ReadOnly;

      RefreshSubmitStatusPanel;
    end;
  UpdateSB;
end;

procedure TfrmMain.acPatientSelectExecute(Sender: TObject);
var
  sID, ErrorMsg: string;
  cp: TMDKRegisteredPatient;
begin
  if not Assigned(Engine) then
    Exit;

  acSave.Enabled := False; // vhaishandria 2007-09-20
  acPatientSelect.Enabled := False; // vhaishandria 2007-09-20

  sID := '';
  if Assigned(Engine.CurrentPatient) and (Engine.CurrentPatient.SessionID <> '')
    then
    begin
      if not Engine.CurrentPatient.ReadOnly then
        begin
          sID := Engine.CurrentPatient.SessionID;
          acSaveExecute(nil);
          if frmStudies.ReleaseStudy(sID, ErrorMsg)= rcStudyStatusOK
          then
              Engine.Report(rtInfo, 'Study <' + sID + '> Released', '', 0, '',
                'Release Study')
          else
              begin
                Engine.Report(rtError, 'Study <' + sID + '> Release Failed', '',
                  0, '', 'Release Study');
                if MessageDLG(
                  'Can not release study "' + sID + '" ' + #13#10 +
                  'Error found: ' + #13#10 + ErrorMsg + #13#10 + #13#10 +
                  'NOTE:' + #13#10 +
                  'Study could be released later by an ADMIN user' + #13#10#13#10
                  +
                  'Do you want to continue without RELEASE?',
                  mtConfirmation, [mbYes, mbNo], 0) <> mrYes then
                  begin
                    acPatientSelect.Enabled := True; // vhaishandria 2007-09-20
                    Exit;
                  end;
              end;
        end;
    end;

  refreshStudyStatus(True);
  Mode := smBlank;
  Engine.CurrentPatient.ReadOnly := true; // to avoid RELEASE by timeout
{$IFDEF STUDY_STATUS_LIST}
  cp := SelectStudyFromList(Left, Top, Height, Width);
{$ELSE}
  cp := SelectStudy(Left, Top, Height, Width);
{$ENDIF}
  SelectPatient(cp);

  acPatientSelect.Enabled := True; // vhaishandria 2007-09-20
  acSave.Enabled := (cp <> nil)
    and not cp.ReadOnly; // vhaishandria 2008-03-31
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.FileExitExecute(Sender: TObject);
begin
  Close;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.AdjustInfoPanelPosition(aStep: Integer);
begin
  if aStep > 0 then
    pnlPtInfo.BevelInner := bvLowered
  else
    pnlPtInfo.BevelInner := bvNone;

  lblPtName.Top := lblPtName.Top + aStep;
  lblPtName.Left := lblPtName.Left + aStep;
  lblPtDemographics.Top := lblPtDemographics.Top + aStep;
  lblPtDemographics.left := lblPtDemographics.left + aStep;
end;

procedure TfrmMain.pnlPtInfoMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  AdjustInfoPanelPosition(1);
  pnlPtInfo.Invalidate;
end;

procedure TfrmMain.pnlPtInfoMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  AdjustInfoPanelPosition(-1);
  if Engine.CurrentPatient <> nil then
    acShowPatientInfoExecute(nil);
end;

///////////////////////////////////////////////////////////////////////////////

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Assigned(Engine) and
    (Engine.CurrentPatient <> nil) and
    (trim(lblStudyNum.Caption) <> '') then
    begin
{$IFNDEF AANTEST}
      if TRUE {Preferences.bValue(onAutosave)} then
        acSaveExecute(nil)
      else if not Engine.CurrentPatient.ReadOnly and
        (MessageDlg('Autosave option is set to FALSE.' + #13#10 +
        'No data will be saved on Exit.' + #13#10 +
        'Exit now?',
        mtConfirmation, [mbYes, mbNo], 0) <> mrYes) then
        begin
          Action := caNone;
          Exit;
        end;
{$ENDIF}
    end;
  ShutDownKitchen;
end;

procedure TfrmMain.ShutDown;
var
  i: Integer;
begin // Close all modal forms here
  for i := 0 to Screen.CustomFormCount - 1 do
    begin
      if Screen.CustomForms[i] = self then
        continue;
      if fsModal in Screen.CustomForms[i].FormState then
        begin
          Screen.CustomForms[i].ModalResult := mrCancel;
          Screen.CustomForms[i].Close;
        end;
    end;
  acSaveExecute(nil);
  ShutDownKitchen('Shut Down by Timeout');
  Application.Terminate;
end;

procedure TfrmMain.RefreshCurrentWindow;
begin
  try
    if fCurrentForm = nil then
      Exit;
  except
    Exit;
  end;

  if fCurrentForm = frmFlow then
    frmFlow.setActionStatus
  else if fCurrentForm = frmSummary then
    frmSummary.setActionStatus
  else if fCurrentForm = frmPre then
    frmPre.setActionStatus
  else if fCurrentForm = frmPost then
    frmPost.setActionStatus
  else if fCurrentForm = frmRxLab then
    frmRxLab.setActionStatus;
end;

procedure TfrmMain.SetUpForm(aForm: TForm; aTab: TWinControl);
begin
  if aForm.Parent <> aTab then
    begin
      aForm.BorderStyle := bsNone;
      aForm.Parent := aTab;
      aForm.Align := alClient;
      aForm.Show;
    end;
end;

procedure TfrmMain.acShowLogExecute(Sender: TObject);
begin
  if Mode <> smLog then
    begin
{$IFDEF LOG_DIALOG}
      frmLog.ShowModal;
{$ELSE}
      Mode := smLog;
{$ENDIF}
      ResetOptions;
    end
  else if (Engine.CurrentPatient.id <> '') and (lblStudyNum.Caption <> '') then
    begin
      ResetOptions;
      Mode := smPatient;
    end
  else
    Mode := smBlank;
end;

procedure TfrmMain.acSaveExecute(Sender: TObject);
begin
  acSave.Enabled := False; // vhaishandria 2007-09-20
  acPatientSelect.Enabled := False; // vhaishandria 2007-09-20

  frmCover.SaveData;
  frmRxLab.SaveData;
  frmFlow.SaveData;
  frmSummary.SaveData;

  Engine.SaveCurrentPatientData;

  frmPost.FrameMDK_Comments.acRefresh.Execute;
  frmPre.FrameMDK_Comments.acRefresh.Execute;
  frmRxLab.FrameMDK_Comments.acRefresh.Execute;
  frmAccess.FrameMDK_Comments.acRefresh.Execute;
  frmFlow.FrameMDK_Comments.acRefresh.Execute;
  frmSummary.FrameMDK_Comments.acRefresh.Execute;

  acSave.Enabled := True; // vhaishandria 2007-09-20
  acPatientSelect.Enabled := True; // vhaishandria 2007-09-20

end;

procedure TfrmMain.acShowPatientInfoExecute(Sender: TObject);
begin
  if Engine.CurrentPatient.ID <> '' then
    begin
      if not Assigned(frmInfo) then
        Application.CreateForm(TfrmInfo, frmInfo);
      frmInfo.mmInfo.Text := Engine.getPatientInfo;
      frmInfo.ShowModal;
      FreeAndNil(frmInfo);
    end
  else
    MessageDlg(msgSelectPatientFirst, mtWarning, [mbOK], 0);
end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (key = VK_ESCAPE) and (ssShift in Shift) then
    acShowLogExecute(nil);
  if (key = Word(char('V'))) and (ssShift in Shift) and (ssCtrl in Shift) then
    ShowStatusMessage(CurrentExeVersion + ' ' + CurrentComments);
end;

procedure TfrmMain.HelpAboutExecute(Sender: TObject);
begin
  if not Assigned(GMVAboutDlg) then
    Application.CreateForm(TfrmGMV_AboutDlg, GMVAboutDlg);
  GMVAboutDlg.Execute;
end;

procedure TfrmMain.acHelpIndexExecute(Sender: TObject);
begin
  Application.HelpCommand(HELP_INDEX, 1001); // this is a patch
end;

procedure TfrmMain.acWebPageExecute(Sender: TObject);
var
  s: string;
begin
  s := Preferences.sValue(onWebPageURL);
  ShellExecute(0, nil, PChar(s), nil, nil, SW_NORMAL)
end;

procedure TfrmMain.pgcMainChange(Sender: TObject);
var
  sCommentsFilter: string;
begin
  case pgcMain.ActivePageIndex of
    0: fCurrentForm := frmCover;
    1: fCurrentForm := frmRxLab;
    2: fCurrentForm := frmAccess;
    3: fCurrentForm := frmPre;
    4: fCurrentForm := frmFlow;
    5: fCurrentForm := frmPost;
    6: fCurrentForm := frmSummary;
    7: fCurrentForm := frmSubmit;
  end;

  pgcMain.HelpContext := 1001 + pgcMain.ActivePageIndex;

  sCommentsFilter := getNotesContextFilter(pgcMain.ActivePageIndex);
  setCDSFilter(Engine.NoteList_CDS, sCommentsFilter);
  Engine.NoteList_CDS.Filtered := True;

  if Assigned(fMenu) then
    mmShell.Unmerge(fMenu);

  frmSubmit.edSignature.Text := '';

  if pgcMain.ActivePage = tsCover then
    begin
      frmCover.ActivateTabForm;
      miComments.Enabled := False;
      fMenu := frmCover.getMainMenu;
    end;

  if pgcMain.ActivePage = tsRxLab then
    begin
      frmRxLab.ActivateTabForm;
      fMenu := frmRxLab.getMainMenu;
    end;

  if pgcMain.ActivePage = tsPreTreatment then
    begin
      frmPre.ActivateTabForm;
      fMenu := frmPre.getMainMenu;
    end;

  if pgcMain.ActivePage = tsAccess then
    begin
      frmAccess.ActivateTabForm;
      fMenu := frmAccess.getMainMenu;
    end;

  if pgcMain.ActivePage = tsFlowSheet then
    begin
      frmFlow.ActivateTabForm;
      fMenu := frmFlow.getMainMenu;
    end;

  if pgcMain.ActivePage = tsPostTreatment then
    begin
      frmPost.ActivateTabForm;
      fMenu := frmPost.getMainMenu;
    end;

  if pgcMain.ActivePage = tsSummary then
    begin
      frmSummary.ActivateTabForm;
      fMenu := frmSummary.getMainMenu;
    end;

  if pgcMain.ActivePage = tsSubmit then
    try
      RefreshSubmitStatusPanel;
      frmSubmit.ActivateTabForm;
      RefreshStudyStatus;
      fMenu := frmSubmit.getMainMenu;
      frmSubmit.acSubmit.Enabled := (pos('Error', lblStudyStatus.Caption) > 0)
        and
        (Length(frmSubmit.edSignature.Text) >
          devOptions.iValue(donMinESigLength));
    except
    end;

  if Assigned(fMenu) then
    mmShell.Merge(fMenu)
  else
    miComments.Enabled := False;
end;

procedure TfrmMain.timerTimer(Sender: TObject);
begin
  timer.Enabled := false;
  StatusBar.Panels[0].Text := '';
  Screen.Cursor := crDefault;
end;

procedure TfrmMain.StatusBarMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ssShift in Shift then
    acShowLogExecute(nil);
  if ssCtrl in Shift then
    acShowGatewayInfoExecute(nil);
end;

procedure TfrmMain.StatusBarDblClick(Sender: TObject);
begin
{$IFDEF AANTEST}
  pnlCommentsControl.Visible := not pnlCommentsControl.Visible;
  if Assigned(frmFlow) then
    frmFlow.pnlExtras.Visible := not frmFlow.pnlExtras.Visible;
{$ELSE}
  acShowLogExecute(nil);
{$ENDIF}
end;

procedure TfrmMain.FormActivate(Sender: TObject);
begin
  Application.HelpFile :=
    ExtractFilePath(Application.ExeName) + '\Hemodialysis.hlp';
end;

// updates the status screen of the cdsStatus dataset
procedure TfrmMain.RefreshSubmitStatusPanel;
begin
  pgcMain.Images := ImageList1;
  try
    frmCover.ReportStatus;
    frmSummary.ReportStatus;
    frmAccess.ReportStatus;
    frmPre.ReportStatus;
    frmPost.ReportStatus;
    frmFlow.ReportStatus;
    frmRxLab.ReportStatus;
    frmSubmit.ReportStatus;
  except
  end;
end;

procedure TfrmMain.GoToPage(aPage: string);
begin
  if aPage = pnCover then
    pgcMain.ActivePage := tsCover;
  if aPage = pnAccess then
    pgcMain.ActivePage := tsAccess;
  if aPage = pnPre then
    pgcMain.ActivePage := tsPreTreatment;
  if aPage = pnRxLab then
    pgcMain.ActivePage := tsRxLab;
  if aPage = pnFlow then
    pgcMain.ActivePage := tsFlowSheet;
  if aPage = pnPost then
    pgcMain.ActivePage := tsPostTreatment;
  if aPage = pnSummary then
    pgcMain.ActivePage := tsSummary;
end;

procedure TfrmMain.acOptionsShowExecute(Sender: TObject);
begin
  acShowLogExecute(nil);
end;

procedure TfrmMain.resetOptions;
var
  iTimeout: Integer;
begin
  if not Assigned(Engine) then
    Exit;

  Screen.Cursor := crHourGlass;
  ShowStatusMessage(' Reloading Options...');
  ResetPreferences(Engine.getSystemOptionByName(onSysOptions),
    Engine.getuserOptionByName(onUserOptions));
  Preferences.Overwrite(Engine.getuserOptionByName(onUserSettings));
  Administrators.Overwrite(Engine.getSystemOptionByName(onAdministrators));

  if RPCBroker <> nil then
    try
      iTimeout := StrToIntDef(Preferences.sValue(onBrokerTimeout), 30);
      RPCBroker.RPCTimeLimit := iTimeout;
    except
      on E: Exception do
        ShowMessage(E.Message);
    end;

  dmData.UpdateFlowsheetIndex(Preferences.bValue(onReverseFlowsheetOrder));

  AssignList(frmRxLab.dbcbRxDialyser.Items,
    Engine.getSystemOptionByName(onDialyzerList));
  AssignList(frmPost.dbcTransportation.Items,
    Engine.getSystemOptionByName(onTransType));
  AssignList(frmPre.dbcTransportation.Items,
    Engine.getSystemOptionByName(onTransType));
  AssignList(frmRxLab.dbcbAC_Type.Items,
    Engine.getSystemOptionByName(onAntiCoagulants));

  frmCover.RefreshGUI;

  AssignList(frmPre.dbeEduKey.Items,
    Engine.getSystemOptionByName(onEducationCodes));

  frmPre.setup;
  frmPost.RefreshGUI;

  UpdateSB;

  Engine.MedList_CDS.FieldByName(fnML_Date).Visible :=
    devOptions.sValue(donShowMedicineDate) = 'TRUE';
  Engine.FLowsheet_CDS.FieldByName(fnFS_Date).Visible :=
    devOptions.sValue(donShowFlowsheetDate) = 'TRUE';
  //  TDateTimeField(Engine.MedList_CDS.FieldByName(fnML_Time)).DisplayFormat := Preferences.sValue(onTimeFormat);
  //  TDateTimeField(Engine.Flowsheet_CDS.FieldByName(fnFS_Time)).DisplayFormat := Preferences.sValue(onTimeFormat);
  //  frmFlow.btnInvalidNote.Visible := Engine.CurrentOperatorMode = rnAdmin;
  frmFlow.cmbAutoRefresh.Text := IntToStr(Preferences.iValue(onRefreshRate) *
    60);
  if frmFlow.fLeftToRefresh > Preferences.iValue(onRefreshRate) * 1000 * 60 then
    frmFlow.fLeftToRefresh := Preferences.iValue(onRefreshRate) * 1000 * 60;

  tmGateway.Interval := devOptions.iValue(donGatewayRequestTimeout)* 1000;

  iTimeout := StrToIntDef(Engine.UserTimeout,1000);
{$IFNDEF AANTEST}
  if iTimeout > MAXIMUM_TIMEOUT_SEC then
    iTimeout := MAXIMUM_TIMEOUT_SEC;
  if iTimeout < MINIMUM_TIMEOUT_SEC then
    iTimeout := MINIMUM_TIMEOUT_SEC;
{$ENDIF}
  UpdateTimeOutInterval(iTimeout);

  frmSummary.SetUp;
  frmSubmit.SetUp;

  if Assigned(frmListEdit) then
    frmListEdit.setQuantityLimit(devOptions.iValue(donMaxProcedureQuantity));

  ShowStatusMessage(' Options Reloaded');

  acShowStatusPanel.Checked := Preferences.bValue(onShowStatusPanel);
  acSetPending.Enabled :=
    Preferences.bValue(onAllowUserResetStudyStatus) and
    (pos('Error', lblStudyStatus.Caption) > 0);
  n6.Enabled := Preferences.bValue(onAllowUserResetStudyStatus);

  if Mode <> smBlank then
    setBackgroundColor(Engine.CurrentPatient.ReadOnly)
  else
    setBackgroundColor(False);

  case pgcMain.ActivePageIndex of
  0:begin
    frmCover.ReportStatus;
    frmCover.RefreshGUI;
    end;
  1:frmRxLab.ReportStatus;
  2:frmPre.ReportStatus;
  3:frmAccess.UpdateGUI;
  4:frmFlow.ReportStatus;
  5:frmPost.ReportStatus;
  6:frmSummary.ReportStatus;
  end;

  Screen.Cursor := crDefault;
end;

procedure TfrmMain.acReloadOptionsExecute(Sender: TObject);
begin
  ResetOptions;
end;

procedure TfrmMain.pgcMainChanging(Sender: TObject;
  var AllowChange: Boolean);
var
  s: string;
  ts: TTabSheet;

begin
  ts := nil;
  if Sender is TPageControl then
    ts := (Sender as TPageControl).ActivePage;
  if not Assigned(ts) then
    Exit;

  if ts = tsCover then
    begin
      frmCover.ReportStatus;
      if Engine.CurrentPatient.ReadOnly then
        Exit;
      if not frmCover.canDeactivate(s) then
        begin
          s := 'Form is not completed:' + #13#10 + #13#10 + s;
          case MessageDlg(s + #13#10 + 'Exit this tab?',
            mtConfirmation, [mbYes, mbNo], 0) of
            mrYes: AllowChange := True;
            mrNo: AllowChange := False;
          end;
        end;
    end
  else
    begin
      AllowChange := True;
      if (ts = tsAccess) then
        frmAccess.ReportStatus
      else if (ts = tsPreTreatment) then
        frmPre.ReportStatus
      else if (ts = tsPostTreatment) then
        frmPost.ReportStatus
      else if (ts = tsSummary) then
        frmSummary.ReportStatus
      else if (ts = tsRxLab) then
        frmRxLab.ReportStatus
      else if (ts = tsFlowSheet) then
        frmFlow.ReportStatus
          ;
    end;
end;

procedure TfrmMain.tmGatewayTimer(Sender: TObject);
var
  s: string;
begin
  try  //vhaishandria 2007-08-06 build 312 update #31
    s := Engine.fRenalController.getGatewayRunningStatus + '    ';
  except
    s := 'Unknown    ';
  end;
  StatusBar.Panels[sbIndex_GatewayStatus].Text := ' CP Gateway: ' + s;
  UpdateSB;
end;

procedure TfrmMain.acShowGatewayInfoExecute(Sender: TObject);
begin
  tmGatewayTimer(nil);
  MessageDLG(Engine.getGatewayInfo, mtInformation, [mbOK], 0);
end;

procedure TfrmMain.acSaveVitalsExecute(Sender: TObject);
begin
  try
    Engine.SubmitVitalsData;
  except
  end;
end;

procedure TfrmMain.acSaveFlowsheetExecute(Sender: TObject);
begin
  try
    Engine.SubmitFlowsheet;
  except
  end;
end;

procedure TfrmMain.acUserManualExecute(Sender: TObject);
var
  s: string;
begin
  s := devOptions.sValue(donWebUserManualURL);
  ShellExecute(0, nil, PChar(s), nil, nil, SW_NORMAL)
end;

procedure TfrmMain.RefreshStudyStatus;
var
  s: string;
  cc: TColor;
begin
  cc := clWindowText;
  lblStudyNum.Font.Color := cc;
  lblLocationID.Font.Color := cc;
  lblStudyDate.Font.Color := cc;

  acSetPending.Enabled := False;
  if acClear then
    begin
      lblStudyNum.Caption := '';
      StatusBar.Panels[sbIndex_StudyID].Text := '';
      lblStudyStatus.Caption := '';
      lblLocationID.Caption := '';
      lblStudyDate.Caption := '';
      lblAppointmentInfo.Caption := '';

      lblPtName.Caption := '';
      lblPtDemographics.Caption := '  No Patient Selected';

      pnlToolbar.Color := clSilver;
    end
  else
    begin
      lblLocationID.Caption := Engine.LocationName;
      lblStudyNum.Caption := Engine.CurrentPatient.SessionID;
      StatusBar.Panels[sbIndex_StudyID].Text := ' ' +
        Engine.CurrentPatient.SessionID;
      s := Engine.getStudyStatus(Engine.CurrentPatient.SessionID);
      if trim(s) <> '' then
        s := trim(s) + '.'
      else
        s := 'Unknown. ';
      lblStudyStatus.Caption := s;
      if pos('Error', lblStudyStatus.Caption) > 0 then
        lblStudyStatus.Font.Color := clRed
      else
        lblStudyStatus.Font.Color := cc;

      acSetPending.Enabled :=
        Preferences.bValue(onAllowUserResetStudyStatus) and
        (pos('Error', lblStudyStatus.Caption) > 0);

      lblAppointmentInfo.Caption := piece(Engine.getAppointmentInfo, '^', 2);
      if pos('have met', lblAppointmentInfo.Caption) > 0 then
        lblAppointmentInfo.Font.Color := cc
      else
        lblAppointmentInfo.Font.Color := clRed;
      lblAppointmentInfo.Left := lblStudyStatus.Left +
        lblStudyStatus.Width + 6;

      lblPtName.Caption := Uppercase(Engine.CurrentPatient.Name);
      lblPtDemographics.Caption := Engine.CurrentPatient.Description +
        Engine.VendorPtID;
      lblStudyDate.Caption := Piece(Engine.StudyDate, ' ', 1);
    end;

  invalidate; // vhaishandria 061006
end;

procedure TfrmMain.acShowStatusPanelExecute(Sender: TObject);
begin
  if userOptions.bValue(onShowStatusPanel) then
    userOptions.setValue(onShowStatusPanel, 'FALSE')
  else
    userOptions.setValue(onShowStatusPanel, 'TRUE');

  acShowStatusPanel.Checked := userOptions.bValue(onShowStatusPanel);

  Engine.setUserOptionByName(onUserOptions, userOptions.ValueList.Text);
  Preferences.Overwrite(userOptions.ValueList.Text);

  frmSubmit.SetUp;
  RefreshSubmitStatusPanel;
end;

procedure TfrmMain.pgcMainMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  i, iCount: Integer;
const
  iDuck = 4;
begin
  if (ssCtrl in Shift) and (Button = mbRight) then
    begin
      iCount := 0;
      for i := 0 to pgcMain.PageCount - 2 do
        if pgcMain.Pages[i].ImageIndex < 2 then
          inc(iCount);
      if iCount = pgcMain.PageCount - 1 then
        for i := 1 to pgcMain.PageCount - 2 do
          pgcMain.Pages[i].ImageIndex := iDuck;
    end;
end;

procedure TfrmMain.ShowStatusMessage(aString: string);
begin
  StatusBar.Panels[0].Text := aString;
  Application.ProcessMessages;
  Timer.Enabled := True;
end;

procedure TfrmMain.acShowGUIExecute(Sender: TObject);
begin
  Mode := smPatient;
end;

procedure TfrmMain.acSaveRPCResultsExecute(Sender: TObject);
begin
{$IFDEF AANTEST}
  SaveRPCResults := not SaveRPCResults;
  acSaveRPCResults.Checked := SaveRPCResults;
{$ELSE}
  SaveRPCResults := False;
{$ENDIF}
end;

procedure TfrmMain.acSetPendingExecute(Sender: TObject);
begin
  if not Assigned(Engine) then
    Exit;
  Engine.setStudyStatusPending(Engine.CurrentPatient.SessionID);
  RefreshStudyStatus;
  try
    frmSubmit.setSubmitStatus(lblStudyStatus.Caption);
  except
  end;
end;

procedure TfrmMain.StatusBarDrawPanel(StatusBar: TStatusBar;
  Panel: TStatusPanel; const Rect: TRect);
begin
  with StatusBar.Canvas do
    begin
      FillRect(Rect);
      if (pos(': Up', Panel.Text) = 0) then
        Font.Color := clRed
      else
        Font.Color := clWindowText;

      TextOut(Rect.Left + 2, Rect.Top + 2, Panel.Text);
    end;
end;

procedure TfrmMain.AppException(Sender: TObject; E: Exception);
begin
  //  Application.ShowException(E);
  //  Application.Terminate;
end;

procedure TfrmMain.ShowOldStyleComments1Click(Sender: TObject);
begin
  ShowOldStyleComments1.Checked := not ShowOldStyleComments1.Checked;

  frmRxLab.pnlRxNotes.Visible := ShowOldStyleComments1.Checked;
  frmRxLab.spbUpdateOldComments.Visible := ShowOldStyleComments1.Checked;

  frmPre.pnlPreNotes.Visible := ShowOldStyleComments1.Checked;
  frmPre.spbUpdateOldComments.Visible := ShowOldStyleComments1.Checked;

  frmPost.pnlPostNotes.Visible := ShowOldStyleComments1.Checked;
  frmPost.spbUpdateOldComments.Visible := ShowOldStyleComments1.Checked;

  frmAccess.pnlCommentsFix.Visible := ShowOldStyleComments1.Checked;

  frmSummary.gbOverallComments.Visible := ShowOldStyleComments1.Checked;
  frmSummary.spbUpdateOldComments.Visible := ShowOldStyleComments1.Checked;
end;

end.

