unit fMDK_PainAssessmentDLG;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, Mask, DBCtrls, Menus, DB;

type
  TdlgPainAssessment = class(TForm)
    gbObservations: TGroupBox;
    Panel69: TPanel;
    pnlPainPatientDetails: TPanel;
    Label14: TLabel;
    Label15: TLabel;
    Label30: TLabel;
    Label31: TLabel;
    Label32: TLabel;
    Label33: TLabel;
    Label18: TLabel;
    dbeOtherComments: TDBEdit;
    dbeOtherTreatment: TDBEdit;
    dbeHelpMed: TDBEdit;
    dbeRelieve: TDBEdit;
    dbeWorse: TDBEdit;
    dbeImpact: TDBEdit;
    Panel1: TPanel;
    OkBtn: TBitBtn;
    CancelBtn: TBitBtn;
    BitBtn1: TBitBtn;
    Panel5: TPanel;
    dbrgPainToleration: TDBRadioGroup;
    pnlPainDetails: TPanel;
    pnlDetailsItems: TPanel;
    Label47: TLabel;
    dbcLocation: TDBComboBox;
    Label53: TLabel;
    dbcIntensity: TDBComboBox;
    Label52: TLabel;
    dbeFrequencyText: TDBEdit;
    Label50: TLabel;
    dbcOnset: TDBComboBox;
    Label49: TLabel;
    dbcDuration: TDBComboBox;
    Label48: TLabel;
    dbcQuality: TDBComboBox;
    pnlPainGeneralItems: TPanel;
    lblPostPain: TLabel;
    dbcPain: TDBComboBox;
    Label44: TLabel;
    dbeLocation: TDBComboBox;
    pnlPainForm: TPanel;
    Label19: TLabel;
    Panel9: TPanel;
    dbrgPain: TDBRadioGroup;
    Label45: TLabel;
    dbeTreatment: TDBEdit;
    lblPainTolerance: TLabel;
    lblPain: TLabel;
    PopupMenu: TPopupMenu;
    Format1: TMenuItem;
    lblPainExtra: TLabel;
    procedure dbcPainChange(Sender: TObject);
    procedure dbrgPainTolerationChange(Sender: TObject);
    procedure dbcPainEnter(Sender: TObject);
    procedure dbcPainExit(Sender: TObject);
    procedure dbcPainContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Format1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
    Originals: TStringList;
    fField: TField;
    fActive: TObject;
    procedure checkDBFields;
    procedure CleanDBFields;
    procedure setPainFormStatus;

    procedure SaveOriginals;
    procedure RestoreOriginals;
  public
    { Public declarations }
    procedure setUp(aType: Integer);
  end;

var
  dlgPainAssessment: TdlgPainAssessment;

function UpdatePainData(aType: Integer): Integer;

implementation

uses uMDK_Summary, uMDK_Options, dMDK_Data, uMDK_Dictionary, uMDK_Common,
  uMDK_CDSCommon, uMDK_Engine, fMDK_DictionaryEdit;

{$R *.dfm}

function UpdatePainData(aType: Integer): Integer;
begin
  if not Assigned(dlgPainAssessment) then
    Application.CreateForm(TdlgPainAssessment, dlgPainAssessment);
  dlgPainAssessment.setUp(aType);
  dlgPainAssessment.SaveOriginals;
  result := dlgPainAssessment.ShowModal;
  if Result = mrCancel then
    dlgPainAssessment.RestoreOriginals;
  freeAndNil(dlgPainAssessment);
end;

////////////////////////////////////////////////////////////////////////////////

procedure TdlgPainAssessment.setUp(aType: Integer);
begin
  case aType of
    0:
      begin // Pre-Treatment
        dbcPain.DataField := fnS_PrePain; // Integer;

        dbrgPainToleration.DataField := fnS_PrePainTolerance;

        dbeLocation.DataField := fnS_PrePainLocation;
        // PrePainLocation',40,40); //
        dbrgPain.DataField := fnS_PrePainAcute; // PrePainAcute');
        dbeTreatment.DataField := fnS_PrePainTreatment;
        // PrePainTreatment',40,40); //
        dbcLocation.DataField := fnS_PrePainIASP; // PrePainIASP',40,40); //;
        dbcIntensity.DataField := fnS_PrePainIntensity;
        // PrePainIntensity',40,40); //;
        dbeFrequencyText.DataField := fnS_PrePainFrequencyText;
        // PrePainFrequency',40,40); //;
        dbcOnset.DataField := fnS_PrePainOnset; // PrePainOnset',40,40); //;
        dbcDuration.DataField := fnS_PrePainDuration;
        // PrePainDuration',40,40); //;
        dbcQuality.DataField := fnS_PrePainQuality;
        // PrePainQuality',40,40); //;

        dbeImpact.DataField := fnS_PrePainImpact; // PrePainImpact',40,40);
        dbeWorse.DataField := fnS_PrePainWorse; // PrePainWorse',40,40);
        dbeRelieve.DataField := fnS_PrePainRelieve; // PrePainRelieve',40,40);
        dbeHelpMed.DataField := fnS_PrePainHelpMed; // PrePainHelpMed',40,40);
        dbeOtherTreatment.DataField := fnS_PrePainOtherTreatments;
        // PrePainOtherTreatments',40,40);
        dbeOtherComments.DataField := fnS_PrePainOtherComments;
        // PrePainOtherComments',40,40);
      end;
    1:
      begin // Post-Treatment
        dbcPain.DataField := fnS_PostPain; // Integer;

        dbrgPainToleration.DataField := fnS_PrePainTolerance;
        dbeLocation.DataField := fnS_PostPainLocation;
        // PrePainLocation',40,40); //
        dbrgPain.DataField := fnS_PostPainAcute; // PrePainAcute');
        dbeTreatment.DataField := fnS_PostPainTreatment;
        // PrePainTreatment',40,40); //
        dbcLocation.DataField := fnS_PostPainIASP; // PrePainIASP',40,40); //;
        dbcIntensity.DataField := fnS_PostPainIntensity;
        // PrePainIntensity',40,40); //;
        dbeFrequencyText.DataField := fnS_PostPainFrequencyText;
        // PrePainFrequency',40,40); //;
        dbcOnset.DataField := fnS_PostPainOnset; // PrePainOnset',40,40); //;
        dbcDuration.DataField := fnS_PostPainDuration;
        // PrePainDuration',40,40); //;
        dbcQuality.DataField := fnS_PostPainQuality;
        // PrePainQuality',40,40); //;

        dbeImpact.DataField := fnS_PostPainImpact; // PrePainImpact',40,40);
        dbeWorse.DataField := fnS_PostPainWorse; // PrePainWorse',40,40);
        dbeRelieve.DataField := fnS_PostPainRelieve; // PrePainRelieve',40,40);
        dbeHelpMed.DataField := fnS_PostPainHelpMed; // PrePainHelpMed',40,40);
        dbeOtherTreatment.DataField := fnS_PostPainOtherTreatments;
        // PrePainOtherTreatments',40,40);
        dbeOtherComments.DataField := fnS_PostPainOtherComments;
        // PrePainOtherComments',40,40);
      end;
  end;

  if Preferences.bValue(onConsiderPainTolerance) then
    begin
      dbrgPainToleration.Visible := True;
      lblPainTolerance.Visible := True;
      lblPain.Caption := 'If the patient can not tolerate pain, ' +
        'please answer the following:';
      pnlPainDetails.Height := 48;
      lblPainExtra.Visible := False;
    end
  else
    begin
      dbrgPainToleration.Visible := False;
      lblPainTolerance.Visible := False;
      lblPain.Caption := 'If the pain exists, please answer the following:';
      lblPainExtra.Visible := True;
      lblPainExtra.Caption := 'If the pain value is ' +
        Preferences.sValue(onPainLevel) +
        ' or more, please answer the following:';
      pnlPainDetails.Height := 25;
    end;
  dbcPainChange(nil);
end;

procedure TdlgPainAssessment.checkDBFields;
begin
  CheckDBField(dbcPain);

  CheckDBField(dbeLocation);
  CheckDBField(dbeTreatment);

  CheckDBField(dbcLocation);
  CheckDBField(dbcIntensity);
  CheckDBField(dbeFrequencyText);
  CheckDBField(dbcOnset);
  CheckDBField(dbcDuration);
  CheckDBField(dbcQuality);

  CheckDBField(dbeImpact);
  CheckDBField(dbeWorse);
  CheckDBField(dbeRelieve);
  CheckDBField(dbeHelpMed);
  CheckDBField(dbeOtherTreatment);
  CheckDBField(dbeOtherComments);
end;

procedure TdlgPainAssessment.CleanDBFields;
begin
  dmData.cdsSummary.Edit;

  if Preferences.bValue(onConsiderPainTolerance) then
    dmData.cdsSummary.FieldByName(dbrgPainToleration.DataField).AsString :=
      'Yes';

  dmData.cdsSummary.FieldByName(dbcLocation.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbcIntensity.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbeFrequencyText.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbcOnset.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbcDuration.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbcQuality.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbeImpact.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbeWorse.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbeRelieve.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbeHelpMed.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbeOtherTreatment.DataField).AsString := '';
  dmData.cdsSummary.FieldByName(dbeOtherComments.DataField).AsString := '';

end;

procedure setupControls(aPanel: TPanel; aValue: Boolean);
var
  i: integer;
  bEnabled: Boolean;
begin
  //  bEnabled := dbrgPainToleration.Value = 'No';
  bEnabled := aValue;
  aPanel.Enabled := bEnabled;
  for i := 0 to aPanel.ControlCount - 1 do
    if aPanel.Controls[i] is TDBEdit then
      TDBEdit(aPanel.Controls[i]).Enabled := bEnabled
    else if aPanel.Controls[i] is TDBComboBox then
      TDBComboBox(aPanel.Controls[i]).Enabled := bEnabled
    else if aPanel.Controls[i] is TPanel then
      TPanel(aPanel.Controls[i]).Enabled := bEnabled
end;

procedure TdlgPainAssessment.dbcPainChange(Sender: TObject);
var
  i, iPain: Integer;
  s: string;
begin
  s := dbcPain.Text;
  i := StrToIntDef(s, 0);
  s := Preferences.sValue(onPainLevel);
  iPain := StrToIntDef(s, 5);

  if Preferences.bValue(onConsiderPainTolerance) then
    begin
      dbrgPainToleration.Enabled := i > 0;
      dbrgPainTolerationChange(nil);
      pnlPainGeneralItems.Height := 90;
    end
  else
    begin
      if not dmData.cdsSummary.Active then
        Exit;

      //      dbrgPain.Enabled := i > iPain;
      dbrgPain.Enabled := i > 0;
      //      setUpControls(pnlPainGeneralItems, i >= iPain);
      setUpControls(pnlPainGeneralItems, i > 0);

      setUpControls(pnlDetailsItems, i >= iPain);
      setUpControls(pnlPainPatientDetails, i >= iPain);
      pnlPainGeneralItems.Height := 107;

    end;

  if i < iPain then
    CleanDBFields;

  checkDBFields;
end;

procedure TdlgPainAssessment.setPainFormStatus;
var
  i, iPain: Integer;
  s: string;
begin
  if Preferences.bValue(onConsiderPainTolerance) then
    dbrgPain.Enabled := dbrgPainToleration.Value = 'No'
  else
    begin
      s := dbcPain.Text;
      i := StrToIntDef(s, 0);
      s := Preferences.sValue(onPainLevel);
      iPain := StrToIntDef(s, 5);
      dbrgPain.Enabled := i >= iPain;
    end;
end;

procedure TdlgPainAssessment.dbrgPainTolerationChange(Sender: TObject);
begin
  setPainFormStatus;
  setUpControls(pnlPainGeneralItems, dbrgPain.Enabled);
  setUpControls(pnlDetailsItems, dbrgPain.Enabled);
  setUpControls(pnlPainPatientDetails, dbrgPain.Enabled);
  checkDBFields;
end;

procedure TdlgPainAssessment.dbcPainEnter(Sender: TObject);
begin
  fField := getActiveField(Sender);
  fActive := Sender;
end;

procedure TdlgPainAssessment.dbcPainExit(Sender: TObject);
begin
  CheckDBField(Sender);
  fField := nil;
  fActive := nil;
end;

procedure TdlgPainAssessment.dbcPainContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
  if Engine.CurrentOperatorMode <> rnAdmin then
    Exit;
  WinCon := TWinControl(Sender);
  dbcPainEnter(Sender);
  PopupMenu.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y +
    MousePos.Y);
  Handled := True;
end;

procedure TdlgPainAssessment.Format1Click(Sender: TObject);
begin
  if fField = nil then
    exit;
  try
    UpdateColumnField(fField, fField.DataSet.Name, fField.FieldName);
    CheckDBField(fActive);
  except
  end;
end;

procedure TdlgPainAssessment.FormCreate(Sender: TObject);
begin
  inherited;
  Originals := TStringList.Create;
end;

procedure TdlgPainAssessment.FormDestroy(Sender: TObject);
begin
  FreeAndNil(Originals);
  inherited;
end;

procedure TdlgPainAssessment.SaveOriginals;

  procedure SaveItem(aName: string);
  begin
    try
      Originals.Add(aName + '=' +
        dmData.cdsSummary.FieldByName(aName).AsString);
    except
    end;
  end;

begin
  Originals.Clear;
  SaveItem(fnS_PrePain);
  SaveItem(fnS_PrePainTolerance);
  SaveItem(fnS_PrePainLocation);
  SaveItem(fnS_PrePainAcute);
  SaveItem(fnS_PrePainTreatment);
  SaveItem(fnS_PrePainIASP);
  SaveItem(fnS_PrePainIntensity);
  SaveItem(fnS_PrePainFrequencyText);
  SaveItem(fnS_PrePainOnset);
  SaveItem(fnS_PrePainDuration);
  SaveItem(fnS_PrePainQuality);
  SaveItem(fnS_PrePainImpact);
  SaveItem(fnS_PrePainWorse);
  SaveItem(fnS_PrePainRelieve);
  SaveItem(fnS_PrePainHelpMed);
  SaveItem(fnS_PrePainOtherTreatments);
  SaveItem(fnS_PrePainOtherComments);

  SaveItem(fnS_PostPain);
  SaveItem(fnS_PostPainTolerance);
  SaveItem(fnS_PostPainLocation);
  SaveItem(fnS_PostPainAcute);
  SaveItem(fnS_PostPainTreatment);
  SaveItem(fnS_PostPainIASP);
  SaveItem(fnS_PostPainIntensity);
  SaveItem(fnS_PostPainFrequencyText);
  SaveItem(fnS_PostPainOnset);
  SaveItem(fnS_PostPainDuration);
  SaveItem(fnS_PostPainQuality);
  SaveItem(fnS_PostPainImpact);
  SaveItem(fnS_PostPainWorse);
  SaveItem(fnS_PostPainRelieve);
  SaveItem(fnS_PostPainHelpMed);
  SaveItem(fnS_PostPainOtherTreatments);
  SaveItem(fnS_PostPainOtherComments);

end;

procedure TdlgPainAssessment.RestoreOriginals;
var
  sValue: string;

  procedure RestoreItem(aName: string);
  begin
    try
      sValue := Originals.Values[aName];
      dmData.cdsSummary.FieldByName(aName).AsString := sValue;
    except
    end;
  end;
begin
  with dmData.cdsSummary do
    begin
      if State <> dsEdit then
        Edit;
      RestoreItem(fnS_PrePain);
      RestoreItem(fnS_PrePainTolerance);
      RestoreItem(fnS_PrePainLocation);
      RestoreItem(fnS_PrePainAcute);
      RestoreItem(fnS_PrePainTreatment);
      RestoreItem(fnS_PrePainIASP);
      RestoreItem(fnS_PrePainIntensity);
      RestoreItem(fnS_PrePainFrequencyText);
      RestoreItem(fnS_PrePainOnset);
      RestoreItem(fnS_PrePainDuration);
      RestoreItem(fnS_PrePainQuality);
      RestoreItem(fnS_PrePainImpact);
      RestoreItem(fnS_PrePainWorse);
      RestoreItem(fnS_PrePainRelieve);
      RestoreItem(fnS_PrePainHelpMed);
      RestoreItem(fnS_PrePainOtherTreatments);
      RestoreItem(fnS_PrePainOtherComments);

      RestoreItem(fnS_PostPain);
      RestoreItem(fnS_PostPainTolerance);
      RestoreItem(fnS_PostPainLocation);
      RestoreItem(fnS_PostPainAcute);
      RestoreItem(fnS_PostPainTreatment);
      RestoreItem(fnS_PostPainIASP);
      RestoreItem(fnS_PostPainIntensity);
      RestoreItem(fnS_PostPainFrequencyText);
      RestoreItem(fnS_PostPainOnset);
      RestoreItem(fnS_PostPainDuration);
      RestoreItem(fnS_PostPainQuality);
      RestoreItem(fnS_PostPainImpact);
      RestoreItem(fnS_PostPainWorse);
      RestoreItem(fnS_PostPainRelieve);
      RestoreItem(fnS_PostPainHelpMed);
      RestoreItem(fnS_PostPainOtherTreatments);
      RestoreItem(fnS_PostPainOtherComments);
      Post;
    end;

end;

end.
