unit fMDK_ReloadFlowsheet;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Reload form
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms/fMDK_ReloadFlowsheet.pas $
*
*       $ History: fMDK_ReloadFlowsheet.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, ActnList, StdActns;

type
  Tdlg_ReloadFlowsheet = class(TForm)
    pnlButtons: TPanel;
    Panel2: TPanel;
    btnOK: TBitBtn;
    BitBtn2: TBitBtn;
    ActionList1: TActionList;
    acSelectFile: TFileOpen;
    acSelect: TFileOpen;
    acSaveNow: TAction;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    grbReloadOptions: TGroupBox;
    Panel4: TPanel;
    Label11: TLabel;
    rbFlowDelete: TRadioButton;
    rbFlowInstrumentOnly: TRadioButton;
    rbFlowNotChange: TRadioButton;
    Panel7: TPanel;
    Label12: TLabel;
    rb2NotChanged: TRadioButton;
    rb2Instrument: TRadioButton;
    rb2All: TRadioButton;
    Panel8: TPanel;
    Label13: TLabel;
    rb4NotChanged: TRadioButton;
    rbReplace: TRadioButton;
    lblVista: TLabel;
    grbDataSource: TGroupBox;
    Panel3: TPanel;
    Label5: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label3: TLabel;
    sbVista: TSpeedButton;
    sbMedList: TSpeedButton;
    sbNotes: TSpeedButton;
    sbSummary: TSpeedButton;
    edVista: TEdit;
    edMedList: TEdit;
    edNotes: TEdit;
    edSummary: TEdit;
    Panel5: TPanel;
    rbFile: TRadioButton;
    rbVistA: TRadioButton;
    Bevel1: TBevel;
    Bevel2: TBevel;
    Panel1: TPanel;
    Label2: TLabel;
    rb3NotChanged: TRadioButton;
    rb3Instrument: TRadioButton;
    rb3All: TRadioButton;
    Bevel3: TBevel;
    Panel6: TPanel;
    cbFile: TCheckBox;
    SpeedButton1: TSpeedButton;
    edFName: TEdit;
    sbFFlowsheet: TSpeedButton;
    Bevel4: TBevel;
    pnlOnlyNewResults: TPanel;
    Bevel5: TBevel;
    rbNewResults: TRadioButton;
    RadioButton1: TRadioButton;
    Label1: TLabel;
    Label8: TLabel;
    procedure rbSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure rbVistAClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure acSaveNowExecute(Sender: TObject);
    procedure sbVistaClick(Sender: TObject);
    procedure sbFFlowsheetClick(Sender: TObject);
    procedure cbFileClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure setLayout(available: Boolean);
    function getLogString(aName: string = ''): string;

  end;

var
  dlg_ReloadFlowsheet: Tdlg_ReloadFlowsheet;

implementation

uses uXML, dMDK_Data, uMDK_Engine, uMDK_Common;

{$R *.dfm}

procedure Tdlg_ReloadFlowsheet.rbSaveClick(Sender: TObject);
begin
  acSelectFile.Enabled := cbFile.Checked;
end;

procedure Tdlg_ReloadFlowsheet.FormCreate(Sender: TObject);
begin
  rbSaveClick(nil);
  rbVistaClick(nil);
  cbFileClick(nil);
end;

procedure Tdlg_ReloadFlowsheet.rbVistAClick(Sender: TObject);
begin
  acSelect.Enabled := not rbVista.Checked;

  edVista.Enabled := not rbVista.Checked;
  edMedList.Enabled := not rbVista.Checked;
  edNotes.Enabled := not rbVista.Checked;

  if not rbVista.Checked then
    edVista.Color := clWindow
  else
    edVista.Color := clBtnFace;
  if not rbVista.Checked then
    edMedList.Color := clWindow
  else
    edMedList.Color := clBtnFace;
  if not rbVista.Checked then
    edNotes.Color := clWindow
  else
    edNotes.Color := clBtnFace;
  if not rbVista.Checked then
    edSummary.Color := clWindow
  else
    edSummary.Color := clBtnFace;

  rbFlowNotChange.Enabled := rbVistA.Checked;
  rbFlowInstrumentOnly.Enabled := rbVistA.Checked;
  rbFlowDelete.Enabled := rbVistA.Checked;
  rb2NotChanged.Enabled := rbVistA.Checked;
  rb2Instrument.Enabled := rbVistA.Checked;
  rb2All.Enabled := rbVistA.Checked;
  rb3NotChanged.Enabled := rbVistA.Checked;
  rb3Instrument.Enabled := rbVistA.Checked;
  rb3All.Enabled := rbVistA.Checked;

  if not rbVista.Checked then
    begin
      rbFlowNotChange.Font.Color := clInactiveCaption;
      rbFlowInstrumentOnly.Font.Color := clInactiveCaption;
      rbFlowDelete.Font.Color := clInactiveCaption;

      rb2NotChanged.Font.Color := clInactiveCaption;
      rb2Instrument.Font.Color := clInactiveCaption;
      rb2All.Font.Color := clInactiveCaption;
      rb3NotChanged.Font.Color := clInactiveCaption;
      rb3Instrument.Font.Color := clInactiveCaption;
      rb3All.Font.Color := clInactiveCaption;
    end
  else
    begin
      rbFlowNotChange.Font.Color := clBtnText;
      rbFlowInstrumentOnly.Font.Color := clBtnText;
      rbFlowDelete.Font.Color := clBtnText;

      rb2NotChanged.Font.Color := clBtnText;
      rb2Instrument.Font.Color := clBtnText;
      rb2All.Font.Color := clBtnText;
      rb3NotChanged.Font.Color := clBtnText;
      rb3Instrument.Font.Color := clBtnText;
      rb3All.Font.Color := clBtnText;
    end;

end;

procedure Tdlg_ReloadFlowsheet.btnOKClick(Sender: TObject);
var
  s: string;
  sl: TStringList;
begin
  if cbFile.Checked then
    begin
      if (edfName.Text = '') then
        begin
          MessageDLG('Save file name is not defined', mtWarning, [mbOK], 0);
          Exit;
        end
      else
        acSaveNow.Execute;
    end;

  s := getLogString;
  Engine.Report(rtDebug, s, '', 0, '', 'RELOAD');

  if not rbVista.Checked then
    begin
      sl := nil;
      if edVista.Text = '' then
        ShowMessage('No file selected...')
      else
        try
          sl := TStringList.Create;
          sl.LoadFromFile(edVista.Text);
          if not dmData.ValidDataSetXML(sl.Text) then
            ShowMessage('Invalid File Format...')
          else
            ModalResult := mrOK;
        finally
          sl.Free;
        end;
    end
  else
    ModalResult := mrOK;
end;

procedure Tdlg_ReloadFlowsheet.setLayout(Available: Boolean);
var
  s: string;
begin
  if not Available then
    begin
      s := 'No records are available for reload';
      rbVista.Checked := False;
      rbVista.Enabled := False;

      lblVista.Font.Color := clRed;
      lblVista.Font.Style := [fsBold];
      lblVista.Visible := True;

      btnOK.Enabled := False;

    end
  else
    begin
      s :=
        'All available to VistA data records will be read from the VistA DB and re-processed';
      lblVista.Visible := False;
      lblVista.Font.Color := clWindowText;
      lblVista.Font.Style := [];
      rbVista.Checked := True;
      rbVista.Enabled := True;
      btnOK.Enabled := True;

    end;
  lblVista.Caption := s;
end;

function Tdlg_ReloadFlowsheet.getLogString(aName: string = ''): string;
var
  sl: TStringList;
  xmlSummary,
    xmlFlowsheet,
    xmlMedList,
    xmlNotes: string;

  procedure prepareXMLStrings;
  begin
    with dmData do
      begin
        try
          cdsFlowSheet.MergeChangeLog;
          xmlFlowsheet := cdsFlowSheet.XMLData;
        except
          xmlFlowsheet := '';
        end;
        try
          cdsMedList.MergeChangeLog;
          xmlMedList := cdsMedList.XMLData;
        except
          xmlMedList := '';
        end;
        try
          cdsNotes.MergeChangeLog;
          xmlNotes := cdsNotes.XMLData;
        except
          xmlNotes := '';
        end;
        try
          cdsSummary.MergeChangeLog;
          xmlSummary := cdsSummary.XMLData;
        except
          xmlNotes := '';
        end;
      end;
  end;

begin
  if trim(aName) = '' then
    Exit;
    
  prepareXMLStrings;
  sl := TStringList.Create;
  sl.Add('FLOWSHEET');
  sl.Add(xmlFlowsheet);
  sl.Add('MEDICATIONS');
  sl.Add(xmlMedList);
  sl.Add('FLOWSHEETNOTES');
  sl.Add(xmlNotes);
  sl.Add('SUMMARY');
  sl.Add(xmlSummary);
  sl.SaveToFile(aName);
  Result := sl.Text;
  sl.Free;
end;

procedure Tdlg_ReloadFlowsheet.acSaveNowExecute(Sender: TObject);
begin
  getLogString(edFName.Text);
end;

procedure Tdlg_ReloadFlowsheet.sbVistaClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    edVista.Text := OpenDialog1.FileName;
end;

procedure Tdlg_ReloadFlowsheet.sbFFlowsheetClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    edFName.Text := SaveDialog1.FileName;
end;

procedure Tdlg_ReloadFlowsheet.cbFileClick(Sender: TObject);
begin
  edFName.Enabled := cbFile.Checked;
  if cbFile.Checked then
    edFName.Color := clWindow
  else
    edFName.Color := clBtnFace;

  acSaveNow.Enabled := cbFile.Checked;
end;

end.
