unit fMDK_Report;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 12/06/07 9:24a $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Report definition form
*       Notes:
*
================================================================================
*       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_Report.pas $
*
* $History: fMDK_Report.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/13/09    Time: 1:15p
 * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
 * Patch 19 source code
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/24/08    Time: 4:23p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/02/08    Time: 9:24a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 6/20/07    Time: 3:23p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 6/04/07    Time: 9:08a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/22/07    Time: 9:16a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 3/28/07    Time: 3:32p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 3/27/07    Time: 1:31p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:38p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:28p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/25/07    Time: 9:39a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:36p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Forms
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:28p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Forms
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 10/25/06   Time: 11:03a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 7/12/06    Time: 9:41a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/28/06    Time: 5:15p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ActnList, Buttons, StdCtrls, ComCtrls, Grids, DBGrids,
  ImgList, AppEvnts
  , dbClient
  ;

type
  TfrmMDK_Report = class(TForm)
    Panel1: TPanel;
    ActionList1: TActionList;
    acTemplateLoad: TAction;
    acTemplateSave: TAction;
    acTemplateProcess: TAction;
    acTemplateSend: TAction;
    acReportPrint: TAction;
    acReportSave: TAction;
    acReportSend: TAction;
    acVerifySyntax: TAction;
    acReportNew: TAction;
    pcMain: TPageControl;
    tsReport: TTabSheet;
    tsTemplate: TTabSheet;
    Panel5: TPanel;
    Panel4: TPanel;
    Panel7: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton5: TSpeedButton;
    mmResult: TMemo;
    Panel3: TPanel;
    reTemplate: TRichEdit;
    pnlKeywords: TPanel;
    Panel8: TPanel;
    cmbFilter: TComboBox;
    dbgKeywords: TDBGrid;
    dlgOpen: TOpenDialog;
    ImageList1: TImageList;
    BitBtn1: TBitBtn;
    cbAutoProcess: TCheckBox;
    spl: TSplitter;
    lbKeywords: TListBox;
    Splitter1: TSplitter;
    dlgSave: TSaveDialog;
    Panel2: TPanel;
    Panel6: TPanel;
    BitBtn5: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn6: TBitBtn;
    ckbKeywords: TCheckBox;
    procedure acTemplateProcessExecute(Sender: TObject);
    procedure acTemplateSaveExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ckbKeywordsClick(Sender: TObject);
    procedure acVerifySyntaxExecute(Sender: TObject);
    procedure pcMainChange(Sender: TObject);
    procedure acTemplateLoadExecute(Sender: TObject);
    procedure dbgKeywordsDblClick(Sender: TObject);
    procedure lbKeywordsDblClick(Sender: TObject);
    procedure acReportSaveExecute(Sender: TObject);
  private
    { Private declarations }
    fReportName: string;
    procedure Process;
    procedure PaintSyntax;
    procedure setUp(aName: string);
  public
    { Public declarations }
    property ReportName: string read fReportName write setUp;
  end;

var
  frmMDK_Report: TfrmMDK_Report;

implementation

uses
  uMDK_Engine, dMDK_Data, uMDK_Common
  , uMDK_ReportEngine
  , uMDK_Dictionary;

{$R *.dfm}

procedure TfrmMDK_Report.acTemplateProcessExecute(Sender: TObject);
begin
  Process;
  if pcMain.ActivePage <> tsReport then
    pcMain.ActivePage := tsReport;
end;

procedure TfrmMDK_Report.Process;
begin
  mmResult.Lines.Text := Engine.getReportValue(reTemplate.Lines.Text);
end;

procedure TfrmMDK_Report.PaintSyntax;
begin
  uMDK_ReportEngine.PaintSyntax(reTemplate);
end;

procedure TfrmMDK_Report.setUp(aName: string);
var
  s: string;
begin
  fReportName := aName;
  try
    s := Engine.getSystemOptionByName(aName);
    if pos('-1', s) <> 1 then
      reTemplate.Lines.Text := s
    else
      reTemplate.Lines.Text := '';
    mmResult.Clear;
    PaintSyntax;
  except
  end;
end;

procedure TfrmMDK_Report.acTemplateSaveExecute(Sender: TObject);
begin
  Engine.setSystemOptionByName(fReportName, reTemplate.Lines.Text);
end;

procedure TfrmMDK_Report.FormCreate(Sender: TObject);
begin
  try
    dbgKeywords.Columns[0].FieldName := fnDict_Tag;
    dbgKeywords.Columns[1].FieldName := fnDict_Comments;
  except
  end;
end;

procedure TfrmMDK_Report.ckbKeywordsClick(Sender: TObject);
begin
  if pnlKeywords.Visible then
    spl.Align := alLeft;
  pnlKeywords.Visible := ckbKeywords.Checked;
  if pnlKeywords.Visible then
    spl.Align := alRight;
end;

procedure TfrmMDK_Report.acVerifySyntaxExecute(Sender: TObject);
begin
  PaintSyntax;
end;

procedure TfrmMDK_Report.pcMainChange(Sender: TObject);
begin
  case pcMain.ActivePageIndex of
    0: if cbAutoprocess.Checked and Assigned(Engine.CurrentPatient) then
        acTemplateProcess.Execute;
    1: PaintSyntax;
    //    2: begin
    //        acTemplateProcess.Execute;
    //        html.LoadFromString(mmResult.Lines.Text,'');
    //      end;
  end;
end;

procedure TfrmMDK_Report.acTemplateLoadExecute(Sender: TObject);
var
  s: string;
begin
  s := dlgOpen.Title;
  dlgOpen.Title := 'Load Report Template';
  if dlgOpen.Execute then
    reTemplate.Lines.LoadFromFile(dlgOpen.FileName);
  dlgOpen.Title := s;
end;

procedure TfrmMDK_Report.dbgKeywordsDblClick(Sender: TObject);
var
  dbe: TCustomMemo;
  s: string;

  procedure CopyKeyword;
  begin
    s :=
      TClientDataSet(dbgKeyWords.DataSource.DataSet).FieldByName(fnDict_Tag).AsString;
    s := '<' + s + '>';
    if (s = '<>') then
      Exit;
    dbe.SelText := s;
  end;

begin
  dbe := TCustomMemo(reTemplate);
  CopyKeyword;
end;

procedure TfrmMDK_Report.lbKeywordsDblClick(Sender: TObject);
var
  dbe: TCustomMemo;
  s: string;

  procedure CopyKeyword;
  begin
    s := lbKeywords.Items[lbKeywords.ItemIndex];
    s := '<' + s + '>';
    if (s = '<>') then
      Exit;
    dbe.SelText := s;
  end;

begin
  dbe := TCustomMemo(reTemplate);
  try
    CopyKeyword;
  except
  end;
end;

procedure TfrmMDK_Report.acReportSaveExecute(Sender: TObject);
begin
  if dlgSave.Execute then
    reTemplate.Lines.SaveToFile(dlgSave.FileName);
end;

end.
