unit fMDK_SelectProvider;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Provider selection form
*       Notes:
*
================================================================================
*       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_SelectProvider.pas $
*
* $History: fMDK_SelectProvider.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/13/09    Time: 1:15p
 * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
 * Patch 19 source code
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/24/08    Time: 4:23p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/02/08    Time: 9:24a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 6/20/07    Time: 3:23p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 6/04/07    Time: 9:08a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/22/07    Time: 9:16a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  oDBController_Renal,
  Buttons, ExtCtrls;

type
  TdlgSelectProvider = class(TForm)
    Panel3: TPanel;
    bbSelect: TBitBtn;
    BitBtn2: TBitBtn;
    Panel1: TPanel;
    pnlTarget: TPanel;
    lblTitle: TLabel;
    edTarget: TComboBox;
    Panel4: TPanel;
    Label2: TLabel;
    lbProviders: TListBox;
    BitBtn5: TBitBtn;
    pnlOptions: TPanel;
    Label1: TLabel;
    ckbVistA: TRadioButton;
    RadioButton2: TRadioButton;
    Bevel1: TBevel;
    procedure edTargetKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bbSelectClick(Sender: TObject);
    procedure lbProvidersKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure lbProvidersDblClick(Sender: TObject);
    procedure edTargetEnter(Sender: TObject);
    procedure edTargetExit(Sender: TObject);
    procedure edTargetKeyPress(Sender: TObject; var Key: Char);
    procedure ckbVistAClick(Sender: TObject);
  private
    { Private declarations }
    fDBC: TDBController_Renal;
    fID: TStringList;
    fRequestType: Integer;
    function setSelection: Boolean;
  public
    { Public declarations }
    ProviderName,
      ProviderID: string;
    property DBC: TDBController_Renal read fDBC write fDBC;
    procedure CleanUp;
    procedure DoSearch;
  end;

var
  dlgSelectProvider: TdlgSelectProvider;

function SelectProvider(aTarget: string; aController: TDBController_Renal;
  RequestType: Integer = 0): string;

implementation

uses uROR_CommonUtils, uMDK_Common, Dialogs;

var
  sHistory0,
    sHistory1,
    sHistory2,
    sHistory3,
    sHistory4: string;

{$R *.dfm}

function SelectProvider(aTarget: string; aController: TDBController_Renal;
  RequestType: Integer = 0): string;
begin
  if not Assigned(dlgSelectProvider) then
    Application.CreateForm(TdlgSelectProvider, dlgSelectProvider);
  with dlgSelectProvider do
    begin
      edTarget.Enabled := True;
      pnlOptions.Visible := False;
      fRequestType := RequestType;
      case fRequestType of
        0:
          begin
            edTarget.Items.Text := sHistory0;
            Caption := 'Select Provider';
            lblTitle.Caption :=
              '&Enter first characters of the name and press "Return":'
          end;
        1:
          begin
            edTarget.Items.Text := sHistory1;
            Caption := 'Select Facility';
            lblTitle.Caption :=
              '&Enter first characters of the facility and press "Return":'
          end;
        2:
          begin
            edTarget.Items.Text := sHistory2;
            Caption := 'Select Administrator';
            lblTitle.Caption :=
              '&Enter first characters of the administrator name and press "Return":'
          end;
        3:
          begin
            edTarget.Items.Text := sHistory3;
            Caption := 'Select Application User';
            lblTitle.Caption :=
              '&Enter first characters of the application user name and press "Return":'
          end;
        4:
          begin
            edTarget.Items.Text := sHistory4;
            Caption := 'Select TIU Title of the CP Class Document';
            lblTitle.Caption :=
              '&Enter first characters of the TIU Note Title and press "Return":'
          end;
        5:
          begin
            pnlTarget.Align := alBottom;
            pnlOptions.Visible := True;
            pnlTarget.Align := alTop;
            edTarget.Items.Text := sHistory0;
            Caption := 'Select Provider';
            lblTitle.Caption :=
              '&Enter first characters of the name and press "Return":';
          end;
      end;

      CleanUp;
      if fRequestType = 5 then
        ckbVistAClick(nil);

      if edTarget.Enabled then
        ActiveControl := edTarget;
      edTarget.Text := aTarget;
      DBC := aController;
      if aTarget <> '' then
        DoSearch;
      if ShowModal = mrOK then
        Result := ProviderName + '^' + ProviderID
      else
        Result := '';

      case fRequestType of
        0, 5:
          begin
            sHistory0 := edTarget.Items.Text;

          end;
        1: sHistory1 := edTarget.Items.Text;
        2: sHistory2 := edTarget.Items.Text;
        3: sHistory3 := edTarget.Items.Text;
        4: sHistory4 := edTarget.Items.Text;
      end;

    end;
end;

procedure TdlgSelectProvider.edTargetKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_Return) and (edTarget.Text <> '') then
    DoSearch;
end;

procedure TdlgSelectProvider.DoSearch;
var
  i: Integer;
  SL: TStringList;
  s: string;
begin
  SL := TStringList.Create;
  case fRequestType of
    0, 5: fDBC.LookupProvider(edTarget.Text, s);
    1: fDBC.LookupFacility(edTarget.Text, s);
    2, 3: fDBC.LookupAdministrator(edTarget.Text, s);
    4: s := fDBC.getCPTIUTitles(edTarget.Text);
  end;
  SL.Text := s;
  if SL.Count > 1 then
    begin
      SL.Delete(0);
      fID.Clear;
      for i := 0 to SL.Count - 1 do
        begin
          fID.Add(Piece(SL[i], '^', 1));
          SL[i] := Piece(SL[i], '^', 2);
        end;
      if edTarget.Items.IndexOf(edTarget.Text) < 0 then
        edTarget.Items.Add(edTarget.Text);
    end
  else
    SL.Text := Piece(s, '^', 2);

  lbProviders.Items.Text := SL.Text;
  if pos('No mat', SL.Text) <> 1 then
    ACtiveControl := lbProviders
  else
    begin
      edTarget.SelStart := length(edTarget.Text) - 1;
      edTarget.SelLength := 1;
    end;
  SL.Free;
end;

procedure TdlgSelectProvider.FormCreate(Sender: TObject);
begin
  fID := TStringList.Create;
end;

procedure TdlgSelectProvider.FormDestroy(Sender: TObject);
begin
  fID.Free;
end;

procedure TdlgSelectProvider.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_Escape then
    ModalResult := mrCancel;
end;

procedure TdlgSelectProvider.bbSelectClick(Sender: TObject);
begin
  if setSelection then
    ModalResult := mrOK;
end;

procedure TdlgSelectProvider.lbProvidersKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if Key = VK_Return then
    begin
      if setSelection then
        ModalResult := mrOK;
    end;
end;

function TdlgSelectProvider.setSelection: Boolean;
var
  s: string;
begin
  if lbProviders.ItemIndex < 0 then
    lbProviders.ItemIndex := 0;

  Result := False;
  try
    ProviderName := lbProviders.Items[lbProviders.ItemIndex];
    if ProviderName = '- Other -' then
      begin
        s := InputBox(Caption, 'Name', '');
        if s <> '' then
          begin
            ProviderName := s;
            ProviderID := s;
            Result := true;
          end;
      end
    else
      begin
        ProviderID := fID[lbProviders.ItemIndex];
        Result := true;
      end;
  except
  end;
end;

procedure TdlgSelectProvider.lbProvidersDblClick(Sender: TObject);
begin
  if setSelection then
    ModalResult := mrOK;
end;

procedure TdlgSelectProvider.CleanUp;
begin
  fID.Clear;
  lbProviders.Items.Clear;
  bbSelect.Enabled := False;
  ProviderID := '';
  ProviderName := '';
end;

procedure TdlgSelectProvider.edTargetEnter(Sender: TObject);
begin
  bbSelect.Enabled := False;
end;

procedure TdlgSelectProvider.edTargetExit(Sender: TObject);
begin
  bbSelect.Enabled := lbProviders.Items.Text <> '';
end;

procedure TdlgSelectProvider.edTargetKeyPress(Sender: TObject;
  var Key: Char);
begin
  Key := Upcase(Key);
end;

procedure TdlgSelectProvider.ckbVistAClick(Sender: TObject);
var
  sl: TStringList;
  i: integer;
  s: string;
begin
  edTarget.Enabled := ckbVista.Checked;
  lbProviders.Items.Clear;
  fID.Clear;
  if not ckbVistA.Checked then
    begin
      fDBC.getSystemOption(onNephrologiests, s);
      sl := TStringList.Create;
      sl.Text := s;

      lbProviders.Items.Add('- Other -');
      for i := 0 to sl.Count - 1 do
        begin
          lbProviders.Items.Add(sl.Values[sl.Names[i]]);
          fID.Add(sl.Names[i]);
        end;
      sl.Free;
    end;
end;

initialization

  sHistory0 := '';
  sHistory1 := '';
  sHistory2 := '';
  sHistory3 := '';
  sHistory4 := '';

end.
