unit fMDK_SorAndFilter;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:37a $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  Contains the Application Sort and Filter form
*       Notes:
*
================================================================================
*       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms/fMDK_SorAndFilter.pas $
*
* $History: fMDK_SorAndFilter.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/13/09    Time: 1:15p
 * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Forms
 * Patch 19 source code
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/24/08    Time: 4:23p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/02/08    Time: 9:24a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Forms
 * 
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 6/20/07    Time: 3:23p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 6/04/07    Time: 9:08a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/22/07    Time: 9:16a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 3/27/07    Time: 1:31p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:38p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:28p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/25/07    Time: 9:39a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Forms
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:36p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Forms
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:28p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Forms
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/28/06    Time: 5:15p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Forms
}
interface

uses Windows, SysUtils, Classes, Graphics, Forms, Controls, StdCtrls,
  Buttons, ExtCtrls, ActnList, ComCtrls;

type
  TdlgSort = class(TForm)
    ActionList1: TActionList;
    acBack: TAction;
    acForth: TAction;
    acFilter: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    sbForth: TSpeedButton;
    sbback: TSpeedButton;
    rbNo: TRadioButton;
    rbYes: TRadioButton;
    edSort: TEdit;
    lbFrom: TListBox;
    lbTo: TListBox;
    TabSheet2: TTabSheet;
    Panel3: TPanel;
    Panel2: TPanel;
    OKBtn: TButton;
    CancelBtn: TButton;
    tsHelp: TTabSheet;
    Memo1: TMemo;
    Panel5: TPanel;
    Panel6: TPanel;
    cmbField: TComboBox;
    cmbAction: TComboBox;
    edValue: TEdit;
    SpeedButton1: TSpeedButton;
    ComboBox19: TComboBox;
    Panel4: TPanel;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    Edit1: TEdit;
    ComboBox3: TComboBox;
    Panel7: TPanel;
    ComboBox4: TComboBox;
    ComboBox5: TComboBox;
    Edit2: TEdit;
    ComboBox6: TComboBox;
    Panel8: TPanel;
    ComboBox7: TComboBox;
    ComboBox8: TComboBox;
    Edit3: TEdit;
    ComboBox9: TComboBox;
    Panel9: TPanel;
    Panel10: TPanel;
    mmFilter: TMemo;
    Panel11: TPanel;
    Label1: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    procedure lbFromClick(Sender: TObject);
    procedure acBackExecute(Sender: TObject);
    procedure acForthExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure acFilterExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure setButtonStatus;
  end;

var
  dlgSort: TdlgSort;

implementation

{$R *.dfm}

procedure TdlgSort.lbFromClick(Sender: TObject);
begin
  rbYes.Checked := True;
end;

procedure TdlgSort.setButtonStatus;
begin
  sbForth.Enabled := lbFrom.Items.Count > 0;
  sbBack.Enabled := lbTo.Items.Count > 0;
  edSort.Text := lbTo.Items.DelimitedText;
end;

procedure TdlgSort.acBackExecute(Sender: TObject);
begin
  if lbTo.ItemIndex < 0 then
    lbTo.ItemIndex := 0;
  lbFrom.Items.Add(lbTo.Items[lbTo.ItemIndex]);
  lbTo.Items.Delete(lbTo.ItemIndex);
  SetButtonStatus;
end;

procedure TdlgSort.acForthExecute(Sender: TObject);
begin
  if lbFrom.ItemIndex < 0 then
    lbFrom.ItemIndex := 0;
  lbTo.Items.Add(lbFrom.Items[lbFrom.ItemIndex]);
  lbFrom.Items.Delete(lbFrom.ItemIndex);
  SetButtonStatus;
end;

procedure TdlgSort.FormCreate(Sender: TObject);
begin
  lbTo.Items.Delimiter := ';';
  lbTo.Items.QuoteChar := '''';
end;

procedure TdlgSort.acFilterExecute(Sender: TObject);
begin
  mmFilter.Text := cmbField.Text + ' ' +
    cmbAction.Text + ' ''' + edValue.Text + '''';
end;

end.
