unit fMDK_Studies;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Grids, DBGrids, ExtCtrls, ComCtrls, Buttons
  , uMDK_Patients, ActnList, ImgList, Menus, DB, DBClient, DBCtrls
  , uMDK_Options
  , uMDK_Common
  ;

type
  TfrmStudies = class(TForm)
    pnlMain: TPanel;
    ActionList1: TActionList;
    acGetActiveStudies: TAction;
    ilStatus: TImageList;
    acUpdateTableByActiveStudyList: TAction;
    acDisable: TAction;
    acEnable: TAction;
    acReview: TAction;
    acRefresh: TAction;
    acSelect: TAction;
    tmrRefresh: TTimer;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Refresh2: TMenuItem;
    Select2: TMenuItem;
    Review1: TMenuItem;
    Enable2: TMenuItem;
    Disable2: TMenuItem;
    Options1: TMenuItem;
    ShowDetails1: TMenuItem;
    N2: TMenuItem;
    acAutorefresh: TAction;
    acShowLegend: TAction;
    ShowLegend1: TMenuItem;
    acShowDetails: TAction;
    N1: TMenuItem;
    ShowHideDetails1: TMenuItem;
    Cancel1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Refresh1: TMenuItem;
    Select1: TMenuItem;
    Review2: TMenuItem;
    Enable1: TMenuItem;
    Disable1: TMenuItem;
    N4: TMenuItem;
    Autorefresh2: TMenuItem;
    ShowLegend3: TMenuItem;
    ShowHideDetails3: TMenuItem;
    Cancel2: TMenuItem;
    acShowDisabledStudies: TAction;
    N3: TMenuItem;
    ShowDisabledStudies1: TMenuItem;
    cdsStudyList: TClientDataSet;
    dsStudyList: TDataSource;
    acGetTableXML: TAction;
    acSaveTableXML: TAction;
    N6: TMenuItem;
    ShowDisabledStudies2: TMenuItem;
    acClearAccessHistory: TAction;
    acLinkTables: TAction;
    acLockHistoryTable: TAction;
    acUnLockHistoryTable: TAction;
    acShowLog: TAction;
    pnlCancel: TPanel;
    pnlActiveStudyList: TPanel;
    grbActiveStudyList: TGroupBox;
    pnlStudyList: TPanel;
    pnlLegendz: TPanel;
    Image2: TImage;
    Image4: TImage;
    Label3: TLabel;
    Label6: TLabel;
    Image1: TImage;
    Label4: TLabel;
    lblReviewed: TLabel;
    imReviewed: TImage;
    pnlStatusTable: TPanel;
    dbgStatus: TDBGrid;
    pnlDetails: TPanel;
    re: TRichEdit;
    Panel14: TPanel;
    Panel15: TPanel;
    Panel16: TPanel;
    Panel17: TPanel;
    Panel19: TPanel;
    Panel20: TPanel;
    Panel21: TPanel;
    Panel18: TPanel;
    acOpenStudyList: TAction;
    lblAutorefresh: TLabel;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton17: TSpeedButton;
    acClose: TAction;
    pnlLegend: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure dbgStatusDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure acRefreshExecute(Sender: TObject);
    procedure acReviewExecute(Sender: TObject);
    procedure dbgStatusTitleClick(Column: TColumn);
    procedure tmrRefreshTimer(Sender: TObject);
    procedure acAutorefreshExecute(Sender: TObject);
    procedure acShowLegendExecute(Sender: TObject);
    procedure acShowDetailsExecute(Sender: TObject);
    procedure dbgStatusDblClick(Sender: TObject);
    procedure dbgStatusKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure acShowDisabledStudiesExecute(Sender: TObject);
    procedure dsStudyListDataChange(Sender: TObject; Field: TField);
    procedure acDisableExecute(Sender: TObject);
    procedure acEnableExecute(Sender: TObject);
    procedure acSelectExecute(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure pnlActiveStudyListResize(Sender: TObject);
    procedure acCloseExecute(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    fAutorefresh: Boolean;
    fIgnore: Boolean;
    fRefreshRate: Integer;
    fCount: Integer;
    fIgnoreTimer: Boolean;
    fIgnoreCDSChange: Boolean;
    fSelectedFieldName: string;
    fHistorySelectedFieldName: string;
    fActiveStudyList: TStringList;
    fSelectedPatient: TMDKRegisteredPatient;
    procedure FreeActiveStudyList;
    procedure AddActiveStudy(aRP: TMDKRegisteredPatient);
    function LocateStudyByID(anID: string): boolean;
    function setStudyStatus(aStatus: string; out ErrorMsg: string): Integer;
    procedure SelectPatient(aReadOnly: Boolean);
    procedure resetRefreshRate;
    procedure setDisabledFilter;
    procedure CreateStudyListCDS;
    function AccessRegistered(aPatientID: string): Boolean;
    procedure SaveBooleanOption(aName: string; aValue: Boolean; aType: string =
      otUser);
    procedure setActionsActiveStatus(aValue:Boolean);
    function getSelectedPatient:TMDKRegisteredPatient;
    function setUseStatus(newStatus:String;
      requiredStatuses: Array of String;
      const stOK: Integer;
      var ErrorMsg: String;
      accessRegistrationNeeded: Boolean = False;
      keepLock:Boolean=False): Integer;
    procedure updateActionStatuses;
    procedure updateStudyDetails;
  public
    { Public declarations }
    property SelectedStudy: TMDKRegisteredPatient read getSelectedPatient;
    function getStudyStatus(anID: String): String;
    function ReleaseStudy(anID: String;var msgError:String): Integer;
  end;


var
  frmStudies: TfrmStudies;

const
  rcStudyList = 1000;
  rcStudyNotFound = rcStudyList + 1;
  rcStudyStatusOK = rcStudyList + 10;
  rcStudyStatusLockFailed = rcStudyList + 12;
  rcStudyStatusChanged = rcStudyList + 13;
  rcStudyStatusWrong = rcStudyList + 14;
  rcStudyStatusUnLockFailed = rcStudyList + 15;
  rcStudyStatusAccessRegistrationFailed = rcStudyList + 16;
  rcStudyStatusChangeFailed = rcStudyList + 17;
  rcTableUpdateFailed = rcStudyList + 18;

function SelectStudy(aLeft, aTop, aHeight, aWidth: Integer;
  Refresh: Boolean=True):
  TMDKRegisteredPatient;

procedure InitStudyList;

implementation

uses dMDK_Data, uMDK_Engine, uMDK_Utils, uMDK_CDSCommon,
  oDBController_Renal, uROR_CommonUtils, fMDK_Wait, fMDK_Info;

const
  snInUse = 'IN USE';
  snEnable = 'ENABLED';
  snDisable = 'DISABLED';

  isEnabled = 0;
  isDisabled = 1;
  isInUse = 2;
  isUnknown = 3;
  isSensitive = 5;
  isSortGray = 8;

  clInUse = $00FFFDE6;
  clEnabled = clWindow;
  clDisabled = $00E8E8E8;
  clUnknown = clLime;

{$R *.dfm}
procedure InitStudyList;
begin
  if not Assigned(frmStudies) then
    begin
      Application.CreateForm(TfrmStudies, frmStudies);
      frmStudies.tmrRefresh.Enabled := False;
      frmStudies.fSelectedFieldName := fnSL_StudyID;
      frmStudies.fHistorySelectedFieldName := fnSL_StudyID;
    end;
end;

function SelectStudy(aLeft, aTop, aHeight, aWidth: Integer;
  Refresh: Boolean=True):
  TMDKRegisteredPatient;
begin
  Screen.Cursor := crHourGlass;

  InitStudyList;

  frmStudies.Left := aLeft;
  frmStudies.Top := aTop;
  frmStudies.Height := aHeight;
  frmStudies.Width := aWidth;

  frmWait.WakeUp(nil,'Refreshing Study List');

  if Refresh then
    frmStudies.acRefresh.Execute;
  Screen.Cursor := crDefault;

  frmWait.LayDown;

  if frmStudies.ShowModal = mrOK then
    Result := frmStudies.SelectedStudy
  else
    Result := nil;
end;

////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////
////////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.FormCreate(Sender: TObject);
begin
  inherited;
  fIgnoreCDSChange := True;
  CreateStudyListCDS;
  fActiveStudyList := TStringList.Create;
  fSelectedPatient := TMDKRegisteredPatient.Create('', '', '', Now, '', '', '',
    '', '', '');
  fIgnoreCDSChange := False;
end;

procedure TfrmStudies.FormDestroy(Sender: TObject);
begin
  FreeActiveStudyList;
  if Assigned(fSelectedPatient) then
    FreeAndNil(fSelectedPatient);
  inherited;
end;

procedure TfrmStudies.FormCloseQuery(Sender: TObject;var CanClose: Boolean);
begin
  tmrRefresh.Enabled := False;
end;

procedure TfrmStudies.CreateStudyListCDS;

  procedure CreateSL(aDS: TClientDataSet);
  begin
    if not FileExists(aDS.FileName) then
      begin
        NewStringField(aDS, fnSL_StudyID, 'Study #', 10, 40);
        NewStringField(aDS, fnSL_PatientID, 'Patient ID', 8, 22);
{$IFNDEF AANTEST}aDS.FieldList.Fields[aDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
        NewBooleanField(aDS, fnSL_Sensitive, fnSL_Sensitive, 8);
{$IFNDEF AANTEST}aDS.FieldList.Fields[aDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
        NewStringField(aDS, fnSL_Name, 'Patient Name', 30, 40);
        NewStringField(aDS, fnSL_Sex, 'Sex', 4, 4);
        NewDateTimeField(aDS, fnSL_DOB, 'DOB', 11);
        NewStringField(aDS, fnSL_SSN, 'SSN', 12, 20);
        NewDateTimeField(aDS, fnSL_CheckedIn, 'Checked In Time', 20,
          gMDK_DateTimeFMT);
        NewStringField(aDS, fnSL_Status, 'Status', 10, 20);
        NewStringField(aDS, fnSL_StatusOld, 'Old Status', 10, 20);
{$IFNDEF AANTEST}aDS.FieldList.Fields[aDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
        NewStringField(aDS, fnSL_StatusBy, 'Status By', 20, 20);
        NewDateTimeField(aDS, fnSL_StatusTime, 'Since', 20, gMDK_DateTimeFMT);
        NewStringField(aDS, fnSL_Comments, 'Workstation', 20, 200);
        NewStringField(aDS, fnSL_LockStatus, 'VistA Lock', 5, 20);
{$IFNDEF AANTEST}aDS.FieldList.Fields[aDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
        NewStringField(aDS, fnSL_LockedBy, 'VistA Locked By', 20, 20);
{$IFNDEF AANTEST}aDS.FieldList.Fields[aDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
        NewDateTimeField(aDS, fnSL_LastModified, 'Last Modified', 12);
{$IFNDEF AANTEST}aDS.FieldList.Fields[aDS.FieldList.Count - 1].Visible := False;
{$ENDIF}
        aDS.IndexFieldNames := 'StudyID';
        aDS.CreateDataSet;
      end;
    aDS.Open;
  end;

begin
  CreateSL(cdsStudyList);
end;

////////////////////////////////////////////////////////////////////////////////
procedure TfrmStudies.resetRefreshRate;
begin
  fRefreshRate := Preferences.iValue(onStudyListRefreshRate);
  if fRefreshRate < 7 then
    fRefreshRate := 7;
  fCount := fRefreshRate;

  fAutorefresh := Preferences.bValue(onStudyListAutorefresh);
  acAutorefresh.Checked := fAutorefresh;
  tmrRefresh.Enabled := fAutorefresh;
  if not acAutorefresh.Checked then
    lblAutorefresh.Caption := 'Autorefresh: Off';

  pnlDetails.Visible := userSettings.bValue(onShowStudyDetails);
  pnlLegend.Visible := userSettings.bValue(onShowStudyDetailsLegend);

  acShowLegend.Checked := pnlLegend.Visible;
  acShowDetails.Checked := pnlDetails.Visible;
  acShowDisabledStudies.Checked := Preferences.bValue(onShowDisabledStudies);
//  acShowDisabledStudies.Enabled := Preferences.bValue(onAllowUserControlStudyStatus);

  cdsStudyList.DisableControls;
  setDisabledFilter;
  cdsStudyList.EnableControls;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.updateStudyDetails;

  function CurrText: TTextAttributes;
  begin
    if re.SelLength > 0 then
      Result := re.SelAttributes
    else
      Result := re.DefAttributes;
  end;

begin
  if not pnlDetails.Visible then
    Exit;
  if fIgnore then
    Exit;

  with re do
    begin
      Lines.Clear;
      Refresh;
      if (cdsStudyList.Active) and
        (cdsStudyList.RecordCount > 0) then
        begin
          Lines.Add(cdsStudyList.FieldByName(fnSL_Name).AsString);
          SelStart := 0;
          SelLength := Length(cdsStudyList.FieldByName(fnSL_Name).AsString);
          CurrText.Style := [fsBold];
          CurrText.Size := Font.Size + 2;
          if cdsStudyList.FieldByName(fnSL_Sensitive).AsBoolean then
            begin
              Lines.Add('   SSN: * SENSITIVE *');
              Lines.Add('   DOB: * SENSITIVE *');
            end
          else
            begin
              Lines.Add('   SSN: ' +
                cdsStudyList.FieldByName(fnSL_SSN).AsString);
              Lines.Add('   DOB: ' + FormatDateTime('MM/DD/YYYY',
                cdsStudyList.FieldByName(fnSL_DOB).AsDateTime));
            end;
          Lines.Add('   Sex: ' + cdsStudyList.FieldByName(fnSL_SEX).AsString);
          Lines.Add('');
          Lines.Add('');
          Lines.Add('Checked Into CP User: ');
          Lines.Add('   Checked in: ' +
            cdsStudyList.FieldByName(fnSL_CheckedIn).AsString);
          Lines.Add('   Study #: ' +
            cdsStudyList.FieldByName(fnSL_StudyID).AsString);
          Lines.Add('   Study Status: ' +
            cdsStudyList.FieldByName(fnSL_Status).AsString);
        end;
      SelStart := 0;
    end;
end;

procedure TfrmStudies.setActionsActiveStatus(aValue:Boolean);
begin
  acClose.Enabled := aValue;
  acRefresh.Enabled := aValue;
  acSelect.Enabled := aValue;
  acReview.Enabled := aValue;
  acEnable.Enabled := aValue;
  acDisable.Enabled := aValue;
end;

procedure TfrmStudies.UpdateActionStatuses;
var
  dataset: TDataset;
  Status: string;

begin
  dataset := dbgStatus.DataSource.DataSet;
  if not Assigned(dataset) then Exit;
  if not dataset.Active then Exit;
  if dataset.RecordCount < 1 then
    begin
      setActionsActiveStatus(False);
      re.Text := '';
    end
  else
    begin
      Status := dataset.FieldByName(fnSL_Status).AsString;

      acEnable.Enabled := (Status = snDisabled) and
        (Preferences.bValue(onAllowUserControlStudyStatus) = True);
      acDisable.Enabled := (Status = snEnabled) and
        (Preferences.bValue(onAllowUserControlStudyStatus) = True);
      acSelect.Enabled := (Status = snEnabled);
      acReview.Enabled := True;
    end;

  acRefresh.Enabled := True; //not Preferences.bValue(onStudyListAutorefresh);
  acClose.Enabled := True;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.dbgStatusDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  dg: TDBGrid;
  field: TField;
  dataset: TDataSet;
  bSensitive: Boolean;
  pattern,
    risk: string;
  RR: TRect;
begin
  dg := TDBGrid(Sender);
  dataset := dg.DataSource.DataSet;
  field := dataset.FieldByName(fnSL_Status);
  risk := field.asString;

  try
    bSensitive := dataset.FieldByName(fnSL_Sensitive).AsBoolean;
  except
    bSensitive := False;
  end;

  if Sender = dbgStatus then
    pattern := fSelectedFieldName
  else
    pattern := fHistorySelectedFieldName;

  if (gdSelected in State) then
    begin
      dg.canvas.font.color := clWhite;
      dg.canvas.brush.color := clNavy;

      if pattern = Column.FieldName then
        dg.canvas.font.Style := [fsBold]
      else
        dg.canvas.font.Style := [];
    end
  else
    begin
      dg.canvas.font.color := clPurple;
      dg.canvas.brush.color := clUnknown;

      if risk = snEnabled then
        dg.canvas.font.color := clBlack;
      if risk = snEnabled then
        dg.canvas.brush.color := clEnabled;

      if risk = snInUse then
        dg.canvas.font.color := clBlue;
      if risk = snInUse then
        dg.canvas.brush.color := clInUse;

      if risk = snDisabled then
        dg.canvas.font.color := clRed;
      if risk = snDisabled then
        dg.canvas.brush.color := clDisabled;

      if pattern = Column.FieldName then
        begin
          dg.canvas.font.Style := [fsBold];
          dg.canvas.font.Color := clPurple;

          if Rect.Right - Rect.Left > dg.Canvas.TextWidth(Column.DisplayName) + 8 then
            ilStatus.Draw(dg.Canvas, Rect.Right - 20, 1, isSortGray, True);
        end
      else
        dg.canvas.font.Style := [];
    end;

  with dg do
    begin
      if Columns[DataCol].FieldName = fnSL_StudyID then
        begin
          Canvas.FillRect(Rect);
          if risk = snInUse then
            ilStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, isInUse, True)
          else if risk = snDisabled then
            ilStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, isDisabled, True)
          else if risk = snEnabled then
            ilStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, isEnabled, True)
          else
            ilStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, isUnknown, True);
          RR := Rect;
          RR.Left := Rect.Left + 20;
          DefaultDrawColumnCell(RR, DataCol, Column, State);
        end
      else if (Columns[DataCol].FieldName = fnSL_SSN) or
        (Columns[DataCol].FieldName = fnSL_DOB) then
        begin
          if bSensitive then
            begin
              Canvas.FillRect(Rect);
              ilStatus.Draw(Canvas, Rect.Left + 4, Rect.Top, isSensitive, True);
              ilStatus.Draw(Canvas, Rect.Left + 14, Rect.Top, isSensitive,
                True);
              ilStatus.Draw(Canvas, Rect.Left + 24, Rect.Top, isSensitive,
                True);
            end
          else
            DefaultDrawColumnCell(Rect, DataCol, Column, State);
        end
      else if (Columns[DataCol].FieldName = fnSL_StatusTime) and
        (Pos('12/30/1899',dataset.FieldByName(fnSL_StatusTime).AsString) = 1) then
        begin
          dg.canvas.font.color := dg.canvas.brush.color;
          DefaultDrawColumnCell(Rect, DataCol, Column, State);
        end
      else
        DefaultDrawColumnCell(Rect, DataCol, Column, State);
    end;
end;

//..............................................................................

procedure TfrmStudies.pnlActiveStudyListResize(Sender: TObject);
begin
  lblAutorefresh.Left := grbActiveStudyList.Width - lblAutorefresh.Width - 8;
end;

procedure TfrmStudies.acCloseExecute(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TfrmStudies.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    ModalResult := mrCancel;
end;

////////////////////////////////////////////////////////////////////////////////

function TfrmStudies.LocateStudyByID(anID: string): boolean;
begin
  try
    result := cdsStudyList.Locate(fnSL_StudyID, VarArrayOf([anID]), []);
  except
    Result := False;
  end
end;

procedure TfrmStudies.SelectPatient(aReadOnly: Boolean);
begin
  fSelectedPatient.ID := cdsStudyList.FieldByName(fnSL_PatientID).AsString;
  fSelectedPatient.SSN := cdsStudyList.FieldByName(fnSL_SSN).AsString;
  fSelectedPatient.Name := cdsStudyList.FieldByName(fnSL_Name).AsString;
  fSelectedPatient.DOB := cdsStudyList.FieldByName(fnSL_DOB).AsDateTime;
  fSelectedPatient.SessionID := cdsStudyList.FieldByName(fnSL_StudyID).AsString;
  fSelectedPatient.Sex := cdsStudyList.FieldByName(fnSL_Sex).AsString;
  fSelectedPatient.ReadOnly := aReadOnly;
end;

procedure TfrmStudies.AddActiveStudy(aRP: TMDKRegisteredPatient);
begin
  if not LocateStudyByID(aRP.SessionID) then
    begin
      cdsStudyList.Insert;
      cdsStudyList.FieldByName(fnSL_StudyID).AsString := aRP.SessionID;
      cdsStudyList.FieldByName(fnSL_PatientID).AsString := aRP.ID;
      cdsStudyList.FieldByName(fnSL_Name).AsString := aRP.Name;
      cdsStudyList.FieldByName(fnSL_DOB).AsString := FormatDateTime('mm/dd/yyyy', aRP.DOB);
      cdsStudyList.FieldByName(fnSL_Sex).AsString := aRP.Sex;
      cdsStudyList.FieldByName(fnSL_SSN).AsString := aRP.SSN;
      cdsStudyList.FieldByName(fnSL_CheckedIn).AsString := aRP.StudyCheckin;
      cdsStudyList.FieldByName(fnSL_Sensitive).AsBoolean :=
        Engine.IsDataSensitive(aRP.ID);
    end
  else
    cdsStudyList.Edit;

  try
//    if (cdsStudyList.FieldByName(fnSL_StatusTime).AsDateTime <> aRP.StatusDate) or
//      (cdsStudyList.FieldByName(fnSL_StatusTime).AsString = '') then
      begin
        cdsStudyList.FieldByName(fnSL_LockStatus).AsString := aRP.LockStatus;
        cdsStudyList.FieldByName(fnSL_LockedBy).AsString := aRP.LockedBy;
        cdsStudyList.FieldByName(fnSL_LastModified).AsDateTime := aRP.LastModified;
        cdsStudyList.FieldByName(fnSL_Status).AsString := aRP.StudyStatus;
        cdsStudyList.FieldByName(fnSL_StatusBy).AsString :=
          Engine.getUserNameByID(aRP.StatusBy);
        cdsStudyList.FieldByName(fnSL_StatusTime).AsDateTime := aRP.StatusDate;
        cdsStudyList.FieldByName(fnSL_Comments).AsString := aRP.Workstation;
        cdsStudyList.Post;
      end;
  except
  end;
end;

procedure TfrmStudies.setDisabledFilter;
begin
  if acShowDisabledStudies.Checked then
    cdsStudyList.Filtered := False
  else
    begin
      cdsStudyList.Filter := fnSL_Status + '<>''' + snDisabled + '''';
      cdsStudyList.Filtered := True;
    end
end;

function TfrmStudies.AccessRegistered(aPatientID: string): Boolean;
var
  SL: TStringList;
  sAccessInfo,
    sInfo: string;
  sWarning: String;
begin
  if cdsStudyList.FieldByName(fnSL_Sensitive).AsBoolean then
    begin
      SL := TStringList.Create;
      sAccessInfo := Engine.getPatientAccessInfo(aPatientID);
      SL.Text := sAccessInfo;
      sInfo := SL[0];
      SL.Delete(0);
      sSecurityWarning := SL.Text;
      sWarning := SL.Text + #13#10+ '          Do you want to continue?';
      SL.Free;

      if sInfo = '0' then
        Result := True
      else if sInfo = '1' then
        Result := MessageDlg(sWarning, mtWarning, [mbYes, mbNo], 0) = mrYes
      else if sInfo = '2' then
        begin
          if MessageDlg(sWarning, mtWarning, [mbYes, mbNo], 0) <> mrYes then
            Result := False
          else
            begin
              Engine.getPatientBulletinInfo(aPatientID);
              Result := True;
            end;
        end
      else if sInfo = '-1' then
        begin
          Result := False;
          MessageDLG('Access registration is not completed'#13#10 +
            'RPC/API failed' + #13#10 + 'Required field is not defined',
            mtWarning, [mbOK], 0);
        end
      else
        begin
          MessageDlg(sSecurityWarning, mtWarning, [mbYes], 0);
          Result := False;
        end;
    end
  else
    Result := True;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.dsStudyListDataChange(Sender: TObject;
  Field: TField);
begin
  if fIgnoreCDSChange then
    Exit;
  UpdateActionStatuses;
  UpdateStudyDetails;
end;

procedure TfrmStudies.tmrRefreshTimer(Sender: TObject);
begin
  if fIgnoreTimer then
    Exit;
  dec(fCount);
  if fCount < 1 then
    begin
      tmrRefresh.Enabled := False;
      acRefreshExecute(nil);
    end
  else
    lblAutorefresh.Caption := Format('Autorefresh in %d sec', [fCount]);
end;

type
   TMyDBGrid = class(TDBGrid)
end;

procedure TfrmStudies.dbgStatusTitleClick(Column: TColumn);
var
  i: Longint;
begin
  i := TMyDBGrid(dbgStatus).LeftCol;

  cdsStudyList.DisableControls;

  if fSelectedFieldName = Column.FieldName then
    begin
    end
  else
    begin
      fSelectedFieldName := Column.FieldName;
      cdsStudyList.IndexFieldNames := fSelectedFieldName;
    end;

  cdsStudyList.EnableControls;
  TMyDBGrid(dbgStatus).LeftCol := i;
end;

procedure TfrmStudies.dbgStatusDblClick(Sender: TObject);
begin
  if acSelect.Enabled then
    acSelect.Execute
  else
    acReview.Execute;
end;

procedure TfrmStudies.dbgStatusKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if key = VK_Return then
    dbgStatusDblClick(nil)
  else if (key = VK_Delete) and (ssCtrl in Shift) and (ssShift in Shift)
    and (Engine.CurrentOperatorMode = rnADMIN) then
    begin
      if MessageDlg('Delete Study <' +
        cdsStudyList.FieldByName(fnSL_StudyID).AsString + '> information?',
        mtConfirmation, [mbOK, mbCancel], 0) = mrOk then
        begin
          Key := 0;
          cdsStudyList.Delete;
          acSaveTableXML.Execute;
        end;
    end;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmStudies.SaveBooleanOption(aName: string; aValue: Boolean;
  aType: string = otUser);
var
  sValue: string;
  Options: TUserOptions;
begin
  if aType = otUser then
    Options := UserOptions
  else if aType = otSystem then
    Options := SysOptions
  else if aType = otDeveloper then
    Options := devOptions
  else if aType = otUserSettings then
    Options := UserSettings
  else
    Exit;
  if aValue then
    sValue := 'TRUE'
  else
    sValue := 'FALSE';

  Options.setValue(aName, sValue);

  if aType = otSystem then
    begin
      Engine.SaveSystemOptions;
      Preferences.Overwrite(sysOptions.ValueList.Text);
      Preferences.Overwrite(userOptions.ValueList.Text);
      Preferences.Overwrite(userSettings.ValueList.Text);
    end
  else if aType = otUser then
    begin
      Engine.SaveUserOptions;
      Preferences.Overwrite(userOptions.ValueList.Text);
      Preferences.Overwrite(userSettings.ValueList.Text);
    end
  else if aType = otUserSettings then
    begin
      Engine.SaveUserOptions;
      Preferences.Overwrite(userSettings.ValueList.Text);
    end
end;

procedure TfrmStudies.acShowLegendExecute(Sender: TObject);
begin
  pnlLegend.Visible := not pnlLegend.Visible;
  acShowLegend.Checked := pnlLegend.Visible;
  SaveBooleanOption(onShowStudyDetailsLegend, acShowLegend.Checked, otUserSettings);
end;

procedure TfrmStudies.acShowDetailsExecute(Sender: TObject);
begin
  fIgnoreCDSChange := True;
  pnlDetails.Visible := not pnlDetails.Visible;
  acShowDetails.Checked := pnlDetails.Visible;
  SaveBooleanOption(onShowStudyDetails, acShowDetails.Checked, otUserSettings);

  fIgnoreCDSChange := False;
  updateStudyDetails;
end;

procedure TfrmStudies.acShowDisabledStudiesExecute(
  Sender: TObject);
begin
  acShowDisabledStudies.Checked := not acShowDisabledStudies.Checked;
  SaveBooleanOption(onShowDisabledStudies, acShowDisabledStudies.Checked, otUser{Settings});
  SetDisabledFilter;
end;

//..............................................................................

procedure TfrmStudies.FreeActiveStudyList;
var
  ap: TMDKRegisteredPatient;
begin
  if Assigned(fActiveStudyList) then
    begin
      while fActiveStudyList.Count > 0 do
        try
          aP := TMDKRegisteredPatient(fActiveStudyList.Objects[0]);
          if aP <> nil then
            ap.Free;
          fActiveStudyList.Delete(0);
        except
        end;
      FreeAndNil(fActiveStudyList);
  end;
end;

procedure TfrmStudies.acAutorefreshExecute(Sender: TObject);
begin
  acAutorefresh.Checked := not acAutorefresh.Checked;
  tmrRefresh.Enabled := acAutorefresh.Checked;
  SaveBooleanOption(onStudyListAutorefresh, acAutorefresh.Checked, otUserSettings);
  if not acAutorefresh.Checked then
    lblAutorefresh.Caption := 'Autorefresh: Off'
  else
    begin
      lblAutorefresh.Caption := 'Autorefresh: On';
      ResetRefreshRate;
    end;
end;

procedure TfrmStudies.acRefreshExecute(Sender: TObject);
var
  sID: string;
  fNow : TDateTime;

  procedure fixStatuses;
  var
    sXML: String;
    aCDS: TClientDataSet;
    BM: TBookmark;
    DT: TDateTime;
    sStudyID,
    sStatus,
    sStatusAt,
    sWS :String;

    procedure ProcessDisabledRecord;
    begin
      sStatusAt := aCDS.FieldByName(fnSL_StatusTime).AsString;
      DT := StrToDateTime(sStatusAt);
      sStatusAt := FloatToStr(WindowsDateTimeToFMDateTime(DT));
      sWS := aCDS.FieldByName(fnSL_Comments).AsString;
      if Engine.fRenalController.LockStudy(StrToInt(sStudyID)) then
        begin
          sStatus := Engine.fRenalController.setStudyUseStatus(
            sStudyID,'2',Engine.UserDUZ,sStatusAt,sWS);
          if pos('-',sStatus) <> 1 then
            begin
              cdsStudyList.Edit;
              cdsStudyList.FieldByName(fnSL_Status).AsString := 'DISABLED';
              cdsStudyList.FieldByName(fnSL_Comments).AsString := sWS;
              cdsStudyList.Post;
              aCDS.Delete;
             end
          else
            aCDS.Next;
          Engine.fRenalController.UnLockStudy(StrToInt(sStudyID));
        end
      else
        aCDS.Next;
    end;

  begin
    sXML := Engine.getSystemOptionByName(onStudyListTable);
    if (sXML <> '') and (sXML <>#13#10) then
      begin
        BM := cdsStudyList.GetBookmark;
        aCDS := TClientDataSet.Create(self);
        aCDS.XMLData := sXML;
        aCDS.Open;
        if aCDS.Active then
          begin
          while not aCDS.Eof do
            begin
              sStudyID := aCDS.FieldByName(fnSL_StudyID).AsString;
              if LocateStudyByID(sStudyID) then
                begin
                  sStatus := aCDS.FieldByName(fnSL_Status).AsString;
                  if sStatus = 'DISABLED' then
                    ProcessDisabledRecord
                  else
                    aCDS.Delete;
                end
              else
                aCDS.Delete;
            end;
            aCDS.MergeChangeLog;
            if aCDS.RecordCount < 1 then
              Engine.setSystemOptionByName(onStudyListTable,'')
            else
              Engine.setSystemOptionByName(onStudyListTable,aCDS.XMLData);
          end;
        FreeAndNil(aCDS);
        cdsStudyList.GotoBookmark(BM);
        cdsStudyList.FreeBookmark(BM);
      end;
  end;

  function getCurrentSTudyID: String;
  begin
    Result := '';
    if (cdsStudyList.RecordCount > 0) and not cdsStudyList.BOF then
      try
        Result := cdsStudyList.FieldByName(fnSL_StudyID).AsString;
      except
      end;
  end;

  procedure setCDSByActiveStudyList;
  var
    i: Integer;
    rp: TMDKRegisteredPatient;

    procedure CleanUpStudyList;
//    var
//      sStudyID: String;
//      iStudy: Integer;
    begin
      cdsStudyList.EmptyDataSet; // vhaishandria 2007-12-05
(*
      ShowInfo(fActiveStudyList.Text);
      cdsStudyList.First;
      while not cdsStudyList.Eof do
        begin
          sStudyID := cdsStudyList.FieldByName(fnSL_StudyID).AsString;
          fActiveStudyList.Find(sStudyID,iStudy);
          if iStudy < 0 then
            begin
              try
                cdsStudyList.Delete;
                cdsStudyList.Post;
              except
                on E: Exception do
                  MessageDLG(E.Message,mtWarning,[mbOK],0);
              end;
            end
          else
            cdsStudyList.Next;
        end;
*)
      cdsStudyList.MergeChangeLog;
    end;

  begin
    CLeanUpStudyList;

    for i := 0 to fActiveStudyList.Count - 1 do
      if Assigned(fActiveStudyList.Objects[i]) then
        begin
          rp := TMDKRegisteredPatient(fActiveStudyList.Objects[i]);
          if rp.StudyStatus = 'IN_USE' then
            rp.StudyStatus := 'IN USE'
          else if rp.StudyStatus = 'ACTIVE' then
            rp.StudyStatus := 'ENABLED';
          AddActiveStudy(rp);
        end;
  end;

begin
  setActionsActiveStatus(False); // vhaishandria 2007-09-19

  tmrRefresh.Enabled := False;
  fIgnoreCDSChange := true;
  cdsStudyList.DisableControls;
  lblAutorefresh.Caption := 'Refreshing...';
  lblAutorefresh.Refresh;
  grbActiveStudyList.Refresh;
  re.Text := '';
  re.Refresh;

  sID := getCurrentStudyID;

  fNow := Now;
  frmWait.AddLogLine(char(VK_TAB) + 'Getting VistA data...');
  FreeActiveStudyList;
  fActiveStudyList := NewRegisteredPatientList(Engine.GetPatientList);
  frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now - fNow));
  fNow := Now;
  frmWait.addLogLine(char(VK_TAB) + 'Updating Study List...');
  setCDSByActiveStudyList;
  frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now - fNow));

  fixStatuses;
  ResetRefreshRate;
  LocateStudyByID(sID);
  UpdateActionStatuses; // vhaishandria 2007-09-19
  updateStudyDetails;
  cdsStudyList.EnableControls;
  fIgnoreCDSChange := false;
end;

function TfrmStudies.getSelectedPatient:TMDKRegisteredPatient;
begin
  Result := fSelectedPatient;
end;

////////////////////////////////////////////////////////////////////////////////

function TfrmStudies.setStudyStatus(aStatus: string; out ErrorMsg:
  string): Integer;
var
  sStatusByName,
  sStatusOld,
  sStatus, sWS,  sStudyID,  sStatusAt, sStatusBy: string;
  DT: TDateTime;
begin
  sStatusOld := cdsStudyList.FieldByName(fnSL_Status).AsString;
  sStudyID := cdsStudyList.FieldByName(fnSL_StudyID).AsString;
  sStatusBy := Engine.UserDUZ;
  sStatusByName := Engine.CurrentOperatorID;
  sWS:= getWorkstationName;
  DT := Now;
  sStatusAt := FloatToStr(WindowsDateTimeToFMDateTime(DT));
  if aStatus = 'DISABLED' then sStatus := '2'
  else sStatus := '1';

  if pos('-',Engine.fRenalController.setStudyUseStatus(
    sStudyID,sStatus,sStatusBy,sStatusAt,sWS)) = 1 then
    begin
      Result := rcStudyStatusChangeFailed;
      ErrorMsg := 'Failed to change Use Status';
      sStatus := sStatusOld;
    end
  else
    begin
      Result := rcStudyStatusOK;
      sStatus := aStatus;
    end;

  try
    if not (cdsStudyList.State = dsEdit) then
      cdsStudyList.Edit;
    cdsStudyList.FieldByName(fnSL_Status).AsString := sStatus;
    cdsStudyList.FieldByName(fnSL_StatusBy).AsString := sStatusByName;
    cdsStudyList.FieldByName(fnSL_StatusTime).AsDateTime := DT;
    cdsStudyList.FieldByName(fnSL_Comments).AsString := sWS;
    cdsStudyList.Post;
  except
    on E: Exception do
      begin
        Result := rcTableUpdateFailed;
        ErrorMsg := E.Message;
      end;
  end;
end;

function TfrmStudies.setUseStatus(newStatus:String;
  requiredStatuses: Array of String;
  const stOK: Integer;
  var ErrorMsg: String;
  accessRegistrationNeeded: Boolean = False;
  keepLock:Boolean=False): Integer;
var
  sID: string;
  iID: Integer;

  function isRequiredStatus(aStatus:String): Boolean;
  var
    i: Integer;
  begin
    Result := False;
    for i := low(requiredStatuses) to high(requiredStatuses) do
      begin
        if aStatus <> requiredStatuses[i] then continue;
        Result := True;
        break;
      end;
  end;

begin
  if accessRegistrationNeeded and
    not AccessRegistered(cdsStudyList.FieldByName(fnSL_PatientID).AsString) then
    begin
      Result := rcStudyStatusAccessRegistrationFailed;
      Exit;
    end;

  fIgnore := True;

  if isRequiredStatus(cdsStudyList.FieldByName(fnSL_Status).AsString) then
    begin
      iID := cdsStudyList.FieldByName(fnSL_StudyID).AsInteger;
      if Engine.fRenalController.LockStudy(iID) then
        begin
          sID := cdsStudyList.FieldByName(fnSL_StudyID).AsString;
          Result := SetStudyStatus(newStatus, ErrorMsg);
          if Result = stOK then
            Engine.Report(rtInfo, newStatus, '', 0, '','Set Study Status')
          else
            Engine.Report(rtError, 'Set Study <' + sID + '> status'+newStatus+' Failed', '', 0,
              '', 'Set Study Status');

          if  not keepLock then
            if not Engine.fRenalController.unLockStudy(iID) then
              Result := rcStudyStatusUnLockFailed;
        end
      else
        begin
          ErrorMsg := 'Lock failed. Study could being edited by another user';
          Result := rcStudyStatusLockFailed;
        end;
    end
  else
    begin
      ErrorMsg := 'Wrong Status';
      Result := rcStudyStatusWrong;
    end;
  fIgnore := False;
end;

procedure ExplainResult(aStudy,aStatus: String;aRC: Integer);
var
  s: String;
begin
  case aRC of
    rcStudyStatusOK:;
    rcStudyStatusLockFailed: s := 'Lock Failed';
    rcStudyStatusUnLockFailed:s := 'Unlock Failed';
    rcStudyStatusWrong: s := 'Wrong Status';
  end;
  if s <> '' then
    MessageDLG(s,mtWarning,[mbOK],0);
end;

procedure TfrmStudies.acDisableExecute(Sender: TObject);
var
  s: String;
begin
  ExplainResult('','',SetUseStatus(snDisabled,[snEnabled],rcStudyStatusOK,s));
end;

procedure TfrmStudies.acEnableExecute(Sender: TObject);
var
  s: String;
begin
  ExplainResult('','',SetUseStatus(snEnabled,[snDisabled],rcStudyStatusOK,s));
end;

procedure TfrmStudies.acSelectExecute(Sender: TObject);
var
  i: Integer;
  sStatus,
  ErrorMsg,
    sID: String;
begin
//  Hide;
  setActionsActiveStatus(False); // vhaishandria 2007-09-19
  sID := cdsStudyList.FieldByName(fnSL_StudyID).AsString;

//  acRefresh.Execute;
  if LocateStudyByID(sID) then
    begin
      sStatus := cdsStudyList.FieldByName(fnSL_Status).AsString;
      if (sStatus = snEnabled) or (sStatus='') then
        begin
          i := SetUseStatus(snInUse, [snEnabled],rcStudyStatusOK,ErrorMsg,True,True);
          case i of
            rcStudyStatusOK:
              begin
                LocateStudyByID(sID);
                SelectPatient(False);
                ModalResult := mrOK;
              end;
          else
              begin
                Show;
                Engine.Report(rtError, 'Study <' + sID + '> selection failed.'+
                  #13#10+ErrorMsg, '', 0, '', 'Select Study');
                MessageDLG('Study <' + sID + '> selection failed.' + #13#13 +
                  ErrorMsg+#13#13+'Try select study again later.',
                  mtInformation,[mbOK],0);
              end;
          end;
        end
      else
        begin
          Show;
          MessageDLG('Study can not be selected for update'+#13#13+
            'Study:  "'+sID+ '"'+#13+
            'Status: "'+sStatus + '"'+#13+
            'Set by:  '+cdsStudyList.FieldByName(fnSL_StatusBy).AsString + #13+
            'On:      '+cdsStudyList.FieldByName(fnSL_StatusTime).AsString + #13+
            'W/S:     '+cdsStudyList.FieldByName(fnSL_Comments).AsString +#13#13 +
            'Try again later', mtWarning,[mbOK],0);
        end;
    end
  else
    Show;
  UpdateActionStatuses;// vhaishandria 2007-09-19
end;

procedure TfrmStudies.acReviewExecute(Sender: TObject);
begin
  setActionsActiveStatus(False);
  if AccessRegistered(cdsStudyList.FieldByName(fnSL_PatientID).AsString) then
    begin
      SelectPatient(True);
      ModalResult := mrOK;
    end;
  UpdateActionStatuses;// vhaishandria 2007-09-19
end;

function TfrmStudies.getStudyStatus(anID: String): String;
var
  BM: TBookmark;
begin
  Result := 'Unknown';
  cdsStudyList.DisableControls;
  try
    BM := cdsStudyList.GetBookmark;
    if locateStudyByID(anID) then
      Result := cdsStudyList.FieldByName(fnSL_Status).AsString;
    cdsStudyList.GotoBookmark(BM);
    cdsStudyList.FreeBookmark(BM);
  except
  end;
  cdsStudyList.EnableControls;
end;

function TfrmStudies.ReleaseStudy(anID: String;var msgError:String): Integer;
var
  iID: Integer;
begin
  iID := StrToIntDef(anID,-1);
  if iID < 0 then
    begin
      Result := iID;
      msgError := 'Error converting <'+anID+'> to integer';
    end
  else
    begin
     if not LocateStudyByID(anID) then
       begin
         Result := rcStudyNotFound;
         msgError := 'Study <'+anID+'> not found';
       end
     else
       begin
         if Engine.fRenalController.unLockStudy(iID) then
           begin
             Result := rcStudyStatusOK;
             msgError := '';
           end
         else
           begin
             Result := rcStudyStatusUnLockFailed;
             msgError := Engine.fRenalController.ResultInfo;
           end;
       end;
    end;
end;

end.
