unit frMDK_Assessment;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
*       Site Name:    Hines OIFO
*       Date Created: 4/18/07
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     frMDK_Assessment definition
*       Notes:
*
================================================================================
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, fr_Simple, ExtCtrls
  , iMDK_Assessment, StdCtrls, ComCtrls, ImgList, ToolWin, ActnList,
  Buttons;

type

  TAccessInfo = record
    R: Boolean;
    W: Boolean;
    M: Boolean;
  end;

  TfrAssessment = class(TfrSimpleFrame)
    pnlCaption: TPanel;
    re: TRichEdit;
    ActionList1: TActionList;
    acUpdate: TAction;
    Panel1: TPanel;
    ImageList1: TImageList;
    pnlButtons2d: TPanel;
    SpeedButton1: TSpeedButton;
    acRefresh: TAction;
    pnlButtons3D: TPanel;
    BitBtn1: TBitBtn;
    procedure acUpdateExecute(Sender: TObject);
    procedure acRefreshExecute(Sender: TObject);
  private
    { Private declarations }
    fAccessInfo: TAccessInfo;
    fAssessment: I_Assessment;
  public
    { Public declarations }
    property AccessInfo: TAccessInfo read fAccessInfo write fAccessInfo;
    property Assessment: I_Assessment read fAssessment;

    procedure setAssessmentInterface(anInterface: I_Assessment);
    procedure setAssessmentCaption(aCaption: string);
    procedure freeInterface;
  end;

var
  frAssessment: TfrAssessment;

function newAssessmentFrame(aCaption: string; anInterface: I_Assessment;
  aParent: TWinControl): TfrAssessment;

implementation

uses
        uMDK_ReportEngine
        ;

{$R *.dfm}

function newAssessmentFrame(aCaption: string; anInterface: I_Assessment;
  aParent: TWinControl): TfrAssessment;
begin
  Result := TfrAssessment.Create(nil);

  Result.setAssessmentInterface(anInterface);
  Result.setAssessmentCaption(aCaption);
end;

procedure TfrAssessment.setAssessmentInterface(anInterface: I_Assessment);
begin
  fAssessment := anInterface;
end;

procedure TfrAssessment.setAssessmentCaption(aCaption: string);
begin
  pnlCaption.Caption := aCaption;
end;

procedure TfrAssessment.freeInterface;
begin
  fAssessment := nil;
end;

procedure TfrAssessment.acUpdateExecute(Sender: TObject);
var
  s: string;
begin
  inherited;
  if Assigned(fAssessment) then
    begin
      s := re.Text;
      s := fAssessment.updateAssessmentText(s);
      if s <> re.Text then
        try
          re.Text := s;
          PaintSyntax(re, False);
        except
        end;
    end;
end;

procedure TfrAssessment.acRefreshExecute(Sender: TObject);
begin
  inherited;
  if Assigned(fAssessment) then
    try
      re.Text := fAssessment.getAssessmentText;
      PaintSyntax(re, False);
    except
    end;
end;

end.
