unit frMDK_TIUNotes;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ActnList
  , StdCtrls, Grids, DBGrids
  , frMDK_StudyNoteSection, Buttons
  ;

type
  TFrameMDK_TIUNotes = class(TFrame)
    pnlTools: TPanel;
    sbxCanvas: TScrollBox;
    Panel1: TPanel;
    lblTIUNotesTitle: TLabel;
    Shape3: TShape;
    Bevel1: TBevel;
  private
    fCurrentNoteText: string;
    fStringValue: string;
    fStringTag: string;

    //    iLineLength: Integer;

    fNL_ID: string; //      'ID';
    fNL_ParentID: string; //'ParentID';
    fNL_PatientID: string; //'PatientID';
    fNL_StudyID: string; // 'StudyID';
    fNL_ItemID: string; //  'ItemID';
    fNL_Tag: string; //     'Tag';
    fNL_DateTime: string; //'DateTime';
    fNL_AuthorID: string; //  'Author';
    fNL_AuthorName: string; //  'Author';
    fNL_Text: string; //    'NoteText';
    fNL_Status: string; //  'Status';
    fNL_StatusBy: string; //'StatusBy';
    fNL_StatusDate: string; //'StatusDate';

    fCurrentFrame: TObject;
    { Private declarations }
    procedure setStringValue(aValue: string);
    procedure setCommentFields(aVAlue: string);
    function ProcessRecord(aValue, aTag: string; iTag: Integer):
      TFrameStudyNoteSection;
  public
    StudyID: string;
    ReportTitle: string;
    { Public declarations }
    property CurrentNoteText: string read fCurrentNoteText;
    property StringValue: string read fStringValue write setStringValue;
    property StringTag: string read fStringTag write fStringTag;
    procedure FindFirst;
    procedure FindLast;
    procedure FindNext(Up: Boolean; aSender: TObject);
    procedure FindCurrent(anID: string; aSender: TObject);
    procedure setUpCanvas(aValue: string; aStringTag: string);
  end;

implementation

uses uMDK_Notes, uMDK_Options, uMDK_Common,
  uMDK_CDSCommon, uMDK_Engine, fMDK_Comments, dMDK_Data, uMDK_Flowsheet,
  fMDK_Info, uMDK_Utils;

{$R *.dfm}

procedure TFrameMDK_TIUNotes.FindFirst;
var
  i: integer;
begin
  for i := 0 to sbxCanvas.ComponentCount - 1 do
    begin
      if sbxCanvas.Components[i] is TframeSTudyNoteSection then
        begin
          TframeStudyNoteSection(sbxCanvas.Components[i]).FocusFirst;
          break;
        end;
    end;
end;

procedure TFrameMDK_TIUNotes.FindLast;
var
  i: integer;
begin
  for i := sbxCanvas.ComponentCount - 1 downto 0 do
    begin
      if sbxCanvas.Components[i] is TframeSTudyNoteSection then
        begin
          TframeStudyNoteSection(sbxCanvas.Components[i]).FocusLast;
          break;
        end;
    end;
end;

procedure TFrameMDK_TIUNotes.FindNext(Up: Boolean; aSender: TObject);
var
  j,
    i: integer;
begin
  for i := 0 to sbxCanvas.ComponentCount - 1 do
    begin
      if sbxCanvas.Components[i] = aSender then
        begin
          if Up then
            begin
              if i = 0 then
                j := sbxCanvas.ComponentCount - 1
              else
                j := i - 1;
              TframeStudyNoteSection(sbxCanvas.Components[j]).FocusLast;
            end
          else
            begin
              if i = sbxCanvas.ComponentCount - 1 then
                j := 0
              else
                j := i + 1;

              TframeStudyNoteSection(sbxCanvas.Components[j]).FocusFirst;
            end;
          break;
        end;
    end;
end;

procedure TFrameMDK_TIUNotes.setUpCanvas(aValue: string; aStringTag: string);
begin
  StringValue := aValue;
  fStringTag := aStringTag;
end;

procedure TFrameMDK_TIUNotes.setCommentFields;
begin
  try
    fNL_ID := piece(aValue, '^', 1);

    fNL_ParentID := '';
    fNL_PatientID := '';

    fNL_StudyID := fNL_ID;

    fNL_ItemID := '';
    fNL_Tag := '';
    fNL_DateTime := piece(aValue, '^', 3);

    fNL_AuthorID := piece(aValue, '^', 4);
    fNL_AuthorName := piece(aValue, '^', 4);

    fNL_Text := aValue;

    fNL_Status := '';
    ;
    fNL_StatusBy := '';
    fNL_StatusDate := '';
  except
  end;
end;

function TFrameMDK_TIUNotes.ProcessRecord(aValue, aTag: string; iTag: Integer):
  TFrameStudyNoteSection;
var
  aSection: TFrameStudyNoteSection;
  sReport: string;
  sReportKeyword: string;
  sType: string;

begin
  setCommentFields(aValue);
  sReportKeyword := Preferences.sValue(onSummaryReportName);
  sReport := Engine.getNoteByNum(fNL_ID, StudyID); //???
  if pos(sReportKeyword, sReport) > 0 then
    sType := 'CP REPORT'
  else
    sType := 'TIU';

  aSection := newStudyNoteSection(sbxCanvas,
    fNL_ID,
    fsLocked,
    aTag,
    fNL_AuthorID, //Name,
    fNL_DateTime,
    sReport, // fNL_Text,// Text of Comment
    sType, // Type of Comment
    fNL_Status,
    fNL_StatusBy,
    fNL_StatusDate,
    200, // Max Height
    iTag, // Tab Order
    False // Collapsed
    );

  aSection.Parent := sbxCanvas;
  aSection.pnlCollapse.Visible := True;
  aSection.pnlStatusDetails.Visible := False;
  aSection.Show;

  aSection.MoveUp;
  Result := aSection;
end;

procedure TFrameMDK_TIUNotes.FindCurrent(anID: string; aSender: TObject);
begin
  fCurrentFrame := aSender;
  fCurrentNoteText := TFrameStudyNoteSection(aSender).Text;
end;

procedure TFrameMDK_TIUNotes.setStringValue(aValue: string);
var
  SL: TStringList;
  aSection: TFrameStudyNoteSection;
  i,
    iTab: Integer;

  procedure CleanSBX(aSBX: TScrollBox);
  var
    i: Integer;
  begin
    i := 0;
    while i < aSBX.ComponentCount do
      begin
        if aSBX.Components[i] is TFrameStudyNoteSection then
          begin
            aSection := TFrameStudyNoteSection(aSBX.Components[i]);
            aSBX.RemoveComponent(aSection);
            if Assigned(aSection) then
              FreeAndNil(aSection);
          end
        else
          inc(i);
      end;
  end;

begin
  fStringValue := aValue;
  CleanSBX(sbxCanvas);

  if aValue = '' then
    Exit;

  SL := TStringList.Create;
  SL.Text := fStringValue;
  iTab := 0;
  for i := 0 to SL.Count - 1 do
    begin
      aSection := ProcessRecord(SL[i], intToStr(iTab), iTab);
      aSection.onFindCurrent := FindCurrent;
      inc(iTab);
    end;
  SL.Free;
end;

end.

