unit uMDK_BillingInfo;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Billing information object
*       Notes:
*
================================================================================
*       $Archive: /Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Objects/uMDK_BillingInfo.pas $
*
* $History: uMDK_BillingInfo.pas $
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/13/09    Time: 1:15p
 * Created in $/Clinical Procedures v1.0 (CP Legacy)/CP Version 1.0 - Patch 19/HEMODIALYSIS_1_0_6_320/APP-HEMODIALYSIS/Objects
 * Patch 19 source code
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/24/08    Time: 4:23p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/HEMODIALYSIS_1_0_6_319_#18/APP-HEMODIALYSIS/Objects
 * 
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/02/08    Time: 9:25a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI Current/HEMODIALYSIS_1_0_6_319/APP-HEMODIALYSIS/Objects
 * 
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 6/20/07    Time: 3:23p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 6/04/07    Time: 9:08a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 5/22/07    Time: 9:16a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0/APP-HEMODIALYSIS/Objects
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 3/27/07    Time: 1:31p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:38p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 3/26/07    Time: 12:28p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP_HEMODIALYSIS/CP MODERNIZATION/APP-HemoDialysis/Objects
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/25/07    Time: 9:39a
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:36p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/APP-HEMODIALYSIS/Objects
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 1/22/07    Time: 1:28p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI 1.0.6.308/CP MODERNIZATION/APP-HemoDialysis/Objects
 * GUI 1.0.6.308 RC January 2007
 *
 * *****************  Version 4  *****************
 * User: Vhaishandria Date: 12/13/06   Time: 1:53p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
 *
 * *****************  Version 3  *****************
 * User: Vhaishandria Date: 7/12/06    Time: 9:41a
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
 *
 * *****************  Version 2  *****************
 * User: Vhaishandria Date: 5/19/06    Time: 5:46p
 * Updated in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
 * May 19
 *
 * *****************  Version 1  *****************
 * User: Vhaishandria Date: 4/28/06    Time: 5:18p
 * Created in $/CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-Hemodialysis/Objects
}

interface
uses
  Classes
  , SysUtils
  ;
type

  TMDK_Provider = class(TObject)
    ID: string;
      Name: string;
    Primary: Boolean;
  end;

  TMDK_Diagnosis = class(TObject)
    ID: string;
    IEN: string;
    Category: string;
    Title: string;
    Primary: Boolean;
  end;

  TMDK_Procedure = class(TObject)
    ID: string;
    IEN: string;
    Category: string;
    Title: string;
    Quantity: Integer;
  end;

  TMDK_BillingInfo = class(TObject)
  private
    fSCC,
      fMST,
      fAOE,
      fIRE,
      fHNC,
      fEC,
      fCV: Integer;

    fStudyID: string;
    fXMLData: string;
    fLegacy: string;

    fService,
      fProcedures,
      fDiagnoses,
      fProviders: TStringList;

    procedure setXMLData(aValue: string);
    procedure setLegacy(aValue: string);
    function getIStudyID: Integer;

    function getXMLData: string;
    function getLegacy: string;

  public
    property SCC: Integer read fSCC write fSCC;
    property MST: Integer read fMST write fMST;
    property AOE: Integer read fAOE write fAOE;
    property IRE: Integer read fIRE write fIRE;
    property HNC: Integer read fHNC write fHNC;
    property EC: Integer read fEC write fEC;
    property CV: Integer read fCV write fCV;

    property Legacy: string read getLegacy write setLegacy;
    property XMLData: string read getXMLData write setXMLData;
    property StudyID: string read fStudyID;
    property iStudyID: Integer read getIStudyID;

    property Procedures: TStringList read fProcedures write fProcedures;
    property Diagnoses: TStringList read fDiagnoses write fDiagnoses;
    property Providers: TStringList read fProviders write fProviders;

    procedure Clear;
    constructor Create;
    destructor Destroy; override;

  end;

const
  iICD9Keyword = 1;
  iICDIEN = 2;
  iICD9Code = 3;
  iICD9ShortDescription = 5;
  iICD9Primary = 6;

  iCPTKeyword = 1;
  iCPTIEN = 2;
  iCPTCode = 3;
  iCPTSHortDescription = 5;
  iCPTQuantity = 7;

  iPRVKeyword = 1;
  iPRVCode = 2;
  iPRVName = 4;
  iPRVPrimary = 6;

implementation

uses uXML, XMLIntf
  , uROR_CommonUtils
  ;

constructor TMDK_BillingInfo.Create;
begin
  inherited;
  fProcedures := TStringList.Create;
  fDiagnoses := TStringList.Create;
  fProviders := TStringList.Create;
  fService := TStringList.Create;

end;

destructor TMDK_BillingInfo.Destroy;
begin
  Clear;
  FreeAndNil(fProcedures);
  FreeAndNil(fProviders);
  FreeAndNil(fDiagnoses);
  FreeAndNil(fService);
  inherited;
end;

procedure TMDK_BillingInfo.Clear;
begin
  fSCC := -1;
  fMST := -1;
  fAOE := -1;
  fIRE := -1;
  fHNC := -1;
  fEC := -1;
  fCV := -1;

  fStudyID := '';
  fXMLData := '';

  while fProviders.Count > 0 do
    begin
      if fProviders.Objects[0] <> nil then
        try
          TMDK_Provider(fProviders.Objects[0]).Free;
        except
        end;
      fProviders.Delete(0);
    end;
  while fDiagnoses.Count > 0 do
    begin
      if fDiagnoses.Objects[0] <> nil then
        try
          TMDK_Diagnosis(fDiagnoses.Objects[0]).Free;
        except
        end;
      fDiagnoses.Delete(0);
    end;
  while fProcedures.Count > 0 do
    begin
      if fProcedures.Objects[0] <> nil then
        try
          TMDK_Procedure(fProcedures.Objects[0]).Free;
        except
        end;
      fProcedures.Delete(0);
    end;
end;

procedure TMDK_BillingInfo.setXMLData(aValue: string);
var
  OK: Boolean;
  i: Integer;
  xDOC: IXMLDocument;
  xNode: IXMLNode;

  __SCC,
    __MST,
    __AOE,
    __IRE,
    __HNC,
    __EC,
    __CV: Integer;

  __StudyID: string;

  function getChildByName(aName: string): Integer;
  begin
    try
      Result := StrToIntDef(xNode.ChildValues[aName], -1);
    except
      Result := -1;
    end;
  end;
  function getChildStringByName(aName: string): string;
  begin
    try
      Result := xNode.ChildValues[aName];
    except
      Result := '';
    end;
  end;

begin
  __SCC := -1;
  __MST := -1;
  __AOE := -1;
  __IRE := -1;
  __HNC := -1;
  __EC := -1;
  __CV := -1;
  try
    OK := False;
    try
      fXMLData := '';
      if (pos('-1', aValue) <> 1) and (trim(aValue) <> '') then
        xDOC := XMLDocument(aValue)
      else
        exit;
    except
      Exit;
    end;
    with xDoc.DocumentElement do
      begin
        for i := 0 to ChildNodes.Count - 1 do
          begin
            xNode := ChildNodes[i];
            if xNode.NodeName = 'STATUS' then
              OK := xNOde.NodeValue = 'OK';
            if xNode.NodeName <> 'RECORD' then
              continue;
            __StudyID := getChildStringByName('STUDY_ID');

            __SCC := getChildByName('SC_CONDITION');
            __MST := getChildByName('MST');
            __AOE := getChildByName('AO_EXPOSURE');
            __IRE := getChildByName('IR_EXPOSURE');
            __HNC := getChildByName('HEAD_NECK_CANCER');
            __EC := getChildByName('EV_CONTAMINENTS');
            __CV := getChildByName('COMBAT_VETERAN');

          end;
      end;
  except
    OK := False;
  end;
  if not OK then
    exit;

  fSCC := __SCC;
  fMST := __MST;
  fAOE := __AOE;
  fIRE := __IRE;
  fHNC := __HNC;
  fEC := __EC;
  fCV := __CV;

  fStudyID := __StudyID;

  fXMLData := aValue;

end;

function TMDK_BillingInfo.getIStudyID: Integer;
begin
  try
    result := StrToInt(fStudyID);
  except
    Result := -1;
  end;
end;

function TMDK_BillingInfo.getXMLData: string;
begin
  Result := fXMLData;
end;

function TMDK_BillingInfo.getLegacy: string;
var
  ss: string;
  i: Integer;
  aPro: TMDK_Provider;
  aProc: TMDK_Procedure;
  aDiag: TMDK_Diagnosis;

  function setCB(aName: string; ckb: Integer): string;
  begin
    Result := '';
    if aName = '' then
      Exit;
    if ckb >= 0 then
      begin
        Result := aName + ';1^';
        if ckb = 1 then
          Result := Result + '1;'
        else
          Result := Result + '0;';

      end
    else
      Result := aName + ';0^;';
  end;

begin
  ss := '';
  try
    ss := ss + setCB('SC', fSCC);
    ss := ss + setCB('AO', fAOE);
    ss := ss + setCB('IR', fIRE);
    ss := ss + setCB('EC', fEC);
    ss := ss + setCB('MST', fMST);
    ss := ss + setCB('HNC', fHNC);
    ss := ss + setCB('CV', fCV);
    ss := ss + #13#10;
    {
      iPRVKeyword = 1;
      iPRVCode = 2;
      iPRVName = 4;
      iPRVPrimary = 6;
    }
    for i := 0 to Providers.Count - 1 do
      begin
        aPro := TMDK_Provider(Providers.Objects[i]);
        ss := ss + 'PRV^' + aPro.ID + '^^' + aPro.Name + '^^';
        if aPro.Primary then
          ss := ss + '1';
        ss := ss + #13#10;
      end;

    {
      iICD9Keyword = 1;
      iICD9Code = 3;
      iICD9ShortDescription = 5;
      iICD9Primary = 6;
    }
    for i := 0 to Diagnoses.Count - 1 do
      begin
        aDiag := TMDK_Diagnosis(Diagnoses.Objects[i]);
        ss := ss + 'POV^' + aDiag.IEN + '^' + aDiag.ID + '^^' + aDiag.Title +
          '^';
        if aDiag.Primary then
          ss := ss + '1';
        ss := ss + #13#10;
      end;
    {
      iCPTKeyword = 1;
      iCPTCode = 3;
      iCPTSHortDescription = 5;
      iCPTQuantity = 7;
    }
    for i := 0 to Procedures.Count - 1 do
      begin
        aProc := TMDK_Procedure(Procedures.Objects[i]);
        ss := ss + 'CPT^' + aProc.IEN + '^' + aProc.ID + '^^' + aProc.Title +
          '^^';
        if aProc.Quantity > 0 then
          ss := ss + IntToStr(aProc.Quantity);
        ss := ss + #13#10;
      end;
  except
  end;
  Result := ss;
end;

procedure TMDK_BillingInfo.setLegacy(aValue: string);
var
  i: Integer;
  SL: TStringList;

  procedure setConnectionData(aV: string);

    function Connection(aSource: string): Integer;
    var
      s1, s2: string;
    begin
      Result := -1;
      if aSource = '' then
        Exit;
      s1 := piece(aSource, '^', 1);
      s2 := piece(piece(aSource, '^', 2), ';', 1);
      if s1 = '0' then
        begin
          Result := -1;
        end
      else
        begin
          Result := StrToIntDef(s2, 0);
        end;
    end;

  var
    ss: string;
  begin
    ss := Piece(aV, 'SC;', 2);
    fSCC := Connection(ss);

    ss := Piece(aV, 'AO;', 2);
    fAOE := Connection(ss);

    ss := Piece(aV, 'IR;', 2);
    fIRE := Connection(ss);

    ss := Piece(aV, 'EC;', 2);
    fEC := Connection(ss);

    ss := Piece(aV, 'HNC;', 2);
    fHNC := Connection(ss);

    ss := Piece(aV, 'MST;', 2);
    fMST := Connection(ss);

    ss := Piece(aV, 'CV;', 2);
    fCV := Connection(ss);
  end;

  procedure AddProvider(aSource: string);
  var
    aProvider: TMDK_Provider;
  begin
    aProvider := TMDK_Provider.Create;
    aProvider.ID := piece(aSource, '^', iPRVCode);
    aProvider.Name := piece(aSource, '^', iPRVName);
    aProvider.Primary := piece(aSource, '^', iPRVPrimary) = '1';
    fProviders.AddObject(aProvider.Name, aProvider);
  end;

  procedure AddCPT(aSource: string);
  var
    aProcedure: TMDK_Procedure;
  begin
    aProcedure := TMDK_Procedure.Create;
    aProcedure.ID := piece(aSource, '^', iCPTCode);
    aProcedure.IEN := piece(aSource, '^', iCPTIEN);
    aProcedure.Title := piece(aSource, '^', iCPTShortDescription);
    aProcedure.Quantity := StrToIntDef(piece(aSource, '^', iCPTQuantity), 1);
    fProcedures.AddObject(aProcedure.Title, aProcedure);
  end;

  procedure AddICD(aSource: string);
  var
    aDiagnosys: TMDK_Diagnosis;
  begin
    aDiagnosys := TMDK_Diagnosis.Create;
    aDiagnosys.IEN := piece(aSource, '^', iICDIEN);
    aDiagnosys.ID := piece(aSource, '^', iICD9Code);
    aDiagnosys.Title := Piece(aSource, '^', iICD9ShortDescription);
    aDiagnosys.Primary := Piece(aSource, '^', iICD9Primary) = '1';
    fDiagnoses.AddObject(aDiagnosys.Title, aDiagnosys);
  end;

begin
  Clear;
  fLegacy := aValue;
  SL := TStringList.Create;
  SL.Text := aValue;
  if SL.Count < 1 then
    Exit;

  SetConnectionData(SL[0]);

  for i := 1 to SL.Count - 1 do
    begin
      if piece(SL[i], '^', 1) = 'PRV' then
        addProvider(SL[i]);
      if piece(SL[i], '^', 1) = 'POV' then
        addICD(SL[i]);
      if piece(SL[i], '^', 1) = 'CPT' then
        addCPT(SL[i]);
    end;
end;

end.
