unit uMDK_FieldFactory;

interface
uses
  DB
  , DBClient;

type
  TFieldFactory = class(TObject)
    class procedure setIDFields(aCDS: TClientDataSet);
    class procedure setStatusFields(aCDS: TClientDataSet);
    class procedure setTimeStampFields(aCDS: TClientDataSet);
    class procedure setDescriptionFields(aCDS: TClientDataSet);
  end;

const
  FN_ID = 'ID';
  FN_TYPE = 'DataType';
  FN_PATIENT_ID = 'PatientID';
  FN_STUDY_ID = 'StudyID';

  FN_DATETIME = 'DateTime';
  FN_DATE_ONLY = 'DateOnly';
  FN_TIME_ONLY = 'TimeOnly';

  FN_STATUS = 'Status';
  FN_STATUS_BY = 'StatusBy';
  FN_STATUS_AT = 'StatusAt';

  FN_SOURCE_ID = 'SourceID';

  FN_DESCRIPTION = 'DESCRIPTION';

implementation
uses
  uMDK_CDSCommon
  ;

class procedure TFieldFactory.setIDFields(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, FN_ID, FN_ID, LENGTH_ID, LENGTH_ID);
{$IFNDEF AANTEST}aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible :=
    False;
{$ENDIF}
    NewStringField(aCDS, FN_TYPE, FN_TYPE, LENGTH_ID, LENGTH_ID);
{$IFNDEF AANTEST}aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible :=
    False;
{$ENDIF}
  except
  end;
end;

class procedure TFieldFactory.setStatusFields(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, FN_STATUS, FN_STATUS, LENGTH_ID, LENGTH_ID);
{$IFNDEF AANTEST}aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible :=
    False;
{$ENDIF}
    NewStringField(aCDS, FN_STATUS_BY, FN_STATUS_BY, LENGTH_ID, LENGTH_ID);
{$IFNDEF AANTEST}aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible :=
    False;
{$ENDIF}
    NewDateTimeField(aCDS, FN_STATUS_AT, FN_STATUS_AT);
{$IFNDEF AANTEST}aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible :=
    False;
{$ENDIF}
  except
  end;
end;

class procedure TFieldFactory.setTimestampFields(aCDS: TClientDataSet);
begin
  try
    NewDateTimeField(aCDS, FN_DATETIME, FN_DATETIME, 8, gMDK_DateTimeFMT);
{$IFNDEF AANTEST}aCDS.FieldList.Fields[aCDS.FieldList.Count - 1].Visible :=
    False;
{$ENDIF}
    NewDateTimeField(aCDS, FN_DATE_ONLY, FN_DATE_ONLY);
    NewDateTimeField(aCDS, FN_TIME_ONLY, FN_TIME_ONLY, 8, gMDK_TimeFMT);
  except
  end;
end;

class procedure TFieldFactory.setDescriptionFields(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, FN_DESCRIPTION, FN_DESCRIPTION, 20, 80);
  except
  end;
end;

end.
