unit uMDK_Summary;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 2/25/08 3:49p $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Summary CDS definition
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects/uMDK_Summary.pas $
*
*       $ History: uMDK_Summary.pas $
}
interface
uses
  SysUtils
  , DBClient, DB
  ;
procedure CreateSummaryDS(aCDS: TClientDataSet);
function addDefaultSummary(aCDS: TClientDataSet; aPatient, aStudy: string):
  Boolean;

const
  fnS_PatientID = 'PatientID'; // String;
  fnS_VendorPtID = 'VendorPtID'; // String;
  fnS_SessionID = 'SessionID'; // String;
  fnS_SessionDate = 'SessionDate'; // String;

  fnS_Date = 'SummaryDate'; // TDateTime;

  fnS_TreatmentStarted = 'Started'; // TDateTime;
  fnS_TreatmentFinished = 'Finished'; // TDateTime;
  fnS_TreatmentDuration = 'Duration'; // TDateTime;
  fnS_TreatmentDurationManual = 'DurationManual'; // TDateTime;

  fnS_TrnCandidate = 'TransCandidate'; // Boolean;
  fnS_TrnWIP = 'TransWIP'; // Boolean;
  fnS_TrnReferred = 'TransReffered'; // Boolean;

  fnS_GoalWeight = 'GoalWeight'; // Real;

  // Rx ======================================================================
  fnS_RxGoalWeight = 'RxGoalWeight';

  fnS_rxDialyser = 'Dialyzer';
  fnS_rxTxLength = 'TxLength';
  fnS_rxReuseNum = 'ReuseNum';
  fnS_RxUltra = 'RxUltra';
  fns_RxEDW = 'RxEDW';
  fnS_rxBFR = 'BFR';
  fnS_rxDialysisFlow = 'DFlow';
  fnS_rxTemp = 'Temp';

  fnS_DF_K = 'DFK';
  fnS_DF_HCO3 = 'DFHCO3';
  fnS_DF_NA = 'DFNA';
  fnS_DF_CA = 'DFCA';

  fnS_AC_Type = 'ACType';
  fnS_AC_Load = 'ACLoad';
  fnS_AC_Doses = 'ACDoses';

  fnS_AC_EndTime = 'ACEndTime';
  fnS_AC_Other = 'ACOther';

  fnS_MoD_NA = 'MODNA';
  fnS_MoD_HCO3 = 'MODHCO3';
  fnS_MoD_Ultrafiltration = 'MODUF';

  fnS_OtherOrders = 'RxOther';

  // Pre assesment ===========================================================
  fnS_PreWeight = 'PreWeight'; // Real;
  fnS_PreDryWeight = 'PreDryWeight'; // Real;

  fnS_PreBPSysStanding = 'PreBPSysStand'; //Integer;
  fnS_PreBPDiasStanding = 'PreBPDiasStand'; //Integer;
  fnS_PrePulseStanding = 'PrePulseStanding'; //Integer

  fnS_PreBPSysSitting = 'PreBPSysSit'; //Integer;
  fnS_PreBPDiasSitting = 'PreBPDiasSit'; //Integer;
  fnS_PrePulseSeated = 'PrePulseSeated'; // Integer;

  fnS_PreTemp = 'PreTemp'; // Real;

  fnS_PreAlert = 'PreAlert';
  fnS_PreConfused = 'PreConfused';
  fnS_PreSedated = 'PreSedated';
  fnS_PreUnresposive = 'PreUnresponsive';
  fnS_PreLethargic = 'PreLethargic';
  fnS_PreRestless = 'PreRestless';

  fnS_PreAmbulatory = 'PreAmbulatory';
  fnS_PreOriented = 'PreOriented';
  fnS_PreOrientedText = 'PreOrientedText';

  fnS_PreTransportation = 'PreTransportation';

  fnS_PreEdema = 'PreEdema'; // Boolean;
  fnS_PreRespirations = 'PreResp'; // Integer;
  fnS_PreSOB = 'PreSOB'; // Boolean;

  fnS_EDU = 'Educated';
  fnS_EDUKey = 'EDUKey';
  fnS_EDUInit = 'EDUInit';

  fnS_BTLNone = 'BTLNone';
  fnS_BTLVisual = 'BTLVisual';
  fnS_BTLDesire = 'BTLDesire';
  fnS_BTLCognition = 'BTLCognition';
  fnS_BTLReligious = 'BTLReligious';
  fnS_BTLEmotional = 'BTLEmotional';
  fnS_BTLLanguage = 'BTLLanguage';
  fnS_BTLPhysical = 'BTLPhysical';

  fnS_PrePainTolerance = 'PrePainTolerance'; // Boolean
  fnS_PrePain = 'PrePain'; // Integer;
  fnS_PrePainLocation = 'PrePainLocation';
  fnS_PrePainAcute = 'PrePainAcute';
  fnS_PrePainTreatment = 'PrePainTreatment';
  fnS_PrePainIASP = 'PrePainIASP';
  fnS_PrePainIntensity = 'PrePainIntensity';
  fnS_PrePainFrequencyText = 'PrePainFrequency';
  fnS_PrePainOnset = 'PrePainOnset';
  fnS_PrePainDuration = 'PrePainDuration';
  fnS_PrePainQuality = 'PrePainQuality';

  fnS_PrePainImpact = 'PrePainImpact';
  fnS_PrePainWorse = 'PrePainWorse';
  fnS_PrePainRelieve = 'PrePainRelieve';
  fnS_PrePainHelpMed = 'PrePainHelpMed';
  fnS_PrePainOtherTreatments = 'PrePainOtherTreatmen';
  fnS_PrePainOtherComments = 'PrePainOtherComments';

  // Post assesment ==========================================================
  fnS_PostWeight = 'PostWeight'; // Real;
  fnS_PostDryWeight = 'PostDryWeight'; // Real;

  fnS_PostBPSysStanding = 'PostBPSysStand'; //Integer;
  fnS_PostBPDiasStanding = 'PostBPDiasStand'; //Integer;
  fnS_PostPulseStanding = 'PostPulseStanding'; //Integer

  fnS_PostBPSysSitting = 'PostBPSysSit'; //Integer;
  fnS_PostBPDiasSitting = 'PostBPDiasSit'; //Integer;
  fnS_PostPulseSeated = 'PostPulseSeated'; // Integer;

  fnS_PostTemp = 'PostTemp'; // Real;

  fnS_PostAlert = 'PostAlert';
  fnS_PostConfused = 'PostConfused';
  fnS_PostSedated = 'PostSedated';
  fnS_PostUnresposive = 'PostUnresponsing';
  fnS_PostLethargic = 'PostLethargic';
  fnS_PostRestless = 'PostRestless';

  fnS_PostAmbulatory = 'PostAmbulatory';
  fnS_PostOriented = 'PostOriented';
  fnS_PostOrientedText = 'PostOrientedText';
  fnS_PostTransportation = 'PostTransportation';

  fnS_PostEdema = 'PostEdema'; // Boolean;
  fnS_PostRespirations = 'PostResp'; // Integer;
  fnS_PostSOB = 'PostSOB'; // Boolean;

  fnS_PostPainTolerance = 'PostPainTolerance'; // Boolean
  fnS_PostPain = 'PostPain'; // Integer;
  fnS_PostPainLocation = 'PostPainLocation';
  fnS_PostPainAcute = 'PostPainAcute';
  fnS_PostPainTreatment = 'PostPainTreatment';
  fnS_PostPainIASP = 'PostPainIASP';
  fnS_PostPainIntensity = 'PostPainIntensity';
  fnS_PostPainFrequencyText = 'PostPainFrequencyText';
  fnS_PostPainOnset = 'PostPainOnset';
  fnS_PostPainDuration = 'PostPainDuration';
  fnS_PostPainQuality = 'PostPainQuality';

  fnS_PostPainImpact = 'PostPainImpact';
  fnS_PostPainWorse = 'PostPainWorse';
  fnS_PostPainRelieve = 'PostPainRelieve';
  fnS_PostPainHelpMed = 'PostPainHelpMed';
  fnS_PostPainOtherTreatments = 'PostPainOtherTreat';
  fnS_PostPainOtherComments = 'PostPainOtherComment';

  // post observations
  fnS_POWeight = 'POWeight'; // Boolean
  fnS_Medication = 'POMedication'; // Boolean
  //    fnS_TlrNop = 'TlrNOP';// Boolean
  fnS_TlrVom = 'TlrVom'; // Boolean
  fnS_TlrHyp = 'TlrHyp'; // Boolean
  fnS_TlrSyn = 'TlrSyn'; // Boolean
  fnS_TlrCram = 'TlrCram'; // Boolean
  fnS_TlrStable = 'TlrStable'; // String
  fnS_TlrOther = 'TlrOther'; // String
  fnS_TlrOtherDoc = 'TlrOtherDoc'; // String

  // Coversheet Totals
  fnS_BloodFlow = 'TotBFlow'; // Real;
  fnS_AVP = 'TotAVP'; //Real;
  fnS_VP_0 = 'TotVP'; // Real;
  fnS_VP_200 = 'TotVP200'; // Real;

  // Safety
  fnS_SafetyChecksOK = 'SafetyChecksOK'; // Boolean;
  //    fnS_OrderVerified = 'SafetyOrder' ; // Boolean;
  //    fnS_AlarmsChecked = 'SafetyAlarm' ; // Boolean;
  //    fnS_DisenfectantNegative = 'SafetyDI' ; // Boolean;

      // Summary Totals

  fnS_TotalUF = 'TotUF'; // Real;
  fnS_TotalLP = 'TotLP'; // Real;
  fnS_TotalKT = 'TotKT'; // Real;
  fnS_TotalKTV = 'TotKTV'; // Real;
  fnS_TotalURR = 'TotURR'; // Real;
  fnS_TotalEUV = 'TotEUV'; // Real;

  fnS_MeanUFR = 'MeanURF'; // Real;
  fnS_MeanTMP = 'MeanTMP'; // Real;
  fnS_MeanTemp = 'MeanTemp'; // Real;
  fnS_MeanConductivity = 'MeanCond'; // Real;

  fnS_AverageBFR = 'AvrBFR'; // Real;
  fnS_AverageDFR = 'AvrDFR'; // Real;

  fnS_IABF = 'IABF';
  fnS_AVP0 = 'AVP0';
  fnS_VP0 = 'VP0';
  fnS_VP200 = 'VP200';

  // Notes
  fnS_PreNotes = 'PreNotes'; // String;
  fnS_PostNotes = 'PostNotes'; // String;
  fnS_WorkflowNotes = 'FlowNotes'; // String;
  fnS_LabNotes = 'LabNotes'; // String;

  fnS_SummaryNotes = 'SummaryNotes'; // String;

  fnS_LastRecord = 'LastRecord';
  fnS_LastTimeUpdated = 'LastTimeUpdated';
  fnS_LastTimeUpdatedRx = 'LastTimeUpdatedRx';

  fnS_Machine = 'Machine';
  fnS_Station = 'Station';
  fnS_MachineType = 'MachineType';

  fnS_FallAssessment = 'FallAssessment';

implementation

uses uMDK_CDSCommon, uMDK_Common, dMDK_Data;

procedure CreateSummaryDS(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, fnS_PatientID, 'PatientID', 8, 20); // String;
    NewStringField(aCDS, fnS_VendorPtID, 'VendorPtID', 8, 30); // String;
    NewStringField(aCDS, fnS_SessionID, 'StudyID', 8, 20); // String;
    NewDateTimeField(aCDS, fnS_SessionDate, 'Study Date'); // TDateTime;
    NewDateTimeField(aCDS, fnS_Date, 'SummaryDate', 10, gMDK_DateFMT);
    // TDateTime;

    NewDateTimeField(aCDS, fnS_TreatmentStarted, 'Started'); // TDateTime;
    TDateTimeField(aCDS.FieldList.Fields[aCDS.FieldCount - 1]).DisplayFormat :=
      'hh:nn';
    NewDateTimeField(aCDS, fnS_TreatmentFinished, 'Finished'); // TDateTime;
    TDateTimeField(aCDS.FieldList.Fields[aCDS.FieldCount - 1]).DisplayFormat :=
      'hh:nn';
    NewDateTimeField(aCDS, fnS_TreatmentDuration, 'Duration', fwDateTime, 'hh:nn'
      {gMDK_TimeFMT}); // TDateTime;
    NewDateTimeField(aCDS, fnS_TreatmentDurationManual, 'DurationManual',
      fwDateTime, 'hh:nn' {gMDK_TimeFMT}); // TDateTime;
    //    TDateTimeField(aCDS.FieldList.Fields[aCDS.FieldCount-1]).DisplayFormat:= 'hh:nn';//'hh:MM:ss';

    NewFloatField(aCDS, fnS_GoalWeight, 'GoalWeight'); // Real;

    // Rx
    NewStringField(aCDS, fnS_rxDialyser, 'Dialyzer', 100, 100);
    //    NewStringField(aCDS,fnS_rxReuseNum,'ReuseNum',8,100);
    NewIntegerField(aCDS, fnS_rxReuseNum, 'ReuseNum', 8); // vhaishandria 050317
    NewTimeField(aCDS, fnS_rxTxLength, 'TxLength');
    TDateTimeField(aCDS.FieldList.Fields[aCDS.FieldCount - 1]).DisplayFormat :=
      'hh:nn';

    NewFloatField(aCDS, fnS_rxBFR, 'BFR');
    NewFloatField(aCDS, fnS_rxDialysisFlow, 'DFlow');
    NewFloatField(aCDS, fnS_rxTemp, 'Temp');
    NewFloatField(aCDS, fnS_rxUltra, 'Ultrafiltration');
    NewFloatField(aCDS, fnS_rxEDW, 'EDW');
    NewFloatField(aCDS, fnS_rxGoalWeight, 'Goal Weight');

    NewFloatField(aCDS, fnS_DF_K, 'DFK');
    NewFloatField(aCDS, fnS_DF_HCO3, 'DFHCO3');
    NewFloatField(aCDS, fnS_DF_NA, 'DFNA');
    NewFloatField(aCDS, fnS_DF_CA, 'DFCA');

    NewStringField(aCDS, fnS_AC_Type, 'ACType', 20, 100);
    NewFloatField(aCDS, fnS_AC_Load, 'ACLoad');
    NewFloatField(aCDS, fnS_AC_Doses, 'ACDoses');
    NewTimeField(aCDS, fnS_AC_EndTime, 'ACEndTime');
    TTimeField(aCDS.FieldList.Fields[aCDS.FieldCount - 1]).DisplayFormat :=
      'hh:MM:ss';

    NewStringField(aCDS, fnS_AC_Other, 'ACOther', 2000, 2000);

    NewFloatField(aCDS, fnS_MoD_NA, 'MODNA'); // See BUG Log Item 1213-154126.830
    NewFloatField(aCDS, fnS_MoD_HCO3, 'MODHCO3');
    NewFloatField(aCDS, fnS_Mod_Ultrafiltration, 'MODUF');
    NewStringField(aCDS, fnS_OtherOrders, 'RxOther', 2000, 2000);

    // Pre assesment  ==========================================================
    NewFloatField(aCDS, fnS_PreWeight, 'PreWeight'); // Real;
    NewFloatField(aCDS, fnS_PreDryWeight, 'PreDryWeight'); // Real;

    NewFloatField(aCDS, fnS_PreTemp, 'PreTemp'); // Real;

    NewIntegerField(aCDS, fnS_PreBPSysStanding, 'PreBPSysStand', 6); //Integer;
    NewIntegerField(aCDS, fnS_PreBPDiasStanding, 'PreBPDiasStand', 6); //Integer;
    NewIntegerField(aCDS, fnS_PreBPSysSitting, 'PreBPSysSit', 6); //Integer;
    NewIntegerField(aCDS, fnS_PreBPDiasSitting, 'PreBPDiasSit', 6); //Integer;
    NewIntegerField(aCDS, fnS_PrePulseStanding, 'PrePulseSanding', 6);
    // Integer;
    NewIntegerField(aCDS, fnS_PrePulseSeated, 'PrePulseSitting', 6); // Integer;

    // Patient Education
    NewBooleanField(aCDS, fnS_EDU, 'Educated'); // Boolean
    NewStringField(aCDS, fnS_EDUKey, 'EduKey', 8, 20); // String;
    NewStringField(aCDS, fnS_EDUInit, 'EduInit', 8, 20); // String;
    // Barriers to Learning
    NewBooleanField(aCDS, fnS_BTLNone, 'BTLNone');
    NewBooleanField(aCDS, fnS_BTLVisual, 'BTLVisual');
    NewBooleanField(aCDS, fnS_BTLDesire, 'BTLDesire');
    NewBooleanField(aCDS, fnS_BTLCognition, 'BTLCognition');
    NewBooleanField(aCDS, fnS_BTLReligious, 'BTLReligious');
    NewBooleanField(aCDS, fnS_BTLEmotional, 'BTLEmotional');
    NewBooleanField(aCDS, fnS_BTLLanguage, 'BTLLanguage');
    NewBooleanField(aCDS, fnS_BTLPhysical, 'BTLPhysical');

    //==========================================================================
    NewStringField(aCDS, fnS_PrePainTolerance, fnS_PrePainTolerance, 10, 10);
    NewIntegerField(aCDS, fnS_PrePain, 'PrePain', 6); // Integer;
    NewStringField(aCDS, fnS_PrePainLocation, 'PrePainLocation', 40, 40); //
    NewStringField(aCDS, fnS_PrePainAcute, 'PrePainAcute', 10, 10);
    NewStringField(aCDS, fnS_PrePainTreatment, 'PrePainTreatment', 40, 40); //
    NewStringField(aCDS, fnS_PrePainIASP, 'PrePainIASP', 40, 40); //;
    NewStringField(aCDS, fnS_PrePainIntensity, 'PrePainIntensity', 40, 40); //;
    NewStringField(aCDS, fnS_PrePainFrequencyText, 'PrePainFrequencyText', 40,
      40); //;
    NewStringField(aCDS, fnS_PrePainOnset, 'PrePainOnset', 40, 40); //;
    NewStringField(aCDS, fnS_PrePainDuration, 'PrePainDuration', 40, 40); //;
    NewStringField(aCDS, fnS_PrePainQuality, 'PrePainQuality', 40, 40); //;
    NewStringField(aCDS, fnS_PrePainImpact, 'PrePainImpact', 40, 40);
    NewStringField(aCDS, fnS_PrePainWorse, 'PrePainWorse', 40, 40);
    NewStringField(aCDS, fnS_PrePainRelieve, 'PrePainRelieve', 40, 40);
    NewStringField(aCDS, fnS_PrePainHelpMed, 'PrePainHelpMed', 40, 40);
    NewStringField(aCDS, fnS_PrePainOtherTreatments, 'PrePainOtherTreatments',
      40, 40);
    NewStringField(aCDS, fnS_PrePainOtherComments, 'PrePainOtherComments', 40,
      40);
    //==========================================================================

    NewBooleanField(aCDS, fnS_PreAlert, 'PreAlert'); // Boolean;
    NewBooleanField(aCDS, fnS_PreConfused, 'PreConfused'); // Boolean;
    NewBooleanField(aCDS, fnS_PreSedated, 'PreSedated'); // Boolean;
    NewBooleanField(aCDS, fnS_PreUnresposive, 'PreUnresponsive'); // Boolean;
    NewBooleanField(aCDS, fnS_PreLethargic, 'PreLethargic'); // Boolean;
    NewBooleanField(aCDS, fnS_PreRestless, 'PreResstless'); // Boolean;

    NewBooleanField(aCDS, fnS_PreAmbulatory, 'PreAmbulatory'); // Boolean;
    NewBooleanField(aCDS, fnS_PreOriented, 'PreOriented'); // Boolean;
    NewStringField(aCDS, fnS_PreOrientedText, 'PreOrientedText', 8, 20);

    // vhaishandria 2007-08-23 Transportation fields size increased
    NewStringField(aCDS, fnS_PreTransportation, 'PreTransportation', 8, 40{15});
    NewStringField(aCDS, fnS_PostTransportation, 'PostTransportation', 8, 40{15});

    NewBooleanField(aCDS, fnS_PreEdema, 'PreEdema'); // Boolean;
    NewIntegerField(aCDS, fnS_PreRespirations, 'PreResp', 6); // Integer;
    NewBooleanField(aCDS, fnS_PreSOB, 'PreSOB'); // Boolean;

    NewBooleanField(aCDS, fnS_TrnCandidate, 'Trn Candidate'); // Boolean;
    NewBooleanField(aCDS, fnS_TrnWIP, 'Trn WorkInPr'); // Boolean;
    NewBooleanField(aCDS, fnS_TrnReferred, 'Referred'); // Boolean;

    // Post assesment  =========================================================
    NewFloatField(aCDS, fnS_PostWeight, 'PostWeight'); // Real;
    NewFloatField(aCDS, fnS_PostDryWeight, 'PostDryWeight'); // Real;
    NewFloatField(aCDS, fnS_PostTemp, 'PostTemp', '##.#'); // Real;

    NewIntegerField(aCDS, fnS_PostBPSysStanding, 'PostBPSysStand', 6); //Integer;
    NewIntegerField(aCDS, fnS_PostBPDiasStanding, 'PostBPDiasStand', 6);
    //Integer;
    NewIntegerField(aCDS, fnS_PostBPSysSitting, 'PostBPSysSit', 6); //Integer;
    NewIntegerField(aCDS, fnS_PostBPDiasSitting, 'PostBPDiasSit', 6); //Integer;
    NewIntegerField(aCDS, fnS_PostPulseStanding, 'PostPulseStanding', 6);
    // Integer;
    NewIntegerField(aCDS, fnS_PostPulseSeated, 'PostPulseSitting', 6);
    // Integer;

  //==========================================================================
    NewStringField(aCDS, fnS_PostPainTolerance, fnS_PostPainTolerance, 10, 10);
    NewIntegerField(aCDS, fnS_PostPain, 'PostPain', 6); // Integer;
    NewStringField(aCDS, fnS_PostPainLocation, 'PostPainLocation', 40, 40); //
    NewStringField(aCDS, fnS_PostPainAcute, 'PostPainAcute', 10, 10);
    NewStringField(aCDS, fnS_PostPainTreatment, 'PostPainTreatment', 40, 40); //
    NewStringField(aCDS, fnS_PostPainIASP, 'PostPainIASP', 40, 40); //;
    NewStringField(aCDS, fnS_PostPainIntensity, 'PostPainIntensity', 40, 40); //;
    NewStringField(aCDS, fnS_PostPainFrequencyText, 'PostPainFrequencyText', 40,
      40); //;
    NewStringField(aCDS, fnS_PostPainOnset, 'PostPainOnset', 40, 40); //;
    NewStringField(aCDS, fnS_PostPainDuration, 'PostPainDuration', 40, 40); //;
    NewStringField(aCDS, fnS_PostPainQuality, 'PostPainQuality', 40, 40); //;
    NewStringField(aCDS, fnS_PostPainImpact, 'PostPainImpact', 40, 40);
    NewStringField(aCDS, fnS_PostPainWorse, 'PostPainWorse', 40, 40);
    NewStringField(aCDS, fnS_PostPainRelieve, 'PostPainRelieve', 40, 40);
    NewStringField(aCDS, fnS_PostPainHelpMed, 'PostPainHelpMed', 40, 40);
    NewStringField(aCDS, fnS_PostPainOtherTreatments, 'PostPainOtherTreatments',
      40, 40);
    NewStringField(aCDS, fnS_PostPainOtherComments, 'PostPainOtherComments', 40,
      40);
    //==========================================================================

    NewBooleanField(aCDS, fnS_PostAlert, 'PostAlert'); // Boolean;
    NewBooleanField(aCDS, fnS_PostConfused, 'PostConfused'); // Boolean;
    NewBooleanField(aCDS, fnS_PostSedated, 'PostSedated'); // Boolean;
    NewBooleanField(aCDS, fnS_PostUnresposive, 'PostUnresponcive'); // Boolean;
    NewBooleanField(aCDS, fnS_PostLethargic, 'PostLethargic'); // Boolean;
    NewBooleanField(aCDS, fnS_PostRestless, 'PostResstless'); // Boolean;

    NewBooleanField(aCDS, fnS_PostAmbulatory, 'PostAmbulatory'); // Boolean;
    NewBooleanField(aCDS, fnS_PostOriented, 'PostOriented'); // Boolean;
    NewStringField(aCDS, fnS_PostOrientedText, 'PostOrientedText', 8, 20);
    // String;

    NewBooleanField(aCDS, fnS_PostEdema, 'PostEdema'); // Boolean;
    NewIntegerField(aCDS, fnS_PostRespirations, 'PostResp', 6); // Integer;
    NewBooleanField(aCDS, fnS_PostSOB, 'PostSOB'); // Boolean;

    NewBooleanField(aCDS, fnS_POWeight, 'POWeight'); // Boolean
    NewBooleanField(aCDS, fnS_Medication, 'POMedication'); // Boolean
    NewBooleanField(aCDS, fnS_TlrVom, 'TlrVom'); // Boolean
    NewBooleanField(aCDS, fnS_TlrHyp, 'TlrHyp'); // Boolean
    NewBooleanField(aCDS, fnS_TlrSyn, 'TlrSyn'); // Boolean
    NewBooleanField(aCDS, fnS_TlrCram, 'TlrCram'); // Boolean //
    NewBooleanField(aCDS, fnS_TlrStable, 'TlrStable'); // Boolean //
    NewBooleanField(aCDS, fnS_TlrOther, 'TlrOther'); // String
    NewStringField(aCDS, fnS_TlrOtherDoc, 'TlrOtherDoc', 20, 2000); // String

    // Coversheet Totals
    NewFloatField(aCDS, fnS_BloodFlow, fnS_BloodFlow); // Real;
    NewFloatField(aCDS, fnS_AVP, fnS_AVP); //Real;
    NewFloatField(aCDS, fnS_VP_0, fnS_VP_0); // Real;
    NewFloatField(aCDS, fnS_VP_200, fnS_VP_200); // Real;

    // Safety
    NewBooleanField(aCDS, fnS_SafetyChecksOK, 'SafetyChecksOK'); // Boolean;
    //    NewBooleanField(aCDS,fnS_OrderVerified,'SafetyOrder'); // Boolean;
    //    NewBooleanField(aCDS,fnS_AlarmsChecked,'SafetyAlarm'); // Boolean;
    //    NewBooleanField(aCDS,fnS_DisenfectantNegative,'SafetyDI'); // Boolean;

        // Summary Totals

    NewFloatField(aCDS, fnS_TotalUF, 'TotUF'); // Real;
    NewFloatField(aCDS, fnS_TotalLP, 'TotLP'); // Real;
    NewFloatField(aCDS, fnS_TotalKT, 'TotKT'); // Real;
    NewFloatField(aCDS, fnS_TotalKTV, 'TotKTV'); // Real;
    NewFloatField(aCDS, fnS_TotalURR, 'TotURR'); // Real;
    NewFloatField(aCDS, fnS_TotalEUV, 'TotEUV'); // Real;

    NewFloatField(aCDS, fnS_MeanUFR, 'MeanURF'); // Real;
    NewFloatField(aCDS, fnS_MeanTMP, 'MeanTMP'); // Real;
    NewFloatField(aCDS, fnS_MeanTemp, 'MeanTemp'); // Real;
    NewFloatField(aCDS, fnS_MeanConductivity, 'MeanCond'); // Real;

    NewFloatField(aCDS, fnS_AverageBFR, 'AvrBFR'); // Real;
    NewFloatField(aCDS, fnS_AverageDFR, 'AvrDFR'); // Real;

    NewFloatField(aCDS, fnS_IABF, 'IABF'); // Real;
    NewFloatField(aCDS, fnS_AVP0, 'AVP0'); // Real;
    NewFloatField(aCDS, fnS_VP0, 'VP0'); // Real;
    NewFloatField(aCDS, fnS_VP200, 'VP200'); // Real;

    // Notes
    NewStringField(aCDS, fnS_PreNotes, 'PreNotes', 10000, 10000); // String;
    NewStringField(aCDS, fnS_PostNotes, 'PostNotes', 10000, 10000); // String;
    NewStringField(aCDS, fnS_WorkflowNotes, 'FlowNotes', 10000, 10000);
    // String;
    NewStringField(aCDS, fnS_LabNotes, 'LabNotes', 10000, 10000); // String;
    NewStringField(aCDS, fnS_SummaryNotes, 'SummaryNotes', 10000, 10000);
    // String;

    NewBooleanField(aCDS, fnS_LastRecord, 'LastRecord'); // Boolean;
    NewDateTimeField(aCDS, fnS_LastTimeUpdated, 'Last Time Updated', 22,
      gMDK_DateTimeFMT); // TDateTime;
// vhaishandria 2007-07-12 reserved for future ---------------------------------
//    NewDateTimeField(aCDS, fnS_LastTimeUpdatedRx, 'Last Time Updated Rx', 22,
//      gMDK_DateTimeFMT); // TDateTime;
//------------------------------------------------------------------------------
    NewStringField(aCDS, fnS_Machine, 'Machine', 12, 12); // String;
    NewStringField(aCDS, fnS_Station, 'Station', 12, 12); // String;
    NewStringField(aCDS, fnS_MachineType, 'MachineType', 12, 12); // String;

    NewStringField(aCDS, fnS_FallAssessment, fnS_FallAssessment, 1000, 1000);

    aCDS.CreateDataSet;

  except
  end;
end;

function addDefaultSummary(aCDS: TClientDataSet; aPatient, aStudy: string):
  Boolean;
(*
  function getDefault(aName:String):String;
  begin
    Result := dmData.getDictionaryDefault(aCDS.Name,aName);
  end;
*)
begin
  Result := False;
  try
    aCDS.Insert;
    aCDS.FieldByName(fnS_PatientID).AsString := aPatient;
    aCDS.FieldByName(fnS_SessionID).AsString := aStudy;
    aCDS.FieldByName(fnS_Date).AsDateTime := Now; // Summary Date

    aCDS.FieldByName(fnS_PreAlert).AsBoolean := False; //'PreAlert';
    aCDS.FieldByName(fnS_PreConfused).AsBoolean := False; //'PreConfused';
    aCDS.FieldByName(fnS_PreSedated).AsBoolean := False; //'PreSedated';
    aCDS.FieldByName(fnS_PreUnresposive).AsBoolean := False; //'PreUnresponsive';
    aCDS.FieldByName(fnS_PreLethargic).AsBoolean := False; //'PreLethargic';
    aCDS.FieldByName(fnS_PreRestless).AsBoolean := False; //'PreRestless';
    aCDS.FieldByName(fnS_PreAmbulatory).AsBoolean := False; //'PreRestless';
    aCDS.FieldByName(fnS_PreOriented).AsBoolean := False; //'PreRestless';

    aCDS.FieldByName(fnS_PreEdema).AsBoolean := False; //'PreEdema' ; // Boolean;
    aCDS.FieldByName(fnS_PreSOB).AsBoolean := False; //'PreSOB' ; // Boolean;

    aCDS.FieldByName(fnS_TrnCandidate).AsBoolean := False;
    //'TransCandidate' ; // Boolean;
    aCDS.FieldByName(fnS_TrnWIP).AsBoolean := False; //'TransWIP' ; // Boolean;
    aCDS.FieldByName(fnS_TrnReferred).AsBoolean := False;
    //'TransReffered' ; // Boolean;

    aCDS.FieldByName(fnS_TrnCandidate).AsBoolean := False;
    //'TransCandidate' ; // Boolean;
    aCDS.FieldByName(fnS_TrnWIP).AsBoolean := False; //'TransWIP' ; // Boolean;
    aCDS.FieldByName(fnS_TrnReferred).AsBoolean := False;
    //'TransReffered' ; // Boolean;

    aCDS.FieldByName(fnS_PostAlert).AsBoolean := False; //'PostAlert';
    aCDS.FieldByName(fnS_PostConfused).AsBoolean := False; //'PostConfused';
    aCDS.FieldByName(fnS_PostSedated).AsBoolean := False; //'PostSedated';
    aCDS.FieldByName(fnS_PostUnresposive).AsBoolean := False;
    //'PostUnresponsing';
    aCDS.FieldByName(fnS_PostLethargic).AsBoolean := False; //'PostLethargic';
    aCDS.FieldByName(fnS_PostRestless).AsBoolean := False; //'PostRestless';
    aCDS.FieldByName(fnS_PostAmbulatory).AsBoolean := False; //'PreRestless';
    aCDS.FieldByName(fnS_PostOriented).AsBoolean := False; //'PreRestless';

    aCDS.FieldByName(fnS_TlrVom).AsBoolean := False; // = 'TlrVom';// Boolean
    aCDS.FieldByName(fnS_TlrHyp).AsBoolean := False; // = 'TlrHyp';// Boolean
    aCDS.FieldByName(fnS_TlrSyn).AsBoolean := False; // = 'TlrSyn';// Boolean
    aCDS.FieldByName(fnS_TlrCram).AsBoolean := False; // = 'TlrCram';// Boolean
    aCDS.FieldByName(fnS_TlrStable).AsBoolean := False;
    // = 'TlrStable';// Boolean
    aCDS.FieldByName(fnS_TlrOther).AsBoolean := False; // = 'TlrOther';// Boolean

    aCDS.FieldByName(fnS_PostEdema).AsBoolean := False;
    //'PostEdema' ; // Boolean;
    aCDS.FieldByName(fnS_PostRespirations).AsString := '';
    //'PostResp' ; // Integer;
    aCDS.FieldByName(fnS_PostSOB).AsBoolean := False; //'PostSOB' ; // Boolean;

    aCDS.FieldByName(fnS_SafetyChecksOK).AsBoolean := False;
    {
        aCDS.FieldByName(fnS_OrderVerified).AsBoolean := False;
        aCDS.FieldByName(fnS_AlarmsChecked).AsBoolean := False;
    //    aCDS.FieldByName(fnS_DisenfectantNegative).AsBoolean := False;
        aCDS.FieldByName(fnS_DisenfectantNegative).AsString :=
          getDefault(fnS_DisenfectantNegative);
    }
    aCDS.FieldByName(fnS_MeanUFR).AsFloat := 0.0;
    aCDS.FieldByName(fnS_MeanTMP).AsFloat := 0.0;
    aCDS.FieldByName(fnS_MeanTemp).AsFloat := 0.0;
    aCDS.FieldByName(fnS_MeanConductivity).AsFloat := 0.0;
    aCDS.FieldByName(fnS_TotalUF).AsFloat := 0.0;
    aCDS.FieldByName(fnS_TotalLP).AsFloat := 0.0;
    aCDS.FieldByName(fnS_TotalKT).AsFloat := 0.0;
    aCDS.FieldByName(fnS_TotalKTV).AsFloat := 0.0;
    //    aCDS.FieldByName(fnS_TotalURR).AsFloat := 0.0;
    aCDS.FieldByName(fnS_AverageBFR).AsFloat := 0.0;
    aCDS.FieldByName(fnS_AverageDFR).AsFloat := 0.0;

    // Barriers to Learning
    aCDS.FieldByName(fnS_BTLNone).AsBoolean := False; //'BTLNone');
    aCDS.FieldByName(fnS_BTLVisual).AsBoolean := False; //'BTLVisual');
    aCDS.FieldByName(fnS_BTLDesire).AsBoolean := False; //'BTLDesire');
    aCDS.FieldByName(fnS_BTLCognition).AsBoolean := False; //'BTLCognition');
    aCDS.FieldByName(fnS_BTLReligious).AsBoolean := False; //'BTLReligious');
    aCDS.FieldByName(fnS_BTLEmotional).AsBoolean := False; //'BTLEmotional');
    aCDS.FieldByName(fnS_BTLLanguage).AsBoolean := False; //'BTLLanguage');
    aCDS.FieldByName(fnS_BTLPhysical).AsBoolean := False; //'BTLPhysical');

    aCDS.FieldByName(fnS_LastRecord).AsBoolean := False; //'BTLPhysical');

    aCDS.FieldByName(fnS_PrePainTolerance).AsString := 'Yes';
    aCDS.FieldByName(fnS_PostPainTolerance).AsString := 'Yes';

    aCDS.FieldByName(fnS_EDU).AsBoolean := False;
    aCDS.FieldByName(fnS_POWeight).AsBoolean := False;
    aCDS.FieldByName(fnS_Medication).AsBoolean := False;
    aCDS.Post;
  except
    Result := False;
  end;
end;

end.
