unit uMDK_Timeline;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
*       Site Name:    Hines OIFO
*       Date Created: 3/17/07
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Timeline object
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Objects/uMDK_Timeline.pas $
*
*       $ History: uMDK_Timeline.pas $
}

interface
uses
  DB, DBClient;

const
  fnTL_EventID = 'ID';
  fnTL_EventType = 'EventType';

  fnTL_DateTime = 'DateTime';
  //  fnTL_Date = 'DateOnly';
  //  fnTL_Time = 'TimeOnly';

  fnTL_Actor = 'Actor';
  fnTL_Action = 'Action';

  fnTL_InstanceType = 'InstanceType';
  fnTL_InstanceID = 'InstanceID';
  fnTL_Description = 'Description';
  fnTL_Comments = 'Comments';

  fnTL_ViewInReport = 'Report';

procedure CreateTimelineCDS(aCDS: TClientDataSet);

implementation
uses
  uMDK_CDSCommon
  ;

procedure CreateTimelineCDS(aCDS: TClientDataSet);
begin
  try
    NewStringField(aCDS, fnTL_EventID, '#', 4, LENGTH_ID);
    NewStringField(aCDS, fnTL_EventType, 'Type', 4, LENGTH_ID);

    //    NewDateTimeField(aCDS, fnTL_Date, 'Date', 8, gMDK_DateFMT);
    //    NewDateTimeField(aCDS, fnTL_Time, 'Time', 8, gMDK_TimeFMT);
    NewDateTimeField(aCDS, fnTL_DateTime, 'Timestamp', 8, gMDK_DateTimeFMT);

    NewStringField(aCDS, fnTL_Actor, fnTL_Actor, 20, LENGTH_NAME);
    NewStringField(aCDS, fnTL_Action, fnTL_Action, 20, LENGTH_NAME);

    NewStringField(aCDS, fnTL_InstanceType, fnTL_InstanceType, 12, LENGTH_ID);
    NewStringField(aCDS, fnTL_InstanceID, fnTL_InstanceID, 12, LENGTH_ID);

    NewStringField(aCDS, fnTL_Description, fnTL_Description, 40,
      LENGTH_Description);
    NewStringField(aCDS, fnTL_Comments, fnTL_Comments, 200, LENGTH_COMMENTS);

    NewBooleanField(aCDS, fnTL_ViewInReport, fnTL_ViewInReport);

    aCDS.CreateDataSet;

    //    aCDS.AddIndex(fnTL_Date + '_Index', fnTL_Date + ';' + fnTL_Time,
    //      [ixDescending]);
    //    aCDS.IndexFieldNames := fnTL_Date + ';' + fnTL_Time;

    aCDS.AddIndex(fnTL_DateTime + '_Index', fnTL_DateTime, [ixDescending]);

    aCDS.IndexDefs.Update;
  except
  end;
end;

end.
