unit uMDK_Workflow;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 9/28/07 10:38a $
*       Site Name:    Hines OIFO
*       Date Created: 3/17/07
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     Workflow object
*       Notes:
*
================================================================================
}

interface
uses
  DB, DBClient;

procedure setWorkflowFields(aCDS: TClientDataSet);
procedure setupWorkflowCDS(aCDS: TClientDataSet);

implementation
uses
  uMDK_Flowsheet
  , uMDK_MedList
  , uMDK_FieldFactory
  , SysUtils
  , uMDK_Notes;

procedure setWorkflowFields(aCDS: TClientDataSet);
var
  ii, i: Integer;
begin
  try
    TFieldFactory.setIDFields(aCDS);
    TFieldFactory.setTimeStampFields(aCDS);
    TFieldFactory.setStatusFields(aCDS);

    TFieldFactory.setDescriptionFields(aCDS);

    setFlowSheetSpecificFields(aCDS);
    ii := aCDS.Fields.Count - 1;
    setMedListSpecificFields(aCDS);
    setNoteListSpecificFields(aCDS);

    for i := ii to aCDS.Fields.Count - 1 do
      aCDS.Fields[i].Visible := False;

  except
    raise Exception.Create('setForkflowFields Error');
  end;
end;

procedure setupWorkflowCDS(aCDS: TClientDataSet);
begin
  try
    setWorkflowFields(aCDS);
    aCDS.CreateDataSet;
    aCDS.AddIndex(FN_DATETIME + '_Index', FN_DATETIME, [ixDescending]);
    aCDS.IndexDefs.Update;
    aCDS.IndexName := FN_DATETIME + '_Index';
  except
    raise Exception.Create('setForkflowCDS Error');
  end;
end;

end.
