unit uMDK_PainCollector;

interface
uses
  iMDK_Assessment
  , Forms
  , Controls
  ;

type
  TSrvPainCollector = class(TInterfacedObject, I_Assessment)
  private
    fAssessmentType: Integer;
    fReportKW: string;
    procedure setAssessmentType(aValue: Integer);
  public
    property AssessmentType: Integer read fAssessmentType write
      setAssessmentType;

    function getAssessmentText: string;
    function updateAssessmentText(aText: string): string;

    function _AddRef: Integer; stdcall;
    function _Release: Integer; stdcall;
  end;

function NewSrvPainCollector(aType: Integer):
  TSrvPainCollector;

implementation

uses
  dMDK_Data, uMDK_Summary, uMDK_Engine, SysUtils, fMDK_PainAssessmentDLG,
  uMDK_ReportEngine;

function NewSrvPainCollector(aType: Integer):
  TSrvPainCollector;
begin
  Result := TSrvPainCollector.Create;
  Result.AssessmentType := aType;
  case aType of
    0: Result.fReportKW := kw_PrePainReport;
    1: Result.fReportKW := kw_PostPainReport;
  end;
end;

////////////////////////////////////////////////////////////////////////////////

function TSrvPainCollector._AddRef;
begin
  result := -1;
end;

function TSrvPainCollector._Release;
begin
  result := -1;
end;

procedure TSrvPainCollector.setAssessmentType(aValue: Integer);
begin
  fAssessmentType := aValue;
end;

function TSrvPainCollector.getAssessmentText: string;
begin
  Result := getPatternValue(fReportKW);
end;

function TSrvPainCollector.updateAssessmentText(aText: string): string;
var
  i: Integer;
begin
  Result := aText;
  i := UpdatePainData(fAssessmentType);
  if i <> mrCancel then
    Result := getAssessmentText;
end;

end.
