unit fMDK_Cover;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 10/07/08 1:30p $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  Contains the Application Cover form
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Build309/Tabs/fMDK_Cover.pas $
*
*       $ History: fMDK_Cover.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, DBCtrls, DB
  , uMDK_Info
  , XMLIntf, ActnList, Buttons
  , Grids, DBGrids, Mask, Menus
  , frMDK_TIUNotes, DBClient, ImgList
  , uMDK_GeneralInfoCollector, fr_Simple, frMDK_Assessment
  ;

type
  TfrmCover = class(TForm)
    pnlCover: TPanel;
    ActionList1: TActionList;
    acGetInfectionData: TAction;
    acSelectProvider: TAction;
    Panel2: TPanel;
    pnlPostingsAndInfectiousDeseases: TPanel;
    pnlTreatmentInfo: TPanel;
    pnlInfo: TPanel;
    Label18: TLabel;
    Label33: TLabel;
    Label34: TLabel;
    Label35: TLabel;
    Label36: TLabel;
    Label38: TLabel;
    Label40: TLabel;
    pnlSchedule: TPanel;
    Bevel11: TBevel;
    Label17: TLabel;
    cbReadOnly: TCheckBox;
    pnlTransplantStatus: TPanel;
    dbcWIP: TDBCheckBox;
    dbcReferred: TDBCheckBox;
    rbNonCandidate: TRadioButton;
    rbCandidate: TRadioButton;
    acReadOnly: TAction;
    dbeCTDate: TDBEdit;
    dbeDiagnosisDate: TDBEdit;
    dbcESRD: TDBComboBox;
    dbeInitialTherapy: TDBEdit;
    dbcModality: TDBComboBox;
    dbcCodeStatus: TDBComboBox;
    btnSelectProvider: TBitBtn;
    pnlTreatmentHistory: TPanel;
    scbDetails: TScrollBox;
    pnlInfectiousDiseases: TPanel;
    mmPostings: TRichEdit;
    spltDetails: TSplitter;
    pnlDiseases: TPanel;
    pnlInfectiousToolbar: TPanel;
    tvVaccination: TTreeView;
    Label2: TLabel;
    pnlPostingsToolbar: TPanel;
    lblDetailsTitle: TLabel;
    pnlPostings: TPanel;
    PopupMenu: TPopupMenu;
    acFormat: TAction;
    Format1: TMenuItem;
    dbcbMon: TDBCheckBox;
    dbcbTue: TDBCheckBox;
    dbcbWed: TDBCheckBox;
    dbcbTh: TDBCheckBox;
    dbcbFri: TDBCheckBox;
    dbcbSat: TDBCheckBox;
    dbcbSun: TDBCheckBox;
    Splitter1: TSplitter;
    Bevel1: TBevel;
    Label5: TLabel;
    pnlCurrentTreatmentToolbar: TPanel;
    Label12: TLabel;
    pnlPatientHistory: TPanel;
    pnlTreatmentHistoryToolbar: TPanel;
    Label13: TLabel;
    pnlSelectedStudyToolbar: TPanel;
    Label14: TLabel;
    pgcHistory: TPageControl;
    tsSummary: TTabSheet;
    pnlPast: TPanel;
    pnlTiming: TPanel;
    Bevel5: TBevel;
    Label170: TLabel;
    Label353: TLabel;
    Label6: TLabel;
    Label156: TLabel;
    dbtStarted: TDBText;
    dbtFinished: TDBText;
    dbtDInstrument: TDBText;
    dbtDAdjusted: TDBText;
    Label7: TLabel;
    Panel15: TPanel;
    Bevel6: TBevel;
    Label84: TLabel;
    Label1: TLabel;
    Label4: TLabel;
    Label96: TLabel;
    Label98: TLabel;
    Label199: TLabel;
    Label3: TLabel;
    Label45: TLabel;
    Label37: TLabel;
    Label146: TLabel;
    dbtPreBPseat: TDBText;
    dbtPreBPStand: TDBText;
    dbtSH_PostPulse: TDBText;
    dbtSH_PostTemp: TDBText;
    dbtSH_PostWeight: TDBText;
    lblUPostBPSeat: TLabel;
    lblUPostBPStand: TLabel;
    dbtPostBPStand: TDBText;
    dbtPostBPSeat: TDBText;
    lblUPostPulse: TLabel;
    lblUPostPulseStanding: TLabel;
    lblUPostTemp: TLabel;
    lblUPostWeight: TLabel;
    lblUGoalWeight: TLabel;
    dbtSH_GoalWeight: TDBText;
    dbtSH_PreWeight: TDBText;
    dbtSH_PreTemp: TDBText;
    dbtSH_PostPulseStanding: TDBText;
    dbtSH_PrePulse: TDBText;
    dbtSH_PrePulseStanding: TDBText;
    pnlSummary: TPanel;
    Bevel4: TBevel;
    Label173: TLabel;
    Label175: TLabel;
    Label181: TLabel;
    Label183: TLabel;
    Label177: TLabel;
    Label179: TLabel;
    Label185: TLabel;
    Label187: TLabel;
    Label189: TLabel;
    Label192: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    dbtTotUF: TDBText;
    dbtTotLP: TDBText;
    dbtmeanURF: TDBText;
    dbtMeanTMP: TDBText;
    dbtAvBFR: TDBText;
    dbtAvDFR: TDBText;
    dbtMeanTemp: TDBText;
    dbtMeanConduct: TDBText;
    dbtTotKT: TDBText;
    dbtTotKTV: TDBText;
    dbtURR: TDBText;
    dbtEstVol: TDBText;
    Panel6: TPanel;
    dbtStudyNumber: TDBText;
    cds: TClientDataSet;
    ds: TDataSource;
    ilStatus: TImageList;
    dbeNephrologist: TDBEdit;
    acDiagnosisDate: TAction;
    acTherapyDate: TAction;
    bbDiagnosisDate: TBitBtn;
    bbInitialTherapy: TBitBtn;
    acTreatmentDate: TAction;
    Panel1: TPanel;
    bbTreatmentDate: TBitBtn;
    GeneralInfo: TfrAssessment;
    ActionList2: TActionList;
    acPrint: TAction;
    PrintDialog1: TPrintDialog;
    imgDemoBackground: TImage;
    Panel3: TPanel;
    SpeedButton2: TSpeedButton;
    lblSelectedStudy: TLabel;
    CoverMainMenu: TMainMenu;
    miDocuments: TMenuItem;
    Print1: TMenuItem;
    dbtSelectedDate: TDBText;
    Bevel2: TBevel;
    dbtStudySessionDate: TDBEdit;
    splInfo: TSplitter;
    pnlInfoAssessment: TPanel;
    procedure FormCreate(Sender: TObject);
    procedure rbNonCandidateClick(Sender: TObject);
    procedure mmPostingsSelectionChange(Sender: TObject);
    procedure acGetInfectionDataExecute(Sender: TObject);
    procedure acSelectProviderExecute(Sender: TObject);
    procedure acReadOnlyExecute(Sender: TObject);
    procedure dbeDiagnosisDateChange(Sender: TObject);
    procedure dbeCTDateContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure dbeCTDateEnter(Sender: TObject);
    procedure dbeCTDateExit(Sender: TObject);
    procedure acFormatExecute(Sender: TObject);
    procedure acDiagnosisDateExecute(Sender: TObject);
    procedure acTherapyDateExecute(Sender: TObject);
    procedure acTreatmentDateExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure acPrintExecute(Sender: TObject);
    procedure pgcHistoryChange(Sender: TObject);
  private
    { Private declarations }
    DBG: TDBGrid;
    fField: TField;
    fActive: TObject;
    fIgnore: Boolean;

    fAllergiesTxt: string;
    fDirectivesTxt: string;
    fWarningsTxt: string;
    fVaccinationTxt: string;

{$IFDEF GENERALINFO_FRAME}
    fGeneralInfoCollector: TSrvGeneralInfoCollector;
{$ENDIF}

    procedure setWarnings(aValue: string);
    procedure setAllergies(aValue: string);
    procedure setDirectives(aValue: string);
    procedure setVaccination(aValue: string);

    procedure setMemo;
    procedure setMemoItem(aName, aValue, aDefault: string);
    procedure mapFields;
    procedure setUpLayout;
    procedure dbgHistoryDrawColumnCell(Sender: TObject;
      const Rect: TRect; DataCol: Integer; Column: TColumn;
      State: TGridDrawState);
  public
    { Public declarations }
    property Ignore: Boolean read fIgnore write fIgnore;

    property AllergiesTxt: string read fAllergiesTXT write setAllergies;
    property DirectivesTxt: string read fDirectivesTXT write setDirectives;
    property WarningsTxt: string read fWarningsTXT write setWarnings;
    property VaccinationTxt: string read fVaccinationTXT write setVaccination;

    procedure ReportStatus;
    procedure ReloadData;
    procedure RefreshGUI;
    procedure setReadOnly(aReadOnly: Boolean);
    procedure DBGridDblClick(Sender: TObject);
    procedure RefreshTIU;
    procedure dbgKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure ActivateTabForm;
    procedure SaveData;
    function canDeactivate(var Reason: string): Boolean;
    function getMainMenu: TMainMenu;
    procedure setMainMenuVisible(aValue: Boolean);
  end;

var
  frmCover: TfrmCover;

implementation

uses uROR_CommonUtils, dMDK_Data, uMDK_Engine, uMDK_Summary, uXML,
  uMDK_Common, uMDK_Options, uMDK_CDSCommon, fMDK_SelectProvider,
  uMDK_ReportEngine, uMDK_Dictionary, fMDK_DictionaryEdit
  , Printers
  , fMDK_Submit
  , uMDK_Notes
  , fMDK_DateTimeSelector
  , fMDK_Studies;

{$R *.dfm}

function IsValidDateString(aString: string): Boolean;
begin
  Result := False;
  try
    StrToDateTime(aString);
    Result := True;
  except
  end;
end;

procedure TfrmCover.mapFields;
begin
  dbtStudySessionDate.DataField := fnS_SessionDate;  // Summary Session Date
  dbtStudyNumber.DataField := fnS_SessionID;
  dbeCTDate.DataField := fnI_StudyDate; // Study Info Date
  dbcESRD.DataField := fnI_Diagnosis;
  dbeDiagnosisDate.DataField := fnI_DiagnosisDate;
  dbeInitialTherapy.DataField := fnI_TherapyDate;
  dbcModality.DataField := fnI_Modality;
  dbcCodeStatus.DataField := fnI_CodeStatus;
  dbeNephrologist.DataField := fnI_Nephrologist;
  //  dbtAD.DataField := fnI_AD;
  dbcbMon.DataField := fnI_Mon;
  dbcbTue.DataField := fnI_Tue;
  dbcbWed.DataField := fnI_Wed;
  dbcbTh.DataField := fnI_Thu;
  dbcbFri.DataField := fnI_Fri;
  dbcbSat.DataField := fnI_Sat;
  dbcbSun.DataField := fnI_sun;

  dbtSH_PreWeight.DataField := fnS_PreWeight;
  dbtSH_PostWeight.DataField := fnS_PostWeight;
  //  dbtSH_GoalWeight.DataField := fnS_GoalWeight;
  dbtSH_GoalWeight.DataField := fnS_RxGoalWeight;
  //  dbtSH_GoalWeight.DataField := fnS_RxEDW;
  dbtSH_PreTemp.DataField := fnS_PreTemp;
  dbtSH_PrePulse.DataField := fnS_PrePulseSeated;
  dbtSH_PrePulseStanding.DataField := fnS_PrePulseStanding;
  dbtSH_PostTemp.DataField := fnS_PostTemp;
  dbtSH_PostPulse.DataField := fnS_PostPulseSeated;
  dbtSH_PostPulseStanding.DataField := fnS_PostPulseStanding;

  // Transplant Status /////////////////////////////////////////////////////////
  dbcWIP.DataField := fnS_TrnWIP;
  dbcReferred.DataField := fnS_TrnReferred;

  //  dbeLastAccess.DataField := fnI_LastUser;
  //  dbeLastAccessTime.DataField := fnI_LastOpened;

  dbtStarted.DataField := fnS_TreatmentStarted;
  dbtFinished.DataField := fnS_TreatmentFinished;
  dbtDInstrument.DataField := fnS_TreatmentDuration;
  dbtDAdjusted.DataField := fnS_TreatmentDurationManual;

  dbtTotUF.DataField := fnS_TotalUF;
  dbtTotLP.DataField := fnS_TotalLP;
  dbtMeanURF.DataField := fnS_MeanUFR;
  dbtMeanTMP.DataField := fnS_MeanTMP;

  dbtAvDFR.DataField := fnS_AverageDFR;
  dbtAvBFR.DataField := fnS_AverageBFR;

  dbtMeanConduct.DataField := fnS_MeanConductivity;
  dbtMeanTemp.DataField := fnS_MeanTemp;
  dbtTotKTV.DataField := fnS_TotalKTV;
  dbtTotKT.DataField := fnS_TotalKT;
  dbtURR.DataField := fnS_TotalURR;
  dbtEstVol.DataField := fnS_TotalEUV; // vhaishandria 20070531

  dbtSelectedDate.DataField := fnS_SessionDate;

//  FrameMDK_TIUNotes.pnlTools.Parent := FrameMDK_TIUNotes.sbxCanvas;
//  FrameMDK_TIUNotes.pnlTools.Align := alTop;
//  FrameMDK_TIUNotes.pnlTools.Visible :=
    Preferences.bValue(onShowPatientTreatmentHistory);
end;

procedure TfrmCover.FormCreate(Sender: TObject);

  function CreateHistoryDBG(aParent: TWinControl): TDBGrid;
  var
    _DBG: TDBGrid;

    procedure setupColumn(aTitleCaption, aFieldName: string; aWidth: Integer =
      65; aColor: TColor = clNavy);
    var
      DBC: TColumn;
    begin
      DBC := _DBG.Columns.Add;

      DBC.Font.Color := aColor;
      DBC.Title.Caption := aTitleCaption;
      DBC.Title.Alignment := taRightJustify;
      DBC.Alignment := taRightJustify;
      DBC.Width := aWidth;
      DBC.FieldName := aFieldName;
    end;

  begin
    _DBG := TDBGrid.Create(aParent);
    _DBG.Parent := pnlTreatmentHistory;
    _DBG.Align := alClient;
    _DBG.ParentColor := True;
    _DBG.Ctl3D := False;
    _DBG.ReadOnly := True;
    _DBG.BorderStyle := bsNone;
    _DBG.FixedColor := Preferences.iValue(onReadOnlyFieldColor);
    _DBG.Options := _DBG.Options - [dgColLines, dgTabs] + [dgRowSelect];
    _DBG.OnDblClick := DBGridDblClick;
    _DBG.OnDrawColumnCell := dbgHistoryDrawColumnCell;
    _DBG.OnKeyDown := dbgKeyDown;

    setupColumn('Check In Date', fnS_SessionDate, 75, clWindowText);
    setupColumn('IA BF', fnS_IABF);
    setupColumn('APV @ 0', fnS_AVP0);
    setupColumn('VP @ 0', fnS_VP0);
    setupColumn('VP @ 200', fnS_VP200, 75);
    setupColumn('Study #', fnS_SessionID, 50);
    setupColumn('Comments', 'Comments', 75);

    _DBG.DataSource := dmData.dsStudyHistory;
    _DBG.Show;
    Result := _DBG;
  end;

begin
  fIgnore := true;

  mapFields;
  DBG := CreateHistoryDBG(pnlTreatmentHistory);

{$IFDEF GENERALINFO_FRAME}
  fGeneralInfoCollector := newSrvGeneralInfoCollector;
  GeneralInfo.setAssessmentInterface(fGeneralInfoCollector);
  GeneralInfo.setAssessmentCaption('General Information');
  pnlInfoAssessment.Visible := True;
  pnlTreatmentInfo.Visible := False;
{$ELSE}
  pnlInfoAssessment.Visible := False;
  splInfo.Visible := False;
  pnlPostingsAndInfectiousDeseases.Align := alClient;
{$ENDIF}

  fIgnore := False;
end;

procedure TfrmCover.setMemoItem(aName, aValue, aDefault: string);
var
  iLen: Integer;
begin
  fIgnore := True;
  with mmPostings do
    begin
      iLen := Length(aName);
      Lines.Add(aName);
      SelStart := SelStart - iLen - 2;
      SelLength := iLen;

      if aValue = '' then
        Lines.Add(aDefault)
      else
        Lines.Add(aValue);
    end;
  fIgnore := False;
end;

procedure TfrmCover.setMemo;
begin
  fIgnore := True;
  with mmPostings do
    begin
      Clear;
      setMemoItem('Allergies', fAllergiesTXT, 'None');
      setMemoItem('Clinical Warnings', fWarningsTXT, 'None');
      setMemoItem('Advanced Directives', fDirectivesTXT, 'None');
    end;
  fIgnore := False;
end;

procedure TfrmCover.setVaccination(aValue: string);
var
  aSL: TStringList;
  sItem, sDate, sValue, sReaction,
    s: string;
  i: Integer;

  sMG,
    sTB,
    sPPD,
    sHepA,
    sHepB,
    sHepBSAntigen,
    sHepBSAntibody,
    sHepBVac,
    sHepC,
    sHepCSAntibody,
    sVac,
    sPN,
    sInfl: string;
{$IFDEF AANTEST}
  tnUnknown,
{$ENDIF}
  tnHA, tnHB, tnHC, tnVac, tnTB,
    tnHBSB, tnHBSAG, tnHBV, tnHCSA,
    tnPPD, tnInfl, tnPne, tvn: TTreeNode;

  function findNode(aKey: string): TTreeNode;
  var
    j: Integer;
  begin
    Result := nil;
    for j := 0 to tvVaccination.Items.Count - 1 do
      if piece(tvVaccination.Items[j].Text, '--', 1) = piece(aKey, '--', 1) then
        begin
          Result := tvVaccination.Items[j];
          exit;
        end;
  end;

  function findMatch(aKey: string): TTreeNode;
  var
    ss: string;
    kn: TTreeNode;
  begin
    kn := nil;
    ss := piece(aKey, '^', 1);
    if ss = 'PPD' then
      kn := tnPPD
    else if ss = 'HEPATITIS A' then
      kn := tnHA
    else if ss = 'HEPATITIS B' then
      kn := tnHBV
    else if ss = 'FLU' then
      kn := tnInfl
    else if ss = 'PNEUMOCOCCAL' then
      kn := tnPne
        ;
    Result := kn;
  end;

  procedure BlankNode(aNode: TTreeNode);
  const
    ss = 'No data available';
  begin
    if aNode.Count <> 0 then
      exit;
    aNode.Text := aNode.Text + ' -- ' + ss;
    aNode.Collapse(True);
  end;

  procedure BlankLabNode(aNode: TTreeNode);
  const
    ss = 'No data available. Check Lab Results.';
  begin
    if aNode.Count <> 0 then
      exit;
    aNode.Text := aNode.Text + ' -- ' + ss;
    aNode.Collapse(True);
  end;

const
  _Hep_A =      'Hepatitis A';
  _Hep_B =      'Hepatitis B';
  _Hep_B_SAg =  'Surface Antigen';
  _Hep_B_SAb =  'Surface Antibody';
  _Hep_B_V =    'Hepatitis B Vaccine Series';
  _Hep_C =      'Hepatitis C';
  _Hep_C_SAb =  'Surface Antibody';
  _TB =         'TB';
  _PPD =        'PPD';
  _Vac =        'Vaccines';
  _Infl =       'Influenza';
  _PV =         'Pneumococcal Vaccine';
  _NDA =        '    No data available';
  _NDALab =     '    No data available. Check Lab Results.';
  _Tab_ =       '    ';

function CheckNoData(aValue,aDefault,aNDA:String):String;
begin
  Result := aValue;
  if trim(aValue)=trim(aDefault) then
    Result := Result + aNDA;
end;

begin
  fVaccinationTXT := aValue;

  sMG :=            _Tab_ + _Tab_;
  sHepA :=          _Hep_A;
  sHepB :=          _Hep_B;
  sHepBSAntigen :=  _Tab_ + _Hep_B_SAg;
  sHepBSAntibody := _Tab_ + _Hep_B_SAb;
  sHepBVac :=       _Tab_ + _Hep_B_V;
  sHepC :=          _Hep_C;
  sHepCSAntibody := _Tab_ + _Hep_C_SAb;
  sTB :=            _TB;
  sPPD :=           _Tab_ + _PPD;
  sVac :=           _Vac;
  sInfl :=          _Tab_ + _Infl;
  sPN :=            _Tab_ +_PV;

  tvVaccination.Items.Clear;
  with tvVaccination do
    begin
      tnHA := Items.AddChild(nil, _Hep_A);

      tnHB := Items.AddChild(nil, _Hep_B);
      tnHBSB := Items.AddChild(tnHB, _Hep_B_Sab);
      tnHBSAG := Items.AddChild(tnHB, _Hep_B_Sag);
      tnHBV := Items.AddChild(tnHB, _Hep_B_V);

      tnHC := Items.AddChild(nil, _Hep_C);
      tnHCSA := Items.AddChild(tnHC, _Hep_C_SAb);

      tnTB := Items.AddChild(nil, _TB);
      tnPPD := Items.AddChild(tnTB, _PPD);

      tnVac := Items.AddChild(nil, _Vac);
      tnInfl := Items.AddChild(tnVac, _Infl);
      tnPne := Items.AddChild(tnVac, _PV);

{$IFDEF AANTEST}
      tnUnknown := Items.AddChild(nil, 'Unknown');
{$ENDIF}
    end;

  aSL := TStringList.Create;
  aSL.Text := aValue;
  try
    for i := 0 to aSL.Count - 1 do
      begin
        try
          s := aSL[i];
          if pos('Vaccination:', s) = 1 then
            continue;

          sItem := Piece(s, '^', 1);
          sValue := Piece(s, '^', 2);
          sReaction := Piece(s, '^', 3);
          if sReaction <> '' then
            sReaction := ' (' + sReaction + ')';
          if pos('.', sValue) = 0 then
            sValue := sValue + '.0'; // Patch vhaishandria 050414

          try
            sDate := FormatDateTime(gMDK_DateFMT,
            FMDateTimeToWindowsDateTime(StrToFloat(sValue)));
          except
            sDate := 'Unknown';
          end;
        except
        end;

        tvn := FindMatch(s);
        if tvn <> nil then
          begin
            s := sItem + ' -- ' + sDate{$IFDEF AANTEST} + '  ' + sReaction{$ENDIF};

            if tvn = tnPPD then
              sPPD := sPPD + _CR_+'<' + sMG + s + '>'{ + _CR_}

            else if tvn = tnHA then
              sHepA := sHepA +  _CR_+'<' + sMG + s + '>'{ + _CR_}
            else if tvn = tnHB then
              sHepB := sHepB +  _CR_+'<' + sMG + s + '>'{ + _CR_}
            else if tvn = tnHBV then
              sHepBVac := sHepBVac +  _CR_+'<' + sMG + s + '>'{ + _CR_}
            else if tvn = tnInfl then
              sInfl := sInfl +  _CR_+'<' + sMG + s + '>'{ + _CR_}
            else if tvn = tnPNE then
              sPN := sPN +  _CR_+'<' + sMG + s + '>'{ + _CR_};

            tvVaccination.Items.AddChild(tvn, s);
          end
{$IFDEF AANTEST}
        else
          tvVaccination.Items.AddChild(tnUnknown, s);
{$ENDIF}
      end;
  except
  end;
  aSL.Free;

  tnHA.Expand(False);
  tnHB.Expand(False);
  tnHC.Expand(False);
  tnPPD.Expand(False);
  tnVac.Expand(False);
  tnTB.Expand(False);

  BlankNode(tnHA); // := Items.AddChild(nil,'Hepatitis A');
  BlankNode(tnHB); //  tnHB := tvn;
  BlankLabNode(tnHBSB); //  tnHBSB := Items.AddChild(tvn,'Surface Antibody');
  BlankLabNode(tnHBSAG); // tnHBSAG := Items.AddChild(tvn,'Surface Antigen');
  BlankNode(tnHBV); // tnHBV := Items.AddChild(tvn,'Hepatitis B Vaccine Series');
  BlankNode(tnHC); //  tnHC := tvn;
  BlankLabNode(tnHCSA); //  tnHCSA := Items.AddChild(tvn,'Surface Antibody');
  BlankNode(tnPPD); //  tnPPD := Items.AddChild(tvn,'PPD');
  BlankNode(tnInfl); //  tnInfl := Items.AddChild(tvn,'Influenza');
  BlankNode(tnPne); //  tnPne := Items.AddChild(tvn,'Pneumococcal Vaccine');

  tvVaccination.FullCollapse;
  tnHA.Collapse(false);
  tnHB.Collapse(false);
  tnHC.Collapse(false);

  if not Preferences.bValue(onShowInfectionTree) then
    begin
      setMemoItem('Infectious Diseases',
        CheckNoData(sHepA,_Hep_A,_NDA) + _CR_+
//        CheckNoData(sHepB,_Hep_B,_NDA) +  _CR_+
        sHepB +  _CR_+
        CheckNoData(sHepBSAntigen,_Hep_B_SAg,_CR_+_Tab_+'<'+_NDALab+'>') + _CR_+
        CheckNoData(sHepBSAntibody,_Hep_B_SAb,_CR_+_Tab_+'<'+_NDALab+'>') + _CR_+
        CheckNoData(sHepBVac,_Hep_B_V,_NDA) + _CR_+  sHepC + _CR_+
        CheckNoData(sHepCSAntibody,_Hep_C_SAb,_CR_+_Tab_+'<'+_NDALab+'>') + _CR_+
        sTB + _CR_+
        CheckNoData(sPPD,_PPD,_NDA) + _CR_+
        sVac+ _CR_+
        CheckNoData(sInfl,_Infl,_NDA) + _CR_+
        CheckNoData(sPN,_PV,_NDA)+_CR_, 'No data available');

      PaintSyntax(mmPostings, False);
    end;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.rbNonCandidateClick(Sender: TObject);
begin
  if Ignore then
    Exit;
  try
    dmData.cdsSummary.Edit;
    dmData.cdsSummary.FieldByName(fnS_TrnCandidate).AsBoolean :=
      rbCandidate.Checked;
    if not rbCandidate.Checked then
      begin
        dmData.cdsSummary.FieldByName(fnS_TrnWIP).AsBoolean := False;
        dmData.cdsSummary.FieldByName(fnS_TrnReferred).AsBoolean := False;
      end;
    dmData.cdsSummary.Post;
  except
  end;
  dbcWIP.Enabled := rbCandidate.Checked;
  dbcReferred.Enabled := rbCandidate.Checked;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.setWarnings(aValue: string);
begin
  fWarningsTXT := aValue;
end;

procedure TfrmCover.setAllergies(aValue: string);
begin
  fAllergiesTXT := aValue;
end;

procedure TfrmCover.setDirectives(aValue: string);
begin
  fDirectivesTXT := aValue;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.mmPostingsSelectionChange(Sender: TObject);
begin
  if not Ignore then
    Exit;
  if (mmPostings.SelLength > 0) and (mmPostings.SelStart >= 0) then
    begin
      mmPostings.SelAttributes.Color := clNavy;
      mmPostings.SelAttributes.Style := [fsBold];
    end;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.acGetInfectionDataExecute(Sender: TObject);
begin
  VaccinationTxt := Engine.PatientVaccination;
end;

procedure TfrmCover.acSelectProviderExecute(Sender: TObject);
var
  s: string;
begin
  s := SelectProvider('', Engine.fRenalController, 5);
  s := piece(s, '^', 1);
  if s <> '' then
    begin
      try
        if dmData.cdsInfo.State <> dsEdit then
          dmData.cdsInfo.Edit;
        dbeNephrologist.Text := s;
        dmData.cdsInfo.Post;
      except
        on E: Exception do
          ShowMessage(E.Message);
      end;
    end;
end;

procedure TfrmCover.acReadOnlyExecute(Sender: TObject);
var
  bReadOnly: Boolean;

  procedure setUpField(aF: TDBEdit);
  begin
    aF.Enabled := not bReadOnly;
    CheckDBField(af);
  end;

  procedure setUpComboField(aF: TDBComboBox);
  begin
    aF.Enabled := not bReadOnly;
    CheckDBField(af);
  end;

begin
  bReadOnly := cbReadOnly.Checked;

  pnlInfo.Enabled := not bReadOnly;
  pnlSchedule.Enabled := not bReadOnly;

  dbcbMon.Enabled := not bReadOnly;
  dbcbTue.Enabled := not bReadOnly;
  dbcbWed.Enabled := not bReadOnly;
  dbcbTh.Enabled := not bReadOnly;
  dbcbFri.Enabled := not bReadOnly;
  dbcbSat.Enabled := not bReadOnly;
  dbcbsun.Enabled := not bReadOnly;

  btnSelectProvider.Enabled := not bReadOnly;
  bbDiagnosisDate.Enabled := not bReadOnly;
  bbInitialTherapy.Enabled := not bReadOnly;
  bbTreatmentDate.Enabled := not bReadOnly;

  setUpField(dbtStudySessionDate);
  setUpField(dbeCTDate);
  setUpComboField(dbcESRD);
  setUpField(dbeDiagnosisDate);
  setUpField(dbeInitialTherapy);
  setUpComboField(dbcModality);
  setUpComboField(dbcCodeStatus);
  setUpField(dbeNephrologist);
  dbeNephrologist.ReadOnly := True; // build 312 update #28

  rbCandidate.Enabled := not bReadOnly;
  rbNonCandidate.Enabled := not bReadOnly;
  dbcWIP.Enabled := not bReadOnly and rbCandidate.Checked;
  dbcReferred.Enabled := not bReadOnly and rbCandidate.Checked;
end;

procedure TfrmCover.setUpLayout;
begin
  if Preferences.bValue(onShowInfectionTree) then
    begin
      spltDetails.Visible := True;
      spltDetails.Align := alRight;
      pnlInfectiousDiseases.Visible := True;
      pnlPostings.Align := alLeft;
      pnlPostings.Width := 135;
      spltDetails.Align := alLeft;
      lblDetailsTitle.Caption := 'Recent Postings';
    end
  else
    begin
      spltDetails.Align := alRight;
      spltDetails.Visible := False;
      pnlInfectiousDiseases.Visible := False;
      pnlPostings.Align := alClient;
      lblDetailsTitle.Caption := 'Recent Postings && Infectious Diseases';
    end;

{$IFDEF GENERALINFO_FRAME}
  GeneralInfo.pnlToolbar.Color := Preferences.iValue(onColorToolbar);
{$ENDIF}

  pnlCurrentTreatmentToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlTreatmentHistoryToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlInfectiousToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlPostingsToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlSelectedStudyToolbar.Color := Preferences.iValue(onColorToolbar);

  setReadOnly(Engine.CurrentPatient.ReadOnly);
end;

procedure TfrmCover.dbeDiagnosisDateChange(Sender: TObject);
begin
  if fIgnore then
    Exit;
  if Sender is TDBEdit then
    if TDBEdit(Sender).Field.AsString = '12/30/1899' then
      TDBEdit(Sender).Text := '';
  ReportStatus;
end;

procedure TfrmCover.ReloadData;
begin
  AllergiesTxt := Engine.PatientAllergies;
  DirectivesTxt := Engine.PatientDirectives;
  WarningsTxt := Engine.PatientWarnings;
  // vhaishandria 20081003 1.0.6.320 ------------------------------------- begin
  VaccinationTxt := Engine.PatientVaccination;        // uncommented on 20081003
  // vhaishandria 20081003 1.0.6.320 --------------------------------------- end

  rbCandidate.Checked :=
    dmData.cdsSummary.FieldByName(fnS_TrnCandidate).AsBoolean;
  rbNonCandidate.Checked := not
    dmData.cdsSummary.FieldByName(fnS_TrnCandidate).AsBoolean;
end;

procedure TfrmCover.RefreshGUI;

  function getValues(anOptionName: string): string;
  var
    sl: TStringList;
    i: integer;
  begin
    SL := nil;
    try
      Result := '';
      sl := TStringList.Create;
      sl.Text := Engine.getSystemOptionByName(anOptionName);
      for i := 0 to sl.Count - 1 do
        Result := result + piece(sl[i], '=', 2) + #13#10;
    finally
      sl.Free;
    end;
  end;

  procedure UpdateField(aField: TDBComboBox; sText: string);
  var
    sOldValue: string;
  begin
    try
      sOldValue := aField.Text;
      aField.Items.Text := sText;
      if sOldValue <> '' then
        try
          aField.Text := sOldValue;
        except
          on E: Exception do
            ShowMessage(E.Message);
        end;

    except
    end;
  end;

begin
  dmData.cdsInfo.DisableControls;

  DBG.FixedColor := Preferences.iValue(onReadOnlyFieldColor);
  scbDetails.Color := Preferences.iValue(onReadOnlyFieldColor);
  pnlTreatmentHistory.Color := Preferences.iValue(onReadOnlyFieldColor);
  tvVaccination.Color := Preferences.iValue(onReadOnlyFieldColor);
  mmPostings.Color := Preferences.iValue(onReadOnlyFieldColor);
//  reSummaryReport.Color := Preferences.iValue(onReadOnlyFieldColor);

  rbCandidate.Checked :=
    dmData.cdsSummary.FieldByName(fnS_TrnCandidate).AsBoolean;
  rbNonCandidate.Checked := not
    dmData.cdsSummary.FieldByName(fnS_TrnCandidate).AsBoolean;

  setMemo;
  setVaccination(VaccinationTxt);

  // set up units
  lblUPostTemp.Caption := getDictionaryUnits('cdsSummary', fnS_PreTemp, 'F');

  updateField(dbcESRD, getValues(onESRD_Diagnosys));
  updateField(dbcModality, getValues(onModalities));
  updateField(dbcCodeStatus, getValues(onCodeStatuses));

  //  dbcNephrologist.Items.Text := getValues(onNephrologiests);
  dmData.cdsInfo.EnableControls;

{$IFDEF GENERALINFO_FRAME}
  GeneralInfo.re.Color := Preferences.iValue(onReadOnlyFieldColor);
  GeneralInfo.pnlButtons2D.Visible :=  not devOptions.bValue(donWindowsXPTheme);
  GeneralInfo.pnlButtons3D.Visible :=  devOptions.bValue(donWindowsXPTheme);
{$ENDIF}
  acReadOnly.Execute; // 2008-04-24 vhaishandria
  setupLayout; // 2008-04-18
end;

procedure TfrmCover.dbeCTDateContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
{$IFNDEF DICTIONARY_FORMAT}// vhaishandria 2007-07-12 b. 312 #26
  Exit; // vhaishandria 20070326 no access to dictionary
{$ENDIF}
  if Engine.CurrentOperatorMode <> rnAdmin then
    Exit;
  WinCon := TWinControl(Sender);
  dbeCTDateEnter(Sender);
  PopupMenu.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y +
    MousePos.Y);
end;

procedure TfrmCover.dbeCTDateEnter(Sender: TObject);
begin
  fField := getActiveField(Sender);
  fActive := Sender;
end;

procedure TfrmCover.dbeCTDateExit(Sender: TObject);
begin
  if not cbReadOnly.Checked then
    CheckDBField(Sender);
  fField := nil;
  fActive := nil;
end;

procedure TfrmCover.acFormatExecute(Sender: TObject);
begin
  if fField = nil then
    exit;
  try
    UpdateColumnField(fField, fField.DataSet.Name, fField.FieldName);
    CheckDBField(fActive);
  except
  end;
end;

procedure TfrmCover.setReadOnly(aReadOnly: Boolean);
begin
  // update to support read only access;
  acReadOnly.Enabled := not aReadOnly;
  pnlTreatmentInfo.Enabled := not aReadOnly;
  pnlCurrentTreatmentToolbar.Enabled := not aReadOnly;

  if not pnlTreatmentInfo.Enabled then
    pnlTreatmentInfo.Color := Preferences.iValue(onColorReview)
  else
    pnlTreatmentInfo.Color := Preferences.iValue(onColorBackground);
end;

procedure TfrmCover.dbgKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  // add code for special actions on DBG
end;

procedure TfrmCover.ActivateTabForm;
begin
{$IFDEF GENERALINFO_FRAME}
  GeneralInfo.acRefresh.Execute;
{$ENDIF}
  pgcHistoryChange(nil);
end;

procedure TfrmCover.ReportStatus;
var
  s: string;

  function getFieldReport(aValue, aLabel: string): string;
  begin
    if aValue = '' then
      Result := aLabel
    else
      Result := '';
  end;

begin
  setUpLayout;

  s := '';
  s := s + getFieldReport(dbeCTDate.Text, 'CurrentTreatment Date, ');
  s := s + getFieldReport(dbeDiagnosisDate.Text, 'Diagnosis Date, ');
  s := s + getFieldReport(dbeInitialTherapy.Text, 'Initial Therapy Date, ');
  s := s + getFieldReport(dbeNephrologist.Text, 'Attending Nephrologist, ');
  s := s + getFieldReport(dbcESRD.Text, 'ESRD Code, ');
  s := s + getFieldReport(dbcModality.Text, 'Modality, ');
  s := s + getFieldReport(dbcCodeStatus.Text, 'Code Status, ');

  if s <> '' then
    begin
      s := 'Required Fields without data: ' + s;
      s := copy(s, 1, Length(s) - 2);
      Engine.ReportStatus(pnCover, 1, s);
    end
  else
    Engine.ReportStatus(pnCover, 0, 'OK');
end;

function TfrmCover.canDeactivate(var Reason: string): Boolean;
begin
  Reason := '';
  Result := True;
end;

procedure TfrmCover.DBGridDblClick(Sender: TObject);
begin
  RefreshTIU;
end;

procedure TfrmCover.RefreshTIU;
var
  SL: TStringList;
  ii: Integer;
  sSL: string;

  re: TRichEdit;
  sKeyword, sTIUID,
    sTIUNote,
    sValue: string;

const
  iiFalls = 3;
  iiSummary = 1;
  iiTIU = 2;

  procedure reScroll(Memo: TRichEdit; aScrollCode: SmallInt);
  var
    ScrollMessage: TWMVScroll;
    i: integer;
  begin
    // With reSummaryReport do
    // SelStart := Perform(EM_LINEINDEX, 0, 0) ;
    ScrollMessage.Msg := WM_VScroll;
    for i := 0 to Memo.Lines.Count do
      begin
        ScrollMessage.ScrollCode := aScrollCode; //sb_Top; //sb_LineDown;
        ScrollMessage.Pos := 0;
        Memo.Dispatch(ScrollMessage);
      end;
  end;

  function getAllNotesReport(aStudy: string): string;
  var
    s: string;
  begin
    Result := '';
    if Engine.fRenalController.GetStudyItem('704.202', '.5', aStudy, s) then
      begin
        try
          if cds.Active then
            cds.Active := False;
          cds.XMLData := s;
          cds.Active := True;
          Result := getNotesReport('', cds);
        except
        end;
      end;
  end;

  function getEdit(aCaption: string; aNum: Integer; anIndex: Integer):
      TRichEdit;
  var
    ts: TTabSheet;
    i: Integer;
  begin
    Result := nil;
    if aNum < pgcHistory.PageCount then
      ts := pgcHistory.Pages[aNum]
    else
      begin
        i := pgcHistory.PageCount;
        repeat
          ts := TTabSheet.Create(pgcHistory);
          ts.Name := 'ts_' + intToStr(i);
          ts.PageControl := pgcHistory;
          ts.ImageIndex := anIndex;
          ts.Caption := aCaption;
          Result := TRichEdit.Create(ts);
          Result.Parent := ts;
          Result.Align := alClient;
          Result.Show;
          Result.ScrollBars := ssBoth;
          Result.ParentColor := true;
          Result.ReadOnly := true;
          Result.BorderStyle := bsNone;
          Result.WordWrap := False;
          Result.Font.Name := 'Courier New';
          Result.Color := Preferences.iValue(onReadOnlyFieldColor);
          inc(i);
        until i >= aNum;
      end;
    if ts <> nil then
      for i := 0 to ts.ComponentCount - 1 do
        if ts.Components[i] is TRichEdit then
          begin
            Result := TRichEdit(ts.Components[i]);
            ts.ImageIndex := anIndex;
            ts.TabVisible := True;
            ts.Caption := aCaption;
            break
          end;
  end;

  procedure HideTabs;
  var
    i: integer;
  begin
    if pgcHistory.PageCount - 1 < 1 then exit;
    try
      for i := 1 to pgcHistory.PageCount - 1 do
        pgcHistory.Pages[i].TabVisible := False;
    except
    end;
  end;

begin
  try
    HideTabs;
    sValue := Engine.getNotesByStudyID(dbtStudyNumber.Caption);
    lblSelectedStudy.Caption := dbtStudyNumber.Caption;
    if (sValue <> '') and devOptions.bValue(onShowPatientTreatmentHistory) then
      begin
        SL := TSTringList.Create;
        SL.Text := sValue;
//        ReSummaryReport.Lines.Text := '';   vjaishandria 2008-04-23
        for ii := 0 to SL.Count - 1 do
          begin
            sSL := SL[ii];
            if pos('-1', sSL) = 1 then
              continue;
            sTIUID := piece(sSL, '^', 1);
            sTIUNote :=
              Engine.getNoteByNum(sTIUID, sTIUID);

            sKeyword := Preferences.sValue(onReportKeyword);
            if pos(sKeyword, sTIUNote) <> 0 then
//              re := getEdit('Result Report', ii + 2, iiSummary)
              re := getEdit('Results (TIU '+sTIUID+')', ii + 2, iiSummary)
            else
              begin
                sKeyword := devOptions.sValue(donFallRiskKeyword);
                if pos(sKeyword, sTIUNote) <> 0 then
                  re := getEdit('TIU ' + sTIUID, ii + 2, iiFalls)
                else
                  re := getEdit('TIU ' + sTIUID, ii + 2, iiTIU);
              end;

            if Assigned(re) then
              begin
                re.Lines.Text := sTIUNote;
                reScroll(re, sb_Top);
              end;
          end;
//        reScroll(reSummaryReport, sb_top); vhaishandria 2008-04-23

        SL.Free;
      end;
  except
  end;
  pgcHistoryChange(nil);
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.acDiagnosisDateExecute(Sender: TObject);
var
  sDate: string;
begin
  sDate := dbeDiagnosisDate.Text;
  if getDateTime('Select Diagnosis Date', 'mm/dd/yyyy', sDate) = mrOK then
    try
      //      fIgnore := True;
      if dmData.cdsInfo.State <> dsEdit then
        dmData.cdsInfo.Edit;
      dbeDiagnosisDate.Text := sDate;
      //      fIgnore := False;
      dmData.cdsInfo.Post;
    except
      on E: Exception do
        ShowMessage(e.Message);
    end;
end;

procedure TfrmCover.acTherapyDateExecute(Sender: TObject);
var
  sDate: string;
begin
  sDate := dbeInitialTherapy.Text;
  if getDateTime('Select Initial Therapy Date', 'mm/dd/yyyy', sDate) = mrOK then
    try
      //      fIgnore := True;
      if dmData.cdsInfo.State <> dsEdit then
        dmData.cdsInfo.Edit;
      dbeInitialTherapy.Text := sDate;
      //      fIgnore := False;
      dmData.cdsInfo.Post;
    except
      on E: Exception do
        ShowMessage(e.Message);
    end;
end;

procedure TfrmCover.acTreatmentDateExecute(Sender: TObject);
var
  sDate: string;
begin
  sDate := dbeCTDate.Text;
  if getDateTime('Select Treatment Date', 'mm/dd/yyyy', sDate) = mrOK then
    try
      //      fIgnore := True;
      if dmData.cdsInfo.State <> dsEdit then
        dmData.cdsInfo.Edit;
      dbeCTDate.Text := sDate;
      //      fIgnore := False;
      dmData.cdsInfo.Post;
(*
      // vhaishandria 2007-07-09 ----------------------------------------- Start
      if dmData.cdsSummary.State <> dsEdit then
        dmData.cdsSummary.Edit;
      dbtStudySessionDate.Text := sDate;
      dmData.cdsSummary.Post;
      // vhaishandria 2007-07-09 ------------------------------------------- End
*)
    except
      on E: Exception do
        ShowMessage(e.Message);
    end;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmCover.dbgHistoryDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  field: TField;
  dataset: TDataSet;
  sText,
    risk: string;
  i: Integer;
begin
  dataset := dmData.cdsStudyHistory;

  field := dataset.FieldByName(fnS_SessionID);
  sText := field.asString;
  risk := frmStudies.getStudyStatus(sText); // 2007-11-17 Active Study List fix
  if risk = 'Unknown' then
    dbg.DefaultDrawColumnCell(Rect, DataCol, Column, State)
  else
    begin
      if not (gdFocused in State) then
        dbg.canvas.font.color := clRed;
      if dbg.Columns[DataCol].FieldName = 'Comments' then
        begin
          sText := 'Not submitted';
          i := dbg.Canvas.TextWidth(sText);
          dbg.Canvas.FillRect(Rect);
          dbg.Canvas.TextRect(Rect, Rect.Right - 3 - i, Rect.Top + 2, sText);
        end
      else
        dbg.DefaultDrawColumnCell(Rect, DataCol, Column, State);
    end;
end;

procedure TfrmCover.SaveData;
begin
  try
    dmData.cdsInfo.Post;
  except
  end;
end;

procedure TfrmCover.FormDestroy(Sender: TObject);
begin
{$IFDEF GENERALINFO_FRAME}
  if Assigned(fGeneralInfoCollector) then
    try
      GeneralInfo.freeInterface;
      FreeAndNil(fGeneralInfoCollector);
    except
    end;
{$ENDIF}

  inherited;
end;

procedure TfrmCover.acPrintExecute(Sender: TObject);
var
  i: Integer;
  re: TRichEdit;
  imgBackground: TBitmap;
  ts: TTabSheet;
  s: string;
begin
  if PrintDialog1.Execute then
    with Printer do
      begin
{$IFDEF DEMO}
        if cmdLineSwitch(['/DEMO']) then
          imgBackground := imgDemoBackground.Picture.Bitmap
        else
{$ENDIF}
          imgBackground := nil;

        s := '';
        re := nil;
        ts := pgcHistory.ActivePage;
        for i := 0 to ts.ComponentCount - 1 do
          if ts.Components[i] is TRichEdit then
            begin
              Re := TRichEdit(ts.Components[i]);
              s := re.Lines.Text;
              Printer.Canvas.Font.Assign(re.Font);
              break;
            end;
        if (s <> '') and Assigned(re) then
          PrintReportString(Printer, s, imgBackground)
      end;
end;

procedure TfrmCover.pgcHistoryChange(Sender: TObject);
begin
  acPrint.Enabled := pgcHistory.ActivePageIndex > 0;
end;

function TfrmCover.getMainMenu: TMainMenu;
begin
  Result := CoverMainMenu;
end;

procedure TfrmCover.setMainMenuVisible(aValue: Boolean);
begin
  miDocuments.Visible := aValue;
end;

end.
