unit fMDK_Flowsheet;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 4/23/08 3:19p $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  Contains the Hemodialysis application Flowsheet form
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Build309/Tabs/fMDK_Flowsheet.pas $
*
*       $ History: fMDK_Flowsheet.pas $
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, StdCtrls, ExtCtrls, DBCtrls, ActnList, ImgList,
  Menus, StdActns, Buttons, TeEngine, Series, TeeProcs, Chart, DbChart,
  ComCtrls, CheckLst, frMDK_StudyNoteSection, frMDK_Comments
  , DB, DBClient, Mask
  ;

type
  TfrmFlow = class(TForm)
    pnlFlowSheet: TPanel;
    ActionList1: TActionList;
    acSetStatus: TAction;
    acRefresh: TAction;
    acAdd: TAction;
    acEdit: TAction;
    ilFlow: TImageList;
    ppmFlowsheet: TPopupMenu;
    AddEntry1: TMenuItem;
    EditEntry1: TMenuItem;
    Invalid1: TMenuItem;
    Refresh1: TMenuItem;
    acMLAdd: TAction;
    acMLDelete: TAction;
    tmrRefresh: TTimer;
    acAutorefresh: TAction;
    FileOpen1: TFileOpen;
    N1: TMenuItem;
    ReadRecord1: TMenuItem;
    acMLedit: TAction;
    acMLValid: TAction;
    ActionList2: TActionList;
    acDBCRefresh: TAction;
    acView3D: TAction;
    acAllowZoom: TAction;
    acLabels: TAction;
    acPoints: TAction;
    acShowAll: TAction;
    acHideAll: TAction;
    acAddNote: TAction;
    acLockNote: TAction;
    Panel55: TPanel;
    dbgFlow: TDBGrid;
    acAddTIUNote: TAction;
    acReLoad: TAction;
    acInvalidNote: TAction;
    acFormat: TAction;
    Format1: TMenuItem;
    N2: TMenuItem;
    ppmFormatMedicine: TPopupMenu;
    Format2: TMenuItem;
    acFormatMedicine: TAction;
    acFormatComments: TAction;
    ppmFormatComments: TPopupMenu;
    Format3: TMenuItem;
    acCommentsRefresh: TAction;
    pgcFlowsheet: TPageControl;
    pnlTimeline: TPanel;
    pnlToolbar: TPanel;
    pnlFlow: TPanel;
    tsTimeline: TTabSheet;
    tsWorkflow: TTabSheet;
    dbgWorkflow: TDBGrid;
    pnlChart: TPanel;
    Panel5: TPanel;
    cbl: TCheckListBox;
    Panel10: TPanel;
    SpeedButton3: TSpeedButton;
    SpeedButton1: TSpeedButton;
    Panel1: TPanel;
    Bevel1: TBevel;
    cbView3D: TCheckBox;
    cbAllowZoom: TCheckBox;
    cbLabels: TCheckBox;
    dbc: TDBChart;
    Series1: TPointSeries;
    Panel4: TPanel;
    Panel40: TPanel;
    btnRefresh: TButton;
    btnEditEntry: TButton;
    btnNewEntry: TButton;
    btnInvalid: TButton;
    btnAddTIU: TButton;
    btnReload: TButton;
    alWorkflow: TActionList;
    acWF_Refresh: TAction;
    pnlAutorefresh: TPanel;
    pnlTools: TPanel;
    cmbAutorefresh: TComboBox;
    cbNewOnly: TCheckBox;
    acInvalidate: TAction;
    acEditItem: TAction;
    acDeleteItem: TAction;
    acClear: TAction;
    btnClear: TButton;
    pnlComments: TPanel;
    FrameMDK_Comments: TFrameMDK_Comments;
    Splitter1: TSplitter;
    pnlMedicine: TPanel;
    dbgMedList: TDBGrid;
    Panel3: TPanel;
    Panel9: TPanel;
    btnDeleteMedicine: TButton;
    btnEditMedicine: TButton;
    btnAddMedicine: TButton;
    btnInvalidMedicine: TButton;
    pnlWorkflowDetails: TPanel;
    pnlID: TPanel;
    dbeDateOnly: TDBEdit;
    dbeTimeOnly: TDBEdit;
    pnlMedication: TPanel;
    dbeDose: TDBEdit;
    dbeUnit: TDBEdit;
    dbeMedication: TDBEdit;
    dbeReason: TDBEdit;
    dbeOutcome: TDBEdit;
    dbeRout: TDBEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Panel8: TPanel;
    pnlNote: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    dbeAuthor: TDBEdit;
    dbmText: TDBMemo;
    pnlFlowsheetRecord: TPanel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    Label15: TLabel;
    DBEdit7: TDBEdit;
    Label16: TLabel;
    DBEdit8: TDBEdit;
    Label17: TLabel;
    DBEdit9: TDBEdit;
    Label18: TLabel;
    DBEdit10: TDBEdit;
    Label19: TLabel;
    DBEdit11: TDBEdit;
    Label20: TLabel;
    DBEdit12: TDBEdit;
    Label21: TLabel;
    DBEdit13: TDBEdit;
    Label22: TLabel;
    DBEdit14: TDBEdit;
    Label23: TLabel;
    DBEdit15: TDBEdit;
    Label24: TLabel;
    DBEdit16: TDBEdit;
    acAddFSRecord: TAction;
    acAddMLRecord: TAction;
    acAddComment: TAction;
    acAddTIU: TAction;
    acReloadFlowsheet: TAction;
    acViewReport: TAction;
    Label25: TLabel;
    dbeGivenBy: TDBEdit;
    pnlWorkflowToolbar: TPanel;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton12: TSpeedButton;
    Panel2: TPanel;
    pnlTables: TPanel;
    mnMain: TMainMenu;
    Comments1: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    MenuItem2: TMenuItem;
    Notes1: TMenuItem;
    Medications1: TMenuItem;
    Add1: TMenuItem;
    Delete2: TMenuItem;
    EditEntry2: TMenuItem;
    Invalid2: TMenuItem;
    Flowsheet1: TMenuItem;
    Refresh2: TMenuItem;
    N3: TMenuItem;
    EditEntry3: TMenuItem;
    AddEntry2: TMenuItem;
    Invalid3: TMenuItem;
    AddTIU1: TMenuItem;
    N4: TMenuItem;
    Reload1: TMenuItem;
    pnlFlowsheetToolBar: TPanel;
    Label26: TLabel;
    pnlFlowsheetActions: TPanel;
    SpeedButton2: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton15: TSpeedButton;
    SpeedButton16: TSpeedButton;
    SpeedButton17: TSpeedButton;
    lblLeft: TLabel;
    pnlMedListToolBar: TPanel;
    Label27: TLabel;
    pnlMedListActions: TPanel;
    SpeedButton18: TSpeedButton;
    SpeedButton19: TSpeedButton;
    SpeedButton20: TSpeedButton;
    SpeedButton21: TSpeedButton;
    N5: TMenuItem;
    Refresh3: TMenuItem;
    pnlExtras: TPanel;
    ckbShowDeleted: TCheckBox;
    pnlMLButtons3D: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    pnlFlowsheet3D: TPanel;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    acDuplicates: TAction;
    ShowDuplicates1: TMenuItem;
    Refresh4: TMenuItem;
    Reload2: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure acEditExecute(Sender: TObject);
    procedure acRefreshExecute(Sender: TObject);
    procedure acSetStatusExecute(Sender: TObject);
    procedure dbgFlowDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure acAddExecute(Sender: TObject);
    procedure acMLDeleteExecute(Sender: TObject);
    procedure acMLAddExecute(Sender: TObject);
    procedure tmrRefreshTimer(Sender: TObject);
    procedure cmbAutorefreshChange(Sender: TObject);
    procedure grpbMedicationsEnter(Sender: TObject);
    procedure grpbMedicationsExit(Sender: TObject);
    procedure gbFlowsheetEnter(Sender: TObject);
    procedure gbFlowsheetExit(Sender: TObject);
    procedure FileOpen1Accept(Sender: TObject);
    procedure acMLeditExecute(Sender: TObject);
    procedure dbgMedListEnter(Sender: TObject);
    procedure dbgMedListDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure acMLValidExecute(Sender: TObject);
    procedure dbgMedListColEnter(Sender: TObject);
    procedure dbgMedListColExit(Sender: TObject);
    procedure acDBCRefreshExecute(Sender: TObject);
    procedure cblDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure cblClick(Sender: TObject);
    procedure acView3DExecute(Sender: TObject);
    procedure acAllowZoomExecute(Sender: TObject);
    procedure acLabelsExecute(Sender: TObject);
    procedure acPointsExecute(Sender: TObject);
    procedure acShowAllExecute(Sender: TObject);
    procedure acHideAllExecute(Sender: TObject);
    procedure sbSubmitVitalsClick(Sender: TObject);
    procedure acAddNoteExecute(Sender: TObject);
    procedure acLockNoteExecute(Sender: TObject);
    procedure acAddTIUNoteExecute(Sender: TObject);
    procedure acReLoadExecute(Sender: TObject);
    procedure acInvalidNoteExecute(Sender: TObject);
    procedure acFormatExecute(Sender: TObject);
    procedure acFormatMedicineExecute(Sender: TObject);
    procedure acFormatCommentsExecute(Sender: TObject);
    procedure dbgMedListDblClick(Sender: TObject);
    procedure dbcClickSeries(Sender: TCustomChart; Series: TChartSeries;
      ValueIndex: Integer; Button: TMouseButton; Shift: TShiftState; X,
      Y: Integer);
    procedure pgcFlowsheetChange(Sender: TObject);
    procedure acWF_RefreshExecute(Sender: TObject);
    procedure acClearExecute(Sender: TObject);
    procedure dbgWorkflowDrawColumnCell(Sender: TObject; const Rect: TRect;
      DataCol: Integer; Column: TColumn; State: TGridDrawState);
    procedure acReloadFlowsheetExecute(Sender: TObject);
    procedure acAddFSRecordExecute(Sender: TObject);
    procedure acAddCommentExecute(Sender: TObject);
    procedure acAddTIUExecute(Sender: TObject);
    procedure ckbShowDeletedClick(Sender: TObject);
    procedure SpeedButton22Click(Sender: TObject);
    procedure acDuplicatesExecute(Sender: TObject);
  private
    { Private declarations }
//    Ignore: Boolean;
  public
    { Public declarations }
    fLeftToRefresh: Integer;
    procedure setGridAlign(anAlign: Talignment);
    procedure ReportStatus;
    procedure setReadOnly(aReadOnly: Boolean = False);
    procedure setActionStatus;
    procedure saveData;
    procedure ActivateTabForm;
    procedure MapFields;
    procedure setWorkflowStatus;
    function getMainMenu: TMainMenu;
  end;

var
  frmFlow: TfrmFlow;

implementation

uses
  dMDK_Data
  , uMDK_Summary
  , fMDK_FlowSheetEdit
  , uMDK_Engine
  , uMDK_InstrumentRecord
  , uMDK_Common
  , fMDK_Summary
  , uMDK_MedList
  , uMDK_CDSCommon
  , fMDK_Medication
  , uMDK_Notes
  , fMDK_Options
  , uMDK_Options
  , fMDK_TIUNote
  , uROR_RPCBroker
  , fMDK_ReloadFlowsheet
  , uXML
  , fMDK_DictionaryEdit
  , uMDK_Dictionary
  , uMDK_Flowsheet
  , fMDK_Comments
  , uMDK_FieldFactory;

{$R *.dfm}

////////////////////////////////////////////////////////////////////////////////
const
  EXTRA_SERIES = 0;

procedure setupChartSeries(
  aChart: TDBChart;
  aCDS: TClientDataSet;
  aCheckListBox: TCheckListBox;
  aXValuesSource: string;
  aSeriesType: string = 'LINE'
  );
var
  tcs: TChartSeries;
  i: Integer;

  function getNewSeries(aName: string): TChartSeries;
  begin
    if aName = 'LINE' then
      begin
        Result := TLineSeries.Create(aChart);
        TLineSeries(Result).LinePen.Width := 2;
        //        TLineSeries(Result).Marks.Visible := True;
      end
    else if aName = 'BAR' then
      begin
        Result := TBarSeries.Create(aChart);
        TBarSeries(Result).CustomBarWidth := 10;
      end
    else
      Result := nil;
  end;

begin
  for i := 0 to aCDS.FieldCount - 1 do
    begin
      if not aCDS.Fields[i].Visible then
        continue;
      if aCDS.Fields[i].FieldName = aXValuesSource then
        continue;
      if aCDS.Fields[i].DataType <> ftFloat then
        continue;
      try
        tcs := getNewSeries(aSeriesType);
        if tcs = nil then
          continue;

        tcs.Title := aCDS.Fields[i].DisplayLabel;
        tcs.ParentChart := aChart;
        tcs.DataSource := aCDS;
        tcs.XValues.ValueSource := aXValuesSource;
        tcs.XValues.DateTime := True;
        tcs.YValues.ValueSource := aCDS.Fields[i].FieldName;
        if aCheckListBox <> nil then
          begin
            aCheckListBox.AddItem(aCDS.Fields[i].DisplayLabel, tcs);
            aCheckListBox.Checked[aCheckListBox.Items.Count - 1] := True;
          end;
      except
      end;
    end;
end;

procedure setupComments(
  aTCS: TPointSeries;
  aChart: TDBChart;
  aCDS: TClientDataSet;
  aCheckListBox: TCheckListBox;
  aXValuesSource: string;
  aTextValuesSource: string
  );
var
  tcs: TPointSeries;
  BM: TBookmark;
  s: string;
  d: Double;
begin
  if not Assigned(aTCS) then
    tcs := TPointSeries.Create(aChart)
  else
    tcs := aTCS;

  tcs.Clear;
  tcs.Title := 'Comments';
  tcs.ParentChart := aChart;
  //  tcs.XValues.ValueSource := aXValuesSource;
  tcs.XValues.DateTime := True;

  aCDS.DisableControls;
  BM := aCDS.GetBookmark;
  aCDS.First;
  while not aCDS.Eof do
    begin
      s := aCDS.FieldbyName(aTextValuesSource).AsString;
      d := aCDS.FieldbyName(aXValuesSource).AsDateTime;
      d := frac(d);
      tcs.AddXY(d, -1);
      aCDS.Next;
    end;
  aCDS.FreeBookmark(BM);
  aCDS.EnableControls;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmFlow.FormCreate(Sender: TObject);
var
  i: Integer;

begin
  setGridAlign(taCenter);
{$IFDEF CHART}
  cbl.Items.Clear;
  cbl.AddItem('Comments', Series1);

  //   setupChartSeries(dbcMedList,Engine.MedList_CDS,nil,fnML_Time,'BAR');
  setupChartSeries(dbc, Engine.MedList_CDS, cbl, fnML_Time, 'BAR');
  setupChartSeries(dbc, Engine.FlowSheet_CDS, cbl, fnFS_Time, 'LINE');

  //   setupComments(Series1,dbc,Engine.NoteList_CDS,cbl,fnNL_DateTime,fnNL_Text);
{$ENDIF}

{$IFDEF AANTEST}
  N1.Visible := True;
  ReadRecord1.Visible := True;
  pnlTools.Visible := True;
{$ELSE}
  ReadRecord1.Visible := False;
  btnReload.Visible := False; //Engine.CurrentOperatorMode = rnAdmin;
  pnlTools.Visible := False;
  btnClear.Visible := False;
{$ENDIF}

{$IFDEF DICTIONARY_FORMAT}
  N1.Visible := True;
  Format1.Visible := True;

{$ELSE}
  N1.Visible := False;
  Format1.Visible := False;
  dbgMedList.PopupMenu := nil;
{$ENDIF}

  FrameMDK_Comments.setUpCanvas(Engine.NoteList_CDS, 'frmFlow');
  MapFields;

  pnlWorkflowDetails.Height := 70;
  tsTimeline.TabVisible := False;

  for i := 0 to pnlFlowsheetActions.ComponentCount - 1 do
    if pnlFlowsheetActions.Components[i] is TSpeedButton then
      TSpeedButton(pnlFlowsheetActions.Components[i]).Font.Style := [];

{$IFDEF IGNORE_DUPLICATES}
  ShowDuplicates1.Visible := True;
{$ENDIF}
end;

procedure TfrmFlow.MapFields;
var
  i: Integer;
  b: Boolean;
begin
  dbeDateOnly.DataField := FN_DATE_ONLY;
  dbeTimeOnly.DataField := FN_TIME_ONLY;

  dbeAuthor.DataField := fnNL_AuthorID;
  dbmText.DataField := fnNL_Text;

  dbeDose.DataField := fnML_Dose;
  dbeUnit.DataField := fnML_Units;
  dbeRout.DataField := fnML_Rout;
  dbeReason.DataField := fnML_Reason;
  dbeMedication.DataField := fnML_Medication;
  dbeOutcome.DataField := fnML_Outcome;
  dbeGivenBy.DataField := fnML_GivenBy;

  dbEdit1.DataField := fnFS_BP;

  dbEdit2.DataField := fnFS_MAP;
  dbEdit3.DataField := fnFS_HR;
  dbEdit4.DataField := fnFS_BFR;
  dbEdit5.DataField := fnFS_DFR;
  dbEdit6.DataField := fnFS_AP;
  dbEdit7.DataField := fnFS_VP;
  dbEdit8.DataField := fnFS_TMP;
  dbEdit9.DataField := fnFS_UFR;
  dbEdit10.DataField := fnFS_FLUID;
  dbEdit11.DataField := fnFS_HEP;
  dbEdit12.DataField := fnFS_COND;
  dbEdit13.DataField := fnFS_BIC;
  dbEdit14.DataField := fnFS_DIAL;
  dbEdit15.DataField := fnFS_IONI;
  dbEdit16.DataField := fnFS_KTV;

  if dmData.cdsWorkflow.Active then
    begin
      i := 0;
      b := False;
      while i < dbgWorkflow.Columns.Count do
        begin
          if dbgWorkflow.Columns[i].FieldName = FN_DATE_ONLY then
            dbgWorkflow.Columns[i].Width := 0;
          if dbgWorkflow.Columns[i].FieldName = fnFS_Source then
            dbgWorkflow.Columns[i].Width := 25;
          if dbgWorkflow.Columns[i].FieldName = fnFS_BP then
            dbgWorkflow.Columns[i].Width := 60;
          if dbgWorkflow.Columns[i].FieldName = fnFS_MAP then
            b := True;
          if b then
            dbgWorkflow.Columns[i].Width := 30;
          inc(i);
        end;
    end;
end;

procedure TfrmFlow.setGridAlign(anAlign: Talignment);
var
  i: Integer;
begin
  for i := 0 to dbgFlow.Columns.Count - 1 do
    begin
      dbgFlow.Columns.Items[i].Alignment := anAlign;
      dbgFlow.Columns.Items[i].Title.Alignment := anAlign;
    end;
end;

procedure TfrmFlow.acEditExecute(Sender: TObject);
begin
  if dbgFlow.DataSource.DataSet.FieldByName(fnFS_Source).AsString <> fsManual
    then
    ShowMessage('Sorry, you can''t edit record received from the instrument.')
  else
    EditFSRecord(TClientDataSet(dbgFlow.DataSource.DataSet),
      Engine.CurrentPatient.ID, Engine.CurrentPatient.SessionID, fsManual,
      fsValid);
end;

procedure TfrmFlow.setActionStatus;
var
  sValue : String;
begin
  if not assigned(Engine) then exit;

  with dbgFlow.DataSource.DataSet do
    acEdit.Enabled := (FieldByName(fnFS_Source).AsString <> fsDevice);

  sValue := dmData.cdsMedList.fieldByName(fnML_Status).asString;

  acMLDelete.Enabled := (dmData.cdsMedList.RecordCount > 0)
    and (dmData.cdsMedList.fieldByName(fnML_Source).asString = '')
    and (sValue<>stML_DELETED)
    and (sValue<>stML_REPLACED)
    and not Engine.CurrentPatient.ReadOnly
    ;

  acMLEdit.Enabled := (dmData.cdsMedList.RecordCount > 0)
    and (sValue<>fsInvalid) // // vhaishandria 2007-08-29 b. 314 #14
    and (sValue<>stML_DELETED)
    and (sValue<>stML_REPLACED)
    //    and (dmData.cdsMedList.fieldByName(fnML_Source).asString='');// vhaishandria 060807
    and not Engine.CurrentPatient.ReadOnly
    ;

  acMLValid.Enabled := not Engine.CurrentPatient.ReadOnly
    and (sValue<>stML_DELETED)
    and (sValue<>stML_REPLACED)
    ;

  FrameMDK_Comments.setActionStatus;

  setReadOnly(Engine.CurrentPatient.ReadOnly);
end;

procedure TfrmFlow.acSetStatusExecute(Sender: TObject);
var
  i: Integer;
  s: string;
  //  BM: TBookmark;

  function getStringValue: string;
  begin
    Result := '';
    if dbgFlow.DataSource.DataSet.FieldbyName(fnFS_Submitted).AsBoolean then
      begin
        Result := 'SUBMITTED';
        Exit;
      end;

    if dbgFlow.DataSource.DataSet.FieldByName(fnFS_Source).AsString = fsManual
      then
      begin
        if (dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Status) and
          (not dbgFlow.DataSource.DataSet.FieldbyName(fnFS_Submitted).AsBoolean)
          and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Submitted))
          and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Date)) and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Source)) and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_PatientID))
          and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_SessionID))
          and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Date)) and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Time)) then
          Result := dbgFlow.DataSource.DataSet.Fields[i].AsString;
      end
    else
      begin
        if (dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Status) and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Date)) and
          ((dbgFlow.DataSource.DataSet.Fields[i].FieldName <> fnFS_Time)) then
          Result := dbgFlow.DataSource.DataSet.Fields[i].AsString;
      end;
  end;

begin
  if dbgFlow.DataSource.DataSet.RecordCount < 1 then
    Exit;

  if dbgFlow.DataSource.DataSet.FieldByName(fnFS_Status).AsString =
    fsInValidSource then
    begin
      MessageDLG('Flowsheet record SSN does not match patient SSN'+#13+
        'Record valid status could not be changed',mtWarning,[mbOK],0);
      Exit;
    end;
  //  BM := dbgFlow.DataSource.DataSet.GetBookmark;

  dmData.cdsFlowSheet.DisableControls;
  with dbgFlow.DataSource.DataSet do
    begin
      for i := 0 to dbgFlow.DataSource.DataSet.FieldCount - 1 do
        s := s + getStringValue;

      if (trim(s) = '') and
        ((Engine.CurrentOperatorMode = rnAdmin) or
        Preferences.bValue(onAllowUserDeleteBlankFSRecords))
        and
        (MessageDlg('The record is blank.  Delete it now?',
        mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
        begin
          dbgFlow.DataSource.DataSet.Delete;
          Engine.Report(rtInfo, 'Blank record was deleted from the flowsheet',
            '', 0, '', 'Flowsheet CleanUp', 'OK', True);
        end
      else
        begin
          Edit;
          if FieldByName(fnFS_Status).AsString = fsValid then
            FieldByName(fnFS_Status).AsString := fsInValid
          else
            FieldByName(fnFS_Status).AsString := fsValid;
          Post;
        end;
      dbgFlow.Invalidate;
    end;
  dmData.cdsFlowSheet.EnableControls;
  //  dbgFlow.Invalidate;
  //  if Assigned(BM) then
  //    begin
  //      dbgFlow.DataSource.DataSet.gotoBookmark(BM);
  //     dbgFlow.DataSource.DataSet.FreeBookmark(BM);
  //    end;
end;

procedure TfrmFlow.acAddExecute(Sender: TObject);
begin
  AddFSRecord(dmData.cdsFlowSheet,
    Engine.CurrentPatient.ID, Engine.CurrentPatient.SessionID, fsManual,
    fsValid);
  setGridAlign(taCenter);
end;

procedure TfrmFlow.acMLDeleteExecute(Sender: TObject);
var
  cds: TClientDataset;
begin
  cds := TClientDataSet(dbgMedList.DataSource.DataSet);
  if not Assigned(cds) then
    Exit;
  try
    if MessageDlg('Do you really want to delete the medicine record?' + #13#13 +
      'Medication: ' + cds.fieldByName(fnML_Medication).AsString + #13#10 +
      'Dose:       ' + cds.fieldByName(fnML_Dose).AsString + ' ' +
      '' + cds.fieldByName(fnML_Units).AsString + ' ' + #13#10 +
      'Rout:       ' + cds.fieldByName(fnML_Rout).AsString + #13#10 +
      #13#10 +
      'Given By:   ' + cds.fieldByName(fnML_GivenBy).AsString + #13#10 +
      'Time given: ' + cds.fieldByName(fnML_Time).AsString,
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then
      begin
        cds.Edit;
        cds.FieldByName(fnML_Status).AsString := 'DELETED';
        cds.FieldByName(fnML_StatusDate).AsDateTime := Now;
        cds.FieldByName(fnML_StatusBy).AsString := Engine.CurrentOperatorID;
        cds.Post;
      end;
  except
  end;
  SetActionStatus;
end;

procedure TfrmFlow.acMLAddExecute(Sender: TObject);
begin
  if AddMedication = 'OK' then
    SetActionStatus;
end;

procedure TfrmFlow.cmbAutorefreshChange(Sender: TObject);
begin
  fLeftToRefresh := StrToIntDef(cmbAutoRefresh.Text, 0) * 1000;
  tmrRefresh.Enabled := fLeftToRefresh <> 0;
  lblLeft.Visible := fLeftToRefresh <> 0;
end;

procedure TfrmFlow.tmrRefreshTimer(Sender: TObject);
var
  i: Integer;
begin
  fLeftToRefresh := fLeftTorefresh - 1000;
  i := fLeftToRefresh div 1000;
  lblLeft.Caption := 'Autorefresh in ' + intToStr(i div 60) + ' min ' +
    IntToStr(i mod 60) + ' sec.';
  lblLeft.Visible := fLeftToRefresh <> 0;
  if fLeftToRefresh = 0 then
    begin
      acRefreshExecute(nil);
      cmbAutorefreshChange(nil);
    end;
end;

procedure TfrmFlow.grpbMedicationsEnter(Sender: TObject);
begin
  // not used?
  acMLDelete.Enabled := dbgMedList.DataSource.DataSet.RecordCount > 0;
  acMLValid.Enabled := dbgMedList.DataSource.DataSet.RecordCount > 0;
  acMLedit.Enabled := dbgMedList.DataSource.DataSet.RecordCount > 0;
end;

procedure TfrmFlow.grpbMedicationsExit(Sender: TObject);
begin
  acMLDelete.Enabled := False;
  acMLValid.Enabled := False;
  acMLEdit.Enabled := False;
end;

procedure TfrmFlow.gbFlowsheetEnter(Sender: TObject);
begin
  acSetStatus.Enabled := True;
end;

procedure TfrmFlow.gbFlowsheetExit(Sender: TObject);
begin
  acSetStatus.Enabled := False;
end;

procedure TfrmFlow.FileOpen1Accept(Sender: TObject);
var
  sl: TStringList;
begin
  sl := TStringList.Create;
  sl.LoadFromFile(FileOpen1.Dialog.FileName);
  Engine.setInstrumentRecord(Engine.CurrentPatient.ID,
    Engine.CurrentPatient.SessionID,
    sl.Text,
    'File <' + FileOpen1.Dialog.FileName + '>');
  sl.Free;
end;

procedure TfrmFlow.acRefreshExecute(Sender: TObject);
var
  bEnabled: Boolean;
begin
  bEnabled := tmrRefresh.Enabled;
  tmrRefresh.Enabled := False;
  cmbAutorefreshChange(nil);

  Engine.getFlowSheetData(not cbNewOnly.Checked);

  if Engine.ProblemList <> '' then
    begin
      try
        dmData.cdsSummary.Edit;
        dmData.cdsSummary.FieldByName(fnS_WorkflowNotes).AsString :=
          Engine.ProblemList;
        dmData.cdsSummary.Post;
      except
      end
    end;

  setGridAlign(taCenter);
{$IFDEF CHART}
  dbc.RefreshData;
  setupComments(Series1, dbc, Engine.NoteList_CDS, cbl, fnNL_DateTime,
    fnNL_Text);
{$ENDIF}

{$IFDEF IGNORE_DUPLICATES}
  MarkDuplicates(Engine.FlowSheet_CDS,fnFS_Duplicate);
{$ENDIF}

  tmrRefresh.Enabled := bEnabled;
end;

procedure TfrmFlow.acMLeditExecute(Sender: TObject);
begin
  //  EditMedication;
  EditMedicationStatus;
  SetActionStatus;
end;

procedure TfrmFlow.dbgMedListEnter(Sender: TObject);
begin
  SetActionStatus;
end;

procedure TfrmFlow.ReportStatus;
var
  iCode: Integer;
  s: string;
begin
  iCode := 0;

  N2.Visible := Engine.CurrentOperatorMode = rnAdmin;
  Format1.Visible := Engine.CurrentOperatorMode = rnAdmin;
  if Engine.CurrentOperatorMode = rnAdmin then
    dbgMedList.PopupMenu := ppmFormatMedicine
  else
    dbgMedList.PopupMenu := nil;
    
  if dmData.cdsSummary.FieldByName(fnS_LastRecord).AsBoolean then
    s := 'All records received' //vhaishandria 060303
  else
    begin
      if Preferences.bValue(onIgnoreUnfinishedStatus) then
        iCode := 0
      else
        iCode := 1;
      s := 'Not all the records received. ';
    end;
  Engine.ReportStatus(pnFlow, iCode, s);

  dbgMedList.Color := Preferences.iValue(onReadOnlyFieldColor);
  //  dbgNotes.Color := Preferences.iValue(onReadOnlyFieldColor);
  dbgFlow.Color := Preferences.iValue(onReadOnlyFieldColor);
  FrameMDK_Comments.Color := Preferences.iValue(onReadOnlyFieldColor);
  FrameMDK_Comments.pnlToolbar.Color := Preferences.iValue(onColorToolbar);

  pnlFlowsheetToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlMedListToolbar.Color := Preferences.iValue(onColorToolbar);

  pnlToolbar.Color := Preferences.iValue(onColorToolbar);

  setReadOnly(Engine.CurrentPatient.ReadOnly);

  pnlFlowsheet3D.Visible := devOptions.bValue(donWindowsXPTheme);
  pnlFlowsheetActions.Visible := not devOptions.bValue(donWindowsXPTheme);

  pnlMLButtons3D.Visible := devOptions.bValue(donWindowsXPTheme);
  pnlMedListActions.Visible := not devOptions.bValue(donWindowsXPTheme);

  FrameMDK_Comments.pnlButtons3DH.Visible := devOptions.bValue(donWindowsXPTheme);
  FrameMDK_Comments.pnlButtons2DH.Visible := not devOptions.bValue(donWindowsXPTheme);

{$IFDEF IGNORE_DUPLICATES}
  dbgFlow.DataSource.DataSet.Filtered :=
   not Preferences.bValue(onSHowFlowsheetDuplicates);
{$ENDIF}
  ckbShowDeleted.Checked := Preferences.bValue(onShowDeletedMedicine);
  dmData.cdsMedList.Filtered := not Preferences.bValue(onShowDeletedMedicine);
end;

procedure TfrmFlow.dbgMedListDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  field: TField;
  dataset: TDataSet;
  sReadOnly,
    risk: string;
begin
  dataset := dbgMedList.DataSource.DataSet;
  field := dataset.FieldByName(fnML_Status);
  risk := field.asString;
  if risk = fsValid then
    dbgMedList.canvas.font.color := clBlack;
  if risk = fsValid then
    dbgMedList.canvas.font.Style := [];

  if risk = fsInValid then
    dbgMedList.canvas.font.color := clRed;
  if risk = fsInValid then
    dbgMedList.canvas.font.Style := [fsStrikeOut];

  if risk = fsValid then
    dbgMedList.canvas.brush.color := clWindow;
  if risk = fsInValid then
    dbgMedList.canvas.brush.color := gErrorBkg;

  if (risk = stML_DELETED) or (risk = stML_REPLACED)  then
    dbgMedList.canvas.brush.color := gErrorBkg;
  if (risk = stML_DELETED) or (risk = stML_REPLACED)  then
    dbgMedList.canvas.font.color := clGray;

  with Sender as TDBGrid do
    begin
      sReadOnly := dataset.FieldByName(fnML_Source).AsString;
      if sReadOnly <> '' then
        begin
          Canvas.Brush.Color := gErrorBkg;
          Canvas.Font.Color := clBlue;
        end;
      if pnlExtras.Visible then
        DefaultDrawColumnCell(Rect, DataCol, Column, State)
      else if Columns[DataCol].FieldName = fnML_Status then
        begin
          Canvas.FillRect(Rect);
          if Columns[DataCol].Field.Value = fsInValid then
            ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, 4, True)
          else if Columns[DataCol].Field.Value = fsValid then
            ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, 3, True)
          else if Columns[DataCol].Field.Value = '' then
            ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, 0, True)
          else
            //            ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, 3, True)
            DefaultDrawColumnCell(Rect, DataCol, Column, State);
        end
      else
        DefaultDrawColumnCell(Rect, DataCol, Column, State);
    end;
end;

procedure TfrmFlow.dbgFlowDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  iExtent: Integer;
  field: TField;
  dataset: TDataSet;
  sType,
    sEvent, sComments,
    risk: string;
  RR: TRect;
  dbg: TDBGrid;
begin
  dbg := TDBGrid(Sender);
  dataset := dbg.DataSource.DataSet;
  field := dataset.FieldByName(fnFS_Status);
  if dbg = dbgWorkflow then
    sType := dataset.FieldByName(FN_TYPE).AsString
  else
    sType := '';

  risk := field.asString;

  if risk = fsValid then
    begin
      dbg.canvas.font.color := clBlack;
      dbg.canvas.brush.color := clWindow;
      dbg.canvas.font.Style := [];
    end
  else if risk = fsInValid then
    begin
      dbg.canvas.font.color := clRed;
      dbg.canvas.font.Style := [fsStrikeOut];
      dbg.canvas.brush.color := gErrorBkg;
    end
  else if risk = fsInValidSource then
    begin
      dbg.canvas.font.color := clRed;
      dbg.canvas.font.Style := [fsStrikeOut];
      dbg.canvas.brush.color := gErrorBkg;
    end;

  if sType = 'MedList' then
    begin
      if dbg.Columns[DataCol].FieldName = fnFS_Source then
        begin
          dbg.Canvas.FillRect(Rect);
          //          if dbg.Columns[DataCol].Field.Value = fsDevice then
          ilFlow.Draw(dbg.Canvas, Rect.Left + 4, Rect.Top, 13, True);
          exit;
        end;
      if dbg.Columns[DataCol].FieldName = fnFS_BP then
        begin
          rr := Rect;
          sComments :=
            DataSet.FieldbyName(fnML_Medication).AsString + ' ' +
            DataSet.FieldbyName(fnML_Dose).AsString + ' ' +
            DataSet.FieldbyName(fnML_Units).AsString + ' ' +
            DataSet.FieldbyName(fnML_Rout).AsString + '    ' +
            DataSet.FieldbyName(fnML_GivenBy).AsString + '   ' +
            DataSet.FieldbyName(fnML_Reason).AsString + '   ' +
            DataSet.FieldbyName(fnML_outcome).AsString
            ;

          dbg.canvas.brush.color := dbgFlow.Color;

          iExtent := dbgFlow.Width;
          rr.Right := rr.Left + iExtent * 4;

          dbg.Canvas.FillRect(rr);
          dbg.Canvas.TextRect(rr, rr.Left + 20, rr.Top + 2, sEvent + '  ' +
            sComments);
        end
      else if (dbg.Columns[DataCol].FieldName = fnFS_date)
        or (dbg.Columns[DataCol].FieldName = fnFS_Time)
        or (dbg.Columns[DataCol].FieldName = fnFS_SessionID)
        or (dbg.Columns[DataCol].FieldName = fnFS_PatientID) then
        dbg.DefaultDrawColumnCell(Rect, DataCol, Column, State);
      Exit;
    end;

  with Sender as TDBGrid do
    begin
      if Columns[DataCol].FieldName = fnFS_Source then
        begin
          Canvas.FillRect(Rect);
          if Columns[DataCol].Field.Value = fsDevice then
            ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, 1, True)
          else if Columns[DataCol].Field.Value = fsManual then
            ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, 2, True)
          else
            ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, 0, True)
        end
{$IFDEF FLOWEVENTS}
      else
        begin
          sEvent := DataSet.FieldbyName(fnFS_Event).AsString;
          if (sEvent = '')
            or (Columns[DataCol].FieldName = fnFS_date)
            or (Columns[DataCol].FieldName = fnFS_Time)
            or (Columns[DataCol].FieldName = fnFS_SessionID)
            or (Columns[DataCol].FieldName = fnFS_PatientID) then
            DefaultDrawColumnCell(Rect, DataCol, Column, State)
          else
            begin
              sComments := DataSet.FieldbyName(fnFS_Comments).AsString;
              if Columns[DataCol].FieldName = fnFS_BP then
                begin
                  rr := Rect;
                  dbg.canvas.brush.color := dbgFlow.Color;

                  iExtent := dbgFlow.Width;
                  rr.Right := rr.Left + iExtent;

                  dbg.Canvas.FillRect(Rr);
                  dbg.Canvas.TextRect(rr, rr.Left + 20, rr.Top + 2, sEvent + '  '
                    + sComments);
                end;
            end;
        end
{$ELSE}
      else
        DefaultDrawColumnCell(Rect, DataCol, Column, State);
{$ENDIF}
    end;
end;

procedure TfrmFlow.acMLValidExecute(Sender: TObject);
var
  dataset: TDataSet;
  BM: TBookmark;
begin
  dataset := dbgMedList.DataSource.DataSet;
  BM := dataset.GetBookmark;
  if dataset.FieldByName(fnML_Status).AsString = fsInvalid then
    begin
//  vhaishandria 2007-08-16 no validation of the invalid record
(*
      if Preferences.bValue(onAllowUserEnableMedicationRecords) then
        begin
          dataset.Edit;
          dataset.FieldByName(fnML_Status).AsString := fsValid;
          dataset.FieldByName(fnML_StatusDate).AsDateTime := Now;
          dataset.FieldByName(fnML_StatusBy).AsString :=
            Engine.CurrentOperatorID;
          dataset.Post;
        end;
*)
    end
  else
    begin
      dataset.Edit;
      dataset.FieldByName(fnML_Status).AsString := fsInvalid;
      dataset.FieldByName(fnML_StatusDate).AsDateTime := Now;
      dataset.FieldByName(fnML_StatusBy).AsString := Engine.CurrentOperatorID;
      dataset.Post;
    end;

  if assigned(BM) then
    begin
      dataset.GotoBookmark(BM);
      dataset.FreeBookmark(BM);
    end;

  SetActionStatus;
end;

procedure TfrmFlow.dbgMedListColEnter(Sender: TObject);
begin
  with dbgMedList.SelectedField do
    begin
      if (FieldName = fnML_GivenBy) then // or (FieldName = fnML_Medication)
        dbgMedList.ReadOnly := False
      else
        dbgMedList.ReadOnly := True
    end;
end;

procedure TfrmFlow.dbgMedListColExit(Sender: TObject);
begin
  with dbgMedList.SelectedField do
    if FieldName = fnML_GivenBy then
      try
        dbgMedList.DataSource.DataSet.Post;
      except
      end
end;

procedure TfrmFlow.acDBCRefreshExecute(Sender: TObject);
begin
{$IFDEF CHART}
  dbc.RefreshData;
{$ENDIF}
end;

procedure TfrmFlow.cblDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  aRect: TRect;
begin
  aRect.Left := Rect.Left;
  aRect.Top := Rect.top;
  aRect.Bottom := Rect.Top + cbl.ItemHeight;
  aRect.Right := Rect.Left + cbl.ItemHeight;
  cbl.Canvas.Brush.Color := TChartSeries(cbl.Items.Objects[Index]).SeriesColor;
  //.Color;
  cbl.Canvas.FillRect(aRect);

  cbl.Canvas.Brush.Color := clBtnFace;
  aRect.Left := Rect.Left + 21;
  aRect.Top := Rect.top;
  aRect.Bottom := Rect.Bottom;
  aRect.Right := Rect.Right;
  cbl.Canvas.FillRect(aRect);

  cbl.Canvas.TextOut(Rect.Left + cbl.ItemHeight + 2, Rect.Top, '- ' +
    TChartSeries(cbl.Items.Objects[Index]).Title);
end;

procedure TfrmFlow.cblClick(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to cbl.Items.Count - 1 do
    begin
      dbc.Series[i + EXTRA_SERIES].Active := cbl.Checked[i];
      dbc.Series[i + EXTRA_SERIES].Marks.Visible := cbLabels.Checked;
    end;
end;

procedure TfrmFlow.acView3DExecute(Sender: TObject);
begin
  dbc.View3D := cbView3d.Checked;
end;

procedure TfrmFlow.acAllowZoomExecute(Sender: TObject);
begin
  dbc.AllowZoom := cbAllowZoom.Checked;
end;

procedure TfrmFlow.acLabelsExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to cbl.Items.Count - 1 do
    TLineSeries(cbl.Items.Objects[i]).Marks.Visible := cbLabels.Checked;
end;

procedure TfrmFlow.acPointsExecute(Sender: TObject);
var
  i: Integer;
begin
  Exit;
  for i := 0 to cbl.Items.Count - 1 do
    //    TLineSeries(cbl.Items.Objects[i]).... := cbPoints.Checked;
end;

procedure TfrmFlow.acShowAllExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to cbl.Items.Count - 1 do
    begin
      TLineSeries(cbl.Items.Objects[i]).Active := true;
      cbl.Checked[i] := true;
    end;
end;

procedure TfrmFlow.acHideAllExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to cbl.Items.Count - 1 do
    begin
      TLineSeries(cbl.Items.Objects[i]).Active := i = cbl.ItemIndex;
      cbl.Checked[i] := i = cbl.ItemIndex;
    end;
end;

procedure TfrmFlow.sbSubmitVitalsClick(Sender: TObject);
begin
  if Preferences.bValue(onSaveFlowsheetVitals) then
    Engine.SubmitVitalsData;
  Engine.SubmitFlowsheet;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmFlow.acAddNoteExecute(Sender: TObject);
var
//  sDate,
    sText: string;

begin
  if AddComment(sText) = mrOK then
    begin
//      sDate := FormatDateTime('yyyymmdd-hh:nn:ss.zzz', Now);
      addNote(Engine.NoteList_CDS,
        sText,
        Engine.UserDUZ,
        pnFlow,
        Name,
//        sDate,
        fsValid,
        Now,
        Engine.getCurrentServerDateTime);
    end;
end;

procedure TfrmFlow.acLockNoteExecute(Sender: TObject);
begin
  dmData.LockCurrentNote;
end;

////////////////////////////////////////////////////////////////////////////////

procedure TfrmFlow.acAddTIUNoteExecute(Sender: TObject);
begin
  AddTIUNote(Engine.CurrentPatient.SessionID, Engine.CurrentOperatorID,
    Engine.UserDUZ);
end;

procedure TfrmFlow.acReLoadExecute(Sender: TObject);
var
  sl: TStringList;
  xmlFlowsheet
    //  , xmlNotes
  , xmlMedlist,
    s: string;
  bReplace,
  b: Boolean;

  function DefaultCopyName(aPrefix: string): string;
  begin
    Result := Engine.CurrentPatient.SessionID + '_' + aPrefix +
      FormatDateTime('_yymmdd-hhmmss_', Now) + '.xml';
  end;

  procedure prepareXMLStrings;
  begin
    try
      TClientDataSet(dbgFlow.DataSource.DataSet).MergeChangeLog;
      xmlFlowsheet := TClientDataSet(dbgFlow.DataSource.DataSet).XMLData;
    except
      xmlFlowsheet := '';
    end;
    try
      TClientDataSet(dbgMedList.DataSource.DataSet).MergeChangeLog;
      xmlMedList := TClientDataSet(dbgMedList.DataSource.DataSet).XMLData;
    except
      xmlMedList := '';
    end;
    (*
        try
          TClientDataSet(dbgNotes.DataSource.DataSet).MergeChangeLog;
          xmlNotes := TClientDataSet(dbgNotes.DataSource.DataSet).XMLData;
        except
          xmlNotes := '';
        end;
    *)
  end;

  procedure CleanFlowsheetCDS(aCDS: TClientDataSet; anOption: Integer);
  begin
    with aCDS do
      begin
        First;
        while not EOF do
          case anOption of
            0: Delete; //Delete All
            1: // delete non Manual records
              if FieldByName(fnFS_Source).AsString = fsManual then
                Next
              else
                Delete;
          end;
      end;
  end;

  procedure CleanMedListCDS(aCDS: TClientDataSet; anOption: Integer);
  begin
    with aCDS do
      begin
        First;
        while not EOF do
          case anOption of
            0: Delete; //Delete All
            1: // delete non Manual records
              if (FieldByName(fnML_Source).AsString = 'GAMBRO') or
                (FieldByName(fnML_Source).AsString = 'FRESENIUS') then
                Delete
              else
                Next;
          end;
      end;
  end;

  procedure CleanNotesCDS(aCDS: TClientDataSet; anOption: Integer);
  begin
    with aCDS do
      begin
        First;
        while not EOF do
          case anOption of
            0: Delete; //Delete All
            1: // delete non Manual records
              if FieldByName(fnNL_AuthorID).AsString = 'FRESENIUS' then
                Delete
              else
                Next;
          end;
      end;
  end;

  procedure restoreTableFromFile(aFileName: string; aDS: TDataSet);
  var
    _s: string;
    _sl: TStringList;
    _CDS: TClientDataSet;
  begin
    if aFileName = '' then
      Exit;
    _sl := TStringList.Create;
    _sl.LoadFromFile(aFileName);
    _s := _sl.Text;
    _sl.Free;

    _CDS := TClientDataSet(aDS);
    CDSLoadData(_CDS, _s);
  end;

begin
  s := '';
  if not
    Engine.fRenalController.GetInstrumentResultList(Engine.CurrentPatient.iStudy,
    s, True) then
    begin
      ShowMessage('Failed to load instrument data.' + #13#10 +
        'The reload is not possible.');
      Exit;
    end
  else
    begin
      if not Assigned(dlg_ReloadFlowsheet) then
        Application.CreateForm(Tdlg_ReloadFlowsheet, dlg_ReloadFlowsheet);
      if not Assigned(dlg_ReloadFlowsheet) then
        begin
          ShowMessage('Failed to create Relod dialog window.' + #13#10 +
            'The reload is not possible.');
          Exit;
        end;
      sl := TStringList.Create;
      sl.Text := s;

      b := sl.Count >= 5;

      if not b then
        begin
          MessageDLG('No Data available for reload.' + #13#10 +
            'Try again later', mtInformation, [mbOK], 0);
          exit;
        end;
    end;

  prepareXMLStrings;

  if dlg_ReloadFlowsheet.ShowModal = mrCancel then
    Exit;

  Invalidate;
  Application.ProcessMessages;  

  with dlg_ReloadFlowsheet do
    begin
      if rbFlowInstrumentOnly.Checked then
        CleanFlowsheetCDS(TClientDataSet(dbgFlow.DataSource.DataSet), 1);
      if rbFlowDelete.Checked then
        CleanFlowsheetCDS(TClientDataSet(dbgFlow.DataSource.DataSet), 0);
      if rb2Instrument.Checked then
        CleanMedListCDS(TClientDataSet(dbgMedList.DataSource.DataSet), 1);
      if rb2All.Checked then
        CleanMedListCDS(TClientDataSet(dbgMedList.DataSource.DataSet), 0);
      if rb3Instrument.Checked then
        CleanNotesCDS(dmData.cdsNotes, 1);
      if rb3All.Checked then
        CleanNotesCDS(dmData.cdsNotes, 0);

      // vhaishandria 2007-07-12
//      if rbReplace.Checked then
        begin
          if dmData.cdsSummary.State <> dsEdit then
            dmData.cdsSummary.Edit;
          dmData.cdsSummary.FieldByName(fnS_LastTimeUpdated).AsDateTime := 0;
          dmData.cdsSummary.Post;
        end;

      b := cbNewOnly.Checked;
      cbNewOnly.Checked := rbNewResults.Checked;


      bReplace := Preferences.bValue(onOverwriteManualInput);
//      if rbReplace.Checked then
//        Preferences.setValue(onOverwriteManualInput,'TRUE');
      Preferences.setValue(onOverwriteManualInput,'FALSE');

      acRefreshExecute(nil);
      if bReplace then
        Preferences.setValue(onOverwriteManualInput,'TRUE')
      else
        Preferences.setValue(onOverwriteManualInput,'FALSE');

      FrameMDK_Comments.acRefreshExecute(nil);

      cbNewOnly.Checked := b;
    end;

end;

procedure TfrmFlow.acInvalidNoteExecute(Sender: TObject);
begin
  dmData.ChangeCurrentNoteValidStatus;
end;

procedure TfrmFlow.acFormatExecute(Sender: TObject);
var
  aF: TField;
begin
  af := dbgFlow.SelectedField;
  UpdateColumnField(aF, dbgFlow.DataSource.DataSet.Name, aF.FieldName);
end;

procedure TfrmFlow.acFormatMedicineExecute(Sender: TObject);
var
  aF: TField;
begin
  af := dbgMedList.SelectedField;
  UpdateColumnField(aF, dbgMedList.DataSource.DataSet.Name, aF.FieldName);
end;

procedure TfrmFlow.acFormatCommentsExecute(Sender: TObject);
//var
//  aF: TField;
begin
  //  af := dbgNotes.SelectedField;
  //  UpdateColumnField(aF, dbgNotes.DataSource.DataSet.Name, aF.FieldName);
end;

procedure TfrmFlow.dbgMedListDblClick(Sender: TObject);
begin
  Exit; //2007-08-03 vhaishandria build 312 #30
        // dblClick action is confusing

  if Engine.CurrentPatient.ReadOnly then
    Exit;
  if dmData.cdsMedList.RecordCount > 0 then
    acMLValidExecute(dbgMedList);
end;

procedure TfrmFlow.dbcClickSeries(Sender: TCustomChart;
  Series: TChartSeries; ValueIndex: Integer; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  s: string;
  d: Double;
  CDS: TClientDataSet;
begin
  // scroll medication list if found
  if Series is TLineSeries then
    begin
      with TLineSeries(Series) do
        begin
        end;
    end
  else if Series is TPointSeries then
    begin
      with TPointSeries(Series) do
        begin
          d := XValue[ValueIndex];
          s := FormatDateTime(gMDK_TimeFMT, d);
          MessageDlg(s, mtWarning, [mbOK], 0);
          {
                    try
                      cds := TClientDataSet(DataSource);
                      cds.Locate(XValues.ValueSource,VarArrayOf([s]),[]);

                    except
                      MessageDlg(s, mtWarning, [mbOK], 0);
                    end;
          }
        end;
    end
  else if Series is TBarSeries then
    begin
      with TBarSeries(Series) do
        begin
          d := XValue[ValueIndex];
          s := FormatDateTime(gMDK_TimeFMT, d);
          try
            cds := TClientDataSet(DataSource);
            cds.Locate(XValues.ValueSource, VarArrayOf([s]), []);
            //            MedicationView;
          except
            MessageDlg(s, mtWarning, [mbOK], 0);
          end;
        end;
    end;
end;

procedure TfrmFlow.pgcFlowsheetChange(Sender: TObject);
begin
  if pgcFlowsheet.ActivePage = tsTimeline then
    setupComments(Series1, dbc, Engine.NoteList_CDS, cbl, fnNL_DateTime,
      fnNL_Text);
  if pgcFlowsheet.ActivePage = tsWorkflow then
    acWF_Refresh.Execute;

  pnlWorkflowToolbar.Visible := pgcFlowsheet.ActivePage = tsWorkflow;
end;

procedure TfrmFlow.setReadOnly(aReadOnly: Boolean = False);
begin
//  dbgFlow.ReadOnly := aReadOnly;
  dbgMedList.ReadOnly := true;

  FrameMDK_Comments.ReadOnly := Engine.CurrentPatient.ReadOnly;

  acRefresh.Enabled := not Engine.CurrentPatient.ReadOnly;
  acReLoad.Enabled := not Engine.CurrentPatient.ReadOnly;
  acAdd.Enabled := not Engine.CurrentPatient.ReadOnly;
  acEdit.Enabled := not Engine.CurrentPatient.ReadOnly;
  acSetStatus.Enabled := not Engine.CurrentPatient.ReadOnly;

  acMLAdd.Enabled := not Engine.CurrentPatient.ReadOnly;
//  acMLValid.Enabled := not Engine.CurrentPatient.ReadOnly
//    and (dbgMedList.DataSource.DataSet.RecordCount > 0);
end;

procedure TfrmFlow.saveData;
begin
end;

procedure TfrmFlow.acWF_RefreshExecute(Sender: TObject);
begin
  dmData.cdsWorkflow.EmptyDataSet;

  CDSAppend(dmData.cdsFlowSheet, dmData.cdsWorkflow,
    '',
    FN_TYPE + '=Flowsheet'
    );
  CDSAppend(dmData.cdsMedList, dmData.cdsWorkflow,
    FN_DATE_ONLY + '=' + fnML_Date + #13#10 +
    FN_TIME_ONLY + '=' + fnML_Time + #13#10,
    FN_TYPE + '=MedList'
    );
  try
    CDSAppend(dmData.cdsNotes, dmData.cdsWorkflow,
      '',
      FN_TYPE + '=NoteList'
      );
  except
  end;

  dmData.cdsWorkflow.First;
  while not dmData.cdsWorkflow.Eof do
    begin
      if dmData.cdsWorkflow.FieldByName(FN_TYPE).Value = 'MedList' then
        begin
          dmData.cdsWorkflow.Edit;
          dmData.cdsWorkflow.FieldByName(FN_DATETIME).Value :=
            round(dmData.cdsWorkflow.FieldByName(FN_DATE_ONLY).asDateTime) +
            frac(dmData.cdsWorkflow.FieldByName(FN_TIME_ONLY).AsDateTime);
          dmData.cdsWorkflow.Post;
        end;

      if dmData.cdsWorkflow.FieldByName(FN_TYPE).Value = 'Flowsheet' then
        begin
          dmData.cdsWorkflow.Edit;
          dmData.cdsWorkflow.FieldByName(FN_DATETIME).Value :=
            round(dmData.cdsWorkflow.FieldByName(FN_DATE_ONLY).asDateTime) +
            frac(dmData.cdsWorkflow.FieldByName(FN_TIME_ONLY).AsDateTime);
          dmData.cdsWorkflow.Post;
        end;

      if dmData.cdsWorkflow.FieldByName(FN_TYPE).Value = 'NoteList' then
        begin
          dmData.cdsWorkflow.Edit;
          dmData.cdsWorkflow.FieldByName(FN_DATE_ONLY).Value :=
            round(dmData.cdsWorkflow.FieldByName(FN_DATETIME).asDateTime);
          dmData.cdsWorkflow.FieldByName(FN_TIME_ONLY).Value :=
            frac(dmData.cdsWorkflow.FieldByName(FN_DATETIME).AsDateTime);
          dmData.cdsWorkflow.Post;
        end;

      dmData.cdsWorkflow.Next;
    end;
end;

procedure TfrmFlow.acClearExecute(Sender: TObject);
begin
  dmData.cdsFlowSheet.EmptyDataSet;
end;

procedure TfrmFlow.dbgWorkflowDrawColumnCell(Sender: TObject;
  const Rect: TRect; DataCol: Integer; Column: TColumn;
  State: TGridDrawState);
var
  iType,
    //    iValidStatus,
  iSource: Integer;

  iExtent: Integer;
  dataset: TDataSet;
  sType, sSource, sStatus,
    sEvent, sComments
    //    ,risk
  : string;
  RR: TRect;
  dbg: TDBGrid;
const
  //        1      8       16
  kwType = 'MedListNoteListFlowsheet';
  //               1      8      15
  kwValidStatus = 'INVALIDUNKNOWNINVALID SOURCE';

begin
  dbg := TDBGrid(Sender);
  dataset := dbg.DataSource.DataSet;

  sStatus := dataset.FieldByName(fnFS_Status).AsString;
  if sStatus = fsValid then
    begin
      dbg.canvas.font.color := clBlack;
      dbg.canvas.brush.color := clWindow;
      dbg.canvas.font.Style := [];
    end
  else if sStatus = fsInValid then
    begin
      dbg.canvas.font.color := clRed;
      dbg.canvas.font.Style := [fsStrikeOut];
      dbg.canvas.brush.color := gErrorBkg;
    end
  else if sStatus = fsInValidSource then
    begin
      dbg.canvas.font.color := clRed;
      dbg.canvas.font.Style := [fsStrikeOut];
      dbg.canvas.brush.color := gErrorBkg;
    end;

  (*
    if sType = 'MedList' then
      begin
        if dbg.Columns[DataCol].FieldName = fnFS_Source then
          begin
            dbg.Canvas.FillRect(Rect);
  //          if dbg.Columns[DataCol].Field.Value = fsDevice then
              ilFlow.Draw(dbg.Canvas, Rect.Left + 4, Rect.Top, 13, True);
            exit;
          end;
        if dbg.Columns[DataCol].FieldName = fnFS_BP then
          begin
            rr := Rect;
            sComments :=
              DataSet.FieldbyName(fnML_Medication).AsString + ' ' +
              DataSet.FieldbyName(fnML_Dose).AsString + ' ' +
              DataSet.FieldbyName(fnML_Units).AsString + ' ' +
              DataSet.FieldbyName(fnML_Rout).AsString + '    ' +
              DataSet.FieldbyName(fnML_GivenBy).AsString + '   ' +
              DataSet.FieldbyName(fnML_Reason).AsString + '   ' +
              DataSet.FieldbyName(fnML_outcome).AsString
              ;

            dbg.canvas.brush.color := dbgFlow.Color;

            iExtent := dbgFlow.Width;
            rr.Right := rr.Left + iExtent*4;

            dbg.Canvas.FillRect(rr);
            dbg.Canvas.TextRect(rr, rr.Left + 20, rr.Top + 2, sEvent + '  ' +
              sComments);
          end
        else if (dbg.Columns[DataCol].FieldName = fnFS_date)
          or (dbg.Columns[DataCol].FieldName = fnFS_Time)
          or (dbg.Columns[DataCol].FieldName = fnFS_SessionID)
          or (dbg.Columns[DataCol].FieldName = fnFS_PatientID) then
          dbg.DefaultDrawColumnCell(Rect, DataCol, Column, State);
        Exit;
      end;
  *)
  with Sender as TDBGrid do
    begin
      if Columns[DataCol].FieldName = fnFS_Source then
        begin
          sSource := dataset.FieldByName(fnFS_Source).AsString;
          if sSource = fsDevice then
            iSource := 1
          else if sSource = fsManual then
            iSource := 14
          else
            iSource := 0;
          Canvas.FillRect(Rect);
          ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, iSource, True)
        end
      else if Columns[DataCol].FieldName = fn_Description then
        begin
          sComments := '';
          sType := dataset.FieldByName(FN_TYPE).AsString;
          iType := pos(sType, kwType);
          case iType of
            1:
              begin
                iType := 13;
                sComments :=
                  DataSet.FieldbyName(fnML_Medication).AsString + ' ' +
                  DataSet.FieldbyName(fnML_Dose).AsString + ' ' +
                  DataSet.FieldbyName(fnML_Units).AsString + ' ' +
                  DataSet.FieldbyName(fnML_Rout).AsString + '    ' +
                  DataSet.FieldbyName(fnML_GivenBy).AsString + '   ' +
                  DataSet.FieldbyName(fnML_Reason).AsString + '   ' +
                  DataSet.FieldbyName(fnML_outcome).AsString
              end;
            8:
              begin
                iType := 12;
                sComments :=
                  DataSet.FieldbyName(fnNL_Text).AsString + '  ' +
                  DataSet.FieldbyName(fnNL_AuthorID).AsString;
              end;
            16: iType := 1;
          else
            iType := 0;
          end;

          Canvas.FillRect(Rect);
          Canvas.TextRect(Rect, Rect.Left + 25, Rect.Top + 2, sComments);
          ilFlow.Draw(Canvas, Rect.Left + 4, Rect.Top, iType, True);
        end
{$IFDEF FLOWEVENTS}
      else
        begin
          sEvent := DataSet.FieldbyName(fnFS_Event).AsString;
          if (sEvent = '')
            or (Columns[DataCol].FieldName = fnFS_date)
            or (Columns[DataCol].FieldName = fnFS_Time)
            or (Columns[DataCol].FieldName = fnFS_SessionID)
            or (Columns[DataCol].FieldName = fnFS_PatientID) then
            DefaultDrawColumnCell(Rect, DataCol, Column, State)
          else
            begin
              sComments := DataSet.FieldbyName(fnFS_Comments).AsString;
              if Columns[DataCol].FieldName = fnFS_BP then
                begin
                  rr := Rect;
                  dbg.canvas.brush.color := dbgFlow.Color;

                  iExtent := dbgFlow.Width;
                  rr.Right := rr.Left + iExtent;

                  dbg.Canvas.FillRect(Rr);
                  dbg.Canvas.TextRect(rr, rr.Left + 20, rr.Top + 2, sEvent + '  '
                    + sComments);
                end;
            end;
        end
{$ELSE}
      else
        DefaultDrawColumnCell(Rect, DataCol, Column, State);
{$ENDIF}
    end;
end;

procedure TfrmFlow.setWorkflowStatus;
begin
  pnlMedication.Visible := dmData.cdsWorkflow.FieldByName(FN_TYPE).AsString =
    'MedList';
  pnlNote.Visible := dmData.cdsWorkflow.FieldByName(FN_TYPE).AsString =
    'NoteList';
  pnlFlowsheetRecord.Visible := dmData.cdsWorkflow.FieldByName(FN_TYPE).AsString
    = 'Flowsheet';
end;

procedure TfrmFlow.acReloadFlowsheetExecute(Sender: TObject);
begin
  acRefresh.Execute;
end;

procedure TfrmFlow.acAddFSRecordExecute(Sender: TObject);
begin
  acAdd.Execute;
end;

procedure TfrmFlow.acAddCommentExecute(Sender: TObject);
begin
  FrameMDK_Comments.acAdd.Execute;
end;

procedure TfrmFlow.acAddTIUExecute(Sender: TObject);
begin
  acAddTIUNote.Execute;
end;

function TfrmFlow.getMainMenu: TMainMenu;
begin
  Result := mnMain;
end;

procedure TfrmFlow.ActivateTabForm;
begin
  FrameMDK_Comments.ActivateFrame;
  SetActionStatus;
end;

procedure TfrmFlow.ckbShowDeletedClick(Sender: TObject);
begin
  dmData.cdsMedList.Filtered := not ckbShowDeleted.Checked;

  if ckbShowDeleted.Checked then
    userSettings.setValue(onShowDeletedMedicine, 'TRUE')
  else
    userSettings.setValue(onShowDeletedMedicine, 'FALSE');

  Engine.SaveUserOptions;
  Preferences.Overwrite(userSettings.ValueList.Text);
end;

procedure TfrmFlow.SpeedButton22Click(Sender: TObject);
begin
  dmData.cdsMedList.Delete;
end;

(*

procedure TfrmFlow.FileOpen1Accept(Sender: TObject);
var
  s:String;
  sl:TStringList;
  anIR: TInstrumentRecord;
begin
  sl := TStringList.Create;
  sl.LoadFromFile(FileOpen1.Dialog.FileName);
  s := sl.Text;
  SL.Free;
  Engine.ProblemList := '';

  //Engine.addFlowsheetRecord(s);
  anIR := getInstrumentRecord(Engine.CurrentPatient.ID,Engine.CurrentPatient.SessionID,s);
  anIR.Free;

  dmData.Params := 'File <'+FileOpen1.Dialog.FileName+'>';
  Engine.Report(etInfo,s,'',0,'','Get Instrument Data From File','OK',TRUE);
  dmData.Params := '';

  if Engine.ProblemList <> '' then
    begin
      s := dbmComments.Text + Engine.ProblemList;
      dmData.cdsSummary.Edit;
      dmData.cdsSummary.FieldByName(fnS_WorkflowNotes).AsString := s;
      dmData.cdsSummary.Post;
    end;
end;*)

procedure TfrmFlow.acDuplicatesExecute(Sender: TObject);
begin
{$IFDEF IGNORE_DUPLICATES}
  if Preferences.bValue(onShowFlowsheetDuplicates) then
    begin
      Preferences.setValue(onShowFlowsheetDuplicates,'FALSE');
      MarkDuplicates(Engine.FlowSheet_CDS,fnFS_Duplicate);
      Engine.FlowSheet_CDS.Filtered := True;
    end
  else
    begin
      Preferences.setValue(onShowFlowsheetDuplicates,'TRUE');
      Engine.FlowSheet_CDS.Filtered := False;
    end;
  ShowDuplicates1.Checked := Preferences.bValue(onShowFlowsheetDuplicates);
{$ENDIF}
end;

end.


