unit fMDK_Log;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 4/22/08 3:06p $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  this unit contains the Hemodialysis application
*                     options tree main form
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Tabs/fMDK_Log.pas $
*
*       $ History: fMDK_Log.pas $
}
interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, DBGrids, ComCtrls, StdCtrls, ExtCtrls, DBCtrls, DBClient,
  Buttons, ValEdit, ActnList, DB
  , uMDK_ReportList
  , fMDK_Options
  , ImgList
{$IFDEF USEXSLT}
  , fMDK_XSLT
{$ENDIF}
  , fMDK_BugReport
  , fMDK_Toolbox
  ;

type

  TfrmLog = class(TForm)
    pnlDeveloper: TPanel;
    pnlDevMenu: TPanel;
    pnlDevMain: TPanel;
    splt: TSplitter;
    pnlDevTree: TPanel;
    pnlDevTreeHeader: TPanel;
    tvwMain: TTreeView;
    pnlDetails: TPanel;
    ActionList1: TActionList;
    acSend: TAction;
    acSaveAs: TAction;
    dlgSave: TSaveDialog;
    acLoad: TAction;
    dlgOpen: TOpenDialog;
    acDictionaryCreate: TAction;
    acDictionarySave: TAction;
    acDictionaryLoad: TAction;
    bvlOptions: TBevel;
    imglst: TImageList;
    Bevel1: TBevel;
    acAddNote: TAction;
    acLoadNotes: TAction;
    acDictionaryReload: TAction;
    acCleanupOptions: TAction;
    pnlClose: TPanel;
    Panel2: TPanel;
    BitBtn2: TBitBtn;
    pnlCleanup: TPanel;
    BitBtn1: TBitBtn;
    procedure tvwMainChange(Sender: TObject; Node: TTreeNode);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure tvwMainDblClick(Sender: TObject);
    procedure acDictionaryReloadExecute(Sender: TObject);
    procedure acCleanupOptionsExecute(Sender: TObject);
    procedure tvwMainChanging(Sender: TObject; Node: TTreeNode;
      var AllowChange: Boolean);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
    fCurrentForm: TForm;

    fReportList: TMDK_ReportList;
    fNoteTemplateListView: TfrmMDK_Options;
    fReportListView: TfrmMDK_Options;
    fNoteList: TfrmMDK_Options;
    fNote: TfrmBugReport;
{$IFDEF SHOWDATASETS}
    fDatasets: TfrmMDK_Options;
{$ENDIF}
{$IFDEF USEXSLT}
    fXSLTList: TfrmMDK_Options;
    fXSLT: TfrmMDK_XSLT;
{$ENDIF}
{$IFDEF TOOLBOX}
    fToolbox: TfrmToolbox;
{$ENDIF}
    procedure setUpOptions(aName, aValue: string; iParent, iChild: Integer);
    procedure setCurrentForm(aForm: TForm);
    procedure RefreshNodeByString(aString: string);
  public
    { Public declarations }

    fOptions: TfrmMDK_Options;
    fSysOptions: TfrmMDK_Options;
    fUserOptions: TfrmMDK_Options;

    property CurrentForm: TForm read fCurrentForm write setCurrentForm;

    procedure setUpTreeView;
    procedure setRole(aRole: string);
    procedure SaveOptions;
    procedure Refresh;
  end;

var
  frmLog: TfrmLog;

implementation

uses dMDK_Data, uMDK_Patients
  , uMDK_CDSCommon, uMDK_Engine,
  uMDK_Common, fMDK_Report, fMDK_CDS
  , uROR_CommonUtils
  , uMDK_Options
  , fMDK_Wait
  , uMDK_Utils
  , uMDK_SubmitHistory
  , uXML
  , fMDK_DictionaryEdit
  , uMDK_ReportEngine;

{$R *.dfm}
const
  iBlank = 0;
  iGear = 1;
  iReport = 2;
  iKey = 3;
  iNote = 4;
  iDocStack = 5;
  iSingleDoc = 6;
  iTools = 7;
  iDevice = 8;
  iTable = 9;
  iNoteList = 10;
  iCustomList = 12;
  iAdmin = 14;

  iXSLTList = 10;
  iXSLTTemplate = 1;

procedure TfrmLog.FormCreate(Sender: TObject);
begin
  fNoteTemplateListView := NewOptionForm(onNoteTemplates);
  fReportListView := NewOptionForm(onReportList);
{$IFDEF SHOWDATASETS}
  fDatasets := NewOptionForm(onDatasetNames);
{$ENDIF}
  fNoteList := NewOptionForm(onNotes);

  fOptions := NewOptionForm(onUserOptions); //061122
  fSysOptions := NewOptionForm(onSysOptions);
  fUserOptions := NewOptionForm(onUserOptions, otUser);

  fNote := NewReport(onSingleNote, '', '', '', '');
{$IFDEF USEXSLT}
  fXSLTList := NewOptionForm(onXSLTList);
  fXSLT := NewMDK_XSLT('');
{$ENDIF}

{$IFDEF TOOLBOX}
  Application.CreateForm(TfrmToolBox, fToolbox);
{$ENDIF}
  try
    SetUpForm(frmMDK_Report, pnlDetails);
    SetUpForm(fOptions, pnlDetails); //061122
    SetUpForm(frmMDK_CDS, pnlDetails);
    SetUpForm(fNoteTemplateListView, pnlDetails);
    SetUpForm(fReportListView, pnlDetails);
{$IFDEF SHOWDATASETS}
    SetUpForm(fDatasets, pnlDetails);
{$ENDIF}
    SetUpForm(fNoteList, pnlDetails);
    SetUpForm(fSysOptions, pnlDetails);
    SetUpForm(fUserOptions, pnlDetails);
    SetUpForm(fNote, pnlDetails);
{$IFDEF TOOLBOX}
    SetUpForm(fToolbox, pnlDetails);
{$ENDIF}
{$IFDEF USEXSLT}
    SetUpForm(fXSLT, pnlDetails);
    SetUpForm(fXSLTList, pnlDetails);
{$ENDIF}
  except
  end;

  fReportList := TMDK_ReportList.Create;

{$IFDEF AANTEST}
  tvwMain.ReadOnly := False;
{$ELSE}
  tvwMain.ReadOnly := True;
{$ENDIF}

  tvwMain.FullExpand;

{$IFDEF LOG_DIALOG}
  Constraints.MinWidth := 800;
  Constraints.MinHeight := 600;
  KeyPreview := True;
  pnlClose.Visible := True;
  pnlDevMenu.Visible := False;
{$ELSE}
  pnlDevMenu.Visible := False;
  pnlClose.Visible := False;
{$ENDIF}
end;

procedure TfrmLog.FormDestroy(Sender: TObject);
begin
{$IFDEF LOG_DIALOG}
  Exit;
{$ENDIF}

{$IFDEF TOOLBOX}
  if fToolbox <> nil then
    FreeAndNil(fToolbox);
{$ENDIF}
  if fReportList <> nil then
    FreeAndNil(fReportList);

{$IFDEF USEXSLT}
  if fXSLT <> nil then
    FreeAndNil(fXSLT);
  if fXSLTList <> nil then
    FreeAndNil(fXSLTList);
{$ENDIF}

  if fNote <> nil then
    FreeAndNil(fNote);
  if fUserOptions <> nil then
    FreeAndNil(fUserOptions);
  if fSysOptions <> nil then
    FreeAndNil(fSysOptions);
  if fNoteList <> nil then
    FreeAndNil(fNoteList);

{$IFDEF SHOWDATASETS}
  if fDataSets <> nil then
    FreeAndNil(fDataSets);
{$ENDIF}
  if fOptions <> nil then
    FreeAndNil(fOptions); //061122
  if fReportList <> nil then
    FreeAndNil(fReportListView);
  if fNoteTemplateListView <> nil then
    FreeAndNil(fNoteTemplateListView);
end;

procedure TfrmLog.tvwMainChange(Sender: TObject; Node: TTreeNode);

  procedure setLevelZero;
  begin
{$IFNDEF AANTEST}
    if (Engine.CurrentOperatorMode = rnADMIN) then
      begin
        frmMDK_CDS.dbN.Enabled := True;
        frmMDK_CDS.dbg.Color := clWindow;
      end
    else
      begin
        frmMDK_CDS.dbg.ReadOnly := True;
        frmMDK_CDS.dbN.Enabled := False;
        frmMDK_CDS.dbg.Color := clInfoBk;
      end;

    if Node.Text = 'Study Events' then
      begin
        frmMDK_CDS.acDeleteAll.Enabled := Engine.CurrentOperatorMode = rnADMIN;
        frmMDK_CDS.acLoad.Enabled := Engine.CurrentOperatorMode = rnADMIN;
        frmMDK_CDS.dbG.ReadOnly := True;
        frmMDK_CDS.dbN.Enabled := True;
        frmMDK_CDS.dbG.Color := clInfoBk;
        frmMDK_CDS.dbG.Invalidate;
      end;

    if (Node.Text = 'Dictionary') or (Node.Text = 'Application Dictionary') then
      begin
        frmMDK_CDS.pnlDictionaryActions1.Visible :=
              (Engine.CurrentOperatorMode = rnADMIN);
{$IFDEF DICTIONARY_BACKUP}
        frmMDK_CDS.pnlDictionaryBackup.Visible :=
              (Engine.CurrentOperatorMode = rnADMIN);
{$ELSE}
        frmMDK_CDS.pnlDictionaryBackup.Visible := False;
{$ENDIF}
        frmMDK_CDS.acDeleteAll.Enabled := (Engine.CurrentOperatorMode =
          rnADMIN);
        frmMDK_CDS.acLoad.Enabled := (Engine.CurrentOperatorMode = rnADMIN);
        frmMDK_CDS.dbN.VisibleButtons := frmMDK_CDS.dbN.VisibleButtons -
          [nbRefresh,nbInsert];
        frmMDK_CDS.pnlCDSDetails.Visible := False;
        frmMDK_CDS.splCDS.Visible := False;
        frmMDK_CDS.dbg.ReadOnly := True;
        frmMDK_CDS.dbg.Color := clInfoBk;
      end
    else
      begin
        frmMDK_CDS.pnlCDSDetails.Visible := True;
        frmMDK_CDS.pnlDictionaryActions1.Visible := False;
        frmMDK_CDS.dbN.VisibleButtons := [nbFirst, nbPrior, nbNext, nbLast];
      end;
    frmMDK_CDS.pnlFieldName.Visible := False;
{$ELSE}
    frmMDK_CDS.SetupLayout(pos('Dictionary',Node.Text > 0);
{$ENDIF}
    frmMDK_CDS.SelectCDS(Node.Text);
    CurrentForm := frmMDK_CDS;
  end;

  procedure ProcessLevelZero;
  var
    i: Integer;
    s: string;
  begin
    if (Node.Text = 'Application Events') or
      (Node.Text = 'Dictionary') or
      (Node.Text = 'Application Dictionary') or
      (Node.Text = 'Study Events') then
      setLevelZero
    else if Node.Text = onReportList then
      CurrentForm := fReportListView
{$IFDEF TOOLBOX}
    else if Node.Text = 'Toolbox' then
      CurrentForm := fToolbox
{$ENDIF}
{$IFDEF SHOWDATASETS}
    else if Node.Text = onDatasetNames then
      CurrentForm := fDatasets
{$ENDIF}
    else if Node.Text = onNotes then
      begin
        fNoteList.LastName := Node.Text;
        fNoteList.setRole(Engine.CurrentOperatorMode);
        CurrentForm := fNoteList;
      end
    else if Node.Text = onNoteTemplates then
      begin
        fNote.reReport.Color := clWindow;
        RefreshNodeByString(fNoteTemplateListView.vleOptions.Strings.Text);
        fNoteTemplateListView.LastName := onNoteTemplates;
        fNoteTemplateListView.setRole(Engine.CurrentOperatorMode);
        CurrentForm := fNoteTemplateListView;
      end
{$IFDEF USEXSLT}
    else if Node.Text = onXSLTList then
      CurrentForm := fXSLTList
{$ENDIF}
    else if Node.Text = nnTablesInfo then
      begin
        fNote.reReport.Color := clWindow;
        fNote.LastName := Node.Text;
        CurrentForm := fNote;
      end
    else if Node.Text = onAdministrators then
      begin
        fOptions.ROnly := False;
        fOptions.LastName := Node.Text;
        fOptions.setRole(Engine.CurrentOperatorMode);
        CurrentForm := fOptions;
      end
    else if Node.Text = onUserPreferences then
      begin
        fUserOptions.LastName := onUserOptions; //Node.Text;
        fUserOptions.setRole(Engine.CurrentOperatorMode);
        CurrentForm := fUserOptions;
      end
    else if Node.Text = onPreferences then
      begin
        fNote.LastName := Node.Text;
        with Preferences do
          begin
            ValueList.Sort;
            s := '';
            for i := 0 to ValueList.Count - 1 do
              s := s + '      ' + ValueList.Names[i] + ' = <' +
                ValueList.Values[ValueList.Names[i]] + '>' + #13#10;
          end;
        fNote.reReport.Color := clInfoBk;
        fNote.reReport.Text := #13#10 +
          '  The application currently uses the following option values:' + #13#10#13#10
          + s;
        PaintSyntax(fNote.reReport, False);
        CurrentForm := fNote;
      end
    else if Node.Text = onCustomDataLists then
      begin
        fNote.LastName := Node.Text;
        CurrentForm := fNote;
      end
  end;

  procedure ProcessLevelOne;
  {$IFDEF SHOWDATASETS}
  var
    s: string;
  {$ENDIF}
  begin
    if Node.Parent.Text = 'Tables' then
      begin
        setLevelZero;
      end
{$IFDEF SHOWDATASETS}
    else if Node.Parent.Text = onDatasetNames then
      begin
{$IFDEF AANTEST}
        frmMDK_CDS.pnlFieldName.Visible := True;
{$ELSE}
        frmMDK_CDS.pnlFieldName.Visible := False;
{$ENDIF}
        if Node.Text = onSubmittedStudies then
          begin
            if not dmData.cdsSubmitHistory.Active or
              (dmData.cdsSubmitHistory.RecordCount < 1) then
              begin
                s := Engine.getSystemOptionByName(onSubmittedStudies);
                if pos(XML_VERSION, s) = 1 then
                  Engine.InitDS(dmData.cdsSubmitHistory, s)
                else
                  RestoreSubmtHistory(dmData.cdsSubmitHistory, s);
              end;
          end;
        frmMDK_CDS.SelectCDS(Node.Text);
{$IFDEF AANTEST}
        frmMDK_CDS.dbg.ReadOnly := False;
        frmMDK_CDS.dbN.Enabled := True;
{$ENDIF}
        CurrentForm := frmMDK_CDS;
      end
{$ENDIF}
{$IFDEF USEXSLT}
    else if Node.Parent.Text = onXSLTList then
      begin
        if fXSLT.LastName <> '' then
          Engine.setSystemOptionByName(fXSLT.LastName, fXSLT.mmTemplate.Text);
        fXSLT.LastName := Node.Text;
        fXSLT.mmTemplate.Text := Engine.getSystemOptionByName(Node.Text);

        CurrentForm := fXSLT;
      end
{$ENDIF}
    else if Node.Parent.Text = onReportList then
      begin
        frmMDK_Report.ReportName := Node.Text;
        CurrentForm := frmMDK_Report;
      end
    else if Node.Parent.Text = onNoteTemplates then
      begin
        frmMDK_Report.ReportName := Node.Text;
        CurrentForm := frmMDK_Report;
      end
    else if Node.Parent.Text = onNotes then
      begin
        fNote.LastName := Node.Text;
        CurrentForm := fNote;
      end
    else if Node.Parent.Text = onCustomDataLists then
      begin
        fOptions.ROnly := False;
        fOptions.LastName := Node.Text;
        fOptions.setRole(Engine.CurrentOperatorMode);
        CurrentForm := fOptions;
      end
    else if Node.Parent.Text = 'Preferences' then
      begin
        if Node.Text = onSystemPreferences then
          begin
            fSysOptions.LastName := onSysOptions;
            fSysOptions.setRole(Engine.CurrentOperatorMode);
            CurrentForm := fSysOptions;
          end
        else if Node.Text = onUserPreferences then
          begin
            CurrentForm := fUserOptions;
            fUserOptions.LastName := onUserOptions;
            fUserOptions.setRole(Engine.CurrentOperatorMode);
            CurrentForm := fUserOptions;
          end;
      end
  end;

begin
  try
    case Node.Level of
      0: ProcessLevelZero;
      1: ProcessLevelOne;
    end;
  except
  end;
  pnlDevTreeHeader.Caption := Node.Text;
end;

procedure TfrmLog.setUpOptions(aName, aValue: string; iParent, iChild: Integer);
var
  i: Integer;
  s: string;
  SL: TStringList;
  tn: TTreeNode;
begin
  SL := TstringList.Create;
  SL.Text := aValue;
  tn := tvwMain.Items.AddChild(nil, aName);
  tn.ImageIndex := iParent;
  tn.SelectedIndex := iParent;
  for i := 0 to SL.Count - 1 do
    begin
      s := SL.Names[i];
      if s <> '' then
        with tvwMain.Items.AddChild(tn, s) do
          begin
            ImageIndex := iChild;
            SelectedIndex := iChild;
          end;
    end;
  SL.Free;

  if aName = onNoteTemplates then
    begin
      fNoteTemplateListView.OwnerTreeNode := tvwMain.Items;
      fNoteTemplateListView.OwnerNode := tn;
    end
  else if aName = onReportList then
    begin
      fReportListView.OwnerTreeNode := tvwMain.Items;
      fReportListView.OwnerNode := tn;
    end

end;

procedure TfrmLog.setUpTreeView;
var
  fNow: TDateTime;
  sl: TStringList;
  i: Integer;
  s: string;
  tnOptions: TTreeNode;

  function setUpNewNode(aParent: TTreeNode; aName: string; i1, i2: Integer):
      TTreeNode;
  var
    _tn: TTreeNode;
  begin
    _tn := tvwMain.Items.AddChild(aParent, aName);
    _tn.ImageIndex := i1;
    _tn.SelectedIndex := i2;
    Result := _tn;
  end;

begin
{$IFNDEF AANTEST}
  if (Engine.CurrentOperatorMode = rnADMIN) then
    begin
      setUpNewNode(nil, 'Administrators', iAdmin, iAdmin);
//      if Preferences.bValue(onShowApplicationDictionary) then
// commented on 2007-09-19 vhaishandria
//        setUpNewNode(nil, 'Application Dictionary', iTable, iTable);
      setUpNewNode(nil, 'Application Events', iTable, iTable);

      tnOptions := setUpNewNode(nil, onCustomDataLists, iCustomList,
        iCustomList);
      sl := TStringList.Create;
      sl.Text := DOMAIN_PICK_LIST;
      for i := 0 to sl.Count - 1 do
        setUpNewNode(tnOptions, sl[i], iCustomList, iCustomList);
      sl.Free;

      fNoteTemplateListView.LastName := onNoteTemplates;
      s := Engine.getSystemOptionByName(onNoteTemplates);
      setUpOptions(onNoteTemplates, s, iReport, iReport);

      tnOptions := setUpNewNode(nil, onPreferences, iCustomList, iCustomList);
      setUpNewNode(tnOptions, onSystemPreferences, iCustomList, iCustomList);
      setUpNewNode(tnOptions, onUserPreferences, iCustomList, iCustomList);

      fNow := Now;
      frmWait.AddLogLine(char(VK_TAB) + 'Set Up Reports:');
      fReportListView.LastName := onReportList;
      fReportList.NameList.Text := fReportListView.vleOptions.Strings.Text;
      setUpOptions(onReportList, fReportListView.vleOptions.Strings.Text,
        iDocStack, iReport);
      frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now -
        fNow));
      Engine.Report(rtDebug, fReportList.NameList.Text, '', Now - fNow, '',
        'Set Up Reports');

      setUpNewNode(nil, 'Study Events', iTable, iTable);
    end
  else
    begin
      tnOptions := setUpNewNode(nil, onPreferences, iCustomList, iCustomList);
      setUpNewNode(tnOptions, onUserPreferences, iCustomList, iCustomList);
    end;
{$ENDIF}

{$IFDEF AANTEST}
  setUpNewNode(nil, 'Administrators', iAdmin, iAdmin);
  setUpNewNode(nil, 'Application Events', iTable, iTable);
  setUpNewNode(nil, 'Study Events', iTable, iTable);
  setUpNewNode(nil, 'Application Dictionary', iTable, iTable);

  tnOptions := setUpNewNode(nil, onCustomDataLists, iCustomList, iCustomList);
  sl := TStringList.Create;
  sl.Text := DOMAIN_PICK_LIST;
  for i := 0 to sl.Count - 1 do
    setUpNewNode(tnOptions, sl[i], iCustomList, iCustomList);
  sl.Free;

  fNoteTemplateListView.LastName := onNoteTemplates;
  s := Engine.getSystemOptionByName(onNoteTemplates);
  setUpOptions(onNoteTemplates, s, iReport, iReport);

  tnOptions := setUpNewNode(nil, onPreferences, iCustomList, iCustomList);
  setUpNewNode(tnOptions, onSystemPreferences, iCustomList, iCustomList);
  setUpNewNode(tnOptions, onUserPreferences, iCustomList, iCustomList);

  fNow := Now;
  frmWait.AddLogLine(char(VK_TAB) + 'Set Up Reports:');
  fReportListView.LastName := onReportList;
  fReportList.NameList.Text := fReportListView.vleOptions.Strings.Text;
  setUpOptions(onReportList, fReportListView.vleOptions.Strings.Text, iDocStack,
    iReport);
  frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now - fNow));
  Engine.Report(rtDebug, fReportList.NameList.Text, '', Now - fNow, '',
    'Set Up Reports');

{$IFDEF SHOWDATASETS}
  fNow := Now;
  frmWait.AddLogLine(char(VK_TAB) + 'Dataset names:');
  fDatasets.LastName := onDatasetNames;
  s := Engine.getSystemOptionByName(onDatasetNames);
  setUpOptions(onDatasetNames, s, iKey, iKey);
  frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now - fNow));
  Engine.Report(rtDebug, Engine.getSystemOptionByName(onDatasetNames), '', Now -
    fNow, '', 'Set Up DB Names');
{$ENDIF}

  fNow := Now;
  frmWait.AddLogLine(char(VK_TAB) + 'Set Up Notes:');
  fNoteList.LastName := onNotes;
  s := Engine.getSystemOptionByName(onNotes);
  setUpOptions(onNotes, s, iNote, iNote);
  frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now - fNow));
  Engine.Report(rtDebug, Engine.getSystemOptionByName(onNotes), '', Now - fNow,
    '', 'Set Up Notes');
{$ENDIF}
{$IFDEF TOOLBOX}
  setUpNewNode(nil, 'Toolbox', iTools, iTools);
{$ENDIF}

{$IFDEF USEXSLT}
  fNow := Now;
  frmWait.AddLogLine(char(VK_TAB) + 'Set Up XSLT:');
  fXSLTList.LastName := onXSLTList;
  s := Engine.getSystemOptionByName(onXSLTList);
  setUpOptions(onXSLTList, s, iXSLTTemplate, iXSLTTemplate);
  frmWait.AppendLogLine(char(VK_TAB) + FormatDateTime('ss.zzz', Now - fNow));
  Engine.Report(rtDebug, 'XSLT', '', Now - fNow, '', 'Set Up XSLT');
{$ENDIF}
end;

procedure TfrmLog.setRole(aRole: string);
var
  sRole: string;
begin
  sRole := aRole;
{$IFDEF AANTEST}
  sRole := rnAdmin;
{$ENDIF}
  fReportListView.setRole(sRole);
{$IFDEF SHOWDATASETS}
  fDatasets.setRole(sRole);
{$ENDIF}
  fNoteList.setRole(sRole);
{$IFDEF USEXSLT}
  fXSLTList.setRole(sRole);
{$ENDIF}
  fSysOptions.setRole(sRole);
  fUserOptions.setRole(sRole);

  frmMDK_CDS.SetStatus(sRole);

{$IFDEF CLEANUP}
  pnlCleanup.Visible := UserOptions.Exists(onAllowUserCleanOptionsList);
  acCleanupOptions.Enabled := Preferences.bValue(onAllowUserCleanOptionsList);
{$ELSE}
  pnlCleanup.Visible := False;
{$ENDIF}
end;

procedure TfrmLog.SaveOptions;
begin
  fSysOptions.SaveOptionList;
  fUserOptions.SaveOptionList;
end;

procedure TfrmLog.tvwMainDblClick(Sender: TObject);

  procedure UpdateNodeByVLE(aVLE: TValueListEditor);
  var
    tn0: TTreeNode;
    i: integer;
    tn: TTreeNode;

  begin
    tn0 := tvwMain.Selected;
    tn := tvwMain.Selected.getFirstChild;
    while tn <> nil do
      begin
        tvwMain.Items.Delete(tn);
        tn := tn0.getFirstChild;
      end;
    for i := 0 to aVLE.Strings.Count - 1 do
      begin
        tn := tvwMain.Items.AddChild(tn0, aVLE.Strings.Names[i]);
        tn.ImageIndex := iNote;
      end;
  end;

  function DictionaryFound: Boolean;
  var
    i: Integer;
  begin
    Result := False;
    for i := 0 to tvwMain.Items.Count - 1 do
      if (tvwMain.Items[i].Level = 0) and
        (tvwMain.Items[i].Text = 'Application Dictionary') then
        begin
          Result := True;
          Break;
        end;
  end;

begin
{$IFNDEF AANTEST}
  Exit; // vhaishandria 2007-10-10 
  if (Engine.CurrentOperatorMode = rnADMIN) and
    //    Preferences.bValue(onShowApplicationDictionary) and
  (tvwMain.Items[0].Text <> 'Application Dictionary') and
    not DictionaryFound then
    tvwMain.Items.AddChild(nil, 'Application Dictionary');
  Exit;
{$ENDIF}

  if tvwMain.Selected.Text = onNotes then
    UpdateNodeByVLE(fNoteList.vleOptions);
end;

procedure TfrmLog.RefreshNodeByString(aString: string);
var
  SL: TStringList;
  tn0: TTreeNode;
  i: integer;
  tn: TTreeNode;

begin
  tn0 := tvwMain.Selected;
  tn := tvwMain.Selected.getFirstChild;
  while tn <> nil do
    begin
      tvwMain.Items.Delete(tn);
      tn := tn0.getFirstChild;
    end;

  if aString = '' then
    Exit;
  SL := TStringLIst.Create;
  SL.Text := aString;

  for i := 0 to SL.Count - 1 do
    begin
      tn := tvwMain.Items.AddChild(tn0, SL.Names[i]);
      tn.ImageIndex := tn0.ImageIndex;
      tn.SelectedIndex := tn0.SelectedIndex;
    end;

  SL.Free;
end;

procedure TfrmLog.setCurrentForm(aForm: TForm);
begin
  try
    if (fCurrentForm <> aForm) and (fCurrentForm <> nil) then
      begin
        try
          fCurrentForm.Enabled := False;
        except
        end;
        fCurrentForm.Hide;
      end;

    fCurrentForm := aForm;

    try
      fCurrentForm.Enabled := True;
    except
    end;
    fCurrentForm.Show;
  except
    on E: Exception do
      MessageDlg('Error Selecting Current Form:' + #13#10#13#10 + E.Message,
        mtWarning, [mbOK], 0);
  end;
end;

procedure TfrmLog.refresh;
begin
  if CurrentForm = fUserOptions then
    begin
      fUserOptions.LastName := fUserOptions.LastName;
      Preferences.Overwrite(sysOptions.ValueList.Text);
      Preferences.Overwrite(userOptions.ValueList.Text);
      Preferences.Overwrite(userSettings.ValueList.Text);
    end;
end;

procedure TfrmLog.acDictionaryReloadExecute(Sender: TObject);
begin
  Engine.LoadDictionaryFromDB;
  Engine.setUpFields;
end;

procedure TfrmLog.acCleanupOptionsExecute(Sender: TObject);
begin
  if (MessageDlg('Delete unused options?', mtConfirmation, [mbNo, mbOK], 0) =
    mrOk) then
    Engine.CleanUpOptions;
end;

procedure TfrmLog.tvwMainChanging(Sender: TObject; Node: TTreeNode;
  var AllowChange: Boolean);
var
  s: string;
begin
  if CurrentForm = fUserOptions then
    AllowChange := fUserOptions.AllowChange(s)
  else if CurrentForm = fSysOptions then
    AllowChange := fSysOptions.AllowChange(s)
  else
    AllowChange := True;
  if not AllowChange then
    MessageDLG('Error:'+#13#13+s+#13#13+
      'Please correct the error before switching to another node',mtError,[mbOK],0);
end;

procedure TfrmLog.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
{$IFDEF LOG_DIALOG}
  if Key = VK_ESCAPE then
    ModalResult := mrCancel;
{$ENDIF}
end;

end.

