unit fMDK_Summary;
{
================================================================================
*
*       Package:      MDK - Clinical Procedures
*       Revision:     $Revision: 1 $  $Modtime: 4/22/08 7:16a $
*       Site Name:    Hines OIFO
*       Date Created: 7/29/05
*       Developers:   andriyevskiy                  
*       Description:  Contains the Application Summary form
*       Notes:
*
================================================================================
*       $ Archive: /CP Version 1.0 - Patch 6 (Renal Enhancement)/GUI/APP-HEMODIALYSIS/Tabs/fMDK_Summary.pas $
*
*       $ History: fMDK_Summary.pas $
}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, Buttons, StdCtrls, DBCtrls, ActnList, ComCtrls, Mask
  , uMDK_BillingInfo, DB, CheckLst, Grids, DBGrids, Menus, frMDK_Comments,
  ImgList
  ;

type
  TfrmSummary = class(TForm)
    pnlSummary: TPanel;
    pnlSummaryItems: TPanel;
    pnlSummaryData: TPanel;
    Label170: TLabel;
    Label353: TLabel;
    Label156: TLabel;
    Label173: TLabel;
    Label175: TLabel;
    Label181: TLabel;
    Label183: TLabel;
    Label177: TLabel;
    Label179: TLabel;
    Label185: TLabel;
    Label187: TLabel;
    Label189: TLabel;
    Label192: TLabel;
    Label8: TLabel;
    dbeDurationManual: TDBEdit;
    dbeFinish: TDBEdit;
    dbeURR: TDBEdit;
    dbeTotKTV: TDBEdit;
    dbeTotKT: TDBEdit;
    dbeMeanConduct: TDBEdit;
    dbeAvDFR: TDBEdit;
    dbeMeanTMP: TDBEdit;
    dbeMeanURF: TDBEdit;
    dbeTotLP: TDBEdit;
    dbeTotUF: TDBEdit;
    dbeAvBFR: TDBEdit;
    dbeMeanTemp: TDBEdit;
    dbeStart: TDBEdit;
    Panel10: TPanel;
    Label209: TLabel;
    Label126: TLabel;
    Label167: TLabel;
    Label13: TLabel;
    dbeAVP0: TDBEdit;
    dbeIABF: TDBEdit;
    dbeVP0: TDBEdit;
    dbeVP200: TDBEdit;
    Panel7: TPanel;
    gbPCE: TGroupBox;
    pnlSubmit: TPanel;
    pnlService: TPanel;
    gbOverallComments: TGroupBox;
    pnlOverallComments: TPanel;
    pnlCommentActions: TPanel;
    Panel5: TPanel;
    dbmSummaryNotes: TDBMemo;
    Label5: TLabel;
    Label3: TLabel;
    Panel8: TPanel;
    Label6: TLabel;
    Label1: TLabel;
    dbeDuration: TDBEdit;
    Bevel1: TBevel;
    Bevel2: TBevel;
    lblPCEStatus: TLabel;
    Label9: TLabel;
    dbeEstVol: TDBEdit;
    btnConditions: TBitBtn;
    BitBtn6: TBitBtn;
    ppmFormat: TPopupMenu;
    Format1: TMenuItem;
    ActionList1: TActionList;
    acFormatField: TAction;
    Panel2: TPanel;
    Label4: TLabel;
    Panel11: TPanel;
    btnConfirm: TBitBtn;
    btnProcedures: TBitBtn;
    btnDiagnoses: TBitBtn;
    btnProviders: TBitBtn;
    Panel12: TPanel;
    Label10: TLabel;
    edLocation: TEdit;
    sbLocation: TBitBtn;
    pnlConditions: TPanel;
    cbxSC: TCheckBox;
    cbxCV: TCheckBox;
    cbxAOE: TCheckBox;
    cbxIRE: TCheckBox;
    cbxEC: TCheckBox;
    cbxMST: TCheckBox;
    cbxHNC: TCheckBox;
    mmService: TMemo;
    lblNote: TLabel;
    lvProcedures: TListView;
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn7: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn2: TBitBtn;
    Panel17: TPanel;
    BitBtn5: TBitBtn;
    rePCE: TRichEdit;
    FrameMDK_Comments: TFrameMDK_Comments;
    Splitter1: TSplitter;
    pnlPCEToolbar: TPanel;
    alPCE: TActionList;
    acConfirm: TAction;
    ilPCE: TImageList;
    acLocation: TAction;
    acProviders: TAction;
    acProcedures: TAction;
    acDiagnoses: TAction;
    acService: TAction;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton6: TSpeedButton;
    pnlPCE: TPanel;
    pnlComments: TPanel;
    pnlButtons2D: TPanel;
    Label2: TLabel;
    pnlPCEStatus: TPanel;
    pnlSummaryToolbar: TPanel;
    Label7: TLabel;
    Panel6: TPanel;
    ActionList2: TActionList;
    acMoveComments: TAction;
    acShowOldComments: TAction;
    Panel3: TPanel;
    spbNCLocation: TSpeedButton;
    spbNCConfirm: TSpeedButton;
    spbNCService: TSpeedButton;
    spbNCDiagnoses: TSpeedButton;
    spbNCProcedures: TSpeedButton;
    spbNCProviders: TSpeedButton;
    Panel4: TPanel;
    Bevel3: TBevel;
    mnMain: TMainMenu;
    Comments1: TMenuItem;
    Edit2: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Delete1: TMenuItem;
    Refresh1: TMenuItem;
    Providers1: TMenuItem;
    Procedures1: TMenuItem;
    Diagnoses1: TMenuItem;
    Service1: TMenuItem;
    Confirm1: TMenuItem;
    Notes1: TMenuItem;
    PCEInformation1: TMenuItem;
    N1: TMenuItem;
    spbUpdateOldComments: TSpeedButton;
    N2: TMenuItem;
    Refresh2: TMenuItem;
    pnlButtons3D: TPanel;
    BitBtn8: TBitBtn;
    BitBtn9: TBitBtn;
    BitBtn10: TBitBtn;
    BitBtn11: TBitBtn;
    BitBtn12: TBitBtn;
    BitBtn13: TBitBtn;
    Bevel4: TBevel;
    procedure FormCreate(Sender: TObject);
    procedure dbeStartDblClick(Sender: TObject);
    procedure dbeTotUFChange(Sender: TObject);
    procedure dbeStartEnter(Sender: TObject);
    procedure dbeStartKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure dbmSummaryNotesChange(Sender: TObject);
    procedure acProvidersExecute(Sender: TObject);
    procedure acDiagnosesExecute(Sender: TObject);
    procedure acProceduresExecute(Sender: TObject);
    procedure cbxSCClick(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure dbmSummaryNotesExit(Sender: TObject);
    procedure dbeTotUFEnter(Sender: TObject);
    procedure dbeStartExit(Sender: TObject);
    procedure acFormatFieldExecute(Sender: TObject);
    procedure dbeStartContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure acConfirmExecute(Sender: TObject);
    procedure acServiceExecute(Sender: TObject);
    procedure acLocationExecute(Sender: TObject);
    procedure acMoveCommentsExecute(Sender: TObject);
    procedure acShowOldCommentsExecute(Sender: TObject);
  private
    { Private declarations }
    fField: TField;
    fActive: TObject;
    fBillingData: TMDK_BillingInfo;

    fIgnore: Boolean;

    procedure setBillingData(aValue: TMDK_BillingInfo);
    procedure UpdatePCE(aTab: Integer);
  public
    { Public declarations }
    Ignore: Boolean;
    property BillingData: TMDK_BillingInfo read fBillingData write
      setBillingData;
    procedure ReportStatus;
    procedure SetUp;
    procedure SaveData;
    procedure setReadOnly(aReadOnly: Boolean = False);
    procedure ActivateTabForm;
    procedure setActionStatus;
    function Verify: string;
    function getMainMenu: TMainMenu;
  end;

var
  frmSummary: TfrmSummary;

implementation

uses uMDK_Summary
  , dMDK_Data
  , fMDK_Main
  , uMDK_Engine
  , uROR_CommonUtils
  , fMDK_Info
  , uMDK_Info
  , uMDK_Common
  , uMDK_CDSCommon
  , uMDK_Options
  , fMDK_Flowsheet
  , fMDK_ListEdit
  , fMDK_HospitalSelector
  , fMDK_FallAssessement
  , fMDK_DictionaryEdit
  , uMDK_Dictionary
  , ClipBrd
  , uMDK_ReportEngine;

{$R *.dfm}

procedure TfrmSummary.FormCreate(Sender: TObject);
begin
  fIgnore := False;

  dbeStart.DataField := fnS_TreatmentStarted;
  dbeFinish.DataField := fnS_TreatmentFinished;
  dbeDuration.DataField := fnS_TreatmentDuration;
  dbeDurationManual.DataField := fnS_TreatmentDurationManual;

  dbeTotUF.DataField := fnS_TotalUF;
  dbeTotLP.DataField := fnS_TotalLP;
  dbeMeanURF.DataField := fnS_MeanUFR;
  dbeMeanTMP.DataField := fnS_MeanTMP;

  dbeAvDFR.DataField := fnS_AverageDFR;
  dbeAvBFR.DataField := fnS_AverageBFR;

  dbeMeanConduct.DataField := fnS_MeanConductivity;
  dbeMeanTemp.DataField := fnS_MeanTemp;
  dbeTotKTV.DataField := fnS_TotalKTV;
  dbeTotKT.DataField := fnS_TotalKT;
  dbeURR.DataField := fnS_TotalURR;

  dbmSummaryNotes.DataField := fnS_SummaryNotes;

  dbeIABF.DataField := fnS_IABF;
  dbeAVP0.DataField := fnS_AVP0;
  dbeVP0.DataField := fnS_VP0;
  dbeVP200.DataField := fnS_VP200;

  dbeEstVol.DataField := fnS_TotalEUV;

  FrameMDK_Comments.setUpCanvas(Engine.NoteList_CDS, pnSummary);
end;

function getInt(aCB: TCheckBox): Integer;
begin
  if not aCB.Enabled then
    Result := -1
  else if aCB.Checked then
    Result := 1
  else
    Result := 0;
end;

procedure TfrmSummary.setBillingData(aValue: TMDK_BillingInfo);
var
  sValue, s: string;
  i: Integer;
  li: TListItem;

const
  sBlankHeader = '......................';
  sBlankBody = '........................................';
  sBlankTail = '......................';

  sLeftMargin = '        ';

  procedure setCheckStatus(aCB: TCheckBox; aValue: Integer);
  begin
    case aValue of
      -1:
        begin
          aCB.Checked := False;
          aCB.Enabled := False;
        end;
      0: aCB.Checked := False;
      1: aCB.Checked := True;
    end;
    aCB.Enabled := aValue >= 0;
  end;

  procedure setCheckReport(aCB: TCheckBox; aValue: Integer);
  var
    sValue: string;
  begin
    li := lvProcedures.Items.Add;
    li.SubItems.Add(aCB.Caption);
    case aValue of
      -1: sValue := 'n/a';
      0: sValue := 'No';
      1: sValue := 'Yes';
    end;
    li.SubItems.Add(sVAlue);

    rePCE.Lines.Add(Format('%-10.10s %-30.30s  --  <%-10.10s>', [sLeftMargin,
      aCB.Caption, sValue]));
  end;

  procedure AddReportLine(aHeader, aBody, aTail: string);
  begin
    li := lvProcedures.Items.Add;
    li.Caption := aHeader;
    li.SubItems.Add(aBody);
    li.SubItems.Add(aTail);
  end;

begin
  fBillingData := aValue;

  lvProcedures.Items.Clear;
  rePCE.Clear;
  addReportLine(sBlankHeader,
    'Location ........................................', sBlankTail);
  addReportLine('', edLocation.Text, '');

  rePCE.Lines.Add(Format('[%s]', ['  Location']));
  rePCE.Lines.Add(Format('%-10.10s %s', [sLeftMargin, edLocation.Text]));
  rePCE.Lines.Add('');

  Engine.getServiceConnections(Engine.CurrentPatient.ID,
    Engine.CurrentPatient.SessionID, s);
  mmService.Lines.Text := s;

  with fBillingData do
    begin
      fIgnore := True;
      setCheckStatus(cbxSC, SCC);
      setCheckStatus(cbxMST, MST);
      setCheckStatus(cbxAOE, AOE);
      setCheckStatus(cbxIRE, IRE);
      setCheckStatus(cbxHNC, HNC);
      setCheckStatus(cbxEC, EC);
      setCheckStatus(cbxCV, CV);
      fIgnore := False;

      addReportLine(sBlankHeader,
        'Healthcare Providers  ........................................',
        sBlankTail);
      rePCE.Lines.Add(Format('[%s]', ['  Healthcare Providers']));
      if Providers.Count = 0 then
        begin
          addReportLine('', 'No providers found', '');
          rePCE.Lines.Add(Format('%s %s', [sLeftMargin, 'No providers found']));
        end
      else
        begin
          for i := 0 to Providers.Count - 1 do
            begin
              try
                li := lvProcedures.Items.Add;
                li.Caption := '';
                s := TMDK_Provider(Providers.Objects[i]).Name;
                li.SubItems.Add(s);
                sValue := '';
                if TMDK_Provider(Providers.Objects[i]).Primary then
                  sValue := 'Primary';
                li.SubItems.Add(sValue);
                rePCE.Lines.Add(Format('%s %s [<%s>]', [sLeftMargin, s,
                  sVAlue]));
              except
              end;
            end;
        end;
      addReportLine('', '', '');
      rePCE.Lines.Add('');

      addReportLine('ICD ................',
        'Diagnoses..................................................',
        sBlankTail);
      rePCE.Lines.Add(Format('[%s]', ['  Diagnoses (ICD Codes)']));

      if Diagnoses.Count > 0 then
        begin
          for i := 0 to Diagnoses.Count - 1 do
            begin
              try
                li := lvProcedures.Items.Add;
                li.Caption := TMDK_Diagnosis(Diagnoses.Objects[i]).ID;
                li.SubItems.Add(TMDK_Diagnosis(Diagnoses.Objects[i]).Title);
                sValue := '';
                if TMDK_Diagnosis(Diagnoses.Objects[i]).Primary then
                  sValue := 'Primary';
                li.SubItems.Add(sValue);

                rePCE.Lines.Add(Format('%-10.10s <%-10.10s> %s  [%s]',
                  [sLeftMargin,
                  TMDK_Diagnosis(Diagnoses.Objects[i]).ID,
                    TMDK_Diagnosis(Diagnoses.Objects[i]).Title, sValue]));
              except
              end;
            end;
        end
      else
        begin
          addReportLine('', 'No diagnosis found', '');
          rePCE.Lines.Add(Format('%s %s', [sLeftMargin, 'No diagnosis found']));
        end;

      addReportLine('', '', '');
      rePCE.Lines.Add('');

      AddReportLIne('CPT ....................',
        'Procedures ........................................', sBlankTail);
      rePCE.Lines.Add(Format('[%s]', ['  Procedures (CPT Codes)']));

      if Procedures.Count > 0 then
        begin
          for i := 0 to Procedures.Count - 1 do
            begin
              sValue :=
                IntToStr(TMDK_Procedure(Procedures.Objects[i]).Quantity);

              li := lvProcedures.Items.Add;
              li.Caption := TMDK_Procedure(Procedures.Objects[i]).ID;
              li.SubItems.Add(TMDK_Procedure(Procedures.Objects[i]).Title);
              li.SubItems.Add(sValue);

              rePCE.Lines.Add(Format('%-10.10s <%-10.10s> %s  [%s]',
                [sLeftMargin,
                TMDK_Procedure(Procedures.Objects[i]).ID,
                  TMDK_Procedure(Procedures.Objects[i]).Title, sValue]));
            end;
        end
      else
        begin
          addReportLine('', 'No procedures found', '');
          rePCE.Lines.Add(Format('%s %s', [sLeftMargin,
            'No procedures found']));
        end;

      addReportLine('', '', '');
      rePCE.Lines.Add('');

      addReportLine('Service .................', sBlankBody, sBlankTail);
      rePCE.Lines.Add(Format('[%s]',
        ['  Service Connection/Rated Disabilities']));

      setCheckReport(cbxSC, SCC);
      setCheckReport(cbxMST, MST);
      setCheckReport(cbxAOE, AOE);
      setCheckReport(cbxIRE, IRE);
      setCheckReport(cbxHNC, HNC);
      setCheckReport(cbxEC, EC);
      setCheckReport(cbxCV, CV);
      addReportLine('', '', '');
      rePCE.Lines.Add('');
      for i := 0 to mmService.Lines.Count - 1 do
        begin
          addReportLine('', mmService.Lines[i], '');
          rePCE.Lines.Add(Format('%-10.10s %s', [sLeftMargin,
            mmService.Lines[i]]));
        end;

    end;

  PaintSyntax(rePCE, False, '[', ']');
  PaintSyntax(rePCE, False);
end;

procedure TfrmSummary.dbeStartDblClick(Sender: TObject);
begin
// 2007-06-29 Exit; // vhaishandria 20070326 No access to dictionary...
Exit; // vhaishandria 2007-07-26
  UpdateDBEditField(TDBEdit(Sender));
  CheckDBField(fActive);
end;

procedure TfrmSummary.dbeTotUFChange(Sender: TObject);
begin
  exit;
  if dmData.bIgnore then
    Exit;
  TestValue(Sender, Ignore);
end;

procedure TfrmSummary.dbeStartEnter(Sender: TObject);
var
  s: string;
  aF: TDateTimeField;
begin
  aF := TDateTimeField(TDBEdit(Sender).Field);
  s := FormatDateTime(aF.DisplayFormat, aF.AsDateTime);
  TDBEdit(Sender).DataSource.DataSet.Edit;
  TDBEdit(Sender).EditText := s;
  TDBEdit(Sender).SelLength := Length(s);

  fField := TDBEdit(Sender).Field;
  fActive := Sender;
end;

procedure TfrmSummary.dbeStartKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then
    dbeStartEnter(Sender)
end;

procedure TfrmSummary.dbmSummaryNotesChange(Sender: TObject);
begin
  if Ignore then
    Exit;
  Ignore := true;
  try
    UpdateMemo(Sender, Engine.Signature);
  except
  end;
  ignore := false;
  spbUpdateOldComments.Enabled := dbmSummaryNotes.Text <> '';
end;

procedure TfrmSummary.ReportStatus;
var
  iCode: Integer;
  s,
    sComment: string;
  OldIgnore: Boolean;

  function AddComma(aValue:String):String;
  begin
    Result := aValue;
    if Result <> '' then
      Result := Result + ', ';
  end;

begin
  oldIgnore := Ignore;
  try
    iCode := 0;
    sComment := '';
    s := '';
    // verify billing info -- billing info is not verified
    // to verify use Engine.ValidBillingInfo(s)

    // verify data =============================================================
    s := '';
    s := s + AddComma(CheckDBField(dbeStart)); // ,'','Start Time. ');
    s := s + AddComma(CheckDBField(dbeFinish)); // ,'','Finished Time. ');
    s := s + AddComma(CheckDBField(dbeDurationManual)); // ,'','Duration Man. ');

    s := s + AddComma(CheckDBField(dbeTotUF)); // ,'','Total UF. ');
    s := s + AddComma(CheckDBField(dbeTotLP)); // ,'','Total LP. ');
    s := s + AddComma(CheckDBField(dbeMeanURF)); // ,'','Mean URF. ');
    s := s + AddComma(CheckDBField(dbeMeanTMP)); // ,'','Mean TMP. ');

    s := s + AddComma(CheckDBField(dbeAvBFR)); // ,'','Av. BRF. ');
    s := s + AddComma(CheckDBField(dbeAvDFR)); // ,'','Av. DRF. ');

    s := s + AddComma(CheckDBField(dbeMeanTemp)); // ,'','Mean Temp. ');
    s := s + AddComma(CheckDBField(dbeMeanConduct)); // ,'','Mean Cond. ');
    s := s + AddComma(CheckDBField(dbeTotKT)); // ,'','Total KT. ');
    s := s + AddComma(CheckDBField(dbeTotKTV)); // ,'','Total KT/V. ');
    s := s + AddComma(CheckDBField(dbeURR)); // ,'','URR. ');
    s := s + AddComma(CheckDBField(dbeEstVol)); // ,'','URR. ');

    s := s + AddComma(CheckDBField(dbeIABF)); // ,'','IABF ');
    s := s + AddComma(CheckDBField(dbeVP0)); // ,'','VP at 0 ');
    s := s + AddComma(CheckDBField(dbeAVP0)); // ,'','AVP at 0 ');
    s := s + AddComma(CheckDBField(dbeVP200)); // ,'','VP at 200 ');

    if copy(s, Length(s)-1,2) = ', ' then
     s := copy(s,1,Length(s)-2);

    if (s <> '') and (iCode < 1) then
      iCode := iCode + 1;
    if s <> '' then
      s := 'Required Fields without data: ' + s
    else
      s := 'OK';

    Engine.ReportStatus(pnSummary, iCode, s);

    lvProcedures.Color := Preferences.iValue(onReadOnlyFieldColor);
    mmService.Color := Preferences.iValue(onReadOnlyFieldColor);
    edLocation.Color := Preferences.iValue(onReadOnlyFieldColor);
    pnlConditions.Color := Preferences.iValue(onReadOnlyFieldColor);

    if devOptions.bValue(donShowHorizontalScrollBarsInComments) then
      begin
        dbmSummaryNotes.ScrollBars := ssBoth;
      end
    else
      begin
        dbmSummaryNotes.ScrollBars := ssVertical;
      end;

  except
  end;
  Ignore := OldIgnore;

  FrameMDK_Comments.pnlButtons2DH.Visible := not devOptions.bValue(donWindowsXPTheme);
  FrameMDK_Comments.pnlButtons3DH.Visible := devOptions.bValue(donWindowsXPTheme);
end;

procedure TfrmSummary.acProvidersExecute(Sender: TObject);
begin
  UpdatePCE(2);
end;

procedure TfrmSummary.acDiagnosesExecute(Sender: TObject);
begin
  UpdatePCE(0);
end;

procedure TfrmSummary.acProceduresExecute(Sender: TObject);
begin
  UpdatePCE(1);
end;

procedure TfrmSummary.cbxSCClick(Sender: TObject);

  procedure setCB(aCB: TCheckBox; aValue: Integer);
  begin
    aCB.Enabled := aValue <> -1;
    aCB.Checked := aValue = 1;
  end;

begin
  if fIgnore then
    Exit;
  fIgnore := True;
  UpdatePCE(3);
  //  SpeedButton2Click(nil);
  fIgnore := False;
  Exit;

  if Sender = cbxSC then
    if cbxSC.Checked then
      fBillingData.SCC := 1
    else
      fBillingData.SCC := 0;

  if Sender = cbxAOE then
    if cbxAOE.Checked then
      fBillingData.AOE := 1
    else
      fBillingData.AOE := 0;

  if Sender = cbxCV then
    if cbxCV.Checked then
      fBillingData.CV := 1
    else
      fBillingData.CV := 0;

  if Sender = cbxIRE then
    if cbxIRE.Checked then
      fBillingData.IRE := 1
    else
      fBillingData.IRE := 0;

  if Sender = cbxEC then
    if cbxEC.Checked then
      fBillingData.EC := 1
    else
      fBillingData.EC := 0;

  if Sender = cbxMST then
    if cbxMST.Checked then
      fBillingData.MST := 1
    else
      fBillingData.MST := 0;

  if Sender = cbxHNC then
    if cbxHNC.Checked then
      fBillingData.HNC := 1
    else
      fBillingData.HNC := 0;

end;

procedure TfrmSummary.UpdatePCE(aTab: Integer);
begin
  UpdateList(Engine.CurrentPatient.ID, Engine.CurrentPatient.SessionID, aTab);
  setup;
  BillingData := Engine.BillingInfo;
  lblPCEStatus.Caption := Engine.PCEBillingStatusDescription;
end;

procedure TfrmSummary.BitBtn6Click(Sender: TObject);
var
  sPre, sSel, sPost: string;
  mmNote: TDBMemo;
begin
  if not Assigned(FallAssessment) then
    Application.CreateForm(TFallAssessment, FallAssessment);

  FallAssessment.CleanUpForm;

  mmNote := dbmSummaryNotes;
  mmNote.SetFocus;
  sPre := '';
  sSel := '';
  sPost := '';
  try
    sPre := copy(mmNote.Text, 1, mmNote.SelStart - 1);
    sSel := copy(mmNote.Text, mmNote.SelStart, mmNote.SelLength);
    sPost := copy(mmNote.Text, mmNote.SelStart + mmNote.SelLength - 1,
      Length(mmNote.Text));
  except
  end;

  try
    FallAssessment.edAge.Text := Engine.CurrentPatient.Age;
    //    iSelStart := mmNote.SelStart;
    if FallAssessment.ShowModal = mrOK then
      begin
        Ignore := True;
        Engine.Summary_CDS.Edit;
        mmNote.Text := sPre + FallAssessment.Report.Text + sPost;
        //        mmNote.SelStart := iSelStart;
        //        mmNote.SelLength := Length(FallAssessment.Report.Text);
        try
          if (Engine.Summary_CDS.State = dsEdit)
            or (Engine.Summary_CDS.State = dsInsert) then
            Engine.Summary_CDS.Post;
        except
          on E: Exception do
            ShowMessage(e.Message);
        end;
        Ignore := false;
      end;
  except
  end;
end;

procedure TfrmSummary.SetUp;
var
  sInfo: string;
begin
  pnlCommentActions.Visible := not Preferences.bValue(onFallsAssessmentAsTIU);
  CheckDBField(dbmSummaryNotes);

  edLocation.Text := Engine.LocationName;
  BillingData := Engine.BillingInfo;
  lblPCEStatus.Caption := Engine.PCEBillingStatusDescription;
  sbLocation.Enabled :=
    (edLocation.Text = '') or
    (Engine.CurrentOperatorMode = rnAdmin);

  sInfo := Engine.getAppointmentInfo;
  btnProcedures.Enabled := pos('have met', sInfo) > 0;
  btnProviders.Enabled := pos('have met', sInfo) > 0;
  btnConditions.Enabled := pos('have met', sInfo) > 0;
  btnDiagnoses.Enabled := pos('have met', sInfo) > 0;
  btnConfirm.Enabled := pos('have met', sInfo) > 0;
  sbLocation.Enabled := pos('have met', sInfo) > 0;

  acConfirm.Enabled := pos('have met', sInfo) > 0;
  acLocation.Enabled := pos('have met', sInfo) > 0;
  acProviders.Enabled := pos('have met', sInfo) > 0;
  acProcedures.Enabled := pos('have met', sInfo) > 0;
  acDiagnoses.Enabled := pos('have met', sInfo) > 0;
  acService.Enabled := pos('have met', sInfo) > 0;


  spbUpdateOldComments.Visible := devOptions.bValue(donIncludeCommentsUpdate);

  spbNCLocation.Caption := '';
  spbNCConfirm.Caption := '';
  spbNCService.Caption := '';
  spbNCDiagnoses.Caption := '';
  spbNCProcedures.Caption := '';
  spbNCProviders.Caption := '';

  FrameMDK_Comments.Color := Preferences.iValue(onReadOnlyFieldColor);
  FrameMDK_Comments.pnlToolbar.Color := Preferences.iValue(onColorToolbar);

  pnlSummaryToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlPCEToolbar.Color := Preferences.iValue(onColorToolbar);
  pnlSummaryItems.Color := Preferences.iValue(onColorBackground);
  pnlPCE.Color := Preferences.iValue(onColorBackground);
  rePCE.Color := Preferences.iValue(onReadOnlyFieldColor);
  pnlPCEStatus.Color := Preferences.iValue(onReadOnlyFieldColor);

  setReadOnly(Engine.CurrentPatient.ReadOnly);

  pnlButtons2D.Visible := not devOptions.bValue(donWindowsXPTheme);
  pnlButtons3D.Visible := devOptions.bValue(donWindowsXPTheme);
end;

procedure TfrmSummary.dbmSummaryNotesExit(Sender: TObject);
begin

  Exit; // vhaishandria
  try
    if (Engine.Summary_CDS.State = dsEdit)
      or (Engine.Summary_CDS.State = dsInsert) then
      Engine.Summary_CDS.Post;
  except
  end;
  CheckDBField(Sender);
  fField := nil;
  fActive := nil;
end;

procedure TfrmSummary.dbeTotUFEnter(Sender: TObject);
begin
  fField := getActiveField(Sender);
  fActive := Sender;
end;

procedure TfrmSummary.dbeStartExit(Sender: TObject);
begin
  fField := nil;
  fActive := nil;
  CheckDBField(Sender);
  ReportStatus;
end;

procedure TfrmSummary.acFormatFieldExecute(Sender: TObject);
begin
  if not devOptions.bValue(onAllowDictionaryEdit) then
    Exit;
  if fField = nil then
    exit;
  try
    UpdateColumnField(fField, fField.DataSet.Name, fField.FieldName);
    CheckDBField(fActive);
  except
  end;
end;

procedure TfrmSummary.dbeStartContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
var
  WinCon: TWinControl;
begin
{$IFNDEF DICTIONARY_FORMAT}// vhaishandria 2007-07-12 b. 312 #26
  Exit; // vhaishandria 20070326 no access to dictionary
{$ENDIF}
  if Engine.CurrentOperatorMode <> rnAdmin then
    Exit;

  dbeTotUFEnter(Sender);
  WinCon := TWinControl(Sender);
  ppmFormat.Popup(WinCon.ClientOrigin.X + MousePos.X, WinCon.ClientOrigin.Y +
    MousePos.Y);
end;

procedure TfrmSummary.SaveData;
begin
  try
    dbmSummaryNotesExit(nil);
  except
    on E: Exception do
      MessageDLG('Summary Save Data:'+#13#10+E.Message,mtWarning,[mbOK],0);
  end;
end;

procedure TfrmSummary.setReadOnly(aReadOnly: Boolean = False);
begin
  pnlSummaryItems.Enabled := not aReadOnly;
  gbPCE.Enabled := not aReadOnly;
  pnlCommentActions.Enabled := not aReadOnly;

  dbmSummaryNotes.ReadOnly := aReadOnly;

  FrameMDK_Comments.ReadOnly := aReadOnly;

  if aReadOnly then

    pnlSummaryItems.Color := Preferences.iValue(onColorReview)
  else
    pnlSummaryItems.Color := Preferences.iValue(onColorBackground);

end;

procedure TfrmSummary.ActivateTabForm;
begin
  Verify;
  ReportStatus;
  FrameMDK_Comments.acRefreshExecute(nil);
  FrameMDK_Comments.ActivateFrame;
  setup;
end;

procedure TfrmSummary.setActionStatus;
begin
  acMoveComments.Enabled := dbmSummaryNotes.Text <> '';
  FrameMDK_Comments.setActionStatus;
  Invalidate;
end;

procedure TfrmSummary.acConfirmExecute(Sender: TObject);
var
  sComment: string;
begin
  if not Engine.ValidBillingInfo(sComment, False) then
    begin
      MessageDlg('Billing Information is not correct.' + #13#10 + #13#10 +
        sComment + #13#10 + #13#10
        , mtInformation, [mbOK], 0);
    end
  else
    MessageDlg('The Billing Information was confirmed.'
      , mtInformation, [mbOK], 0);

  lblPCEStatus.Caption := Engine.PCEBillingStatusDescription;
end;

procedure TfrmSummary.acServiceExecute(Sender: TObject);
begin
  UpdatePCE(3);
end;

procedure TfrmSummary.acLocationExecute(Sender: TObject);
var
  anIEN, aName: string;
begin
  if SelectLocation('', anIEN, aName) then
    begin
      if Engine.setLocation(anIEN) then
        begin
          Engine.LocationID := anIEN;
          Engine.LocationName := aName;
          edLocation.Text := aName;
          frmMain.lblLocationID.Caption := aName;
        end
      else
        ShowMessage('Location could not be changed...');
      setup;
    end;
end;

function TfrmSummary.Verify: string;
begin
  Result := '';
  //  FrameMDK_Comments.moveComment(dbmSummaryNotes.DataField,'');
  if dbmSummaryNotes.Text <> '' then
    Result := 'Old Comments field is not empty  ';
end;

procedure TfrmSummary.acMoveCommentsExecute(Sender: TObject);
begin
  if dbmSummaryNotes.Modified then
    try
      dmData.cdsSummary.Post;
    except
    end;

  if dbmSummaryNotes.Text <> '' then
    FrameMDK_Comments.moveComment(dbmSummaryNotes.DataField, '')
  else
    MessageDLG('No comments available for update', mtInformation, [mbOK], 0);
end;

procedure TfrmSummary.acShowOldCommentsExecute(Sender: TObject);
begin
  gbOverallComments.Visible := not gbOverallComments.Visible;
end;

function TfrmSummary.getMainMenu: TMainMenu;
begin
  Result := mnMain;
end;

end.
