unit uMDK_NoScrollDBGrid;

interface
uses
  DBGrids
  , Messages
  , Windows
  , Classes
  , Comctrls
  ;

type
  TNoScrollDBGrid = class(TDBGrid)
  private
    procedure WMNCCalcSize(var Msg: TMessage);
      message WM_NCCALCSIZE;
  end;

  TNoScrollTreeView = class(TTreeView)
  private
    procedure WMNCCalcSize(var Msg: TMessage);
      message WM_NCCALCSIZE;
  end;

function newNoVScrollDBGrid(anOwner:TComponent): TNoScrollDBGrid;

implementation

function newNoVScrollDBGrid(anOwner:TComponent): TNoScrollDBGrid;
begin
  Result := TNoScrollDBGrid.Create(anOwner);
end;
//This removes both scrollbars. If you want to remove only the vertical one
//change the scrollstyles constant accordingly.
procedure TNoScrollDBGrid.WMNCCalcSize(var Msg: TMessage);
const
  Scrollstyles = WS_VSCROLL {or WS_HSCROLL};
var
  Style: Integer;
begin
  Style := GetWindowLong(Handle, GWL_STYLE);
  if (Style and Scrollstyles) <> 0 then
    SetWindowLong(Handle, GWL_STYLE, Style and not Scrollstyles);
  inherited;
end;

procedure TNoScrollTreeView.WMNCCalcSize(var Msg: TMessage);
const
  Scrollstyles = WS_VSCROLL {or WS_HSCROLL};
var
  Style: Integer;
begin
  Style := GetWindowLong(Handle, GWL_STYLE);
  if (Style and Scrollstyles) <> 0 then
    SetWindowLong(Handle, GWL_STYLE, Style and not Scrollstyles);
  inherited;
end;

end.
