unit uMDK_RPCEvent;

interface
uses
  Classes, SysUtils;
  
type
  TRPCEventItem = class(TObject)
  public
    Start: TDateTime;
    Stop: TDateTime;
    RPC: string;
    Params: TStrings;
    Results: TStrings;

    constructor Create;
    destructor Destroy; override;
  end;

function newRPCEventItem(
  aStart, aStop: TDateTime;
  RemoteProcedure: string;
  Parameters: array of string; MultList: TStringList = nil;
//  RPCMode: TRPCMode = [];
  RetList: TStrings = nil): TRPCEventItem;


implementation

function newRPCEventItem(
  aStart, aStop: TDateTime;
  RemoteProcedure: string;
  Parameters: array of string; MultList: TStringList = nil;
//  RPCMode: TRPCMode = [];
  RetList: TStrings = nil): TRPCEventItem;
var
  Item: TRPCEventItem;
  i, j: Integer;
begin
  Item := TRPCEventItem.Create;
  Item.Start := aStart;
  Item.Stop := aStop;
  Item.RPC := RemoteProcedure;

  Item.Params.Add('Params: ---------------------------------------------------');
  i := 0;
  while i <= High(Parameters) do
  begin
    if (Copy(Parameters[i], 1, 1) = '@') and (Parameters[i] <> '@') then
    begin
      Item.Params.Add('Reference ' + IntToStr(i) + ' <' + Copy(Parameters[i], 2, Length(Parameters[i])) + '>');
    end
    else
    begin
      Item.Params.Add('Literal ' + IntToStr(i) + ' <' + Parameters[i] + '>');
    end;
    Inc(i);
  end;

  if MultList <> nil then
    if MultList.Count > 0 then
    begin
      Item.Params.Add('List:');
      for j := 1 to MultList.Count do
        Item.Params.Add(MultList[j - 1]);
    end;

  if RetList <> nil then
    if RetList.Count > 0 then
    begin
      Item.Results.Add('Results: --------------------------------------------------');
      for j := 0 to RetList.Count - 1 do
        Item.Results.Add(RetList[j]);
    end;
  Result := Item;
end;

////////////////////////////////////////////////////////////////////////////////

constructor TRPCEventItem.Create;
begin
  inherited;
  Params := TStringList.Create;
  Results := TStringList.Create;
end;

destructor TRPCEventItem.Destroy;
begin
  Params.Free;
  Results.Free;
  inherited;
end;

end.
